using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;

namespace entity
{
    public partial class BitmapControl : UserControl
    {
        public Raw.ParsedBitmap pm;
        public int MapNumber;
        int zoom = 1;
        int currchunk = 0;
        public BitmapControl(int mapnumber)
        {
            InitializeComponent();
            MapNumber = mapnumber;

            Maps.map[MapNumber].OpenMap(MapTypes.Internal);

            pm = new entity.Raw.ParsedBitmap(ref Maps.map[MapNumber].SelectedMeta, mapnumber);
           

            for (int x = 0; x < pm.Properties.Length; x++)
                treeView1.Nodes.Add("Bitmap Chunk #" + x.ToString());
            Maps.map[mapnumber].CloseMap();

            DisplayBitmap(0);
        }

        private void treeView1_AfterSelect(object sender, TreeViewEventArgs e)
        {
            DisplayBitmap(treeView1.SelectedNode.Index);
           
        }

        public void DisplayBitmap(int chunk)
        {
            pictureBox1.Image = pm.FindChunkAndDecode(chunk, 0, ref Maps.map[MapNumber].SelectedMeta, MapNumber, chunk,0);
            pictureBox1.Width = pm.Properties[chunk].width * zoom;
            pictureBox1.Height = pm.Properties[chunk].height * zoom;
            pictureBox1.SizeMode = PictureBoxSizeMode.StretchImage;
            currchunk = chunk;
        }

        private void pictureBox1_Click(object sender, EventArgs e)
        {
            zoom++;
            if (zoom > 3) zoom = 1;
            DisplayBitmap(currchunk);
        }
    }
}
