using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
namespace entity
{
    public sealed class MetaBuilder
    {
        private static MemoryStream MetaStream;
        private static int metasize=0;
        private static int tagnumber = 0;
        public static Meta BuildMeta(MetaSplitter metasplit,int mapnumber)
        {
           
            metasize=0;
            MetaStream= new MemoryStream(metasplit.Header.chunksize);
            BinaryWriter BW = new BinaryWriter(MetaStream);
            #region WriteMetaHeader
        //    BW.BaseStream.Position = 0;
         //   BW.Write(metasplit.Header.MS.ToArray(), 0, metasplit.Header.chunksize);
           metasize += metasplit.Header.chunksize;
            #endregion
           tagnumber = metasplit.tagnumber;


            Meta m = new Meta();
            
            
            List<Meta.Item> NewItems = new List<Meta.Item>();
            RecursivelyAddPiecesToMeta(metasplit.Header, ref NewItems,ref BW);
            m.items = NewItems;
            if (MetaStream.Length % 4 != 0) {
                metasize += (int)MetaStream.Length % 4;
                MetaStream.SetLength(MetaStream.Length + MetaStream.Length % 4); }
            m.MS = MetaStream;
            m.size = metasize;
            m.type = metasplit.type;
            m.name = metasplit.name;
            m.rawType = metasplit.rawtype;
            m.raw = metasplit.raw;
            m.magic = metasplit.magic;
            m.offset = metasplit.offset;

            m.tagnumber = tagnumber;
            m.RelinkReferences(mapnumber);
            m.WriteReferences();
      //      m.items.Clear();
            MetaScanner Ms = new MetaScanner();
            if (m.rawType != RawDataContainerType.Empty)
            {
                Maps.map[mapnumber].OpenMap(MapTypes.Internal);
                m.raw = Maps.map[mapnumber].Functions.Meta.ReadRaw(m.tagnumber, mapnumber, false);
                Maps.map[mapnumber].CloseMap();
            }
         //   Maps.map[mapnumber].OpenMap(MapTypes.Internal);
         // IFPIO ifp=IFP.IFPHashMap.GetIfp(m.type);
       //     m.parsed = true;
       //   Ms.ScanWithIFP(ref ifp, ref m, mapnumber) ;
        //  Maps.map[mapnumber].CloseMap();
            return m;
        }
        public static void RecursivelyAddPiecesToMeta(MetaSplitter.SplitReflexive reflex, ref List<Meta.Item> destination, ref BinaryWriter BW)
        {
            for (int x = 0; x < reflex.Chunks.Count; x++)
            {
                BW.BaseStream.Position = reflex.translation + (reflex.chunksize * x);
                BW.Write(reflex.Chunks[x].MS.ToArray(), 0, reflex.chunksize);
                for (int y = 0; y < reflex.Chunks[x].ChunkResources.Count; y++)
                {
                    Meta.Item i = reflex.Chunks[x].ChunkResources[y] as Meta.Item;


                    switch (i.type)
                    {
                        case Meta.ItemType.Reflexive:
                            MetaSplitter.SplitReflexive treflex = (MetaSplitter.SplitReflexive)i;
                            treflex.offset = reflex.translation  + i.offset + (reflex.chunksize * x);
                            
                            treflex.translation = metasize;
                            treflex.chunkcount = treflex.Chunks.Count;
                            
                            metasize += treflex.chunksize * treflex.chunkcount;
                            treflex.type = Meta.ItemType.Reflexive;
                            treflex.intag = tagnumber;
                            treflex.pointstotagnumber = tagnumber;
                            RecursivelyAddPiecesToMeta(treflex, ref  destination, ref BW);
                            destination.Add(treflex);
                            break;

                        case Meta.ItemType.Ident:
                            MetaSplitter.SplitIdent id = (MetaSplitter.SplitIdent)i;
                            id.offset = reflex.translation + id.offset + (reflex.chunksize * x);
                            id.intag = tagnumber;
                            destination.Add(id);

                            break;
                        case Meta.ItemType.String:
                            MetaSplitter.SplitString ss = (MetaSplitter.SplitString)i;
                            ss.offset = reflex.translation + ss.offset + (reflex.chunksize * x);
                            ss.intag = tagnumber;
                            destination.Add(ss);
                            break;

                    }


                }
            }
        }
    }
}
