using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.IO;
using System.Windows.Forms;

namespace entity.Forms
{
    public partial class HexView : UserControl
    {
        #region Fields
        private string txtBitmask = "";
        private string txtByte = "";
        private string txtUByte = "";
        private string txtShort = "";
        private string txtUShort = "";
        private string txtLong = "";
        private string txtULong = "";
        private string txtFloat = "";
        private string txtIdentTagType = "";
        private string txtIdentName = "";
        private string txtSID = "";
        private string txtReflexiveCount = "";
        private string txtReflexiveTagType = "";
        private string txtReflexiveTagName = "";
        private string txtReflexiveTranslation = "";

        private int Offset = 0;
        public int MapOffset = 0;
        private Meta meta;
        private int mapnumber;
        public string filePath;
        private int selectionoffset=0;
        private int selectionlength = 0;
       entity.Forms.HexEditor.GoToDialogBox gt = new entity.Forms.HexEditor.GoToDialogBox();
        #endregion

        #region Constructor
        public HexView()
        {
          
            InitializeComponent();
        }
        #endregion
        public void Setup(string path)
        {
            filePath = path;
            
        }
      
        public void Reload(Meta m, int mapnumberx)
        {
            if (m == null) { return; }
            mapnumber = mapnumberx;
            meta = m;
          
            this.txtbHexViewer.ByteArray = m.MS.ToArray();
            this.vScrollBar1.Maximum = (int)m.MS.ToArray().Length / 10;
            OffsetUpdater(0);
           // Colorize();
            //UpdateTxtbInfo();
     
        }

        public void Colorize()
        {
           
            int tempstart = this.txtbHexViewer.SelectionStart;
            int templength = this.txtbHexViewer.SelectionLength;
          //  this.txtbHexViewer.DeselectAll();
            Color c = this.txtbHexViewer.SelectionColor;
         //   this.txtbHexViewer.SelectionColor = Color.Black;
            for (int x = 0; x < meta.items.Count; x++)
            {
                
                if (meta.items[x].offset >= Offset && meta.items[x].offset < Offset + 476)
                {

                    if (meta.items[x] is Meta.Reflexive)
                    {

                        this.txtbHexViewer.Select((meta.items[x].offset - Offset) * 3, 24);
                        this.txtbHexViewer.SelectionColor = Color.Red;
                    }
                    else if (meta.items[x] is Meta.String)
                    {

                        this.txtbHexViewer.Select((meta.items[x].offset - Offset) * 3, 12);
                        this.txtbHexViewer.SelectionColor = Color.Blue;
                    }
                    else if (meta.items[x] is Meta.Ident)
                    {

                        this.txtbHexViewer.Select((meta.items[x].offset - Offset) * 3, 12);
                        this.txtbHexViewer.SelectionColor = Color.Green;
                    }
                   // MessageBox.Show("test");
                }
            }
            this.txtbHexViewer.Select(tempstart, templength);
            this.txtbHexViewer.SelectionColor = c;
          //  Application.DoEvents();

        }

        private void vScrollBar1_Scroll(object sender, ScrollEventArgs e)
        {

            HexRichTextBox._Paint = false;
            this.vScrollBar1.Scroll -= new System.Windows.Forms.ScrollEventHandler(this.vScrollBar1_Scroll);
            
              Offset = vScrollBar1.Value * 10;
                         
            this.txtbHexViewer.LoadHex(Offset);
            this.txtbOffsets.DeselectAll();            
            OffsetUpdater(vScrollBar1.Value);

            this.vScrollBar1.Scroll += new System.Windows.Forms.ScrollEventHandler(this.vScrollBar1_Scroll);
            HexRichTextBox._Paint = true;

        }
        private void txtbHexViewer_SelectionChanged(object sender, EventArgs e)
        {
            ConvertHexStringToByteArray(txtbHexViewer.SelectedText);
        }
        public  void ConvertHexStringToByteArray(string hex)
        {
            if (hex.Length == 0) { return; }
            ClearTxt();
            byte[] bytes = GetBytes(hex);
            switch (bytes.Length)
            {
                case 1:
                    {
                        this.txtUByte = bytes[0].ToString();
                        this.txtByte = ConvertBytesTosbyte(bytes).ToString();
                        break;
                    }
                case 2:
                    {
                        this.txtShort = BitConverter.ToInt16(bytes, 0).ToString();// ConvertBytesToint16(bytes).ToString();
                        this.txtUShort = BitConverter.ToUInt16(bytes, 0).ToString();
                        goto case 1;
                    }
                case 3:
                    {
                        goto case 2;
                    }
                case 4:
                    {
                        this.txtLong = BitConverter.ToInt32(bytes, 0).ToString(); //ConvertBytesToInt32(bytes).ToString();
                        this.txtULong = BitConverter.ToUInt32(bytes, 0).ToString();//ConvertBytesToUInt32(bytes).ToString();=
                        this.txtFloat = BitConverter.ToSingle(bytes, 0).ToString();
                        int temp=BitConverter.ToInt32(bytes, 0);
                        int tagnum = Maps.map[mapnumber].Functions.Meta.FindMetaByID(temp, mapnumber);
                        if (tagnum != -1)
                        {
                            this.txtIdentTagType = Maps.map[mapnumber].MetaInfo.TagType[tagnum];
                            this.txtIdentName = Maps.map[mapnumber].FileNames.Name[tagnum];
                        }
                        int stringid = (temp & 0xFFFF);
                        int stringcount = (temp >> 16) & 0xFFFF;
                        int middlebyte =stringcount  & 0xFF;
                        stringcount = (stringcount >> 8) & 0xFF; ;
                      
                        if (stringid>0&&stringid<Maps.map[mapnumber].MapHeader.scriptReferenceCount&&Maps.map[mapnumber].Strings.Length[stringid] == stringcount&&middlebyte==0)
                        {
                            this.txtSID = Maps.map[mapnumber].Strings.Name[stringid];
                        }
                        
                        ConvertBytesToBoolArray(bytes);
                        goto case 2;
                    }
                case 8:
                    int temp1 = BitConverter.ToInt32(bytes, 0);
                    int temp2 = BitConverter.ToInt32(bytes, 4);
                    int rcount = temp1 & 0xFFFF;
                    int rzero = (rcount >> 8) & 0xFF;
                    rcount = rcount & 0xFF;
                    int rtranslation = temp2 - meta.magic;
                    int tagnumx = Maps.map[mapnumber].Functions.Meta.FindMetaByOffset(rtranslation, mapnumber);
                    
                    if (tagnumx != -1 && rzero == 0)
                    {
                        rtranslation -= Maps.map[mapnumber].MetaInfo.Offset[tagnumx];
                        this.txtReflexiveCount = rcount.ToString();
                        this.txtReflexiveTagType = Maps.map[mapnumber].MetaInfo.TagType[tagnumx];
                        this.txtReflexiveTagName = Maps.map[mapnumber].FileNames.Name[tagnumx];
                        this.txtReflexiveTranslation = rtranslation.ToString();
                    }
                    goto case 4;
                default:
                    {
                        if (bytes.Length > 8)
                            goto case 8;
                        if (bytes.Length > 4)
                            goto case 4;
                        break;
                    }
            }
            UpdateTxtbInfo();
        }
        private void ClearTxt()
        {
            txtBitmask = "";
            txtByte = "";
            txtUByte = "";
            txtShort = "";
            txtUShort = "";
            txtLong = "";
            txtULong = "";
            txtFloat = "";
            txtIdentTagType = "";
            txtIdentName = "";
            txtSID = "";
            txtReflexiveCount = "";
            txtReflexiveTagName = "";
            txtReflexiveTagType="";
            txtReflexiveTranslation="";
        }
        private void UpdateTxtbInfo()
        {
            txtbInfo.Text = "Unsigned Byte      " + txtUByte + '\n'
                + "Signed Byte        " + txtByte + '\n'
                + "Unsigned Short     " + txtUShort + '\n'
                + "Signed Short       " + txtShort + '\n'
                + "Unsigned Long      " + txtULong + '\n'
                + "Signed Long        " + txtLong + '\n'
                + "Float              " + txtFloat + '\n'
                + "Bitmask            " + txtBitmask + '\n'
                + "Ident Tag Type     " + txtIdentTagType + '\n'
                + "Ident Name         " + txtIdentName + '\n'
                + "SID                " + txtSID + '\n'
                + "Reflexive - Count  " + txtReflexiveCount + '\n'
                + "Points To - Type   " + txtReflexiveTagType + '\n'
                + "Points To - Name   " + txtReflexiveTagName + '\n'
                + "Points To - Offset " + txtReflexiveTranslation;
        }
        public int GetOffsetInMeta()
        {
            return -1;
        }
        private void ConvertBytesToBoolArray(byte[] bytes)
        {
            bool[] bitArray = new bool[32];
            int input = BitConverter.ToInt32(bytes, 0);
            int bittester = 1;
            for (int counter = 0; counter < 32; counter++)
            {
                bitArray[counter] = (input & bittester) > 0 ? true : false;
                bittester *= 2;
            }
            MakeBinaryStringFromBoolArray(bitArray);
        }
        private void MakeBinaryStringFromBoolArray(bool[] bits)
        {
            txtBitmask = "";
            for (int counter = 0; counter < bits.Length; counter++)
            {
                txtBitmask += bits[counter] == true ? "1" : "0";
            }
        }
        private sbyte ConvertBytesTosbyte(byte[] bytes)
        {
            return (sbyte)bytes[0];
        }

        private void OffsetUpdater(int value)
        {

            string tempstring;
            string[] offsets = new string[16];
            for (int counter = 0; counter < 16; counter++)
            {
               // offsets[counter] = (value * 10 + counter * 10).ToString().PadLeft(11, '0');
                offsets[counter] = (value + (counter * 10)).ToString("X").PadLeft(11, '0');
            }

            tempstring = offsets[0];
            for (int counter = 1; counter < 16; counter++)
            {
                tempstring += System.Environment.NewLine+offsets[counter];
            }
            txtbOffsets.Text = tempstring;
        }

        //Thanks to neilck over at the code project for these 3 functions (GetBytes, IsHexDigit and HexToByte)
        public static byte[] GetBytes(string hexString)
        {
            string newString = "";
            char c;
            // remove all none A-F, 0-9, characters
            for (int i = 0; i < hexString.Length; i++)
            {
                c = hexString[i];
                if (IsHexDigit(c))
                    newString += c;
            }
            // if odd number of characters, discard last character
            if (newString.Length % 2 != 0)
            {
                newString = newString.Substring(0, newString.Length - 1);
            }

            int byteLength = newString.Length / 2;
            byte[] bytes = new byte[byteLength];
            string hex;
            int j = 0;
            for (int i = 0; i < bytes.Length; i++)
            {
                hex = new String(new Char[] { newString[j], newString[j + 1] });
                bytes[i] = HexToByte(hex);
                j += 2;
            }
            return bytes;
        }
        private static bool IsHexDigit(Char c)
        {
            int numChar;
            int numA = Convert.ToInt32('A');
            int num1 = Convert.ToInt32('0');
            c = Char.ToUpper(c);
            numChar = Convert.ToInt32(c);
            if (numChar >= numA && numChar < (numA + 6))
                return true;
            if (numChar >= num1 && numChar < (num1 + 10))
                return true;
            return false;
        }
        private static byte HexToByte(string hex)
        {
            if (hex.Length > 2 || hex.Length <= 0)
                throw new ArgumentException("hex must be 1 or 2 characters in length");
            byte newByte = byte.Parse(hex, System.Globalization.NumberStyles.HexNumber);
            return newByte;
        }

   

        private void txtbHexViewer_MouseClick(object sender, MouseEventArgs e)
        {
            selectionoffset = this.Offset+this.txtbHexViewer.SelectionStart;
            selectionlength = this.txtbHexViewer.SelectionLength;
        }

        private void saveToolStripMenuItem_Click(object sender, EventArgs e)
        {
            FileStream fs = new FileStream(this.filePath,FileMode.Open);
            BinaryWriter BW = new BinaryWriter(fs);
            BW.BaseStream.Position = meta.offset;
            BW.Write(this.txtbHexViewer.ByteArray);
            BW.Close();
            fs.Close();
        }

  
        private void txtbHexViewer_TextChanged(object sender, EventArgs e)
        {
            Colorize();
        }

        private void goToToolStripMenuItem_Click(object sender, EventArgs e)
        {
            gt.ShowDialog();
            if (gt.DialogResult != DialogResult.Cancel)
            {
                this.Offset = gt.Offset;
                this.txtbHexViewer.LoadHex(this.Offset);
                this.OffsetUpdater(this.Offset);
               
                vScrollBar1.Value = this.Offset / 10;
                this.txtbHexViewer.SelectionLength = 0;
                this.txtbHexViewer.SelectionStart = 0;
            }
        }

        private void HexView_KeyDown(object sender, KeyEventArgs e)
        {
      
        }

        private void txtbHexViewer_KeyDown(object sender, KeyEventArgs e)
        {
         
        }

        private void txtbHexViewer_KeyPress(object sender, KeyPressEventArgs e)
        {
            
           // if (e. == Keys.G && e.Control == true)
           // {
             //   gt.ShowDialog();
              //  if (gt.DialogResult != DialogResult.Cancel)
             //   {
           ///  ///       this.Offset = gt.Offset;
           //         this.txtbHexViewer.LoadHex(this.Offset);
           //         this.OffsetUpdater(this.Offset);
           //     }
           // }
        }

    }
}
