using System;
using System.Drawing;
using System.Collections;
using System.IO;
using System.Collections.Generic;
using System.ComponentModel;
using System.Windows.Forms;
using entity.Forms;
namespace entity
{
    /// <summary>
    /// Summary description for MapForm.
    /// </summary>
    /// 

    public class MapForm : System.Windows.Forms.Form
    {
        public int mapnumber;

        //public Map info;
        public FormFunctions ff = new FormFunctions();
        public MetaScanner metaScanner = new MetaScanner();

        public FormFunctions.MetaView metaView = FormFunctions.MetaView.TagTypeView;

        private IContainer components;
        private System.Windows.Forms.TreeView treeView1;
        private System.Windows.Forms.SaveFileDialog saveMetaDialog;
        private System.Windows.Forms.OpenFileDialog loadMetaDialog;
        private System.Windows.Forms.FolderBrowserDialog folderBrowserDialog;
        private System.Windows.Forms.OpenFileDialog openInfoFileDialog;
        private System.Windows.Forms.ContextMenu displayMenu;
        private System.Windows.Forms.MenuItem menuItem1;
        private System.Windows.Forms.MenuItem ShowReflex;
        private System.Windows.Forms.MenuItem ShowString;
        private System.Windows.Forms.MenuItem ShowIdent;
        private System.Windows.Forms.MenuItem SwapItem;
        private StatusStrip statusStrip1;
        private ToolStripProgressBar progressbar;
        private ToolStripStatusLabel statusbar;
        private ListView references;
        private ColumnHeader refs;
        private Panel panel2;
        private PictureBox pictureBox1;
        private RichTextBox secondaryMagicBox;
        private RichTextBox primaryMagicBox;
        private Label label4;
        private Label label6;
        private Panel panel3;
        private CheckBox recursiveCheckBox;
        private CheckBox parsedCheckBox;
        private Button loadMetaButton;
        private Button saveMetaButton;
        private RichTextBox metaTypeBox;
        private Label label2;
        private RichTextBox metaIdentBox;
        private RichTextBox metaSizeBox;
        private RichTextBox metaOffsetBox;
        private Label label5;
        private Label label3;
        private Label label1;
        private Button signMapButton;
        private Button analyzeMapButton;
        private Button buildButton;
        public SplitContainer splitContainer1;
        private SplitContainer splitContainer2;
        private Panel MetaEditorPanel;
        private ToolStripContainer toolStripContainer1;
        private ToolStrip toolStrip1;
        private ToolStripDropDownButton toolStripDropDownButton1;
        private ToolStripMenuItem referenceEditorToolStripMenuItem;
        private ToolStripDropDownButton toolStripDropDownButton2;
        private ToolStripMenuItem metaTreeToolStripMenuItem;
        private ToolStripMenuItem toolsToolStripMenuItem;
        private ToolStripMenuItem metaEditorToolStripMenuItem;
        private ToolStripProgressBar toolStripProgressBar1;
        private MenuItem chunkclone;
        private ContextMenuStrip treeviewcontext;
        private ToolStripMenuItem renameToolStripMenuItem;
        private ToolStripMenuItem duplicateToolStripMenuItem;
        private ToolStripMenuItem duplicateRecursivelyToolStripMenuItem;
        private HexView hexView1;
        private ToolStripMenuItem hexEditorToolStripMenuItem;
        private ToolStripMenuItem sortByToolStripMenuItem;
        private ToolStripMenuItem tagTypeToolStripMenuItem;
        private ToolStripMenuItem folderHierarchyToolStripMenuItem;
        private ToolStripMenuItem rebuilderToolStripMenuItem;
        private CheckBox soundsCheckBox;
        private ToolStripMenuItem overwriteMetaToolStripMenuItem;
        private ContextMenuStrip BitmapContextStrip;
        private ToolStripMenuItem saveBitmapToolStripMenuItem;
        private SaveFileDialog saveBitmapDialog1;
        private ToolStripDropDownButton rawDataDropDown;
        private ContextMenuStrip ModelContextStrip;
        private ToolStripMenuItem exportModelToolStripMenuItem;
        private ContextMenuStrip BSPcontextMenu;
        private ToolStripMenuItem exportOBJToolStripMenuItem;
        private ContextMenuStrip collContextMenu;
        private ToolStripMenuItem extractMeshToOBJToolStripMenuItem;
        private ToolStripMenuItem collisonViewerToolStripMenuItem;
        private CheckBox scanbspwithifp;
        private ToolStripMenuItem exportMeshToolStripMenuItem;
        private ToolStripMenuItem expandMeshX3ToolStripMenuItem;
        private SaveFileDialog saveFileDialog1;
        private ToolStripMenuItem toOBJToolStripMenuItem;
        private ToolStripMenuItem toXToolStripMenuItem;
        private ToolStripMenuItem bSPCollisionToolStripMenuItem;
        private ToolStripMenuItem toolStripMenuItem2;
        private ToolStripMenuItem exportCollisonToOBJToolStripMenuItem;
        private ToolStripMenuItem bspcollisionViewerToolStripMenuItem;
        private ToolStripMenuItem makeBSPStickyToolStripMenuItem;
        private ToolStripMenuItem fixSystemLinkToolStripMenuItem;
        private ToolStripMenuItem injectMeshesToolStripMenuItem;
        private ToolStripMenuItem injectOBJToolStripMenuItem;
        private ToolStripMenuItem portalsToolStripMenuItem;
        private ToolStripMenuItem portalViewerToolStripMenuItem;
        private ToolStripMenuItem convertCEToH2ToolStripMenuItem;
        private Panel LibraryPanel;
        private Button button1;
        private ToolStripMenuItem pluginsToolStripMenuItem;
        private ToolStripMenuItem injectBitmapToolStripMenuItem;
        private PluginManager plugins = new PluginManager();
        private ToolStripMenuItem convertToBumpMapToolStripMenuItem;
        private entity.Forms.Meta_Editor.MetaEditor ME;
        public Feline_rawr.RTHData RTHInfo;
        private TextBox XboxIP;
        private Button buttDisconnect;
        private Button buttConnect;
        private ToolStripMenuItem injectBSPVisualMeshToolStripMenuItem;
        private ToolStripMenuItem exportMeshToOBJToolStripMenuItem;
        private ContextMenuStrip prtmcontext;
        private ToolStripMenuItem viewPRTMToolStripMenuItem;
        private ToolStripMenuItem extractPRTMOBJToolStripMenuItem;
        private OpenFileDialog openBitmapDialog1;
        private ToolStripMenuItem viewBSPToolStripMenuItem;
        private ToolStripMenuItem viewModelToolStripMenuItem;
        private Panel ltmpTools;
        private ToolStripMenuItem bitmapEditorToolStripMenuItem;
        private ToolStripMenuItem exportScriptsToolStripMenuItem;
        private MenuItem menuItem2;
        private int selectedplugin = -1;

        public MapForm()
        {
            InitializeComponent();
        }

        public void LoadSkin()
        {


            #region Declarations
            Color Skin_Panel2_Color = this.panel2.BackColor;
            Color Skin_Panel2_Text_Color = label4.ForeColor;
            Color Skin_Panel2_Button_Color = signMapButton.BackColor;
            Color Skin_Panel2_ButtonText_Color = signMapButton.ForeColor;
            Color Skin_Panel2_DisconnectButton_Color = buttDisconnect.BackColor;
            Color Skin_Panel2_DisconnectButton_TextColor = buttDisconnect.ForeColor;
            Color Skin_Panel3_Color = this.panel3.BackColor;
            Color Skin_Panel3_Text_Color = metaOffsetBox.ForeColor;
            Color Skin_Panel3_Button_Color = saveMetaButton.BackColor;
            Color Skin_Panel3_ButtonText_Color = saveMetaButton.ForeColor;
            Color Skin_LibraryPanel_Color = this.LibraryPanel.BackColor;
            Color Skin_LibraryPanel_Text_Color = this.references.ForeColor;
            Color Skin_Treeview1_Background_Color = treeView1.BackColor;
            Color Skin_Treeview1_Text_Color = treeView1.ForeColor;



            System.IO.StreamReader SettingsStreamReader = new System.IO.StreamReader(Application.StartupPath + "\\Skins\\Settings.xml");
            System.Xml.XmlTextReader SettingsXMLReader = new System.Xml.XmlTextReader(SettingsStreamReader);
            System.Xml.XmlDocument settingsxmlreader = new System.Xml.XmlDocument();
            settingsxmlreader.Load(SettingsXMLReader);
            System.Xml.XmlNodeList settingsnodelist = settingsxmlreader.SelectNodes("skin/settings");
            //Use Skin
            System.Xml.XmlNode SettingsInfo = settingsnodelist.Item(0).SelectSingleNode("Use_Skin");
            string Use_Skin = SettingsInfo.InnerText.ToString();
            //Skin Path
            SettingsInfo = settingsnodelist.Item(0).SelectSingleNode("Skin_Path");
            string Skin_Path = Application.StartupPath + "\\skins\\" + SettingsInfo.InnerText.ToString();
            SettingsStreamReader.Close();


            if (Use_Skin == "true")
            {

            #endregion

                #region XMLReader
                if (System.IO.File.Exists(Skin_Path) == true)
                {

                    System.IO.StreamReader sr = new StreamReader(Skin_Path);
                    System.Xml.XmlTextReader xr = new System.Xml.XmlTextReader(sr);
                    System.Xml.XmlDocument settingsxml = new System.Xml.XmlDocument();
                    settingsxml.Load(xr);
                    System.Xml.XmlNodeList FormSettingsXmlNode = settingsxml.SelectNodes("skin/settings");
                    System.Xml.XmlNode colorfinder = FormSettingsXmlNode.Item(0).SelectSingleNode("Skin_Panel2_Color");
                    Skin_Panel2_Color = Color.FromArgb(Convert.ToInt32(colorfinder.InnerText.ToString()));
                    colorfinder = FormSettingsXmlNode.Item(0).SelectSingleNode("Skin_Panel2_Text_Color");
                    Skin_Panel2_Text_Color = Color.FromArgb(Convert.ToInt32(colorfinder.InnerText.ToString()));
                    colorfinder = FormSettingsXmlNode.Item(0).SelectSingleNode("Skin_Panel2_Button_Color");
                    Skin_Panel2_Button_Color = Color.FromArgb(Convert.ToInt32(colorfinder.InnerText.ToString()));
                    colorfinder = FormSettingsXmlNode.Item(0).SelectSingleNode("Skin_Panel2_ButtonText_Color");
                    Skin_Panel2_ButtonText_Color = Color.FromArgb(Convert.ToInt32(colorfinder.InnerText.ToString()));
                    colorfinder = FormSettingsXmlNode.Item(0).SelectSingleNode("Skin_Panel2_DisconnectButton_Color");
                    Skin_Panel2_DisconnectButton_Color = Color.FromArgb(Convert.ToInt32(colorfinder.InnerText.ToString()));
                    colorfinder = FormSettingsXmlNode.Item(0).SelectSingleNode("Skin_Panel2_DisconnectButton_TextColor");
                    Skin_Panel2_DisconnectButton_TextColor = Color.FromArgb(Convert.ToInt32(colorfinder.InnerText.ToString()));
                    colorfinder = FormSettingsXmlNode.Item(0).SelectSingleNode("Skin_Panel3_Color");
                    Skin_Panel3_Color = Color.FromArgb(Convert.ToInt32(colorfinder.InnerText.ToString()));
                    colorfinder = FormSettingsXmlNode.Item(0).SelectSingleNode("Skin_Panel3_Text_Color");
                    Skin_Panel3_Text_Color = Color.FromArgb(Convert.ToInt32(colorfinder.InnerText.ToString()));
                    colorfinder = FormSettingsXmlNode.Item(0).SelectSingleNode("Skin_Panel3_Button_Color");
                    Skin_Panel3_Button_Color = Color.FromArgb(Convert.ToInt32(colorfinder.InnerText.ToString()));
                    colorfinder = FormSettingsXmlNode.Item(0).SelectSingleNode("Skin_Panel3_ButtonText_Color");
                    Skin_Panel3_ButtonText_Color = Color.FromArgb(Convert.ToInt32(colorfinder.InnerText.ToString()));
                    colorfinder = FormSettingsXmlNode.Item(0).SelectSingleNode("Skin_LibraryPanel_Color");
                    Skin_LibraryPanel_Color = Color.FromArgb(Convert.ToInt32(colorfinder.InnerText.ToString()));
                    colorfinder = FormSettingsXmlNode.Item(0).SelectSingleNode("Skin_LibraryPanel_Text_Color");
                    Skin_LibraryPanel_Text_Color = Color.FromArgb(Convert.ToInt32(colorfinder.InnerText.ToString()));
                    colorfinder = FormSettingsXmlNode.Item(0).SelectSingleNode("Skin_Treeview1_Background_Color");
                    Skin_Treeview1_Background_Color = Color.FromArgb(Convert.ToInt32(colorfinder.InnerText.ToString()));
                    colorfinder = FormSettingsXmlNode.Item(0).SelectSingleNode("Skin_Treeview1_Text_Color");
                    Skin_Treeview1_Text_Color = Color.FromArgb(Convert.ToInt32(colorfinder.InnerText.ToString()));
                    sr.Close();

                #endregion

                    #region Panel2Shit
                    //Set up the Panel Color
                    this.panel2.BackColor = Skin_Panel2_Color;
                    primaryMagicBox.BackColor = Skin_Panel2_Color;
                    secondaryMagicBox.BackColor = Skin_Panel2_Color;
                    splitContainer1.BackColor = Skin_Panel2_Color;
                    this.BackColor = Skin_Panel2_Color;
                    //Set all the font color
                    label4.ForeColor = Skin_Panel2_Text_Color;
                    label6.ForeColor = Skin_Panel2_Text_Color;
                    primaryMagicBox.ForeColor = Skin_Panel2_Text_Color;
                    secondaryMagicBox.ForeColor = Skin_Panel2_Text_Color;
                    //Set the button color
                    signMapButton.BackColor = Skin_Panel2_Button_Color;
                    buildButton.BackColor = Skin_Panel2_Button_Color;
                    button1.BackColor = Skin_Panel2_Button_Color;
                    analyzeMapButton.BackColor = Skin_Panel2_Button_Color;
                    buttConnect.BackColor = Skin_Panel2_Button_Color;
                    //Set the button font color
                    signMapButton.ForeColor = Skin_Panel2_ButtonText_Color;
                    buildButton.ForeColor = Skin_Panel2_ButtonText_Color;
                    button1.ForeColor = Skin_Panel2_ButtonText_Color;
                    analyzeMapButton.ForeColor = Skin_Panel2_ButtonText_Color;
                    buttConnect.ForeColor = Skin_Panel2_ButtonText_Color;
                    //Set the disconnect button color and font
                    buttDisconnect.BackColor = Skin_Panel2_DisconnectButton_Color;
                    buttDisconnect.ForeColor = Skin_Panel2_DisconnectButton_TextColor;
                    #endregion

                    #region Panel3Shit
                    //Set up the Panel Color
                    this.panel3.BackColor = Skin_Panel3_Color;
                    metaOffsetBox.BackColor = Skin_Panel3_Color;
                    metaSizeBox.BackColor = Skin_Panel3_Color;
                    metaIdentBox.BackColor = Skin_Panel3_Color;
                    metaTypeBox.BackColor = Skin_Panel3_Color;
                    //Set up the font color
                    label1.ForeColor = Skin_Panel3_Text_Color;
                    label2.ForeColor = Skin_Panel3_Text_Color;
                    label3.ForeColor = Skin_Panel3_Text_Color;
                    label5.ForeColor = Skin_Panel3_Text_Color;
                    metaOffsetBox.ForeColor = Skin_Panel3_Text_Color;
                    metaSizeBox.ForeColor = Skin_Panel3_Text_Color;
                    metaIdentBox.ForeColor = Skin_Panel3_Text_Color;
                    metaTypeBox.ForeColor = Skin_Panel3_Text_Color;
                    recursiveCheckBox.ForeColor = Skin_Panel3_Text_Color;
                    parsedCheckBox.ForeColor = Skin_Panel3_Text_Color;
                    soundsCheckBox.ForeColor = Skin_Panel3_Text_Color;
                    scanbspwithifp.ForeColor = Skin_Panel3_Text_Color;
                    recursiveCheckBox.BackColor = Skin_Panel3_Color;
                    parsedCheckBox.BackColor = Skin_Panel3_Color;
                    soundsCheckBox.BackColor = Skin_Panel3_Color;
                    scanbspwithifp.BackColor = Skin_Panel3_Color;
                    //Set up the button color
                    saveMetaButton.BackColor = Skin_Panel3_Button_Color;
                    loadMetaButton.BackColor = Skin_Panel3_Button_Color;
                    //Set up the button text color
                    saveMetaButton.ForeColor = Skin_Panel3_ButtonText_Color;
                    loadMetaButton.ForeColor = Skin_Panel3_ButtonText_Color;

                    #endregion

                    #region LibraryPanelShit
                    //Set up the panel color
                    this.LibraryPanel.BackColor = Skin_LibraryPanel_Color;
                    references.BackColor = Skin_LibraryPanel_Color;
                    references.ForeColor = Skin_LibraryPanel_Text_Color;
                    ltmpTools.BackColor = Skin_LibraryPanel_Color;
                    #endregion

                    #region Treeview1Shit
                    //Set up the treeview background color
                    treeView1.BackColor = Skin_Treeview1_Background_Color;
                    //Set up the treeview font color
                    treeView1.ForeColor = Skin_Treeview1_Text_Color;
                    #endregion
                }
            }
        }

        public MapForm(string path)
        {


            RTHInfo = new Feline_rawr.RTHData();
            InitializeComponent();

            try
            {
                LoadSkin();
            }
            catch (Exception ex)
            {
                MessageBox.Show("There was an error while loading the skin.\n" + ex.Message);
            }

            this.mapnumber = Maps.Add(path);
            if (mapnumber == -1) { this.Close(); return; }
            primaryMagicBox.Text = Maps.map[this.mapnumber].PrimaryMagic.ToString("X");
            secondaryMagicBox.Text = Maps.map[this.mapnumber].SecondaryMagic.ToString("X");
            ff.AddMetasToTreeView(Maps.map[this.mapnumber], treeView1, metaView, false);
            plugins.Plugin.Add(Application.StartupPath + "\\Libraries");
            AddPlugins();
            if (Maps.map[this.mapnumber].HaloVersion == Map.HaloVersionEnum.Halo2) DisplayMapBitmap();
            ff.AddColumnsToListView(references, Maps.map[mapnumber].DisplayType);
            //ff.AddTagTypesToComboBox(info,tagTypeComboBox);

        }


        public void AddPlugins()
        {

            pluginsToolStripMenuItem.DropDownItems.Clear();
            string type = "22222gfdgfdgdfgdfgdfgfdgfdgdg";
            if (Maps.map[mapnumber].SelectedMeta != null) type = Maps.map[mapnumber].SelectedMeta.type;
            for (int x = 0; x < plugins.Plugin.Count; x++)
            {


                if (plugins.Plugin[x].tagtype == "*.*" || plugins.Plugin[x].tagtype == "!*.*" || plugins.Plugin[x].tagtype == type)
                {
                    pluginsToolStripMenuItem.DropDownItems.Add(plugins.Plugin[x].GetName());
                    pluginsToolStripMenuItem.DropDownItems[pluginsToolStripMenuItem.DropDownItems.Count - 1].Click += new EventHandler(pluginToolStripMenuItemdescription_Click);
                }
            }

        }

        void pluginToolStripMenuItemdescription_Click(object sender, EventArgs e)
        {


            for (int x = 0; x < plugins.Plugin.Count; x++)
            {

                if (plugins.Plugin[x].PluginName == ((ToolStripDropDownItem)sender).Text)
                {
                    selectedplugin = x;
                    referenceEditorToolStripMenuItem.Checked = false;
                    metaEditorToolStripMenuItem.Checked = false;
                    hexEditorToolStripMenuItem.Checked = false;
                    LibraryPanel.Controls.Clear();
                    Application.DoEvents();
                    plugins.Plugin[x].Run(mapnumber, ref progressbar);
                    LibraryPanel.Controls.Add(plugins.Plugin[x]);
                    MetaEditorPanel.Visible = false;
                    hexView1.Visible = false;
                    references.Visible = false;
                    LibraryPanel.Visible = true;
                    break;
                }

            }

        }


        /// <summary>
        /// Clean up any resources being used.
        /// </summary>
        protected override void Dispose(bool disposing)
        {
            if (disposing)
            {
                if (components != null)
                {
                    components.Dispose();
                }
            }
            base.Dispose(disposing);
        }

        #region Windows Form Designer generated code
        /// <summary>
        /// Required method for Designer support - do not modify
        /// the contents of this method with the code editor.
        /// </summary>
        private void InitializeComponent()
        {
            this.components = new System.ComponentModel.Container();
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(MapForm));
            this.treeView1 = new System.Windows.Forms.TreeView();
            this.treeviewcontext = new System.Windows.Forms.ContextMenuStrip(this.components);
            this.renameToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
            this.duplicateToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
            this.duplicateRecursivelyToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
            this.sortByToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
            this.tagTypeToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
            this.folderHierarchyToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
            this.overwriteMetaToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
            this.convertCEToH2ToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
            this.saveMetaDialog = new System.Windows.Forms.SaveFileDialog();
            this.loadMetaDialog = new System.Windows.Forms.OpenFileDialog();
            this.folderBrowserDialog = new System.Windows.Forms.FolderBrowserDialog();
            this.openInfoFileDialog = new System.Windows.Forms.OpenFileDialog();
            this.displayMenu = new System.Windows.Forms.ContextMenu();
            this.SwapItem = new System.Windows.Forms.MenuItem();
            this.menuItem2 = new System.Windows.Forms.MenuItem();
            this.menuItem1 = new System.Windows.Forms.MenuItem();
            this.ShowReflex = new System.Windows.Forms.MenuItem();
            this.ShowIdent = new System.Windows.Forms.MenuItem();
            this.ShowString = new System.Windows.Forms.MenuItem();
            this.chunkclone = new System.Windows.Forms.MenuItem();
            this.statusStrip1 = new System.Windows.Forms.StatusStrip();
            this.progressbar = new System.Windows.Forms.ToolStripProgressBar();
            this.statusbar = new System.Windows.Forms.ToolStripStatusLabel();
            this.references = new System.Windows.Forms.ListView();
            this.refs = new System.Windows.Forms.ColumnHeader();
            this.panel2 = new System.Windows.Forms.Panel();
            this.buttDisconnect = new System.Windows.Forms.Button();
            this.buttConnect = new System.Windows.Forms.Button();
            this.XboxIP = new System.Windows.Forms.TextBox();
            this.button1 = new System.Windows.Forms.Button();
            this.toolStripContainer1 = new System.Windows.Forms.ToolStripContainer();
            this.toolStrip1 = new System.Windows.Forms.ToolStrip();
            this.toolStripDropDownButton1 = new System.Windows.Forms.ToolStripDropDownButton();
            this.referenceEditorToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
            this.metaEditorToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
            this.hexEditorToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
            this.rebuilderToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
            this.fixSystemLinkToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
            this.pluginsToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
            this.exportScriptsToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
            this.toolStripDropDownButton2 = new System.Windows.Forms.ToolStripDropDownButton();
            this.metaTreeToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
            this.toolsToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
            this.rawDataDropDown = new System.Windows.Forms.ToolStripDropDownButton();
            this.pictureBox1 = new System.Windows.Forms.PictureBox();
            this.BitmapContextStrip = new System.Windows.Forms.ContextMenuStrip(this.components);
            this.saveBitmapToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
            this.injectBitmapToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
            this.convertToBumpMapToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
            this.bitmapEditorToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
            this.secondaryMagicBox = new System.Windows.Forms.RichTextBox();
            this.primaryMagicBox = new System.Windows.Forms.RichTextBox();
            this.label4 = new System.Windows.Forms.Label();
            this.label6 = new System.Windows.Forms.Label();
            this.panel3 = new System.Windows.Forms.Panel();
            this.scanbspwithifp = new System.Windows.Forms.CheckBox();
            this.soundsCheckBox = new System.Windows.Forms.CheckBox();
            this.recursiveCheckBox = new System.Windows.Forms.CheckBox();
            this.parsedCheckBox = new System.Windows.Forms.CheckBox();
            this.loadMetaButton = new System.Windows.Forms.Button();
            this.saveMetaButton = new System.Windows.Forms.Button();
            this.metaTypeBox = new System.Windows.Forms.RichTextBox();
            this.label2 = new System.Windows.Forms.Label();
            this.metaIdentBox = new System.Windows.Forms.RichTextBox();
            this.metaSizeBox = new System.Windows.Forms.RichTextBox();
            this.metaOffsetBox = new System.Windows.Forms.RichTextBox();
            this.label5 = new System.Windows.Forms.Label();
            this.label3 = new System.Windows.Forms.Label();
            this.label1 = new System.Windows.Forms.Label();
            this.signMapButton = new System.Windows.Forms.Button();
            this.analyzeMapButton = new System.Windows.Forms.Button();
            this.buildButton = new System.Windows.Forms.Button();
            this.splitContainer1 = new System.Windows.Forms.SplitContainer();
            this.splitContainer2 = new System.Windows.Forms.SplitContainer();
            this.MetaEditorPanel = new System.Windows.Forms.Panel();
            this.ME = new entity.Forms.Meta_Editor.MetaEditor();
            this.LibraryPanel = new System.Windows.Forms.Panel();
            this.hexView1 = new entity.Forms.HexView();
            this.ltmpTools = new System.Windows.Forms.Panel();
            this.toolStripProgressBar1 = new System.Windows.Forms.ToolStripProgressBar();
            this.saveBitmapDialog1 = new System.Windows.Forms.SaveFileDialog();
            this.ModelContextStrip = new System.Windows.Forms.ContextMenuStrip(this.components);
            this.viewModelToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
            this.exportModelToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
            this.toOBJToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
            this.toXToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
            this.exportMeshToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
            this.injectMeshesToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
            this.injectOBJToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
            this.BSPcontextMenu = new System.Windows.Forms.ContextMenuStrip(this.components);
            this.viewBSPToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
            this.exportOBJToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
            this.bSPCollisionToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
            this.toolStripMenuItem2 = new System.Windows.Forms.ToolStripMenuItem();
            this.exportCollisonToOBJToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
            this.bspcollisionViewerToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
            this.expandMeshX3ToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
            this.makeBSPStickyToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
            this.portalsToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
            this.portalViewerToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
            this.injectBSPVisualMeshToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
            this.exportMeshToOBJToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
            this.collContextMenu = new System.Windows.Forms.ContextMenuStrip(this.components);
            this.extractMeshToOBJToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
            this.collisonViewerToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
            this.saveFileDialog1 = new System.Windows.Forms.SaveFileDialog();
            this.prtmcontext = new System.Windows.Forms.ContextMenuStrip(this.components);
            this.viewPRTMToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
            this.extractPRTMOBJToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
            this.openBitmapDialog1 = new System.Windows.Forms.OpenFileDialog();
            this.treeviewcontext.SuspendLayout();
            this.statusStrip1.SuspendLayout();
            this.panel2.SuspendLayout();
            this.toolStripContainer1.TopToolStripPanel.SuspendLayout();
            this.toolStripContainer1.SuspendLayout();
            this.toolStrip1.SuspendLayout();
            ((System.ComponentModel.ISupportInitialize)(this.pictureBox1)).BeginInit();
            this.BitmapContextStrip.SuspendLayout();
            this.panel3.SuspendLayout();
            this.splitContainer1.Panel1.SuspendLayout();
            this.splitContainer1.Panel2.SuspendLayout();
            this.splitContainer1.SuspendLayout();
            this.splitContainer2.Panel1.SuspendLayout();
            this.splitContainer2.Panel2.SuspendLayout();
            this.splitContainer2.SuspendLayout();
            this.MetaEditorPanel.SuspendLayout();
            this.ModelContextStrip.SuspendLayout();
            this.BSPcontextMenu.SuspendLayout();
            this.collContextMenu.SuspendLayout();
            this.prtmcontext.SuspendLayout();
            this.SuspendLayout();
            // 
            // treeView1
            // 
            this.treeView1.AllowDrop = true;
            this.treeView1.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
            this.treeView1.ContextMenuStrip = this.treeviewcontext;
            this.treeView1.Dock = System.Windows.Forms.DockStyle.Fill;
            this.treeView1.Location = new System.Drawing.Point(0, 0);
            this.treeView1.Name = "treeView1";
            this.treeView1.Size = new System.Drawing.Size(303, 593);
            this.treeView1.TabIndex = 0;
            this.treeView1.DragDrop += new System.Windows.Forms.DragEventHandler(this.treeView1_DragDrop);
            this.treeView1.AfterSelect += new System.Windows.Forms.TreeViewEventHandler(this.treeView1_AfterSelect);
            this.treeView1.KeyPress += new System.Windows.Forms.KeyPressEventHandler(this.treeView1_KeyPress);
            this.treeView1.DragEnter += new System.Windows.Forms.DragEventHandler(this.treeView1_DragEnter);
            this.treeView1.ItemDrag += new System.Windows.Forms.ItemDragEventHandler(this.treeView1_ItemDrag);
            // 
            // treeviewcontext
            // 
            this.treeviewcontext.Items.AddRange(new System.Windows.Forms.ToolStripItem[] {
            this.renameToolStripMenuItem,
            this.duplicateToolStripMenuItem,
            this.duplicateRecursivelyToolStripMenuItem,
            this.sortByToolStripMenuItem,
            this.overwriteMetaToolStripMenuItem,
            this.convertCEToH2ToolStripMenuItem});
            this.treeviewcontext.Name = "treeviewcontext";
            this.treeviewcontext.Size = new System.Drawing.Size(188, 136);
            // 
            // renameToolStripMenuItem
            // 
            this.renameToolStripMenuItem.Name = "renameToolStripMenuItem";
            this.renameToolStripMenuItem.Size = new System.Drawing.Size(187, 22);
            this.renameToolStripMenuItem.Text = "Rename";
            this.renameToolStripMenuItem.Visible = false;
            // 
            // duplicateToolStripMenuItem
            // 
            this.duplicateToolStripMenuItem.Name = "duplicateToolStripMenuItem";
            this.duplicateToolStripMenuItem.Size = new System.Drawing.Size(187, 22);
            this.duplicateToolStripMenuItem.Text = "Duplicate";
            this.duplicateToolStripMenuItem.Click += new System.EventHandler(this.duplicateToolStripMenuItem_Click);
            // 
            // duplicateRecursivelyToolStripMenuItem
            // 
            this.duplicateRecursivelyToolStripMenuItem.Name = "duplicateRecursivelyToolStripMenuItem";
            this.duplicateRecursivelyToolStripMenuItem.Size = new System.Drawing.Size(187, 22);
            this.duplicateRecursivelyToolStripMenuItem.Text = "Duplicate Recursively";
            this.duplicateRecursivelyToolStripMenuItem.Click += new System.EventHandler(this.duplicateRecursivelyToolStripMenuItem_Click);
            // 
            // sortByToolStripMenuItem
            // 
            this.sortByToolStripMenuItem.DropDownItems.AddRange(new System.Windows.Forms.ToolStripItem[] {
            this.tagTypeToolStripMenuItem,
            this.folderHierarchyToolStripMenuItem});
            this.sortByToolStripMenuItem.Name = "sortByToolStripMenuItem";
            this.sortByToolStripMenuItem.Size = new System.Drawing.Size(187, 22);
            this.sortByToolStripMenuItem.Text = "Sort By";
            // 
            // tagTypeToolStripMenuItem
            // 
            this.tagTypeToolStripMenuItem.Checked = true;
            this.tagTypeToolStripMenuItem.CheckState = System.Windows.Forms.CheckState.Checked;
            this.tagTypeToolStripMenuItem.Name = "tagTypeToolStripMenuItem";
            this.tagTypeToolStripMenuItem.Size = new System.Drawing.Size(164, 22);
            this.tagTypeToolStripMenuItem.Text = "Tag Type";
            this.tagTypeToolStripMenuItem.Click += new System.EventHandler(this.tagTypeToolStripMenuItem_Click);
            // 
            // folderHierarchyToolStripMenuItem
            // 
            this.folderHierarchyToolStripMenuItem.Name = "folderHierarchyToolStripMenuItem";
            this.folderHierarchyToolStripMenuItem.Size = new System.Drawing.Size(164, 22);
            this.folderHierarchyToolStripMenuItem.Text = "Folder Hierarchy";
            this.folderHierarchyToolStripMenuItem.Click += new System.EventHandler(this.folderHierarchyToolStripMenuItem_Click);
            // 
            // overwriteMetaToolStripMenuItem
            // 
            this.overwriteMetaToolStripMenuItem.Name = "overwriteMetaToolStripMenuItem";
            this.overwriteMetaToolStripMenuItem.Size = new System.Drawing.Size(187, 22);
            this.overwriteMetaToolStripMenuItem.Text = "Overwrite Meta";
            this.overwriteMetaToolStripMenuItem.Visible = false;
            this.overwriteMetaToolStripMenuItem.Click += new System.EventHandler(this.overwriteMetaToolStripMenuItem_Click);
            // 
            // convertCEToH2ToolStripMenuItem
            // 
            this.convertCEToH2ToolStripMenuItem.Name = "convertCEToH2ToolStripMenuItem";
            this.convertCEToH2ToolStripMenuItem.Size = new System.Drawing.Size(187, 22);
            this.convertCEToH2ToolStripMenuItem.Text = "Convert CE to H2";
            this.convertCEToH2ToolStripMenuItem.Visible = false;
            this.convertCEToH2ToolStripMenuItem.Click += new System.EventHandler(this.convertCEToH2ToolStripMenuItem_Click);
            // 
            // openInfoFileDialog
            // 
            this.openInfoFileDialog.Filter = "Info File (*.info) | *.info";
            // 
            // displayMenu
            // 
            this.displayMenu.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.SwapItem,
            this.menuItem2,
            this.menuItem1,
            this.chunkclone});
            // 
            // SwapItem
            // 
            this.SwapItem.Index = 0;
            this.SwapItem.Text = "Swap";
            this.SwapItem.Click += new System.EventHandler(this.SwapItem_Click);
            // 
            // menuItem2
            // 
            this.menuItem2.Index = 1;
            this.menuItem2.Text = "Goto";
            this.menuItem2.Click += new System.EventHandler(this.menuItem2_Click);
            // 
            // menuItem1
            // 
            this.menuItem1.Index = 2;
            this.menuItem1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.ShowReflex,
            this.ShowIdent,
            this.ShowString});
            this.menuItem1.Text = "Display";
            // 
            // ShowReflex
            // 
            this.ShowReflex.Index = 0;
            this.ShowReflex.Text = "Reflexives";
            this.ShowReflex.Click += new System.EventHandler(this.ShowReflex_Click_1);
            // 
            // ShowIdent
            // 
            this.ShowIdent.Index = 1;
            this.ShowIdent.Text = "Idents";
            this.ShowIdent.Click += new System.EventHandler(this.ShowIdent_Click_1);
            // 
            // ShowString
            // 
            this.ShowString.Index = 2;
            this.ShowString.Text = "Strings";
            this.ShowString.Click += new System.EventHandler(this.ShowString_Click);
            // 
            // chunkclone
            // 
            this.chunkclone.Index = 3;
            this.chunkclone.Text = "Clone Chunk";
            this.chunkclone.Click += new System.EventHandler(this.chunkclone_Click);
            // 
            // statusStrip1
            // 
            this.statusStrip1.Items.AddRange(new System.Windows.Forms.ToolStripItem[] {
            this.progressbar,
            this.statusbar});
            this.statusStrip1.Location = new System.Drawing.Point(0, 571);
            this.statusStrip1.Name = "statusStrip1";
            this.statusStrip1.Size = new System.Drawing.Size(604, 22);
            this.statusStrip1.TabIndex = 13;
            this.statusStrip1.Text = "statusStrip1";
            // 
            // progressbar
            // 
            this.progressbar.Name = "progressbar";
            this.progressbar.Size = new System.Drawing.Size(200, 16);
            this.progressbar.Step = 1;
            this.progressbar.Style = System.Windows.Forms.ProgressBarStyle.Continuous;
            // 
            // statusbar
            // 
            this.statusbar.BackColor = System.Drawing.Color.LightGray;
            this.statusbar.BorderSides = ((System.Windows.Forms.ToolStripStatusLabelBorderSides)((((System.Windows.Forms.ToolStripStatusLabelBorderSides.Left | System.Windows.Forms.ToolStripStatusLabelBorderSides.Top)
                        | System.Windows.Forms.ToolStripStatusLabelBorderSides.Right)
                        | System.Windows.Forms.ToolStripStatusLabelBorderSides.Bottom)));
            this.statusbar.Name = "statusbar";
            this.statusbar.Size = new System.Drawing.Size(387, 17);
            this.statusbar.Spring = true;
            // 
            // references
            // 
            this.references.AllowColumnReorder = true;
            this.references.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
            this.references.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
            this.refs});
            this.references.Dock = System.Windows.Forms.DockStyle.Fill;
            this.references.GridLines = true;
            this.references.HeaderStyle = System.Windows.Forms.ColumnHeaderStyle.Nonclickable;
            this.references.Location = new System.Drawing.Point(0, 0);
            this.references.Name = "references";
            this.references.Size = new System.Drawing.Size(421, 571);
            this.references.TabIndex = 14;
            this.references.UseCompatibleStateImageBehavior = false;
            this.references.View = System.Windows.Forms.View.Details;
            this.references.MouseDown += new System.Windows.Forms.MouseEventHandler(this.references_MouseDown);
            // 
            // refs
            // 
            this.refs.Text = "References";
            this.refs.Width = 5000;
            // 
            // panel2
            // 
            this.panel2.BackColor = System.Drawing.Color.SteelBlue;
            this.panel2.Controls.Add(this.buttDisconnect);
            this.panel2.Controls.Add(this.buttConnect);
            this.panel2.Controls.Add(this.XboxIP);
            this.panel2.Controls.Add(this.button1);
            this.panel2.Controls.Add(this.toolStripContainer1);
            this.panel2.Controls.Add(this.pictureBox1);
            this.panel2.Controls.Add(this.secondaryMagicBox);
            this.panel2.Controls.Add(this.primaryMagicBox);
            this.panel2.Controls.Add(this.label4);
            this.panel2.Controls.Add(this.label6);
            this.panel2.Controls.Add(this.panel3);
            this.panel2.Controls.Add(this.signMapButton);
            this.panel2.Controls.Add(this.analyzeMapButton);
            this.panel2.Controls.Add(this.buildButton);
            this.panel2.Dock = System.Windows.Forms.DockStyle.Fill;
            this.panel2.Location = new System.Drawing.Point(0, 0);
            this.panel2.Name = "panel2";
            this.panel2.Size = new System.Drawing.Size(179, 571);
            this.panel2.TabIndex = 16;
            // 
            // buttDisconnect
            // 
            this.buttDisconnect.BackColor = System.Drawing.Color.OrangeRed;
            this.buttDisconnect.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
            this.buttDisconnect.Location = new System.Drawing.Point(92, 545);
            this.buttDisconnect.Name = "buttDisconnect";
            this.buttDisconnect.Size = new System.Drawing.Size(80, 23);
            this.buttDisconnect.TabIndex = 33;
            this.buttDisconnect.Text = "Disconnect";
            this.buttDisconnect.UseVisualStyleBackColor = false;
            this.buttDisconnect.Click += new System.EventHandler(this.buttDisconnect_Click);
            // 
            // buttConnect
            // 
            this.buttConnect.BackColor = System.Drawing.Color.CornflowerBlue;
            this.buttConnect.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
            this.buttConnect.Location = new System.Drawing.Point(7, 545);
            this.buttConnect.Name = "buttConnect";
            this.buttConnect.Size = new System.Drawing.Size(75, 23);
            this.buttConnect.TabIndex = 32;
            this.buttConnect.Text = "Connect";
            this.buttConnect.UseVisualStyleBackColor = false;
            this.buttConnect.Click += new System.EventHandler(this.buttConnect_Click);
            // 
            // XboxIP
            // 
            this.XboxIP.Location = new System.Drawing.Point(8, 519);
            this.XboxIP.Name = "XboxIP";
            this.XboxIP.Size = new System.Drawing.Size(164, 20);
            this.XboxIP.TabIndex = 31;
            this.XboxIP.Text = "Debug   Xbox\'s   IP   Address";
            // 
            // button1
            // 
            this.button1.BackColor = System.Drawing.Color.CornflowerBlue;
            this.button1.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
            this.button1.Location = new System.Drawing.Point(7, 489);
            this.button1.Name = "button1";
            this.button1.Size = new System.Drawing.Size(77, 23);
            this.button1.TabIndex = 30;
            this.button1.Text = "Check IFPs";
            this.button1.UseVisualStyleBackColor = false;
            this.button1.Click += new System.EventHandler(this.button1_Click);
            // 
            // toolStripContainer1
            // 
            // 
            // toolStripContainer1.ContentPanel
            // 
            this.toolStripContainer1.ContentPanel.Size = new System.Drawing.Size(179, 0);
            this.toolStripContainer1.Dock = System.Windows.Forms.DockStyle.Top;
            this.toolStripContainer1.Location = new System.Drawing.Point(0, 0);
            this.toolStripContainer1.Name = "toolStripContainer1";
            this.toolStripContainer1.Size = new System.Drawing.Size(179, 25);
            this.toolStripContainer1.TabIndex = 29;
            this.toolStripContainer1.Text = "toolStripContainer1";
            // 
            // toolStripContainer1.TopToolStripPanel
            // 
            this.toolStripContainer1.TopToolStripPanel.Controls.Add(this.toolStrip1);
            // 
            // toolStrip1
            // 
            this.toolStrip1.AutoSize = false;
            this.toolStrip1.Dock = System.Windows.Forms.DockStyle.None;
            this.toolStrip1.Items.AddRange(new System.Windows.Forms.ToolStripItem[] {
            this.toolStripDropDownButton1,
            this.toolStripDropDownButton2,
            this.rawDataDropDown});
            this.toolStrip1.Location = new System.Drawing.Point(0, 0);
            this.toolStrip1.Name = "toolStrip1";
            this.toolStrip1.Size = new System.Drawing.Size(179, 25);
            this.toolStrip1.Stretch = true;
            this.toolStrip1.TabIndex = 0;
            // 
            // toolStripDropDownButton1
            // 
            this.toolStripDropDownButton1.DropDownItems.AddRange(new System.Windows.Forms.ToolStripItem[] {
            this.referenceEditorToolStripMenuItem,
            this.metaEditorToolStripMenuItem,
            this.hexEditorToolStripMenuItem,
            this.rebuilderToolStripMenuItem,
            this.fixSystemLinkToolStripMenuItem,
            this.pluginsToolStripMenuItem,
            this.exportScriptsToolStripMenuItem});
            this.toolStripDropDownButton1.ImageTransparentColor = System.Drawing.Color.Magenta;
            this.toolStripDropDownButton1.Name = "toolStripDropDownButton1";
            this.toolStripDropDownButton1.Size = new System.Drawing.Size(45, 22);
            this.toolStripDropDownButton1.Text = "Tools";
            // 
            // referenceEditorToolStripMenuItem
            // 
            this.referenceEditorToolStripMenuItem.Checked = true;
            this.referenceEditorToolStripMenuItem.CheckState = System.Windows.Forms.CheckState.Checked;
            this.referenceEditorToolStripMenuItem.Name = "referenceEditorToolStripMenuItem";
            this.referenceEditorToolStripMenuItem.Size = new System.Drawing.Size(166, 22);
            this.referenceEditorToolStripMenuItem.Text = "Reference Editor";
            this.referenceEditorToolStripMenuItem.Click += new System.EventHandler(this.fgdgfgdgdToolStripMenuItem_Click);
            // 
            // metaEditorToolStripMenuItem
            // 
            this.metaEditorToolStripMenuItem.Name = "metaEditorToolStripMenuItem";
            this.metaEditorToolStripMenuItem.Size = new System.Drawing.Size(166, 22);
            this.metaEditorToolStripMenuItem.Text = "Meta Editor";
            this.metaEditorToolStripMenuItem.Click += new System.EventHandler(this.metaEditorToolStripMenuItem_Click);
            // 
            // hexEditorToolStripMenuItem
            // 
            this.hexEditorToolStripMenuItem.Name = "hexEditorToolStripMenuItem";
            this.hexEditorToolStripMenuItem.Size = new System.Drawing.Size(166, 22);
            this.hexEditorToolStripMenuItem.Text = "Hex Editor";
            this.hexEditorToolStripMenuItem.Click += new System.EventHandler(this.hexEditorToolStripMenuItem_Click);
            // 
            // rebuilderToolStripMenuItem
            // 
            this.rebuilderToolStripMenuItem.Name = "rebuilderToolStripMenuItem";
            this.rebuilderToolStripMenuItem.Size = new System.Drawing.Size(166, 22);
            this.rebuilderToolStripMenuItem.Text = "Rebuilder";
            this.rebuilderToolStripMenuItem.Click += new System.EventHandler(this.rebuilderToolStripMenuItem_Click);
            // 
            // fixSystemLinkToolStripMenuItem
            // 
            this.fixSystemLinkToolStripMenuItem.Name = "fixSystemLinkToolStripMenuItem";
            this.fixSystemLinkToolStripMenuItem.Size = new System.Drawing.Size(166, 22);
            this.fixSystemLinkToolStripMenuItem.Text = "Fix System Link";
            this.fixSystemLinkToolStripMenuItem.Click += new System.EventHandler(this.fixSystemLinkToolStripMenuItem_Click);
            // 
            // pluginsToolStripMenuItem
            // 
            this.pluginsToolStripMenuItem.Name = "pluginsToolStripMenuItem";
            this.pluginsToolStripMenuItem.Size = new System.Drawing.Size(166, 22);
            this.pluginsToolStripMenuItem.Text = "Plugins";
            // 
            // exportScriptsToolStripMenuItem
            // 
            this.exportScriptsToolStripMenuItem.Name = "exportScriptsToolStripMenuItem";
            this.exportScriptsToolStripMenuItem.Size = new System.Drawing.Size(166, 22);
            this.exportScriptsToolStripMenuItem.Text = "Export Scripts";
            this.exportScriptsToolStripMenuItem.Visible = false;
            this.exportScriptsToolStripMenuItem.Click += new System.EventHandler(this.exportScriptsToolStripMenuItem_Click);
            // 
            // toolStripDropDownButton2
            // 
            this.toolStripDropDownButton2.DropDownItems.AddRange(new System.Windows.Forms.ToolStripItem[] {
            this.metaTreeToolStripMenuItem,
            this.toolsToolStripMenuItem});
            this.toolStripDropDownButton2.ImageTransparentColor = System.Drawing.Color.Magenta;
            this.toolStripDropDownButton2.Name = "toolStripDropDownButton2";
            this.toolStripDropDownButton2.Size = new System.Drawing.Size(54, 22);
            this.toolStripDropDownButton2.Text = "Display";
            this.toolStripDropDownButton2.TextDirection = System.Windows.Forms.ToolStripTextDirection.Horizontal;
            // 
            // metaTreeToolStripMenuItem
            // 
            this.metaTreeToolStripMenuItem.Checked = true;
            this.metaTreeToolStripMenuItem.CheckState = System.Windows.Forms.CheckState.Checked;
            this.metaTreeToolStripMenuItem.Name = "metaTreeToolStripMenuItem";
            this.metaTreeToolStripMenuItem.Size = new System.Drawing.Size(134, 22);
            this.metaTreeToolStripMenuItem.Text = "Meta Tree";
            this.metaTreeToolStripMenuItem.Click += new System.EventHandler(this.metaListToolStripMenuItem_Click);
            // 
            // toolsToolStripMenuItem
            // 
            this.toolsToolStripMenuItem.Checked = true;
            this.toolsToolStripMenuItem.CheckState = System.Windows.Forms.CheckState.Checked;
            this.toolsToolStripMenuItem.Name = "toolsToolStripMenuItem";
            this.toolsToolStripMenuItem.Size = new System.Drawing.Size(134, 22);
            this.toolsToolStripMenuItem.Text = "Tools";
            this.toolsToolStripMenuItem.Click += new System.EventHandler(this.toolsWindowToolStripMenuItem_Click);
            // 
            // rawDataDropDown
            // 
            this.rawDataDropDown.DisplayStyle = System.Windows.Forms.ToolStripItemDisplayStyle.Image;
            this.rawDataDropDown.Enabled = false;
            this.rawDataDropDown.Image = ((System.Drawing.Image)(resources.GetObject("rawDataDropDown.Image")));
            this.rawDataDropDown.ImageTransparentColor = System.Drawing.Color.Magenta;
            this.rawDataDropDown.Name = "rawDataDropDown";
            this.rawDataDropDown.Size = new System.Drawing.Size(29, 22);
            this.rawDataDropDown.Text = "toolStripDropDownButton3";
            // 
            // pictureBox1
            // 
            this.pictureBox1.BackColor = System.Drawing.Color.Transparent;
            this.pictureBox1.ContextMenuStrip = this.BitmapContextStrip;
            this.pictureBox1.Image = ((System.Drawing.Image)(resources.GetObject("pictureBox1.Image")));
            this.pictureBox1.Location = new System.Drawing.Point(7, 209);
            this.pictureBox1.Name = "pictureBox1";
            this.pictureBox1.Size = new System.Drawing.Size(168, 155);
            this.pictureBox1.SizeMode = System.Windows.Forms.PictureBoxSizeMode.StretchImage;
            this.pictureBox1.TabIndex = 28;
            this.pictureBox1.TabStop = false;
            // 
            // BitmapContextStrip
            // 
            this.BitmapContextStrip.Items.AddRange(new System.Windows.Forms.ToolStripItem[] {
            this.saveBitmapToolStripMenuItem,
            this.injectBitmapToolStripMenuItem,
            this.convertToBumpMapToolStripMenuItem,
            this.bitmapEditorToolStripMenuItem});
            this.BitmapContextStrip.Name = "contextMenuStrip1";
            this.BitmapContextStrip.Size = new System.Drawing.Size(189, 92);
            // 
            // saveBitmapToolStripMenuItem
            // 
            this.saveBitmapToolStripMenuItem.Name = "saveBitmapToolStripMenuItem";
            this.saveBitmapToolStripMenuItem.Size = new System.Drawing.Size(188, 22);
            this.saveBitmapToolStripMenuItem.Text = "Save Bitmap";
            this.saveBitmapToolStripMenuItem.Click += new System.EventHandler(this.saveBitmapToolStripMenuItem_Click);
            // 
            // injectBitmapToolStripMenuItem
            // 
            this.injectBitmapToolStripMenuItem.Name = "injectBitmapToolStripMenuItem";
            this.injectBitmapToolStripMenuItem.Size = new System.Drawing.Size(188, 22);
            this.injectBitmapToolStripMenuItem.Text = "Inject";
            this.injectBitmapToolStripMenuItem.Click += new System.EventHandler(this.injectBitmapToolStripMenuItem_Click);
            // 
            // convertToBumpMapToolStripMenuItem
            // 
            this.convertToBumpMapToolStripMenuItem.Name = "convertToBumpMapToolStripMenuItem";
            this.convertToBumpMapToolStripMenuItem.Size = new System.Drawing.Size(188, 22);
            this.convertToBumpMapToolStripMenuItem.Text = "Convert To BumpMap";
            this.convertToBumpMapToolStripMenuItem.Click += new System.EventHandler(this.convertToBumpMapToolStripMenuItem_Click);
            // 
            // bitmapEditorToolStripMenuItem
            // 
            this.bitmapEditorToolStripMenuItem.Name = "bitmapEditorToolStripMenuItem";
            this.bitmapEditorToolStripMenuItem.Size = new System.Drawing.Size(188, 22);
            this.bitmapEditorToolStripMenuItem.Text = "Bitmap Editor";
            this.bitmapEditorToolStripMenuItem.Click += new System.EventHandler(this.bitmapEditorToolStripMenuItem_Click);
            // 
            // secondaryMagicBox
            // 
            this.secondaryMagicBox.BackColor = System.Drawing.Color.SteelBlue;
            this.secondaryMagicBox.BorderStyle = System.Windows.Forms.BorderStyle.None;
            this.secondaryMagicBox.Location = new System.Drawing.Point(12, 432);
            this.secondaryMagicBox.Name = "secondaryMagicBox";
            this.secondaryMagicBox.ReadOnly = true;
            this.secondaryMagicBox.Size = new System.Drawing.Size(160, 16);
            this.secondaryMagicBox.TabIndex = 27;
            this.secondaryMagicBox.Text = "";
            // 
            // primaryMagicBox
            // 
            this.primaryMagicBox.BackColor = System.Drawing.Color.SteelBlue;
            this.primaryMagicBox.BorderStyle = System.Windows.Forms.BorderStyle.None;
            this.primaryMagicBox.Location = new System.Drawing.Point(12, 392);
            this.primaryMagicBox.Name = "primaryMagicBox";
            this.primaryMagicBox.ReadOnly = true;
            this.primaryMagicBox.Size = new System.Drawing.Size(160, 16);
            this.primaryMagicBox.TabIndex = 26;
            this.primaryMagicBox.Text = "";
            // 
            // label4
            // 
            this.label4.BackColor = System.Drawing.Color.Transparent;
            this.label4.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
            this.label4.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label4.Location = new System.Drawing.Point(8, 412);
            this.label4.Name = "label4";
            this.label4.Size = new System.Drawing.Size(162, 16);
            this.label4.TabIndex = 25;
            this.label4.Text = "Secondary Magic:";
            // 
            // label6
            // 
            this.label6.BackColor = System.Drawing.Color.Transparent;
            this.label6.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
            this.label6.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label6.Location = new System.Drawing.Point(8, 372);
            this.label6.Name = "label6";
            this.label6.Size = new System.Drawing.Size(162, 16);
            this.label6.TabIndex = 24;
            this.label6.Text = "Primary Magic:";
            // 
            // panel3
            // 
            this.panel3.BackColor = System.Drawing.Color.WhiteSmoke;
            this.panel3.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
            this.panel3.Controls.Add(this.scanbspwithifp);
            this.panel3.Controls.Add(this.soundsCheckBox);
            this.panel3.Controls.Add(this.recursiveCheckBox);
            this.panel3.Controls.Add(this.parsedCheckBox);
            this.panel3.Controls.Add(this.loadMetaButton);
            this.panel3.Controls.Add(this.saveMetaButton);
            this.panel3.Controls.Add(this.metaTypeBox);
            this.panel3.Controls.Add(this.label2);
            this.panel3.Controls.Add(this.metaIdentBox);
            this.panel3.Controls.Add(this.metaSizeBox);
            this.panel3.Controls.Add(this.metaOffsetBox);
            this.panel3.Controls.Add(this.label5);
            this.panel3.Controls.Add(this.label3);
            this.panel3.Controls.Add(this.label1);
            this.panel3.Location = new System.Drawing.Point(7, 30);
            this.panel3.Name = "panel3";
            this.panel3.Size = new System.Drawing.Size(168, 173);
            this.panel3.TabIndex = 19;
            // 
            // scanbspwithifp
            // 
            this.scanbspwithifp.BackColor = System.Drawing.Color.Transparent;
            this.scanbspwithifp.Checked = true;
            this.scanbspwithifp.CheckState = System.Windows.Forms.CheckState.Checked;
            this.scanbspwithifp.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
            this.scanbspwithifp.Location = new System.Drawing.Point(74, 145);
            this.scanbspwithifp.Name = "scanbspwithifp";
            this.scanbspwithifp.Size = new System.Drawing.Size(93, 24);
            this.scanbspwithifp.TabIndex = 32;
            this.scanbspwithifp.Text = "Scan With Ent";
            this.scanbspwithifp.UseVisualStyleBackColor = false;
            // 
            // soundsCheckBox
            // 
            this.soundsCheckBox.BackColor = System.Drawing.Color.Transparent;
            this.soundsCheckBox.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
            this.soundsCheckBox.Location = new System.Drawing.Point(8, 144);
            this.soundsCheckBox.Name = "soundsCheckBox";
            this.soundsCheckBox.Size = new System.Drawing.Size(76, 24);
            this.soundsCheckBox.TabIndex = 31;
            this.soundsCheckBox.Text = "Sounds";
            this.soundsCheckBox.UseVisualStyleBackColor = false;
            // 
            // recursiveCheckBox
            // 
            this.recursiveCheckBox.BackColor = System.Drawing.Color.Transparent;
            this.recursiveCheckBox.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
            this.recursiveCheckBox.Location = new System.Drawing.Point(8, 96);
            this.recursiveCheckBox.Name = "recursiveCheckBox";
            this.recursiveCheckBox.Size = new System.Drawing.Size(76, 24);
            this.recursiveCheckBox.TabIndex = 30;
            this.recursiveCheckBox.Text = "Recursive";
            this.recursiveCheckBox.UseVisualStyleBackColor = false;
            // 
            // parsedCheckBox
            // 
            this.parsedCheckBox.BackColor = System.Drawing.Color.Transparent;
            this.parsedCheckBox.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
            this.parsedCheckBox.Location = new System.Drawing.Point(8, 120);
            this.parsedCheckBox.Name = "parsedCheckBox";
            this.parsedCheckBox.Size = new System.Drawing.Size(76, 24);
            this.parsedCheckBox.TabIndex = 29;
            this.parsedCheckBox.Text = "Parsed";
            this.parsedCheckBox.UseVisualStyleBackColor = false;
            this.parsedCheckBox.CheckedChanged += new System.EventHandler(this.parsedCheckBox_CheckedChanged_1);
            // 
            // loadMetaButton
            // 
            this.loadMetaButton.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
            this.loadMetaButton.Location = new System.Drawing.Point(84, 121);
            this.loadMetaButton.Name = "loadMetaButton";
            this.loadMetaButton.Size = new System.Drawing.Size(75, 23);
            this.loadMetaButton.TabIndex = 28;
            this.loadMetaButton.Text = "Inject";
            this.loadMetaButton.Click += new System.EventHandler(this.loadMetaButton_Click_1);
            // 
            // saveMetaButton
            // 
            this.saveMetaButton.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
            this.saveMetaButton.Location = new System.Drawing.Point(84, 97);
            this.saveMetaButton.Name = "saveMetaButton";
            this.saveMetaButton.Size = new System.Drawing.Size(75, 23);
            this.saveMetaButton.TabIndex = 27;
            this.saveMetaButton.Text = "Save";
            this.saveMetaButton.Click += new System.EventHandler(this.saveMetaButton_Click);
            // 
            // metaTypeBox
            // 
            this.metaTypeBox.BackColor = System.Drawing.Color.WhiteSmoke;
            this.metaTypeBox.BorderStyle = System.Windows.Forms.BorderStyle.None;
            this.metaTypeBox.Location = new System.Drawing.Point(72, 72);
            this.metaTypeBox.Name = "metaTypeBox";
            this.metaTypeBox.ReadOnly = true;
            this.metaTypeBox.Size = new System.Drawing.Size(100, 16);
            this.metaTypeBox.TabIndex = 26;
            this.metaTypeBox.Text = "";
            // 
            // label2
            // 
            this.label2.BackColor = System.Drawing.Color.Transparent;
            this.label2.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
            this.label2.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label2.Location = new System.Drawing.Point(8, 72);
            this.label2.Name = "label2";
            this.label2.Size = new System.Drawing.Size(60, 16);
            this.label2.TabIndex = 25;
            this.label2.Text = "Type:";
            // 
            // metaIdentBox
            // 
            this.metaIdentBox.BackColor = System.Drawing.Color.WhiteSmoke;
            this.metaIdentBox.BorderStyle = System.Windows.Forms.BorderStyle.None;
            this.metaIdentBox.Location = new System.Drawing.Point(72, 52);
            this.metaIdentBox.Name = "metaIdentBox";
            this.metaIdentBox.ReadOnly = true;
            this.metaIdentBox.Size = new System.Drawing.Size(100, 16);
            this.metaIdentBox.TabIndex = 24;
            this.metaIdentBox.Text = "";
            // 
            // metaSizeBox
            // 
            this.metaSizeBox.BackColor = System.Drawing.Color.WhiteSmoke;
            this.metaSizeBox.BorderStyle = System.Windows.Forms.BorderStyle.None;
            this.metaSizeBox.Location = new System.Drawing.Point(72, 32);
            this.metaSizeBox.Name = "metaSizeBox";
            this.metaSizeBox.ReadOnly = true;
            this.metaSizeBox.Size = new System.Drawing.Size(100, 16);
            this.metaSizeBox.TabIndex = 23;
            this.metaSizeBox.Text = "";
            // 
            // metaOffsetBox
            // 
            this.metaOffsetBox.BackColor = System.Drawing.Color.WhiteSmoke;
            this.metaOffsetBox.BorderStyle = System.Windows.Forms.BorderStyle.None;
            this.metaOffsetBox.Location = new System.Drawing.Point(71, 8);
            this.metaOffsetBox.Name = "metaOffsetBox";
            this.metaOffsetBox.ReadOnly = true;
            this.metaOffsetBox.Size = new System.Drawing.Size(100, 16);
            this.metaOffsetBox.TabIndex = 22;
            this.metaOffsetBox.Text = "";
            // 
            // label5
            // 
            this.label5.BackColor = System.Drawing.Color.Transparent;
            this.label5.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
            this.label5.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label5.Location = new System.Drawing.Point(8, 52);
            this.label5.Name = "label5";
            this.label5.Size = new System.Drawing.Size(60, 16);
            this.label5.TabIndex = 19;
            this.label5.Text = "Ident:";
            // 
            // label3
            // 
            this.label3.BackColor = System.Drawing.Color.Transparent;
            this.label3.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
            this.label3.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label3.Location = new System.Drawing.Point(8, 32);
            this.label3.Name = "label3";
            this.label3.Size = new System.Drawing.Size(60, 16);
            this.label3.TabIndex = 17;
            this.label3.Text = "Size:";
            // 
            // label1
            // 
            this.label1.BackColor = System.Drawing.Color.Transparent;
            this.label1.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
            this.label1.Font = new System.Drawing.Font("Arial", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label1.Location = new System.Drawing.Point(8, 8);
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size(60, 16);
            this.label1.TabIndex = 15;
            this.label1.Text = "Offset:";
            // 
            // signMapButton
            // 
            this.signMapButton.BackColor = System.Drawing.Color.CornflowerBlue;
            this.signMapButton.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
            this.signMapButton.Location = new System.Drawing.Point(8, 461);
            this.signMapButton.Name = "signMapButton";
            this.signMapButton.Size = new System.Drawing.Size(76, 23);
            this.signMapButton.TabIndex = 18;
            this.signMapButton.Text = "Sign";
            this.signMapButton.UseVisualStyleBackColor = false;
            this.signMapButton.Click += new System.EventHandler(this.signMapButton_Click_1);
            // 
            // analyzeMapButton
            // 
            this.analyzeMapButton.BackColor = System.Drawing.Color.CornflowerBlue;
            this.analyzeMapButton.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
            this.analyzeMapButton.Location = new System.Drawing.Point(92, 489);
            this.analyzeMapButton.Name = "analyzeMapButton";
            this.analyzeMapButton.Size = new System.Drawing.Size(80, 23);
            this.analyzeMapButton.TabIndex = 12;
            this.analyzeMapButton.Text = "Analyze Map";
            this.analyzeMapButton.UseVisualStyleBackColor = false;
            this.analyzeMapButton.Click += new System.EventHandler(this.analyzeMapButton_Click_1);
            // 
            // buildButton
            // 
            this.buildButton.BackColor = System.Drawing.Color.CornflowerBlue;
            this.buildButton.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
            this.buildButton.Location = new System.Drawing.Point(92, 461);
            this.buildButton.Name = "buildButton";
            this.buildButton.Size = new System.Drawing.Size(80, 23);
            this.buildButton.TabIndex = 11;
            this.buildButton.Text = "Build";
            this.buildButton.UseVisualStyleBackColor = false;
            this.buildButton.Click += new System.EventHandler(this.buildButton_Click_1);
            // 
            // splitContainer1
            // 
            this.splitContainer1.BackColor = System.Drawing.Color.SteelBlue;
            this.splitContainer1.Dock = System.Windows.Forms.DockStyle.Fill;
            this.splitContainer1.Location = new System.Drawing.Point(0, 0);
            this.splitContainer1.Name = "splitContainer1";
            // 
            // splitContainer1.Panel1
            // 
            this.splitContainer1.Panel1.Controls.Add(this.treeView1);
            // 
            // splitContainer1.Panel2
            // 
            this.splitContainer1.Panel2.Controls.Add(this.splitContainer2);
            this.splitContainer1.Panel2.Controls.Add(this.statusStrip1);
            this.splitContainer1.Size = new System.Drawing.Size(911, 593);
            this.splitContainer1.SplitterDistance = 303;
            this.splitContainer1.TabIndex = 17;
            // 
            // splitContainer2
            // 
            this.splitContainer2.Dock = System.Windows.Forms.DockStyle.Fill;
            this.splitContainer2.FixedPanel = System.Windows.Forms.FixedPanel.Panel2;
            this.splitContainer2.Location = new System.Drawing.Point(0, 0);
            this.splitContainer2.Name = "splitContainer2";
            // 
            // splitContainer2.Panel1
            // 
            this.splitContainer2.Panel1.Controls.Add(this.MetaEditorPanel);
            this.splitContainer2.Panel1.Controls.Add(this.LibraryPanel);
            this.splitContainer2.Panel1.Controls.Add(this.hexView1);
            this.splitContainer2.Panel1.Controls.Add(this.references);
            this.splitContainer2.Panel1.Controls.Add(this.ltmpTools);
            // 
            // splitContainer2.Panel2
            // 
            this.splitContainer2.Panel2.Controls.Add(this.panel2);
            this.splitContainer2.Size = new System.Drawing.Size(604, 571);
            this.splitContainer2.SplitterDistance = 421;
            this.splitContainer2.TabIndex = 14;
            // 
            // MetaEditorPanel
            // 
            this.MetaEditorPanel.BackColor = System.Drawing.Color.PeachPuff;
            this.MetaEditorPanel.Controls.Add(this.ME);
            this.MetaEditorPanel.Dock = System.Windows.Forms.DockStyle.Fill;
            this.MetaEditorPanel.Location = new System.Drawing.Point(0, 0);
            this.MetaEditorPanel.Name = "MetaEditorPanel";
            this.MetaEditorPanel.Size = new System.Drawing.Size(421, 571);
            this.MetaEditorPanel.TabIndex = 15;
            this.MetaEditorPanel.Visible = false;
            // 
            // ME
            // 
            this.ME.AutoScroll = true;
            this.ME.BackColor = System.Drawing.Color.Gray;
            this.ME.Dock = System.Windows.Forms.DockStyle.Fill;
            this.ME.Location = new System.Drawing.Point(0, 0);
            this.ME.Name = "ME";
            this.ME.Padding = new System.Windows.Forms.Padding(10);
            this.ME.Size = new System.Drawing.Size(421, 571);
            this.ME.TabIndex = 0;
            // 
            // LibraryPanel
            // 
            this.LibraryPanel.AutoScroll = true;
            this.LibraryPanel.BackColor = System.Drawing.Color.White;
            this.LibraryPanel.Dock = System.Windows.Forms.DockStyle.Fill;
            this.LibraryPanel.Location = new System.Drawing.Point(0, 0);
            this.LibraryPanel.Name = "LibraryPanel";
            this.LibraryPanel.Size = new System.Drawing.Size(421, 571);
            this.LibraryPanel.TabIndex = 16;
            this.LibraryPanel.Visible = false;
            // 
            // hexView1
            // 
            this.hexView1.BackColor = System.Drawing.Color.DarkGray;
            this.hexView1.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
            this.hexView1.Dock = System.Windows.Forms.DockStyle.Fill;
            this.hexView1.Location = new System.Drawing.Point(0, 0);
            this.hexView1.Name = "hexView1";
            this.hexView1.Padding = new System.Windows.Forms.Padding(10);
            this.hexView1.Size = new System.Drawing.Size(421, 571);
            this.hexView1.TabIndex = 0;
            this.hexView1.Visible = false;
            // 
            // ltmpTools
            // 
            this.ltmpTools.AutoScroll = true;
            this.ltmpTools.BackColor = System.Drawing.Color.White;
            this.ltmpTools.Dock = System.Windows.Forms.DockStyle.Fill;
            this.ltmpTools.Location = new System.Drawing.Point(0, 0);
            this.ltmpTools.Name = "ltmpTools";
            this.ltmpTools.Size = new System.Drawing.Size(421, 571);
            this.ltmpTools.TabIndex = 17;
            this.ltmpTools.Visible = false;
            // 
            // toolStripProgressBar1
            // 
            this.toolStripProgressBar1.Name = "toolStripProgressBar1";
            this.toolStripProgressBar1.Size = new System.Drawing.Size(100, 16);
            // 
            // saveBitmapDialog1
            // 
            this.saveBitmapDialog1.Filter = "DDS  (*.DDS) | *.DDS|Bitmap (*.BMP) | *.BMP|Jpg (*.JPG) | *.JPG";
            // 
            // ModelContextStrip
            // 
            this.ModelContextStrip.Items.AddRange(new System.Windows.Forms.ToolStripItem[] {
            this.viewModelToolStripMenuItem,
            this.exportModelToolStripMenuItem,
            this.exportMeshToolStripMenuItem,
            this.injectMeshesToolStripMenuItem});
            this.ModelContextStrip.Name = "contextMenuStrip2";
            this.ModelContextStrip.Size = new System.Drawing.Size(157, 92);
            // 
            // viewModelToolStripMenuItem
            // 
            this.viewModelToolStripMenuItem.Name = "viewModelToolStripMenuItem";
            this.viewModelToolStripMenuItem.Size = new System.Drawing.Size(156, 22);
            this.viewModelToolStripMenuItem.Text = "View Model";
            this.viewModelToolStripMenuItem.Click += new System.EventHandler(this.viewModelToolStripMenuItem_Click);
            // 
            // exportModelToolStripMenuItem
            // 
            this.exportModelToolStripMenuItem.DropDownItems.AddRange(new System.Windows.Forms.ToolStripItem[] {
            this.toOBJToolStripMenuItem,
            this.toXToolStripMenuItem});
            this.exportModelToolStripMenuItem.Name = "exportModelToolStripMenuItem";
            this.exportModelToolStripMenuItem.Size = new System.Drawing.Size(156, 22);
            this.exportModelToolStripMenuItem.Text = "Export Meshes";
            this.exportModelToolStripMenuItem.Click += new System.EventHandler(this.exportModelToolStripMenuItem_Click);
            // 
            // toOBJToolStripMenuItem
            // 
            this.toOBJToolStripMenuItem.Name = "toOBJToolStripMenuItem";
            this.toOBJToolStripMenuItem.Size = new System.Drawing.Size(123, 22);
            this.toOBJToolStripMenuItem.Text = "To .OBJ";
            this.toOBJToolStripMenuItem.Click += new System.EventHandler(this.toOBJToolStripMenuItem_Click);
            // 
            // toXToolStripMenuItem
            // 
            this.toXToolStripMenuItem.Name = "toXToolStripMenuItem";
            this.toXToolStripMenuItem.Size = new System.Drawing.Size(123, 22);
            this.toXToolStripMenuItem.Text = "To .X";
            this.toXToolStripMenuItem.Click += new System.EventHandler(this.toXToolStripMenuItem_Click);
            // 
            // exportMeshToolStripMenuItem
            // 
            this.exportMeshToolStripMenuItem.Name = "exportMeshToolStripMenuItem";
            this.exportMeshToolStripMenuItem.Size = new System.Drawing.Size(156, 22);
            this.exportMeshToolStripMenuItem.Text = "Export Mesh";
            this.exportMeshToolStripMenuItem.Visible = false;
            this.exportMeshToolStripMenuItem.Click += new System.EventHandler(this.exportMeshToolStripMenuItem_Click);
            // 
            // injectMeshesToolStripMenuItem
            // 
            this.injectMeshesToolStripMenuItem.DropDownItems.AddRange(new System.Windows.Forms.ToolStripItem[] {
            this.injectOBJToolStripMenuItem});
            this.injectMeshesToolStripMenuItem.Name = "injectMeshesToolStripMenuItem";
            this.injectMeshesToolStripMenuItem.Size = new System.Drawing.Size(156, 22);
            this.injectMeshesToolStripMenuItem.Text = "Inject Meshes ";
            // 
            // injectOBJToolStripMenuItem
            // 
            this.injectOBJToolStripMenuItem.Name = "injectOBJToolStripMenuItem";
            this.injectOBJToolStripMenuItem.Size = new System.Drawing.Size(139, 22);
            this.injectOBJToolStripMenuItem.Text = "Inject .OBJ";
            this.injectOBJToolStripMenuItem.Click += new System.EventHandler(this.injectOBJToolStripMenuItem_Click);
            // 
            // BSPcontextMenu
            // 
            this.BSPcontextMenu.Items.AddRange(new System.Windows.Forms.ToolStripItem[] {
            this.viewBSPToolStripMenuItem,
            this.exportOBJToolStripMenuItem,
            this.bSPCollisionToolStripMenuItem,
            this.expandMeshX3ToolStripMenuItem,
            this.makeBSPStickyToolStripMenuItem,
            this.portalsToolStripMenuItem,
            this.injectBSPVisualMeshToolStripMenuItem,
            this.exportMeshToOBJToolStripMenuItem});
            this.BSPcontextMenu.Name = "BSPcontextMenu";
            this.BSPcontextMenu.Size = new System.Drawing.Size(206, 180);
            // 
            // viewBSPToolStripMenuItem
            // 
            this.viewBSPToolStripMenuItem.Name = "viewBSPToolStripMenuItem";
            this.viewBSPToolStripMenuItem.Size = new System.Drawing.Size(205, 22);
            this.viewBSPToolStripMenuItem.Text = "View BSP";
            this.viewBSPToolStripMenuItem.Click += new System.EventHandler(this.viewBSPToolStripMenuItem_Click);
            // 
            // exportOBJToolStripMenuItem
            // 
            this.exportOBJToolStripMenuItem.Name = "exportOBJToolStripMenuItem";
            this.exportOBJToolStripMenuItem.Size = new System.Drawing.Size(205, 22);
            this.exportOBJToolStripMenuItem.Text = "Export Meshes to .OBJs";
            this.exportOBJToolStripMenuItem.Click += new System.EventHandler(this.exportOBJToolStripMenuItem_Click);
            // 
            // bSPCollisionToolStripMenuItem
            // 
            this.bSPCollisionToolStripMenuItem.DropDownItems.AddRange(new System.Windows.Forms.ToolStripItem[] {
            this.toolStripMenuItem2,
            this.exportCollisonToOBJToolStripMenuItem,
            this.bspcollisionViewerToolStripMenuItem});
            this.bSPCollisionToolStripMenuItem.Name = "bSPCollisionToolStripMenuItem";
            this.bSPCollisionToolStripMenuItem.Size = new System.Drawing.Size(205, 22);
            this.bSPCollisionToolStripMenuItem.Text = "BSP Collision";
            // 
            // toolStripMenuItem2
            // 
            this.toolStripMenuItem2.Name = "toolStripMenuItem2";
            this.toolStripMenuItem2.Size = new System.Drawing.Size(208, 22);
            this.toolStripMenuItem2.Text = "Inject Collision Mesh .OBJ";
            this.toolStripMenuItem2.Click += new System.EventHandler(this.injectCollisionMeshOBJToolStripMenuItem_Click);
            // 
            // exportCollisonToOBJToolStripMenuItem
            // 
            this.exportCollisonToOBJToolStripMenuItem.Name = "exportCollisonToOBJToolStripMenuItem";
            this.exportCollisonToOBJToolStripMenuItem.Size = new System.Drawing.Size(208, 22);
            this.exportCollisonToOBJToolStripMenuItem.Text = "Export Collison to .OBJ";
            this.exportCollisonToOBJToolStripMenuItem.Click += new System.EventHandler(this.exportCollisonToOBJToolStripMenuItem_Click);
            // 
            // bspcollisionViewerToolStripMenuItem
            // 
            this.bspcollisionViewerToolStripMenuItem.Name = "bspcollisionViewerToolStripMenuItem";
            this.bspcollisionViewerToolStripMenuItem.Size = new System.Drawing.Size(208, 22);
            this.bspcollisionViewerToolStripMenuItem.Text = "Collision Viewer";
            this.bspcollisionViewerToolStripMenuItem.Click += new System.EventHandler(this.bspcollisionViewerToolStripMenuItem_Click);
            // 
            // expandMeshX3ToolStripMenuItem
            // 
            this.expandMeshX3ToolStripMenuItem.Name = "expandMeshX3ToolStripMenuItem";
            this.expandMeshX3ToolStripMenuItem.Size = new System.Drawing.Size(205, 22);
            this.expandMeshX3ToolStripMenuItem.Text = "Expand Collision Mesh X3";
            this.expandMeshX3ToolStripMenuItem.Visible = false;
            this.expandMeshX3ToolStripMenuItem.Click += new System.EventHandler(this.expandMeshX3ToolStripMenuItem_Click);
            // 
            // makeBSPStickyToolStripMenuItem
            // 
            this.makeBSPStickyToolStripMenuItem.Name = "makeBSPStickyToolStripMenuItem";
            this.makeBSPStickyToolStripMenuItem.Size = new System.Drawing.Size(205, 22);
            this.makeBSPStickyToolStripMenuItem.Text = "Make BSP Sticky";
            this.makeBSPStickyToolStripMenuItem.Visible = false;
            this.makeBSPStickyToolStripMenuItem.Click += new System.EventHandler(this.makeBSPStickyToolStripMenuItem_Click);
            // 
            // portalsToolStripMenuItem
            // 
            this.portalsToolStripMenuItem.DropDownItems.AddRange(new System.Windows.Forms.ToolStripItem[] {
            this.portalViewerToolStripMenuItem});
            this.portalsToolStripMenuItem.Name = "portalsToolStripMenuItem";
            this.portalsToolStripMenuItem.Size = new System.Drawing.Size(205, 22);
            this.portalsToolStripMenuItem.Text = "Portals";
            this.portalsToolStripMenuItem.Visible = false;
            // 
            // portalViewerToolStripMenuItem
            // 
            this.portalViewerToolStripMenuItem.Name = "portalViewerToolStripMenuItem";
            this.portalViewerToolStripMenuItem.Size = new System.Drawing.Size(148, 22);
            this.portalViewerToolStripMenuItem.Text = "Portal Viewer";
            this.portalViewerToolStripMenuItem.Click += new System.EventHandler(this.portalViewerToolStripMenuItem_Click);
            // 
            // injectBSPVisualMeshToolStripMenuItem
            // 
            this.injectBSPVisualMeshToolStripMenuItem.Name = "injectBSPVisualMeshToolStripMenuItem";
            this.injectBSPVisualMeshToolStripMenuItem.Size = new System.Drawing.Size(205, 22);
            this.injectBSPVisualMeshToolStripMenuItem.Text = "Inject BSP Visual Mesh";
            this.injectBSPVisualMeshToolStripMenuItem.Click += new System.EventHandler(this.injectBSPVisualMeshToolStripMenuItem_Click);
            // 
            // exportMeshToOBJToolStripMenuItem
            // 
            this.exportMeshToOBJToolStripMenuItem.Name = "exportMeshToOBJToolStripMenuItem";
            this.exportMeshToOBJToolStripMenuItem.Size = new System.Drawing.Size(205, 22);
            this.exportMeshToOBJToolStripMenuItem.Text = "Export Mesh To OBJ";
            this.exportMeshToOBJToolStripMenuItem.Click += new System.EventHandler(this.exportMeshToOBJToolStripMenuItem_Click);
            // 
            // collContextMenu
            // 
            this.collContextMenu.Items.AddRange(new System.Windows.Forms.ToolStripItem[] {
            this.extractMeshToOBJToolStripMenuItem,
            this.collisonViewerToolStripMenuItem});
            this.collContextMenu.Name = "collContextMenu";
            this.collContextMenu.Size = new System.Drawing.Size(188, 48);
            // 
            // extractMeshToOBJToolStripMenuItem
            // 
            this.extractMeshToOBJToolStripMenuItem.Name = "extractMeshToOBJToolStripMenuItem";
            this.extractMeshToOBJToolStripMenuItem.Size = new System.Drawing.Size(187, 22);
            this.extractMeshToOBJToolStripMenuItem.Text = "Extract Mesh to .OBJ";
            this.extractMeshToOBJToolStripMenuItem.Click += new System.EventHandler(this.extractMeshToOBJToolStripMenuItem_Click);
            // 
            // collisonViewerToolStripMenuItem
            // 
            this.collisonViewerToolStripMenuItem.Name = "collisonViewerToolStripMenuItem";
            this.collisonViewerToolStripMenuItem.Size = new System.Drawing.Size(187, 22);
            this.collisonViewerToolStripMenuItem.Text = "Collison Viewer";
            this.collisonViewerToolStripMenuItem.Click += new System.EventHandler(this.collisonViewerToolStripMenuItem_Click);
            // 
            // saveFileDialog1
            // 
            this.saveFileDialog1.Filter = ".obj |*.obx|.X|*.X";
            // 
            // prtmcontext
            // 
            this.prtmcontext.Items.AddRange(new System.Windows.Forms.ToolStripItem[] {
            this.viewPRTMToolStripMenuItem,
            this.extractPRTMOBJToolStripMenuItem});
            this.prtmcontext.Name = "prtmcontext";
            this.prtmcontext.Size = new System.Drawing.Size(177, 48);
            // 
            // viewPRTMToolStripMenuItem
            // 
            this.viewPRTMToolStripMenuItem.Name = "viewPRTMToolStripMenuItem";
            this.viewPRTMToolStripMenuItem.Size = new System.Drawing.Size(176, 22);
            this.viewPRTMToolStripMenuItem.Text = "View Particle Model";
            this.viewPRTMToolStripMenuItem.Click += new System.EventHandler(this.viewPRTMToolStripMenuItem_Click);
            // 
            // extractPRTMOBJToolStripMenuItem
            // 
            this.extractPRTMOBJToolStripMenuItem.Name = "extractPRTMOBJToolStripMenuItem";
            this.extractPRTMOBJToolStripMenuItem.Size = new System.Drawing.Size(176, 22);
            this.extractPRTMOBJToolStripMenuItem.Text = "Extract PRTM .OBJ";
            this.extractPRTMOBJToolStripMenuItem.Click += new System.EventHandler(this.extractPRTMOBJToolStripMenuItem_Click);
            // 
            // openBitmapDialog1
            // 
            this.openBitmapDialog1.Filter = "DDS  (*.DDS) | *.DDS";
            // 
            // MapForm
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.BackColor = System.Drawing.Color.DarkGray;
            this.ClientSize = new System.Drawing.Size(911, 593);
            this.Controls.Add(this.splitContainer1);
            this.Name = "MapForm";
            this.Text = "MapForm";
            this.WindowState = System.Windows.Forms.FormWindowState.Maximized;
            this.DragDrop += new System.Windows.Forms.DragEventHandler(this.treeView1_DragDrop);
            this.Closed += new System.EventHandler(this.MapForm_Closed);
            this.DragEnter += new System.Windows.Forms.DragEventHandler(this.treeView1_DragEnter);
            this.Load += new System.EventHandler(this.MapForm_Load);
            this.treeviewcontext.ResumeLayout(false);
            this.statusStrip1.ResumeLayout(false);
            this.statusStrip1.PerformLayout();
            this.panel2.ResumeLayout(false);
            this.panel2.PerformLayout();
            this.toolStripContainer1.TopToolStripPanel.ResumeLayout(false);
            this.toolStripContainer1.ResumeLayout(false);
            this.toolStripContainer1.PerformLayout();
            this.toolStrip1.ResumeLayout(false);
            this.toolStrip1.PerformLayout();
            ((System.ComponentModel.ISupportInitialize)(this.pictureBox1)).EndInit();
            this.BitmapContextStrip.ResumeLayout(false);
            this.panel3.ResumeLayout(false);
            this.splitContainer1.Panel1.ResumeLayout(false);
            this.splitContainer1.Panel2.ResumeLayout(false);
            this.splitContainer1.Panel2.PerformLayout();
            this.splitContainer1.ResumeLayout(false);
            this.splitContainer2.Panel1.ResumeLayout(false);
            this.splitContainer2.Panel2.ResumeLayout(false);
            this.splitContainer2.ResumeLayout(false);
            this.MetaEditorPanel.ResumeLayout(false);
            this.ModelContextStrip.ResumeLayout(false);
            this.BSPcontextMenu.ResumeLayout(false);
            this.collContextMenu.ResumeLayout(false);
            this.prtmcontext.ResumeLayout(false);
            this.ResumeLayout(false);

        }
        #endregion

        private void MapForm_Closed(object sender, System.EventArgs e)
        {

            Form1 x = (Form1)this.MdiParent;
            x.mapclosed(sender);
        }
        public void debugwrite(string text)
        {

        }
        public void DisplayMapBitmap()
        {
            Maps.map[this.mapnumber].OpenMap(MapTypes.Internal);
            Maps.map[this.mapnumber].BR.BaseStream.Position = Maps.map[this.mapnumber].MetaInfo.Offset[3] + 920;
            int tempc2 = Maps.map[this.mapnumber].BR.ReadInt32();
            int tempr2 = Maps.map[this.mapnumber].BR.ReadInt32() - Maps.map[this.mapnumber].SecondaryMagic;
            Maps.map[this.mapnumber].BR.BaseStream.Position = tempr2 + 16;
            int tempc = Maps.map[this.mapnumber].BR.ReadInt32();
            int tempr = Maps.map[this.mapnumber].BR.ReadInt32() - Maps.map[this.mapnumber].SecondaryMagic;
            if (tempc != 0)
            {
                Maps.map[this.mapnumber].BR.BaseStream.Position = tempr + 8;
                int temptag = Maps.map[this.mapnumber].Functions.Meta.FindMetaByID(Maps.map[this.mapnumber].BR.ReadInt32(), mapnumber);
                Meta m = new Meta();
                m.ReadMetaFromMap(temptag, mapnumber, false);
                Raw.ParsedBitmap pm = new Raw.ParsedBitmap(ref m, mapnumber);
                //MessageBox.Show("test");
                Bitmap b = pm.FindChunkAndDecode(0, 0, ref m, mapnumber, 0, 0);
                pictureBox1.Image = b;
            }
            else
            {
                Maps.map[mapnumber].BR.BaseStream.Position = tempr2 + 8;
                tempc = Maps.map[this.mapnumber].BR.ReadInt32();
                if (tempc != 0)
                {
                    tempr = Maps.map[this.mapnumber].BR.ReadInt32() - Maps.map[this.mapnumber].SecondaryMagic;
                    Maps.map[this.mapnumber].BR.BaseStream.Position = tempr + 12;
                    int temptag = Maps.map[this.mapnumber].Functions.Meta.FindMetaByID(Maps.map[this.mapnumber].BR.ReadInt32(), mapnumber);
                    Meta m = new Meta();
                    m.ReadMetaFromMap(temptag, mapnumber, false);
                    Raw.ParsedBitmap pm = new Raw.ParsedBitmap(ref m, mapnumber);
                    //MessageBox.Show("test");
                    Bitmap b = pm.FindChunkAndDecode(0, 0, ref m, mapnumber, 0, 0);
                    pictureBox1.Image = b;
                }
            }
            //statusbar.Text = pm.Properties[0].formatname.ToString() + " - Swizzle:" + pm.Properties[0].swizzle.ToString();




            Maps.map[mapnumber].CloseMap();
        }
        private void treeView1_AfterSelect(object sender, System.Windows.Forms.TreeViewEventArgs e)
        {
            if (metaView == FormFunctions.MetaView.TagTypeView)
            {
                if (e.Node.Parent == null)
                {
                    //panel1.Visible=false;
                    Maps.map[mapnumber].SelectedMeta = null;
                    return;
                }
                for (int x = 0; x < Maps.map[mapnumber].IndexHeader.metaCount; x++)
                {
                    if (Maps.map[mapnumber].MetaInfo.TagType[x] == e.Node.Parent.Text && Maps.map[mapnumber].FileNames.Name[x] == e.Node.Text)
                    {
                        //info.SelectedMeta=x;
                        //panel1.Visible=true;
                        loadmeta(x);
                        return;
                    }
                }
            }
            else
            {
                for (int x = 0; x < Maps.map[mapnumber].IndexHeader.metaCount; x++)
                {
                    string[] tempn = Maps.map[mapnumber].FileNames.Name[x].Split('\\');

                    string tempi = tempn[tempn.Length - 1] + "." + Maps.map[mapnumber].MetaInfo.TagType[x];
                    int i = Maps.map[mapnumber].FileNames.Name[x].LastIndexOf('\\');
                    string tempp = "";
                    if (i != -1) { tempp = Maps.map[mapnumber].FileNames.Name[x].Substring(0, i) + "\\"; }
                    //  MessageBox.Show(e.Node.Tag.ToString());
                    if (e.Node.Text == tempi && e.Node.Tag.ToString() == Maps.map[mapnumber].FileNames.Name[x] + "." + Maps.map[mapnumber].MetaInfo.TagType[x])
                    {
                        loadmeta(x);
                        return;
                    }
                }
                Maps.map[mapnumber].SelectedMeta = null;

            }



        }
        public void loadmeta(int tag)
        {
            Maps.map[mapnumber].OpenMap(MapTypes.Internal);

            Meta meta = new Meta();

            meta.tagnumber = tag;
            Meta.ScanMetaItems(ref meta, scanbspwithifp.Checked, parsedCheckBox.Checked, mapnumber);
            Maps.map[mapnumber].SelectedMeta = meta;
            Maps.map[mapnumber].CloseMap();



            if (meta.type == "bitm")//;&&Maps.map[mapnumber].HaloVersion!= Map.HaloVersionEnum.Halo1 )
            {



                Raw.ParsedBitmap pm = new Raw.ParsedBitmap(ref meta, mapnumber);
                Bitmap b = pm.FindChunkAndDecode(0, 0, ref meta, mapnumber, 0, 0);
                pictureBox1.Image = b;
                statusbar.Text = pm.Properties[0].width.ToString() + " X " + pm.Properties[0].height.ToString() + " - " + pm.Properties[0].formatname.ToString() + " - Swizzle:" + pm.Properties[0].swizzle.ToString() + "- Location: " + meta.raw.rawChunks[0].rawLocation.ToString();

            }


            meta.SortItemsByOffset();
            //form shit
            metaOffsetBox.Text = meta.offset.ToString("X");
            metaSizeBox.Text = meta.size.ToString("X");
            metaIdentBox.Text = meta.ident.ToString("X");
            metaTypeBox.Text = meta.type;


            switch (meta.type)
            {
                case "PRTM":
                    rawDataDropDown.DropDown = prtmcontext;
                    rawDataDropDown.Enabled = true;
                    break;
                case "mode":
                case "mod2":
                    rawDataDropDown.DropDown = ModelContextStrip;
                    rawDataDropDown.Enabled = true;
                    break;
                case "bitm":
                    rawDataDropDown.DropDown = BitmapContextStrip;
                    rawDataDropDown.Enabled = true;
                    if (ltmpTools.Visible) bitmapEditorToolStripMenuItem_Click(bitmapEditorToolStripMenuItem, null);
                    break;
                case "sbsp":
                    rawDataDropDown.DropDown = BSPcontextMenu;
                    rawDataDropDown.Enabled = true;
                    break;
                case "coll":
                    rawDataDropDown.DropDown = collContextMenu;
                    rawDataDropDown.Enabled = true;
                    break;
                default:
                    rawDataDropDown.Enabled = false;
                    break;
            }


            if (MetaEditorPanel.Visible == true)
            {
                Maps.map[mapnumber].SelectedMeta = meta;
                if (Maps.map[mapnumber].SelectedMeta != null)
                {
                    if (this.ME.selectedTagType == Maps.map[mapnumber].SelectedMeta.type)
                    {
                        this.ME.ReloadMetaForSameTagType(true);
                    }
                    else
                    {
                        this.ME.loadControls(mapnumber);
                    }
                }
            }
            else if (hexView1.Visible == true)
            {


                hexView1.Reload(meta, mapnumber);
                hexView1.Setup(Maps.map[mapnumber].filePath);
                //hexView1.Colorize();

            }
            else if (references.Visible == true)
            {
                ff.AddReferencesToListView(meta, references, Maps.map[mapnumber].DisplayType);
            }










            if (selectedplugin != -1 && LibraryPanel.Visible == true)
            {
                if (((EntityPlugin)plugins.Plugin[selectedplugin]).tagtype == meta.type || ((EntityPlugin)plugins.Plugin[selectedplugin]).tagtype == "!*.*")
                {
                    ((EntityPlugin)plugins.Plugin[selectedplugin]).Run(mapnumber, ref progressbar);
                }
            }

            AddPlugins();
        }



        private void loadMetaButton_Click_1(object sender, System.EventArgs e)
        {
            if (loadMetaDialog.ShowDialog() == DialogResult.Cancel) { return; }
            Meta newm = new Meta();

            newm.LoadMetaFromFile(loadMetaDialog.FileName, mapnumber);

            if (newm.size >= 0 && newm.size <= Maps.map[mapnumber].SelectedMeta.size)
            {
                Maps.map[mapnumber].OpenMap(MapTypes.Internal);
                Maps.map[mapnumber].BW.BaseStream.Position = Maps.map[mapnumber].SelectedMeta.offset;
                Maps.map[mapnumber].BW.BaseStream.Write(newm.MS.ToArray(), 0, newm.size);
                Maps.map[mapnumber].CloseMap();
                ff.AddReferencesToListView(Maps.map[mapnumber].SelectedMeta, references, Maps.map[mapnumber].DisplayType);
                MessageBox.Show("Done");
            }
            else
            {
                MessageBox.Show("Meta Won't Fit");
                return;
            }

        }

        private void analyzeMapButton_Click_1(object sender, System.EventArgs e)
        {
            saveMetaDialog.FileName = "Layout.xml";
            if (saveMetaDialog.ShowDialog() == DialogResult.Cancel) { return; }
            DateTime dt = DateTime.Now;
            MapAnalyzer analyze = new MapAnalyzer();
            MapLayout layout = analyze.ScanMapForLayOut(mapnumber, false);
            layout.ReadChunks(mapnumber);
            layout.SaveToXml(saveMetaDialog.FileName, mapnumber);
            layout = null;
            analyze = null;
            GC.Collect();
            DateTime dt2 = DateTime.Now;
            TimeSpan dt3 = dt2.Subtract(dt); ;
            MessageBox.Show(dt3.ToString());
        }

        private void signMapButton_Click_1(object sender, System.EventArgs e)
        {
            Maps.map[mapnumber].Sign();
            MessageBox.Show("Done");
        }

        private void buildButton_Click_1(object sender, System.EventArgs e)
        {
            if (openInfoFileDialog.ShowDialog() == DialogResult.Cancel) { return; }
            this.Enabled = false;
            this.Focus();

            MapAnalyzer analyze = new MapAnalyzer();

            MapLayout layout = analyze.ScanMapForLayOut(mapnumber, false);
            layout.ReadChunks(mapnumber);
            Builder build = new Builder();
            build.BuildMapFromInfoFile(openInfoFileDialog.FileName, ref layout, mapnumber, soundsCheckBox.Checked);

            Maps.Refresh(mapnumber);
            ff.AddMetasToTreeView(Maps.map[mapnumber], treeView1, metaView, false);
            this.Enabled = true;
            MessageBox.Show("Done");

        }

        private void parsedCheckBox_CheckedChanged_1(object sender, System.EventArgs e)
        {
            if (Maps.map[mapnumber].SelectedMeta == null) { return; }
            loadmeta(Maps.map[mapnumber].SelectedMeta.tagnumber);
        }

        private void ShowReflex_Click_1(object sender, System.EventArgs e)
        {
            Maps.map[mapnumber].DisplayType = Meta.ItemType.Reflexive;
            ff.AddColumnsToListView(references, Maps.map[mapnumber].DisplayType);
            ff.AddReferencesToListView(Maps.map[mapnumber].SelectedMeta, references, Maps.map[mapnumber].DisplayType);
        }

        private void ShowIdent_Click_1(object sender, System.EventArgs e)
        {
            Maps.map[mapnumber].DisplayType = Meta.ItemType.Ident;
            ff.AddColumnsToListView(references, Maps.map[mapnumber].DisplayType);
            ff.AddReferencesToListView(Maps.map[mapnumber].SelectedMeta, references, Maps.map[mapnumber].DisplayType);
        }

        private void ShowString_Click(object sender, System.EventArgs e)
        {
            Maps.map[mapnumber].DisplayType = Meta.ItemType.String;
            ff.AddColumnsToListView(references, Maps.map[mapnumber].DisplayType);
            ff.AddReferencesToListView(Maps.map[mapnumber].SelectedMeta, references, Maps.map[mapnumber].DisplayType);
        }

        private void SwapItem_Click(object sender, System.EventArgs e)
        {
            if (parsedCheckBox.Checked == true)
            {
                MessageBox.Show("Turn off parsing first");
                return;
            }
            if (references.SelectedIndices.Count == 0) { return; }

            for (int x = 0; x < references.SelectedIndices.Count; x++)
            {
                int d = references.SelectedIndices[x];
                int tempcount = 0;

                for (int y = 0; y < Maps.map[mapnumber].SelectedMeta.items.Count; y++)
                {
                    Meta.Item item = (Meta.Item)Maps.map[mapnumber].SelectedMeta.items[y];

                    if (item.type == Maps.map[mapnumber].DisplayType)
                    {
                        switch (item.type)
                        {
                            case Meta.ItemType.Ident:
                                if (tempcount == d)
                                {
                                    Meta.Ident id = (Meta.Ident)item;
                                    IdentSwapper iswap = new IdentSwapper();
                                    int offx = Maps.map[mapnumber].MetaInfo.Offset[Maps.map[mapnumber].SelectedMeta.tagnumber] + id.offset;
                                    iswap.LoadStuff(id.pointstotagnumber, offx, mapnumber);

                                    iswap.ShowDialog();
                                    iswap.Dispose();
                                    y = Maps.map[mapnumber].SelectedMeta.items.Count;
                                }
                                tempcount++;
                                break;
                            default:
                                break;

                        }

                    }

                }

            }

            Maps.map[mapnumber].CloseMap();
            loadmeta(Maps.map[mapnumber].SelectedMeta.tagnumber);
        }

        private void treeView1_ItemDrag(object sender, System.Windows.Forms.ItemDragEventArgs e)
        {
            if (Maps.map[mapnumber].SelectedMeta == null) { return; }

            this.DoDragDrop(this, DragDropEffects.Copy | DragDropEffects.Move);

        }

        public ArrayList scanandpassmetasfordraganddrop()
        {
            Maps.map[mapnumber].OpenMap(MapTypes.Internal);
            ArrayList metas = Maps.map[mapnumber].SelectedMeta.RecursivelyLoadMetas(mapnumber, parsedCheckBox.Checked, progressbar);
            Maps.map[mapnumber].CloseMap();
            return metas;
        }

        private void treeView1_DragEnter(object sender, System.Windows.Forms.DragEventArgs e)
        {
            e.Effect = DragDropEffects.Move;
        }

        private void treeView1_DragDrop(object sender, System.Windows.Forms.DragEventArgs e)
        {
            MapForm f = (MapForm)e.Data.GetData(this.GetType());
            if (f == this) { return; }
            //  try
            //  {
            this.Enabled = false;
            this.Focus();

            ArrayList metas = new ArrayList(0);

            metas = f.scanandpassmetasfordraganddrop();

            for (int x = 0; x < metas.Count; x++)
            {
                Meta temp = (Meta)metas[x];
                string tagtype = temp.type;
                string tagname = temp.name;
                int tempint = Maps.map[mapnumber].Functions.Meta.FindByNameAndTagType(tagtype, tagname, mapnumber);
                if (tempint != -1)
                {
                    metas.RemoveAt(x);
                    continue;
                }
                temp.RelinkReferences(mapnumber);
            }


            MapAnalyzer analyze = new MapAnalyzer();
            MapLayout layout = analyze.ScanMapForLayOut(mapnumber, false);
            layout.ReadChunks(mapnumber);
            Builder build = new Builder();
            build.MapBuilder(metas, ref layout, mapnumber, soundsCheckBox.Checked);
            Maps.Refresh(mapnumber);
            ff.AddMetasToTreeView(Maps.map[mapnumber], treeView1, metaView, false);
            this.Enabled = true;
            MessageBox.Show("Done");
            //  }
            //  catch
            //  {
            this.Enabled = true;

            //  }

        }

        private void toolStripComboBox1_Click(object sender, EventArgs e)
        {

        }

        private void MapForm_Load(object sender, EventArgs e)
        {

        }

        private void metaListToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (metaTreeToolStripMenuItem.Checked == false)
            {
                splitContainer1.Panel1Collapsed = false;
                metaTreeToolStripMenuItem.Checked = true;
            }
            else
            {
                splitContainer1.Panel1Collapsed = true;
                metaTreeToolStripMenuItem.Checked = false;
            }
        }

        private void toolsWindowToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (toolsToolStripMenuItem.Checked == false)
            {
                splitContainer2.Panel1Collapsed = false;
                toolsToolStripMenuItem.Checked = true;
            }
            else
            {
                splitContainer2.Panel1Collapsed = true;
                toolsToolStripMenuItem.Checked = false;
            }
        }

        private void references_MouseDown(object sender, MouseEventArgs e)
        {

            if (e.Button != MouseButtons.Right) { return; }
            displayMenu.Show(references, new Point(e.X, e.Y));

            return;
        }

        private void saveMetaButton_Click(object sender, EventArgs e)
        {
            if (Maps.map[mapnumber].SelectedMeta == null) { return; }
            if (recursiveCheckBox.Checked == false)
            {


                string[] split = Maps.map[mapnumber].SelectedMeta.name.Split('\\');
                string temp = split[split.Length - 1] + "." + Maps.map[mapnumber].SelectedMeta.type;
                temp = temp.Replace('<', '_');
                temp = temp.Replace('>', '_');
                saveMetaDialog.FileName = temp;
                if (saveMetaDialog.ShowDialog() == DialogResult.Cancel) { return; }
                Maps.map[mapnumber].SelectedMeta.SaveMetaToFile(saveMetaDialog.FileName);

            }
            else
            {
                if (folderBrowserDialog.ShowDialog() == DialogResult.Cancel) { return; }
                Maps.map[mapnumber].OpenMap(MapTypes.Internal);
                Maps.map[mapnumber].SelectedMeta.SaveRecursive(folderBrowserDialog.SelectedPath, mapnumber, parsedCheckBox.Checked, progressbar);
                Maps.map[mapnumber].CloseMap();
                MessageBox.Show("Done");
            }

        }

        private void fgdgfgdgdToolStripMenuItem_Click(object sender, EventArgs e)
        {
            referenceEditorToolStripMenuItem.Checked = true;
            metaEditorToolStripMenuItem.Checked = false;
            hexEditorToolStripMenuItem.Checked = false;
            MetaEditorPanel.Visible = false;
            hexView1.Visible = false;
            references.Visible = true;
            LibraryPanel.Visible = false;
            ltmpTools.Visible = false;
            if (Maps.map[mapnumber].SelectedMeta != null)
            {
                ff.AddReferencesToListView(Maps.map[mapnumber].SelectedMeta, references, Maps.map[mapnumber].DisplayType);
            }
        }

        private void metaEditorToolStripMenuItem_Click(object sender, EventArgs e)
        {
            referenceEditorToolStripMenuItem.Checked = false;
            metaEditorToolStripMenuItem.Checked = true;
            hexEditorToolStripMenuItem.Checked = false;
            MetaEditorPanel.Visible = true;
            references.Visible = false;
            hexView1.Visible = false;
            LibraryPanel.Visible = false;
            ltmpTools.Visible = false;
            if (Maps.map[mapnumber].SelectedMeta != null)
            {
                ME.loadControls(mapnumber);
            }

        }

        private void button1_Click(object sender, EventArgs e)
        {
            Maps.map[mapnumber].OpenMap(MapTypes.Internal);
            MetaItemComparer mi = new MetaItemComparer(mapnumber, Application.StartupPath);
            Maps.map[mapnumber].CloseMap();
            MessageBox.Show("Done");
        }

        private void chunkclone_Click(object sender, EventArgs e)
        {
            if (Maps.map[mapnumber].SelectedMeta == null) { return; }

            Maps.map[mapnumber].OpenMap(MapTypes.Internal);
            ChunkClonerWindow cw = new ChunkClonerWindow(Maps.map[mapnumber].SelectedMeta.tagnumber, mapnumber);

            cw.ShowDialog();
            if (cw.result == true)
            {
                int i = Maps.map[mapnumber].SelectedMeta.tagnumber;

                Meta.ItemType me = Maps.map[mapnumber].DisplayType;
                Maps.Refresh(mapnumber);
                loadmeta(i);
                ff.AddReferencesToListView(Maps.map[mapnumber].SelectedMeta, references, me);
                MessageBox.Show("Done");
            }

            Maps.map[mapnumber].CloseMap();
        }

        private void duplicateRecursivelyToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (Maps.map[mapnumber].SelectedMeta == null) { return; }
            this.Enabled = false;
            this.Focus();

            MapAnalyzer analyze = new MapAnalyzer();

            MapLayout layout = analyze.ScanMapForLayOut(mapnumber, false);
            layout.ReadChunks(mapnumber);
            Builder build = new Builder();
            ArrayList metas = new ArrayList();
            metas = scanandpassmetasfordraganddrop();
            for (int x = 0; x < metas.Count; x++)
            {


                string[] temps = ((Meta)metas[x]).name.Split('(', ')', ' ');
                string newname = temps[0];
                int tempcount = 1;
                do
                {
                    bool done = false;
                    newname = temps[0] + " (" + tempcount.ToString() + ")";
                    int index = Array.IndexOf(Maps.map[mapnumber].FileNames.Name, newname);
                    if (index == -1)
                    {
                        break;
                    }

                    do
                    {


                        if (Maps.map[mapnumber].MetaInfo.TagType[index] == ((Meta)metas[x]).type)
                        {
                            tempcount += 1;
                            break;
                        }
                        index = Array.IndexOf(Maps.map[mapnumber].FileNames.Name, newname, index + 1);
                        if (index == -1)
                        {
                            done = true;
                            break;
                        }

                    } while (tempcount != -1);
                    if (done == true) { break; }
                }
                while (tempcount != -1);
                ((Meta)metas[x]).name = newname;
            }

            build.MapBuilder(metas, ref layout, mapnumber, soundsCheckBox.Checked);
            Maps.Refresh(mapnumber);
            ff.AddMetasToTreeView(Maps.map[mapnumber], treeView1, metaView, false);
            this.Enabled = true;
            MessageBox.Show("Done");
        }

        private void duplicateToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (Maps.map[mapnumber].SelectedMeta == null) { return; }
            this.Enabled = false;
            this.Focus();

            MapAnalyzer analyze = new MapAnalyzer();

            MapLayout layout = analyze.ScanMapForLayOut(mapnumber, false);
            layout.ReadChunks(mapnumber);
            Builder build = new Builder();
            ArrayList metas = new ArrayList();

            string[] temps = Maps.map[mapnumber].SelectedMeta.name.Split('(', ')', ' ');
            string newname = temps[0];
            int tempcount = 1;
            do
            {
                bool done = false;
                newname = temps[0] + " (" + tempcount.ToString() + ")";
                int index = Array.IndexOf(Maps.map[mapnumber].FileNames.Name, newname);
                if (index == -1)
                {
                    break;
                }

                do
                {


                    if (Maps.map[mapnumber].MetaInfo.TagType[index] == Maps.map[mapnumber].SelectedMeta.type)
                    {
                        tempcount += 1;
                        break;
                    }
                    index = Array.IndexOf(Maps.map[mapnumber].FileNames.Name, newname, index + 1);
                    if (index == -1)
                    {
                        done = true;
                        break;
                    }

                } while (tempcount != -1);
                if (done == true) { break; }
            }
            while (tempcount != -1);
            Maps.map[mapnumber].SelectedMeta.name = newname;
            metas.Add(Maps.map[mapnumber].SelectedMeta);
            build.MapBuilder(metas, ref layout, mapnumber, soundsCheckBox.Checked);
            Maps.Refresh(mapnumber);
            ff.AddMetasToTreeView(Maps.map[mapnumber], treeView1, metaView, false);
            this.Enabled = true;
            MessageBox.Show("Done");
        }

        private void hexEditorToolStripMenuItem_Click(object sender, EventArgs e)
        {


            referenceEditorToolStripMenuItem.Checked = false;
            metaEditorToolStripMenuItem.Checked = false;
            hexEditorToolStripMenuItem.Checked = true;
            MetaEditorPanel.Visible = false;
            references.Visible = false;
            hexView1.Visible = true;
            LibraryPanel.Visible = false;
            ltmpTools.Visible = false;
            if (Maps.map[mapnumber].SelectedMeta != null)
            {
                hexView1.Reload(Maps.map[mapnumber].SelectedMeta, mapnumber);
                hexView1.Setup(Maps.map[mapnumber].filePath);
                //  hexView1.Colorize();

            }


        }

        private void tagTypeToolStripMenuItem_Click(object sender, EventArgs e)
        {
            tagTypeToolStripMenuItem.Checked = true;
            folderHierarchyToolStripMenuItem.Checked = false;
            metaView = FormFunctions.MetaView.TagTypeView;
            ff.AddMetasToTreeView(Maps.map[mapnumber], treeView1, metaView, false);
        }

        private void folderHierarchyToolStripMenuItem_Click(object sender, EventArgs e)
        {
            tagTypeToolStripMenuItem.Checked = false;
            folderHierarchyToolStripMenuItem.Checked = true;
            metaView = FormFunctions.MetaView.FolderView;

            ff.AddMetasToTreeView(Maps.map[mapnumber], treeView1, metaView, false);
        }

        private void rebuilderToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Maps.map[mapnumber].OpenMap(MapTypes.Internal);
            Rebuilder re = new Rebuilder(mapnumber);
            re.ShowDialog();
            Maps.map[mapnumber].CloseMap();
            if (re.DialogResult != DialogResult.Cancel)
            {
                Maps.Refresh(mapnumber);
                ff.AddMetasToTreeView(Maps.map[mapnumber], treeView1, metaView, false);
            }

        }

        private void overwriteMetaToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (loadMetaDialog.ShowDialog() == DialogResult.Cancel) { return; }
            Meta newm = new Meta();

            newm.LoadMetaFromFile(loadMetaDialog.FileName, mapnumber);
            MetaOverWriter.OverWrite(mapnumber, Maps.map[mapnumber].SelectedMeta.tagnumber, ref newm);
            int i = Maps.map[mapnumber].SelectedMeta.tagnumber;
            Meta.ItemType me = Maps.map[mapnumber].DisplayType;
            Maps.Refresh(mapnumber);
            loadmeta(i);
            ff.AddReferencesToListView(Maps.map[mapnumber].SelectedMeta, references, me);
            MessageBox.Show("Done");
        }



        private void exportModelToolStripMenuItem_Click(object sender, EventArgs e)
        {

        }

        private void exportOBJToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (folderBrowserDialog.ShowDialog() == DialogResult.Cancel) { return; }
            BSP.BSPModel pm = new BSP.BSPModel(ref Maps.map[mapnumber].SelectedMeta, mapnumber);
            string[] temps = Maps.map[mapnumber].SelectedMeta.name.Split('\\');
            pm.Name = temps[temps.Length - 1];


            pm.ExtractModel(folderBrowserDialog.SelectedPath);

            MessageBox.Show("Done");
        }

        private void exportCollisonToOBJToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (saveMetaDialog.ShowDialog() == DialogResult.Cancel) { return; }
            BSP.BSPModel.BSPCollision pm = new entity.BSP.BSPModel.BSPCollision(Maps.map[mapnumber].SelectedMeta);
            //  string[] temps = info.SelectedMeta.name.Split('\\');
            //pm.Name = temps[temps.Length - 1];


            pm.ExtractCollisonMesh(saveMetaDialog.FileName);

            MessageBox.Show("Done");
        }

        private void extractMeshToOBJToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (saveMetaDialog.ShowDialog() == DialogResult.Cancel) { return; }
            MetaContainers.coll coll = new entity.MetaContainers.coll(ref Maps.map[mapnumber].SelectedMeta, mapnumber);
            coll.ExtractMeshes(saveMetaDialog.FileName);
        }



        private void bspcollisionViewerToolStripMenuItem_Click(object sender, EventArgs e)
        {
            BSP.BSPModel.BSPCollision coll = new entity.BSP.BSPModel.BSPCollision(Maps.map[mapnumber].SelectedMeta);
            Renderer.BSPCollisionViewer bv = new entity.Renderer.BSPCollisionViewer(coll, mapnumber);
        }

        private void injectCollisionMeshOBJToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (loadMetaDialog.ShowDialog() == DialogResult.Cancel) { return; }
            BSP.BSPModel.BSPCollision coll = new entity.BSP.BSPModel.BSPCollision(Maps.map[mapnumber].SelectedMeta);
            coll.InjectCollisonMesh(loadMetaDialog.FileName, Maps.map[mapnumber].SelectedMeta, mapnumber);
            loadmeta(Maps.map[mapnumber].SelectedMeta.tagnumber);
        }

        private void collisonViewerToolStripMenuItem_Click(object sender, EventArgs e)
        {
            MetaContainers.coll coll = new MetaContainers.coll(ref Maps.map[mapnumber].SelectedMeta, mapnumber);
            Renderer.CollisionViewer cv = new entity.Renderer.CollisionViewer(coll, mapnumber);
        }

        private void exportMeshToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (folderBrowserDialog.ShowDialog() == DialogResult.Cancel) { return; }
            Raw.ParsedModel pm = new Raw.ParsedModel(ref Maps.map[mapnumber].SelectedMeta, mapnumber);
            pm.ExtractMesh(folderBrowserDialog.SelectedPath);
            MessageBox.Show("Done");
        }

        private void expandMeshX3ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            BSP.BSPModel.BSPCollision coll = new entity.BSP.BSPModel.BSPCollision(Maps.map[mapnumber].SelectedMeta);
            Maps.map[mapnumber].OpenMap(MapTypes.Internal);

            for (int x = 0; x < coll.Vertices.Length; x++)
            {
                coll.Vertices[x].X *= 3;
                coll.Vertices[x].Y *= 3;
                coll.Vertices[x].Z *= 3;
                Maps.map[mapnumber].BW.BaseStream.Position = Maps.map[mapnumber].SelectedMeta.offset + coll.VerticeReflexiveTranslation + (x * 16);
                //  info.BW.Write(coll.Vertices[x].X);
                // info.BW.Write(coll.Vertices[x].Y);
                //  info.BW.Write(coll.Vertices[x].Z);
            }
            for (int x = 0; x < coll.Planes.Length; x++)
            {
                coll.Planes[x].W *= 3;
                Maps.map[mapnumber].BW.BaseStream.Position = Maps.map[mapnumber].SelectedMeta.offset + coll.PlaneReflexiveTranslation + (x * 16) + 12;

                Maps.map[mapnumber].BW.Write(coll.Planes[x].W);
            }
            loadmeta(Maps.map[mapnumber].SelectedMeta.tagnumber);
            MessageBox.Show("Done");
        }

        private void toOBJToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (folderBrowserDialog.ShowDialog() == DialogResult.Cancel) { return; }
            Raw.ParsedModel pm = new Raw.ParsedModel(ref Maps.map[mapnumber].SelectedMeta, mapnumber);
            pm.ExtractMeshesToOBJ(folderBrowserDialog.SelectedPath, mapnumber);
            MessageBox.Show("Done");
        }

        private void toXToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (folderBrowserDialog.ShowDialog() == DialogResult.Cancel) { return; }
            Raw.ParsedModel pm = new Raw.ParsedModel(ref Maps.map[mapnumber].SelectedMeta, mapnumber);
            pm.ExtractMeshesToX(folderBrowserDialog.SelectedPath);
            MessageBox.Show("Done");
        }

        private void makeBSPStickyToolStripMenuItem_Click(object sender, EventArgs e)
        {
            BSP.BSPModel.BSPCollision coll = new entity.BSP.BSPModel.BSPCollision(Maps.map[mapnumber].SelectedMeta);
            Maps.map[mapnumber].OpenMap(MapTypes.Internal);

            for (int x = 0; x < coll.SurfaceReflexiveCount; x++)
            {
                byte i = 4;
                Maps.map[mapnumber].BW.BaseStream.Position = Maps.map[mapnumber].SelectedMeta.offset + coll.SurfaceReflexiveTranslation + (x * 8) + 4;
                Maps.map[mapnumber].BW.Write(i);

            }
            Maps.map[mapnumber].CloseMap();
            MessageBox.Show("Done");
        }

        private void fixSystemLinkToolStripMenuItem_Click(object sender, EventArgs e)
        {
            int count = 0;
            List<int> ids = new List<int>();
            for (int x = 0; x < Maps.map[mapnumber].IndexHeader.metaCount; x++)
            {
                switch (Maps.map[mapnumber].MetaInfo.TagType[x])
                {
                    case "bipd":
                    case "bloc":
                    case "ctrl":


                    case "jpt!":
                    case "mach":

                    case "scen":
                    case "ssce":
                    case "vehi":
                        ids.Add(Maps.map[mapnumber].MetaInfo.Ident[x]);
                        count++;
                        break;
                    case "eqip":
                    case "garb":
                    case "proj":
                        ids.Add(Maps.map[mapnumber].MetaInfo.Ident[x]);
                        ids.Add(Maps.map[mapnumber].MetaInfo.Ident[x]);
                        count += 2;
                        break;
                    case "weap":
                        ids.Add(Maps.map[mapnumber].MetaInfo.Ident[x]);
                        ids.Add(Maps.map[mapnumber].MetaInfo.Ident[x]);
                        ids.Add(Maps.map[mapnumber].MetaInfo.Ident[x]);
                        count += 3;
                        break;

                }
            }
            Maps.map[mapnumber].OpenMap(MapTypes.Internal);
            Meta m = new Meta();
            m.ReadMetaFromMap(3, mapnumber, true);

            IFPIO io = IFP.IFPHashMap.GetIfp("scnr", mapnumber);
            MetaScanner ms = new MetaScanner();
            m.headersize = io.headerSize;
            ms.ScanWithIFP(ref io, ref m, mapnumber);


            MetaSplitter metasplit = new MetaSplitter();
            metasplit.SplitWithIFP(ref io, ref m, mapnumber);


            for (int x = 0; x < metasplit.Header.Chunks[0].ChunkResources.Count; x++)
            {
                if (metasplit.Header.Chunks[0].ChunkResources[x].offset == 984)
                {
                    MetaSplitter.SplitReflexive reflex = (MetaSplitter.SplitReflexive)metasplit.Header.Chunks[0].ChunkResources[x];
                    int diff = count - reflex.Chunks.Count;


                    for (int y = 0; y < diff; y++)
                    {
                        MetaSplitter.SplitReflexive fuck = new MetaSplitter.SplitReflexive();
                        fuck.splitReflexiveType = MetaSplitter.SplitReflexive.SplitReflexiveType.Chunk;
                        fuck.chunksize = 4;

                        fuck.MS = new MemoryStream(4);
                        reflex.Chunks.Add(fuck);
                    }
                    for (int y = 0; y < reflex.Chunks.Count; y++)
                    {
                        BinaryWriter BW = new BinaryWriter(reflex.Chunks[y].MS);
                        BW.Write(ids[y]);
                    }
                    metasplit.Header.Chunks[0].ChunkResources[x] = reflex;
                    break;
                }
            }
            Meta newmeta = MetaBuilder.BuildMeta(metasplit, mapnumber);

            Maps.map[mapnumber].OpenMap(MapTypes.Internal);

            ChunkAdder.Add(mapnumber, newmeta);
            Maps.map[mapnumber].CloseMap();
            // info.OpenMap(MapTypes.Internal);
            //  info.BW.BaseStream.Position = m.offset + r.translation;
            // for (int x = 0; x < count; x++)
            //  {
            //      info.BW.Write(ids[x]);
            //  }
            //  info.CloseMap();
            Maps.Refresh(mapnumber);
            MessageBox.Show("Done");
        }

        private void injectOBJToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (folderBrowserDialog.ShowDialog() == DialogResult.Cancel) { return; }
            Raw.ParsedModel pm = new Raw.ParsedModel(ref Maps.map[mapnumber].SelectedMeta, mapnumber);
            Meta addme = pm.InjectModel(folderBrowserDialog.SelectedPath, Maps.map[mapnumber].SelectedMeta, mapnumber);
            addme.name += "(new)";
            PromptBox promptbox = new PromptBox(addme.name);

            if (promptbox.ShowDialog() == DialogResult.OK) addme.name = promptbox.name;
            ArrayList oi = new ArrayList();
            oi.Add(addme);
            MapAnalyzer analyze = new MapAnalyzer();

            MapLayout layout = analyze.ScanMapForLayOut(mapnumber, false);
            layout.ReadChunks(mapnumber);
            Builder build = new Builder();
            build.MapBuilder(oi, ref layout, mapnumber, false);

            Maps.Refresh(mapnumber);
            ff.AddMetasToTreeView(Maps.map[mapnumber], treeView1, metaView, false);
            this.Enabled = true;
            MessageBox.Show("Done");
        }

        private void portalViewerToolStripMenuItem_Click(object sender, EventArgs e)
        {
            PortalViewer pv = new PortalViewer(ref Maps.map[mapnumber].SelectedMeta, mapnumber);

        }

        private void convertCEToH2ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            string[] split = Maps.map[mapnumber].SelectedMeta.name.Split('\\');
            string temp = split[split.Length - 1] + "." + Maps.map[mapnumber].SelectedMeta.type;
            temp = temp.Replace('<', '_');
            temp = temp.Replace('>', '_');
            saveMetaDialog.FileName = temp;
            if (saveMetaDialog.ShowDialog() == DialogResult.Cancel) { return; }
            switch (Maps.map[mapnumber].SelectedMeta.type)
            {
                case "bitm":
                    Raw.ParsedBitmap pb = new entity.Raw.ParsedBitmap(ref Maps.map[mapnumber].SelectedMeta, mapnumber);
                    pb.ConvertCEtoH2ParsedBitmap(ref Maps.map[mapnumber].SelectedMeta, mapnumber);
                    break;
            }
            Maps.map[mapnumber].SelectedMeta.SaveMetaToFile(saveMetaDialog.FileName);
        }


        private void saveBitmapToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (saveBitmapDialog1.ShowDialog() == DialogResult.Cancel) { return; }
            switch (saveBitmapDialog1.FilterIndex)
            {
                case 1:
                    Raw.ParsedBitmap bm = new entity.Raw.ParsedBitmap(ref Maps.map[mapnumber].SelectedMeta, mapnumber);
                    FileStream fs = new FileStream(saveBitmapDialog1.FileName, FileMode.Create);
                    BinaryWriter br = new BinaryWriter(fs);
                    DDS.ExtractDDS(Maps.map[mapnumber].SelectedMeta, bm, ref br, 0);
                    br.Close();
                    fs.Close();
                    break;
                case 2:
                    pictureBox1.Image.Save(saveBitmapDialog1.FileName, System.Drawing.Imaging.ImageFormat.Bmp);
                    break;
                case 3:
                    pictureBox1.Image.Save(saveBitmapDialog1.FileName, System.Drawing.Imaging.ImageFormat.Jpeg);
                    break;
            }


        }



        private void injectBitmapToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (openBitmapDialog1.ShowDialog() == DialogResult.Cancel) { return; }
            switch (openBitmapDialog1.FilterIndex)
            {
                case 1:
                    Raw.ParsedBitmap bm = new entity.Raw.ParsedBitmap(ref Maps.map[mapnumber].SelectedMeta, mapnumber);
                    FileStream fs = new FileStream(openBitmapDialog1.FileName, FileMode.Open);
                    BinaryReader br = new BinaryReader(fs);
                    DDS.InjectDDS(Maps.map[mapnumber].SelectedMeta, bm, ref br, 0);
                    br.Close();
                    fs.Close();
                    break;

            }
        }

        private void convertToBumpMapToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (saveBitmapDialog1.ShowDialog() == DialogResult.Cancel) { return; }
            Panel p = new Panel();
            Renderer.Renderer r = new entity.Renderer.Renderer();
            r.CreateDevice(p);
            Maps.map[mapnumber].OpenMap(MapTypes.Internal);
            Raw.ParsedBitmap pm = new Raw.ParsedBitmap(ref Maps.map[mapnumber].SelectedMeta, mapnumber);
            Bitmap b = pm.FindChunkAndDecode(0, 0, ref Maps.map[mapnumber].SelectedMeta, mapnumber, 0, 0);
            MetaContainers.ShaderInfo s = new entity.MetaContainers.ShaderInfo();
            s.BumpMapBitmap = b;
            Maps.map[mapnumber].CloseMap();
            s.MakeTextures(ref r.device);
            Microsoft.DirectX.Direct3D.TextureLoader.Save(saveBitmapDialog1.FileName, Microsoft.DirectX.Direct3D.ImageFileFormat.Dds, s.NormalMap);
        }

        private void buttConnect_Click(object sender, EventArgs e)
        {
            if (!RTHInfo.Connected)
            {
                if (Feline_rawr.RTH_Imports.InitRTH(XboxIP.Text) < 0)
                {
                    MessageBox.Show("Couldn't Connect to xbox at: " + XboxIP.Text);
                    RTHInfo.XBoxIPAddy = "0.0.0.0";
                    RTHInfo.Connected = false;
                }
                else
                {
                    MessageBox.Show("Connected to Xbox at: " + XboxIP.Text);
                    RTHInfo.XBoxIPAddy = XboxIP.Text;
                    RTHInfo.Connected = true;
                }
            }
            else
            {
                MessageBox.Show("Already connected at: " + RTHInfo.XBoxIPAddy);
            }
        }

        private void buttDisconnect_Click(object sender, EventArgs e)
        {
            if (RTHInfo.Connected)
            {
                Feline_rawr.RTH_Imports.DeInitRTH();
                RTHInfo.Connected = false;
                RTHInfo.XBoxIPAddy = "0.0.0.0";
            }
        }

        private void injectBSPVisualMeshToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (folderBrowserDialog.ShowDialog() == DialogResult.Cancel) { return; }
            BSP.BSPModel pm = new entity.BSP.BSPModel(ref Maps.map[mapnumber].SelectedMeta, mapnumber);
            Meta addme = pm.InjectModel(folderBrowserDialog.SelectedPath, Maps.map[mapnumber].SelectedMeta, mapnumber);
            addme.name += "(new)";
            PromptBox promptbox = new PromptBox(addme.name);

            if (promptbox.ShowDialog() == DialogResult.OK) addme.name = promptbox.name;
            ArrayList oi = new ArrayList();
            oi.Add(addme);
            MapAnalyzer analyze = new MapAnalyzer();

            MapLayout layout = analyze.ScanMapForLayOut(mapnumber, false);
            layout.ReadChunks(mapnumber);
            Builder build = new Builder();
            build.MapBuilder(oi, ref layout, mapnumber, false);

            Maps.Refresh(mapnumber);
            ff.AddMetasToTreeView(Maps.map[mapnumber], treeView1, metaView, false);
            this.Enabled = true;
            MessageBox.Show("Done");
        }

        private void exportMeshToOBJToolStripMenuItem_Click(object sender, EventArgs e)
        {

            if (saveMetaDialog.ShowDialog() == DialogResult.Cancel) { return; }
            BSP.BSPModel pm = new BSP.BSPModel(ref Maps.map[mapnumber].SelectedMeta, mapnumber);
            string[] temps = saveMetaDialog.FileName.Split('\\');
            string[] temps2 = temps[temps.Length - 1].Split('.');
            pm.Name = temps2[0];


            //         pm.LoadModelStructure(ref Maps.map[mapnumber].SelectedMeta, mapnumber);
            //    pm.LoadPermutations(ref Maps.map[mapnumber].SelectedMeta, mapnumber);
            //     pm.LoadUnknowns(ref Maps.map[mapnumber].SelectedMeta, mapnumber);
            //     pm.Shaders = new entity.BSP.BSPModel.BSPShaderContainer( pm, ref Maps.map[mapnumber].SelectedMeta, mapnumber);
            pm.ExtractModelAsSingleMesh(saveMetaDialog.FileName);

            MessageBox.Show("Done");
        }

        private void viewPRTMToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Renderer.PRTMModel pm = new Renderer.PRTMModel(ref Maps.map[mapnumber].SelectedMeta, mapnumber);

            ModelViewer mv = new ModelViewer(pm);
        }

        private void extractPRTMOBJToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (folderBrowserDialog.ShowDialog() == DialogResult.Cancel) { return; }
            Renderer.PRTMModel pm = new Renderer.PRTMModel(ref Maps.map[mapnumber].SelectedMeta, mapnumber);

            pm.ExtractMeshesToOBJ(folderBrowserDialog.SelectedPath, mapnumber);
            MessageBox.Show("Done");
        }

        private void viewBSPToolStripMenuItem_Click(object sender, EventArgs e)
        {

            BSP.BSPModel bsp = new BSP.BSPModel(ref Maps.map[mapnumber].SelectedMeta, mapnumber);

            // MessageBox.Show("test");
            BSPViewer bv = new BSPViewer(bsp, mapnumber);

            bsp.Dispose();
            bsp = null;

            bv.Dispose();
            bv = null;

        }

        private void viewModelToolStripMenuItem_Click(object sender, EventArgs e)
        {

            Raw.ParsedModel pm = new Raw.ParsedModel(ref Maps.map[mapnumber].SelectedMeta, mapnumber);

            ModelViewer mv = new ModelViewer(pm);

            pm.Dispose();
            pm = null;
            mv.Dispose();
            mv = null;

        }

        private void lTMPViewerToolStripMenuItem_Click(object sender, EventArgs e)
        {

            MetaEditorPanel.Visible = false;
            hexView1.Visible = false;
            references.Visible = false;
            LibraryPanel.Visible = false;
            ltmpTools.Visible = true;


        }







        private void bitmapEditorToolStripMenuItem_Click(object sender, EventArgs e)
        {
            ltmpTools.Visible = true;
            ltmpTools.BringToFront();
            ltmpTools.Controls.Clear();
            BitmapControl bc = new BitmapControl(mapnumber);
            ltmpTools.Controls.Add(bc);

        }

        private void exportScriptsToolStripMenuItem_Click(object sender, EventArgs e)
        {
            entity.Scripts.Scripts s = new entity.Scripts.Scripts(mapnumber);
            s.WriteScriptInfotoText("C:\\scripts.txt");
            MessageBox.Show("Done");
        }

        private void treeView1_KeyPress(object sender, KeyPressEventArgs e)
        {

            if ((int)(byte)e.KeyChar == 22)//Ctrl + v
            {
                if (Maps.map[mapnumber].SelectedMeta == null) { return; }
                if (Maps.map[mapnumber].SelectedMeta.type == "PRTM")
                {
                    //PRTM Viewer
                    Renderer.PRTMModel pm = new Renderer.PRTMModel(ref Maps.map[mapnumber].SelectedMeta, mapnumber);
                    ModelViewer mv = new ModelViewer(pm);
                }
                else if (Maps.map[mapnumber].SelectedMeta.type == "mod2" || Maps.map[mapnumber].SelectedMeta.type == "mode")
                {
                    //MODE Viewer
                    Raw.ParsedModel pm = new Raw.ParsedModel(ref Maps.map[mapnumber].SelectedMeta, mapnumber);
                    ModelViewer mv = new ModelViewer(pm);
                    pm.Dispose();
                    pm = null;
                    mv.Dispose();
                    mv = null;
                }
                else if (Maps.map[mapnumber].SelectedMeta.type == "coll")
                {
                    MetaContainers.coll coll = new MetaContainers.coll(ref Maps.map[mapnumber].SelectedMeta, mapnumber);
                    Renderer.CollisionViewer cv = new entity.Renderer.CollisionViewer(coll, mapnumber);
                }
                else if (Maps.map[mapnumber].SelectedMeta.type == "sbsp")
                {
                    //SBSP Viewer
                    BSP.BSPModel bsp = new BSP.BSPModel(ref Maps.map[mapnumber].SelectedMeta, mapnumber);
                    // MessageBox.Show("test");
                    BSPViewer bv = new BSPViewer(bsp, mapnumber);
                    bsp.Dispose();
                    bsp = null;
                    bv.Dispose();
                    bv = null;
                }

            }

        }

        private void menuItem2_Click(object sender, EventArgs e)
        {
            //if only one item is selected
            if (references.SelectedIndices.Count == 1)
            {
                //the type and tag selected
                string type = "", tag = "";

                //find out what the type and tag are
                switch (Maps.map[mapnumber].DisplayType)
                {
                    case Meta.ItemType.Ident:
                        type = references.FocusedItem.SubItems[2].Text;
                        tag = references.FocusedItem.SubItems[3].Text;
                        break;

                    case Meta.ItemType.Reflexive:
                        type = references.FocusedItem.SubItems[5].Text;
                        tag = references.FocusedItem.SubItems[6].Text;
                        break;

                    case Meta.ItemType.String:
                        type = references.FocusedItem.SubItems[3].Text;
                        tag = references.FocusedItem.SubItems[4].Text;
                        break;

                    default:
                        return;
                }

                //select the new tag in the treeview (in doing so will load it)
                foreach (TreeNode tn in treeView1.Nodes)
                {
                    if (tn.Text == type)
                    {
                        foreach (TreeNode tn2 in tn.Nodes)
                        {
                            if (tn2.Text == tag)
                            {
                                treeView1.SelectedNode = tn2;
                                break;
                            }
                        }
                        break;
                    }
                }
            }
        }
    }
}