using System;
using System.Collections.Generic;
using System.ComponentModel;

namespace entity.H1MetaContainers
{


    public class H1SBSP : TagInterface
    {
        
        

        public H1SBSP(int tagnumber, int mapnumber)
            : base(tagnumber, mapnumber)
        {
           this.Header = new TagBlock("SBSP", SBSP.Layout, Map.HaloVersionEnum.Halo1);
           this.Header.ReadElements();

       
         

        }
     
        public class SBSP : TagBlockLayout
        {
            public PaddingX temppadding = new PaddingX(200,"TempPadding");
            public TagBlock bsp = new TagBlock("BSP Collision", BSP.Layout, Map.HaloVersionEnum.Halo1);
            public RealRGBColor test = new RealRGBColor("rgb");

            public SBSP() 
            {
                Add(temppadding);
                Add(bsp);
                Add(test);
            }

            
             public class BSP : TagBlockLayout
            {

                public TagBlock bsp_3d_nodes = new TagBlock("BSP_3D_Nodes",BSP3DNode.Layout, Map.HaloVersionEnum.Halo1);
                public TagBlock bsp_planes = new TagBlock("BSP_Planes", BSP_Plane.Layout,Map.HaloVersionEnum.Halo1);
                public TagBlock bsp_leaves = new TagBlock("BSP_Leaves", Leaf.Layout, Map.HaloVersionEnum.Halo1);
                public TagBlock bsp_2d_references = new TagBlock("BSP_2D_References", BSP_2D_Reference.Layout, Map.HaloVersionEnum.Halo1);
                public TagBlock bsp_2d_nodes = new TagBlock("BSP_2D_Nodes", BSP_2D_Node.Layout,Map.HaloVersionEnum.Halo1);
                public TagBlock bsp_surfaces = new TagBlock("BSP_Surfaces", BSP_Surface.Layout, Map.HaloVersionEnum.Halo1);
                public TagBlock bsp_edges = new TagBlock("BSP_Edges", Edge.Layout, Map.HaloVersionEnum.Halo1);
                public TagBlock bsp_vertices = new TagBlock("BSP_Vertices", Vertice.Layout, Map.HaloVersionEnum.Halo1);
                public BSP()
                {
                    Add(bsp_3d_nodes);
                    Add(bsp_planes);
                    Add(bsp_leaves);
                    Add(bsp_2d_references);
                    Add(bsp_2d_nodes);
                    Add(bsp_surfaces);
                    Add(bsp_edges);
                    Add(bsp_vertices);
                }


                public class BSP3DNode : TagBlockLayout
                {
                    LongInteger plane_index = new LongInteger("BSP_Plane Index");
                    LongInteger backchild = new LongInteger("Back Child");
                    ShortInteger frontchild = new ShortInteger("Front Child");
                    ByteInteger unknown1 = new ByteInteger("unknown1");
                    ByteInteger unknown2 = new ByteInteger("unknown2");
                    public BSP3DNode()
                       
                    {
                        Add(plane_index);
                        Add(backchild);
                        Add(unknown1);
                        Add(frontchild);
                        Add(unknown2);
                    }

                    public static readonly BSP3DNode Layout = new BSP3DNode();
                }


                public class BSP_Plane : TagBlockLayout
                {
                    RealPlane3D plane = new RealPlane3D("BSP_Plane");

                    public BSP_Plane()
                       
                    {
                        Add(plane);
                    }

                    public static readonly BSP_Plane Layout = new BSP_Plane();
                }


                public class Leaf : TagBlockLayout
                {
                    WordFlags flags = new WordFlags("Flags");
                    ShortInteger bsp2drefcount = new ShortInteger("BSP_2D_Reference Count");
                    LongInteger bsp2drefindex = new LongInteger("BSP_2D_Reference Start Index");
                    public Leaf()
                       
                    {
                        Add(flags);
                        Add(bsp2drefcount);
                        Add(bsp2drefindex);
                    }

                    public static readonly Leaf Layout = new Leaf();
                }



                public class BSP_2D_Reference : TagBlockLayout
                {
                    LongInteger plane_index = new LongInteger("BSP_Plane Index");
                    LongInteger bsp_2d_node_index = new LongInteger("BSP_2D_Node Index");
                    public BSP_2D_Reference()
                       
                    {
                        Add(plane_index);
                        Add(bsp_2d_node_index);
                    }

                    public static readonly BSP_2D_Reference Layout = new BSP_2D_Reference();
                }

                public class BSP_2D_Node : TagBlockLayout
                {
                    RealPlane3D plane = new RealPlane3D("Plane");
                    LongInteger leftchild = new LongInteger("Left Child");
                    LongInteger rightchild = new LongInteger("Right Child");
                    public BSP_2D_Node()
                       
                    {
                        Add(plane);
                        Add(leftchild);
                        Add(rightchild);
                    }
                    public static readonly BSP_2D_Node Layout = new BSP_2D_Node();

                }

                public class BSP_Surface : TagBlockLayout
                {
                    LongInteger plane_index = new LongInteger("Plane Index");
                    LongInteger first_edge = new LongInteger("First Edge");
                    ByteFlags flags = new ByteFlags("Flags");
                    ByteInteger breakablesurface_index = new ByteInteger("Breakable Surface Index");
                    ShortInteger collision_material_index = new ShortInteger("Collision Material Index");

                    public BSP_Surface()
                       
                    {
                        Add(plane_index);
                        Add(first_edge);
                        Add(flags);
                        Add(breakablesurface_index);
                        Add(collision_material_index);
                    }
                    public static readonly BSP_Surface Layout = new BSP_Surface();

                }



                public class Edge : TagBlockLayout
                {
                    LongInteger StartVertex = new LongInteger("Start Vertex");
                    LongInteger EndVertex = new LongInteger("End Vertex");
                    LongInteger ForwardEdge = new LongInteger("Forward Edge");
                    LongInteger ReverseEdge = new LongInteger("Reverse Edge");
                    LongInteger LeftSurface = new LongInteger("Left Surface");
                    LongInteger RightSurface = new LongInteger("Right Surface");
                    public Edge()
                       
                    {
                        Add(StartVertex);
                        Add(EndVertex);
                        Add(ForwardEdge);
                        Add(ReverseEdge);
                        Add(LeftSurface);
                        Add(RightSurface);
                    }

                    public static readonly Edge Layout = new Edge();
                }

                public class Vertice : TagBlockLayout
                {
                    RealPoint3D vertice = new RealPoint3D("Vertice");
                    LongInteger firstedge = new LongInteger("First Edge");
                    public Vertice()
                       
                    {
                        Add(vertice);
                        Add(firstedge);
                     }

                    public static readonly Vertice Layout = new Vertice();
                }

                 public static readonly BSP Layout = new BSP();
            }

            public static readonly SBSP Layout = new SBSP();
        }
    }
}
