using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
using System.Collections;
using System.Windows.Forms;
using Microsoft.DirectX;
using Microsoft.DirectX.Direct3D;

namespace entity.MetaContainers
{
    public class coll
    {
        #region Fields
        public List<CollisionMesh> Meshes = new List<CollisionMesh>();
        public List<PathfindingSphere> Spheres = new List<PathfindingSphere>();
        public List<string> ConditionStrings = new List<string>();
        #endregion
        #region Constructor
        public coll(ref Meta meta,int mapnumber)
        {
            BinaryReader BR=new BinaryReader(meta.MS);
            BR.BaseStream.Position=28;
            int tempc=BR.ReadInt32();
            int tempr=BR.ReadInt32()-meta.magic-meta.offset;
             for (int xxx = 0; xxx < tempc; xxx++)
                {
                    BR.BaseStream.Position = tempr + (xxx * 12);
                    string index1string = Maps.map[mapnumber].Strings.Name[BR.ReadUInt16()];
                BR.BaseStream.Position = tempr +(xxx*12)+ 4;
                int tempcxx = BR.ReadInt32();
                int temprxx = BR.ReadInt32() - meta.magic - meta.offset;
                for (int xx = 0; xx < tempcxx; xx++)
                {
                    BR.BaseStream.Position = temprxx + (xx * 20);
                    string index2string = Maps.map[mapnumber].Strings.Name[BR.ReadUInt16()];
                    BR.BaseStream.Position = temprxx + (xx * 20) + 4;
                    int tempcx = BR.ReadInt32();
                    int temprx = BR.ReadInt32() - meta.magic - meta.offset;
                    //Meshes = new CollisionMesh[tempc];
                    for (int x = 0; x < tempcx; x++)
                    {
                        CollisionMesh cm = new CollisionMesh();
                        cm.index1 = xxx;
                        cm.index1string = index1string;
                        cm.index2 = xx;
                        cm.index2string = index2string;
                        if (ConditionStrings.IndexOf(cm.index2string) == -1)
                        {
                            ConditionStrings.Add(cm.index2string);
                        }
                        cm.index3 = x;
                  
                        BR.BaseStream.Position = temprx + (x * 68) + 52;
                        int tempc2 = BR.ReadInt32();
                        int tempr2 = BR.ReadInt32() - meta.magic - meta.offset;

                    
                        cm.Faces = new ushort[tempc2 * 3];
                        for (int y = 0; y < tempc2; y++)
                        {
                            BR.BaseStream.Position = tempr2 + (y * 12);
                            cm.Faces[(y * 3)] = BR.ReadUInt16();
                            cm.Faces[(y * 3) + 1] = BR.ReadUInt16();
                            cm.Faces[(y * 3) + 2] = cm.Faces[(y * 3) + 1];// BR.ReadUInt16();
                        }


                        BR.BaseStream.Position = temprx + (x * 68) + 60;
                        tempc2 = BR.ReadInt32();
                        tempr2 = BR.ReadInt32() - meta.magic - meta.offset;

                        //Meshes[x] = new CollisionMesh();
                        cm.Vertices = new Vector3[tempc2];
                        for (int y = 0; y < tempc2; y++)
                        {
                            BR.BaseStream.Position = tempr2 + (y * 16);
                            cm.Vertices[y].X = BR.ReadSingle();
                            cm.Vertices[y].Y = BR.ReadSingle();
                            cm.Vertices[y].Z = BR.ReadSingle();
                        }
                        
                        Meshes.Add(cm);
                    }
                }
            }
            BR.BaseStream.Position = 36;
            tempc = BR.ReadInt32();
            tempr = BR.ReadInt32() - meta.magic - meta.offset;
            for (int xxx = 0; xxx < tempc; xxx++)
            {
                BR.BaseStream.Position = tempr + (20 * xxx);
                PathfindingSphere ps = new PathfindingSphere();
                ps.nodeindex = BR.ReadInt32();
                ps.position = new Vector3();
                ps.position.X = BR.ReadSingle();
                ps.position.Y = BR.ReadSingle();
                ps.position.Z = BR.ReadSingle();
                ps.radius = BR.ReadSingle();
                Spheres.Add(ps);
            }

        }
        #endregion
        #region Methods
        public void ExtractMeshes(string FilePath)
        {
          
            for (int x = 0; x < Meshes.Count; x++)
            {
                FileStream FS = new FileStream(FilePath
                    +"["+Meshes[x].index1string+"]"
                    + "[" + Meshes[x].index2string + "]"
                    +"["+Meshes[x].index3.ToString()+"]"
                    +".obj", FileMode.Create);
                StreamWriter SW = new StreamWriter(FS);
                SW.WriteLine("# ------------------------------------");
                SW.WriteLine("# Halo 2 Collision Mesh - Extracted with Entity");
                SW.WriteLine("# ------------------------------------");
                for (int xx = 0; xx < Meshes[x].Vertices.Length; xx++)
                {
                    string temps = "v " + Meshes[x].Vertices[xx].X.ToString() + " "
                                        + Meshes[x].Vertices[xx].Y.ToString() + " "
                                        + Meshes[x].Vertices[xx].Z.ToString();
                    SW.WriteLine(temps);
                }
                for (int xx = 0; xx < Meshes[x].Faces.Length; xx += 3)
                {
                    string temps = "f " + (Meshes[x].Faces[xx] + 1) + " "
                                        + (Meshes[x].Faces[xx + 1] + 1) + " "
                                        + (Meshes[x].Faces[xx + 1] + 1);
                    SW.WriteLine(temps);
                }

                SW.Close();
                FS.Close();
            }
        }
        #endregion
        #region
        public class CollisionMesh
        {
            public Vector3[] Vertices;
            public ushort[] Faces;
            public int index1;
            public string index1string;
            public int index2;
            public string index2string;
            public int index3;
        }
        public class PathfindingSphere
        {
            public int nodeindex;
            public Vector3 position;
            public float radius;
        }
        #endregion
    }

    public class DirectXBSPCollision
    {
        public IndexBuffer ib;
        public VertexBuffer vb;
        public int verticeCount;
        public int faceCount;
        public DirectXBSPCollision(ref Device device,ref BSP.BSPModel.BSPCollision tempcoll)
        {
            CreateVertexBuffers(ref device, ref tempcoll);
            CreateIndexBuffers(ref device, ref tempcoll);
            verticeCount = tempcoll.Vertices.Length;
            faceCount = tempcoll.Faces.Length;
        }

        private void CreateIndexBuffers(ref Device device, ref BSP.BSPModel.BSPCollision tempcoll)
        {

            ib = new IndexBuffer(typeof(short), tempcoll.Faces.Length, device, Usage.WriteOnly, Pool.Default);
            ib.SetData(tempcoll.Faces, 0, LockFlags.None);
            ib.Unlock();
        
        }
        private void CreateVertexBuffers(ref Device device, ref BSP.BSPModel.BSPCollision tempcoll)
        {

            vb = new VertexBuffer(typeof(CustomVertex.PositionColored), tempcoll.Vertices.Length, device, Usage.WriteOnly, CustomVertex.PositionColored.Format, Pool.Default);
            CustomVertex.PositionColored[] verts = (CustomVertex.PositionColored[])vb.Lock(0, 0); // Lock the buffer (which will return our structs)
 
            for (int i = 0; i < tempcoll.Vertices.Length; i++)
            {

                verts[i].Position = new Vector3(tempcoll.Vertices[i].X, tempcoll.Vertices[i].Y, tempcoll.Vertices[i].Z);
           
               
            }
            // Unlock (and copy) the data
            vb.Unlock();
        }

        public  void Draw(ref Device device)
            {
            
                    device.SetStreamSource(0, vb, 0);
                    device.VertexFormat = CustomVertex.PositionColored.Format;
                    device.Indices = ib;
                   
                    device.RenderState.AlphaBlendEnable = false;
                    device.RenderState.AlphaTestEnable = false;



                   
                        device.SetTexture(0, null);
                        
                        PrimitiveType pt;
                    
                           pt = PrimitiveType.TriangleList;
                           device.DrawIndexedPrimitives(
                          pt,
                          0,
                          0,
                          this.verticeCount,
                          0,
                          this.faceCount/3);
        }
        
    }


    public class DirectXCollision
    {
        public List<IndexBuffer> ib = new List<IndexBuffer>();
        public List<VertexBuffer> vb = new List<VertexBuffer>();
        public List<Mesh> sphere = new List<Mesh>();
        public List<Matrix> spherematrix = new List<Matrix>();
        public List<int> verticeCount = new List<int>();
        public List<int> faceCount = new List<int>();
        public DirectXCollision(ref Device device, ref MetaContainers.coll tempcoll)
        {
            CreateVertexBuffers(ref device, ref tempcoll);
            CreateIndexBuffers(ref device, ref tempcoll);
            CreateSpheres(ref device, ref tempcoll);
            //     verticeCount = tempcoll.Vertices.Length;

            //   faceCount = tempcoll.Faces.Length;
        }
        private void CreateSpheres(ref Device device, ref MetaContainers.coll tempcoll)
        {
            for (int x = 0; x < tempcoll.Spheres.Count; x++)
            {
                Mesh m = Mesh.Sphere(device, tempcoll.Spheres[x].radius, 10, 10);
                sphere.Add(m);
                Matrix mm = Matrix.Identity; ;
                mm.Multiply(Matrix.Translation(tempcoll.Spheres[x].position));
                spherematrix.Add(mm);
            }
        }
        private void CreateIndexBuffers(ref Device device, ref MetaContainers.coll tempcoll)
        {

            for (int x = 0; x < tempcoll.Meshes.Count; x++)
            {
                if (tempcoll.Meshes[x].index2string == tempcoll.ConditionStrings[0])
                {
                    IndexBuffer tempib;
                    tempib = new IndexBuffer(typeof(short), tempcoll.Meshes[x].Faces.Length, device, Usage.WriteOnly, Pool.Default);
                    tempib.SetData(tempcoll.Meshes[x].Faces, 0, LockFlags.None);
                    tempib.Unlock();
                    ib.Add(tempib);
                    faceCount.Add(tempcoll.Meshes[x].Faces.Length);
                }
            }


        }
        private void CreateVertexBuffers(ref Device device, ref MetaContainers.coll tempcoll)
        {
            for (int x = 0; x < tempcoll.Meshes.Count; x++)
            {
                if (tempcoll.Meshes[x].index2string == tempcoll.ConditionStrings[0])
                {
                    VertexBuffer vbx = new VertexBuffer(typeof(CustomVertex.PositionColored), tempcoll.Meshes[x].Vertices.Length, device, Usage.WriteOnly, CustomVertex.PositionColored.Format, Pool.Default);
                    CustomVertex.PositionColored[] verts = (CustomVertex.PositionColored[])vbx.Lock(0, 0); // Lock the buffer (which will return our structs)

                    for (int i = 0; i < tempcoll.Meshes[x].Vertices.Length; i++)
                    {

                        verts[i].Position = new Vector3(tempcoll.Meshes[x].Vertices[i].X, tempcoll.Meshes[x].Vertices[i].Y, tempcoll.Meshes[x].Vertices[i].Z);


                    }

                    vbx.Unlock();
                    vb.Add(vbx);
                    verticeCount.Add(tempcoll.Meshes[x].Vertices.Length);

                }
            }


        }
        public void DrawSpheres(ref Device device)
        {
            for (int x = 0; x<this.sphere.Count; x++)
            {
                
                device.RenderState.AlphaBlendEnable = false;
                device.RenderState.AlphaTestEnable = false;



                device.Transform.World = spherematrix[x];
                device.SetTexture(0, null);

                this.sphere[0].DrawSubset(0);
            }
        }

        public void DrawMeshes(ref Device device)
        {
            for (int i = 0; i < this.vb.Count; i++)
            {

            device.SetStreamSource(0, vb[i], 0);
            device.VertexFormat = CustomVertex.PositionColored.Format;
            device.Indices = ib[i];

            device.RenderState.AlphaBlendEnable = false;
            device.RenderState.AlphaTestEnable = false;



            device.Transform.World = Matrix.Identity;
            device.SetTexture(0, null);

            PrimitiveType pt;

            pt = PrimitiveType.TriangleList;
            device.DrawIndexedPrimitives(
           pt,
           0,
           0,
           this.verticeCount[i],
           0,
           this.faceCount[i] / 3);
        }
        }
    }
}
