using System;
using System.Collections.Generic;
using System.Text;
using System.Drawing;
using Microsoft.DirectX;
using Microsoft.DirectX.Direct3D;
namespace entity.MetaContainers
{
    public class ShaderInfo
    {
        #region Fields
        int levels = 1;
        public int tagnumber;
        public string shaderName;
        public Bitmap MainBitmap;
        public Texture MainTexture;
        public string MainName="";
        public AlphaType Alpha;
        public Bitmap BumpMapBitmap;
        public Texture BumpMapTexture;
        public string BumpMapName;
        public Bitmap CubeMapBitmap;
        public Texture CubeMapTexture;
        public string CubeMapName;
        public Texture NormalMap;

        public Bitmap primarydetailBitmap;
        public Texture primarydetailTexture;
        public string primarydetailName;
        public float primarydetailuscale;
        public float primarydetailvscale;
        public float primarydetailwscale;
        public Bitmap secondarydetailBitmap;
        public Texture secondarydetailTexture;
        public string secondarydetailName;
        public float secondarydetailuscale;
        public float secondarydetailvscale;
        public float secondarydetailwscale;

        public Bitmap microdetailBitmap;
        public Texture microdetailTexture;
        public string microdetailName;
        public float microdetailuscale;
        public float microdetailvscale;
        public float microdetailwscale;
        public List<Bitmap> Bitmaps = new List<Bitmap>();
        public List<string> BitmapNames = new List<string>();
        public Texture[] BitmapTextures;

        #endregion
        #region Enums
        public enum AlphaType
        {
            None,
            AlphaTest,
            AlphaBlend,

        }
        #endregion
        #region Constructor
        public ShaderInfo()
        {
        }
        public ShaderInfo(int tagnumber, int mapnumber)
        {
            switch (Maps.map[mapnumber].HaloVersion)
            {
                case Map.HaloVersionEnum.Halo2:
                    H2ShaderInfo(tagnumber, mapnumber);
                    break;
                case Map.HaloVersionEnum.Halo1:
                case Map.HaloVersionEnum.HaloCE:
                    CEShaderInfo(tagnumber, mapnumber);
                    break;
            }
        }
        public void CEShaderInfo(int tagnumber, int mapnumber)
        {
            this.tagnumber = tagnumber;
            if (this.tagnumber == -1) { return; }
            this.shaderName = Maps.map[mapnumber].FileNames.Name[this.tagnumber];


            Maps.map[mapnumber].OpenMap(MapTypes.Internal);
            int mainid = 0;
            int primarydetail = -1;
            int secondarydetail = -1;
            int micro = -1;
            switch (Maps.map[mapnumber].MetaInfo.TagType[tagnumber])
            {

                case "schi":
                    Maps.map[mapnumber].BR.BaseStream.Position = Maps.map[mapnumber].MetaInfo.Offset[tagnumber] + 228;
                    mainid = Maps.map[mapnumber].BR.ReadInt32();
                    break;
                case "soso":
                    Maps.map[mapnumber].BR.BaseStream.Position = Maps.map[mapnumber].MetaInfo.Offset[tagnumber] + 176;
                    mainid = Maps.map[mapnumber].BR.ReadInt32();
                    break;
                case "sgla":
                    Maps.map[mapnumber].BR.BaseStream.Position = Maps.map[mapnumber].MetaInfo.Offset[tagnumber] + 356;
                    mainid = Maps.map[mapnumber].BR.ReadInt32();
                    break;
                case "scex":
                    Maps.map[mapnumber].BR.BaseStream.Position = Maps.map[mapnumber].MetaInfo.Offset[tagnumber] + 900;
                    mainid = Maps.map[mapnumber].BR.ReadInt32();
                    break;
                case "senv":
                    Maps.map[mapnumber].BR.BaseStream.Position = Maps.map[mapnumber].MetaInfo.Offset[tagnumber] + 148;
                    mainid = Maps.map[mapnumber].BR.ReadInt32();
                    Maps.map[mapnumber].BR.BaseStream.Position = Maps.map[mapnumber].MetaInfo.Offset[tagnumber] + 180;
                    this.primarydetailuscale = Maps.map[mapnumber].BR.ReadSingle();
                    this.primarydetailvscale = this.primarydetailuscale;
                    this.primarydetailwscale = 1;
                    Maps.map[mapnumber].BR.BaseStream.Position = Maps.map[mapnumber].MetaInfo.Offset[tagnumber] + 196;
                    primarydetail =  Maps.map[mapnumber].BR.ReadInt32();

                    Maps.map[mapnumber].BR.BaseStream.Position = Maps.map[mapnumber].MetaInfo.Offset[tagnumber] + 200;
                    this.secondarydetailuscale = Maps.map[mapnumber].BR.ReadSingle();
                    this.secondarydetailvscale = this.secondarydetailuscale;
                    this.secondarydetailwscale = 1;
                    Maps.map[mapnumber].BR.BaseStream.Position = Maps.map[mapnumber].MetaInfo.Offset[tagnumber] + 216;
                    secondarydetail  = Maps.map[mapnumber].BR.ReadInt32();

                    Maps.map[mapnumber].BR.BaseStream.Position = Maps.map[mapnumber].MetaInfo.Offset[tagnumber] + 248;
                    this.microdetailuscale = Maps.map[mapnumber].BR.ReadSingle();
                    this.microdetailvscale = this.secondarydetailuscale;
                    this.microdetailwscale = 1;
                    Maps.map[mapnumber].BR.BaseStream.Position = Maps.map[mapnumber].MetaInfo.Offset[tagnumber] + 264;
                    micro = Maps.map[mapnumber].BR.ReadInt32();

                    Maps.map[mapnumber].BR.BaseStream.Position = Maps.map[mapnumber].MetaInfo.Offset[tagnumber] + 40;
                    byte alphatest = Maps.map[mapnumber].BR.ReadByte();
                    int test=alphatest & 1;
                    if ((test) != 0) this.Alpha = AlphaType.AlphaTest;
                    break;
                case "swat":
                    Maps.map[mapnumber].BR.BaseStream.Position = Maps.map[mapnumber].MetaInfo.Offset[tagnumber] + 88;
                    mainid = Maps.map[mapnumber].BR.ReadInt32();
                    break;
                case "smet":
                    Maps.map[mapnumber].BR.BaseStream.Position = Maps.map[mapnumber].MetaInfo.Offset[tagnumber] + 88;
                    mainid = Maps.map[mapnumber].BR.ReadInt32();
                    break;
            }


            Maps.map[mapnumber].CloseMap();

            mainid = Maps.map[mapnumber].Functions.Meta.FindMetaByID(mainid, mapnumber);
            primarydetail = Maps.map[mapnumber].Functions.Meta.FindMetaByID(primarydetail, mapnumber);
            secondarydetail = Maps.map[mapnumber].Functions.Meta.FindMetaByID(secondarydetail, mapnumber);
            micro = Maps.map[mapnumber].Functions.Meta.FindMetaByID(micro, mapnumber);
            if (mainid == -1) { return; }
            if (Maps.map[mapnumber].MetaInfo.external[mainid] == true)
            {
                Maps.map[mapnumber].OpenMap(MapTypes.Bitmaps);
            }
            else
            {
                Maps.map[mapnumber].OpenMap(MapTypes.Internal);
            }
            Meta tempmeta = new Meta();
            tempmeta.ReadMetaFromMap(mainid, mapnumber, false);

            Maps.map[mapnumber].CloseMap();
            Raw.ParsedBitmap pm = new Raw.ParsedBitmap(ref tempmeta, mapnumber);
            this.MainBitmap = pm.FindChunkAndDecode(0, 0, ref tempmeta, mapnumber, 0,0);
            this.MainName = Maps.map[mapnumber].FileNames.Name[mainid];

            if (primarydetail != -1)
            {


                if (Maps.map[mapnumber].MetaInfo.external[primarydetail] == true)
                {
                    Maps.map[mapnumber].OpenMap(MapTypes.Bitmaps);
                }
                else
                {
                    Maps.map[mapnumber].OpenMap(MapTypes.Internal);
                }
                tempmeta = new Meta();
                tempmeta.ReadMetaFromMap(primarydetail, mapnumber, false);

                Maps.map[mapnumber].CloseMap();
                pm = new Raw.ParsedBitmap(ref tempmeta, mapnumber);
                this.primarydetailBitmap = pm.FindChunkAndDecode(0, 0, ref tempmeta, mapnumber, 0, 0);
                this.primarydetailName = Maps.map[mapnumber].FileNames.Name[primarydetail];

            }

            if (secondarydetail != -1)
            {


                if (Maps.map[mapnumber].MetaInfo.external[secondarydetail] == true)
                {
                    Maps.map[mapnumber].OpenMap(MapTypes.Bitmaps);
                }
                else
                {
                    Maps.map[mapnumber].OpenMap(MapTypes.Internal);
                }
                tempmeta = new Meta();
                tempmeta.ReadMetaFromMap(secondarydetail, mapnumber, false);

                Maps.map[mapnumber].CloseMap();
                pm = new Raw.ParsedBitmap(ref tempmeta, mapnumber);
                this.secondarydetailBitmap = pm.FindChunkAndDecode(0, 0, ref tempmeta, mapnumber, 0, 0);
                this.secondarydetailName = Maps.map[mapnumber].FileNames.Name[secondarydetail];

            }


            if (micro != -1)
            {


                if (Maps.map[mapnumber].MetaInfo.external[micro] == true)
                {
                    Maps.map[mapnumber].OpenMap(MapTypes.Bitmaps);
                }
                else
                {
                    Maps.map[mapnumber].OpenMap(MapTypes.Internal);
                }
                tempmeta = new Meta();
                tempmeta.ReadMetaFromMap(micro, mapnumber, false);

                Maps.map[mapnumber].CloseMap();
                pm = new Raw.ParsedBitmap(ref tempmeta, mapnumber);
                this.microdetailBitmap = pm.FindChunkAndDecode(0, 0, ref tempmeta, mapnumber, 0, 0);
                this.microdetailName = Maps.map[mapnumber].FileNames.Name[micro];

            }





        }
        public void H2ShaderInfo(int tagnumber, int mapnumber)
        {
            Maps.map[mapnumber].OpenMap(MapTypes.Internal);


            this.tagnumber = tagnumber;
            if (this.tagnumber == -1) { return; }
            this.shaderName = Maps.map[mapnumber].FileNames.Name[this.tagnumber];
            Maps.map[mapnumber].BR.BaseStream.Position = Maps.map[mapnumber].MetaInfo.Offset[this.tagnumber] + 4;
            int tempstem = Maps.map[mapnumber].Functions.Meta.FindMetaByID(Maps.map[mapnumber].BR.ReadInt32(), mapnumber);
            if (tempstem != -1)
            {
                if (Maps.map[mapnumber].FileNames.Name[tempstem].IndexOf("alphatest") != -1)
                {
                    this.Alpha = ShaderInfo.AlphaType.AlphaTest;
                }
                else if (Maps.map[mapnumber].FileNames.Name[tempstem].IndexOf("alpha") != -1)
                {
                    this.Alpha = ShaderInfo.AlphaType.AlphaBlend;
                }
                else if (Maps.map[mapnumber].FileNames.Name[tempstem].IndexOf("water") != -1)
                {
                    this.Alpha = ShaderInfo.AlphaType.AlphaBlend;
                }
                else
                {
                    this.Alpha = ShaderInfo.AlphaType.None;
                }
            }
            else
            {
                this.Alpha = ShaderInfo.AlphaType.None;
            }

            Maps.map[mapnumber].BR.BaseStream.Position = Maps.map[mapnumber].MetaInfo.Offset[this.tagnumber] + 12;
            int tempc2 = Maps.map[mapnumber].BR.ReadInt32();
            int tempr2 = Maps.map[mapnumber].BR.ReadInt32() - Maps.map[mapnumber].SecondaryMagic;
            if (tempc2 != 0)
            {
                Maps.map[mapnumber].BR.BaseStream.Position = tempr2 + 4;
                int tempcrap = Maps.map[mapnumber].Functions.Meta.FindMetaByID(Maps.map[mapnumber].BR.ReadInt32(), mapnumber);


                if (tempcrap != -1)
                {
                    Meta tempmeta = new Meta();
                    tempmeta.ReadMetaFromMap(tempcrap, mapnumber, false);
                    Raw.ParsedBitmap pm = new Raw.ParsedBitmap(ref tempmeta, mapnumber);
                    this.MainBitmap = pm.FindChunkAndDecode(0, 0, ref tempmeta, mapnumber, 0,0);
                    this.MainName = Maps.map[mapnumber].FileNames.Name[tempcrap];
                    this.levels = pm.Properties[0].mipMapCount;
                }

            }
            Maps.map[mapnumber].OpenMap(MapTypes.Internal);
            Maps.map[mapnumber].BR.BaseStream.Position = Maps.map[mapnumber].MetaInfo.Offset[this.tagnumber] + 32;
            tempc2 = Maps.map[mapnumber].BR.ReadInt32();
            tempr2 = Maps.map[mapnumber].BR.ReadInt32() - Maps.map[mapnumber].SecondaryMagic;

            Maps.map[mapnumber].BR.BaseStream.Position = tempr2 + 24;
            int fuckr = Maps.map[mapnumber].BR.ReadInt32();
            if (fuckr != 0)
            {
                fuckr -= Maps.map[mapnumber].SecondaryMagic;
                Maps.map[mapnumber].BR.BaseStream.Position = fuckr;
                this.primarydetailuscale = Maps.map[mapnumber].BR.ReadSingle();
                this.primarydetailvscale = Maps.map[mapnumber].BR.ReadSingle();
                this.primarydetailwscale = Maps.map[mapnumber].BR.ReadSingle();
                Maps.map[mapnumber].BR.ReadSingle();
                this.secondarydetailuscale = Maps.map[mapnumber].BR.ReadSingle();
                this.secondarydetailvscale = Maps.map[mapnumber].BR.ReadSingle();
                this.secondarydetailwscale = Maps.map[mapnumber].BR.ReadSingle();
            }
            Maps.map[mapnumber].BR.BaseStream.Position = tempr2 + 4;
            tempc2 = Maps.map[mapnumber].BR.ReadInt32();
            tempr2 = Maps.map[mapnumber].BR.ReadInt32() - Maps.map[mapnumber].SecondaryMagic;

            /*

            for (int x = 0; x < tempc2; x++)
            {
                Maps.map[mapnumber].BR.BaseStream.Position = tempr2 + (x * 12);
                int tempcrap = Maps.map[mapnumber].Functions.Meta.FindMetaByID(Maps.map[mapnumber].BR.ReadInt32(), mapnumber);
                if (tempcrap == -1) { continue; }
                Meta tempmeta = new Meta();
                tempmeta.ReadMetaFromMap(tempcrap, mapnumber, false);
                Raw.ParsedBitmap pm = new Raw.ParsedBitmap(ref tempmeta, mapnumber);
                Bitmaps.Add(pm.FindChunkAndDecode(0, 0, ref tempmeta, mapnumber, 0));
               BitmapNames.Add(Maps.map[mapnumber].FileNames.Name[tempcrap]);
            }
          
*/
            //   Maps.map[mapnumber].BR.BaseStream.Position = tempr + 20;
            //   tempc2 = Maps.map[mapnumber].BR.ReadInt32();
            //  tempr2 = Maps.map[mapnumber].BR.ReadInt32() - Maps.map[mapnumber].SecondaryMagic;


            //    tempc2 = tempc;
            //    tempr2 = tempr;
            if (tempc2 != 0)
            {
                Maps.map[mapnumber].BR.BaseStream.Position = tempr2;
                int tempcrap = Maps.map[mapnumber].Functions.Meta.FindMetaByID(Maps.map[mapnumber].BR.ReadInt32(), mapnumber);

                if (tempcrap != -1)
                {

                    int test = Maps.map[mapnumber].FileNames.Name[tempcrap].IndexOf("reflection_maps");
                    if (Maps.map[mapnumber].FileNames.Name[tempcrap].IndexOf("_bump") != -1)
                    {
                        Meta tempmeta = new Meta();
                        tempmeta.ReadMetaFromMap(tempcrap, mapnumber, false);
                        Raw.ParsedBitmap pm = new Raw.ParsedBitmap(ref tempmeta, mapnumber);
                        this.BumpMapBitmap = pm.FindChunkAndDecode(0, 0, ref tempmeta, mapnumber, 0,0);
                        this.BumpMapName = Maps.map[mapnumber].FileNames.Name[tempcrap];
                    }
                    else if (Maps.map[mapnumber].FileNames.Name[tempcrap].IndexOf("_cube_map") != -1)
                    {
                        Meta tempmeta = new Meta();
                        tempmeta.ReadMetaFromMap(tempcrap, mapnumber, false);
                        Raw.ParsedBitmap pm = new Raw.ParsedBitmap(ref tempmeta, mapnumber);
                        this.CubeMapBitmap = pm.FindChunkAndDecode(0, 0, ref tempmeta, mapnumber, 0,0);
                        this.CubeMapName = Maps.map[mapnumber].FileNames.Name[tempcrap];
                    }
                    else if (Maps.map[mapnumber].FileNames.Name[tempcrap].IndexOf("default_") == -1 && this.MainBitmap == null && test == -1)
                    {
                        Meta tempmeta = new Meta();
                        tempmeta.ReadMetaFromMap(tempcrap, mapnumber, false);
                        Raw.ParsedBitmap pm = new Raw.ParsedBitmap(ref tempmeta, mapnumber);
                        this.MainBitmap = pm.FindChunkAndDecode(0, 0, ref tempmeta, mapnumber, 0,0);
                        this.MainName = Maps.map[mapnumber].FileNames.Name[tempcrap];
                        this.levels = pm.Properties[0].mipMapCount;
                    }
                    else if (test != -1)
                    {

                        Maps.map[mapnumber].BR.BaseStream.Position += 8;
                        tempcrap = Maps.map[mapnumber].Functions.Meta.FindMetaByID(Maps.map[mapnumber].BR.ReadInt32(), mapnumber);
                        Meta tempmeta = new Meta();
                        tempmeta.ReadMetaFromMap(tempcrap, mapnumber, false);
                        Raw.ParsedBitmap pm = new Raw.ParsedBitmap(ref tempmeta, mapnumber);
                        ///  this.MainBitmap = pm.FindChunkAndDecode(0, 0, ref tempmeta, mapnumber);
                        //  this.MainName = Maps.map[mapnumber].FileNames.Name[tempcrap];
                    }
                }
                Maps.map[mapnumber].OpenMap(MapTypes.Internal);
                Maps.map[mapnumber].BR.BaseStream.Position = tempr2 + 24;
                tempcrap = Maps.map[mapnumber].Functions.Meta.FindMetaByID(Maps.map[mapnumber].BR.ReadInt32(), mapnumber);
                if (tempcrap != -1 && this.MainBitmap == null)
                {
                    Meta tempmeta = new Meta();
                    tempmeta.ReadMetaFromMap(tempcrap, mapnumber, false);
                    Raw.ParsedBitmap pm = new Raw.ParsedBitmap(ref tempmeta, mapnumber);
                    this.MainBitmap = pm.FindChunkAndDecode(0, 0, ref tempmeta, mapnumber, 0,0);
                    this.MainName = Maps.map[mapnumber].FileNames.Name[tempcrap];
                    this.levels = pm.Properties[0].mipMapCount;
                }
                else if (this.MainBitmap == null)
                {
                    Maps.map[mapnumber].BR.BaseStream.Position = tempr2 + 12;
                    tempcrap = Maps.map[mapnumber].Functions.Meta.FindMetaByID(Maps.map[mapnumber].BR.ReadInt32(), mapnumber);
                    if (tempcrap != -1)
                    {
                        Meta tempmeta = new Meta();
                        tempmeta.ReadMetaFromMap(tempcrap, mapnumber, false);
                        Raw.ParsedBitmap pm = new Raw.ParsedBitmap(ref tempmeta, mapnumber);
                        this.MainBitmap = pm.FindChunkAndDecode(0, 0, ref tempmeta, mapnumber, 0,0);
                        this.MainName = Maps.map[mapnumber].FileNames.Name[tempcrap];
                        this.levels = pm.Properties[0].mipMapCount;
                    }
                }



            }
            Maps.map[mapnumber].CloseMap();
        }
        #endregion
        public void MakeTextures(ref Device device)
        {
            /*
            BitmapTextures = new Texture[Bitmaps.Count];
            for (int x = 0; x < Bitmaps.Count; x++) BitmapTextures[x] = CreateTexture(ref device, Bitmaps[x]);
             */
            if (BumpMapBitmap != null)
            {



              //  BumpMapTexture = CreateTexture(ref device, BumpMapBitmap);
              //  SurfaceDescription desc = BumpMapTexture.GetLevelDescription(0);
             //   NormalMap = new Texture(device, desc.Width, desc.Height, BumpMapTexture.LevelCount, 0, Format.A8R8G8B8, Pool.Managed);
              //  TextureLoader.ComputeNormalMap(NormalMap, BumpMapTexture, 0, Channel.Alpha, 1.0f);
            }
            if (primarydetailBitmap != null)
            {
                primarydetailTexture = CreateTexture(ref device, primarydetailBitmap);
            }
            if (secondarydetailBitmap != null)
            {
                secondarydetailTexture = CreateTexture(ref device, secondarydetailBitmap);
            }
            if (microdetailBitmap != null)
            {
                microdetailTexture = CreateTexture(ref device, microdetailBitmap);
            }
            if (CubeMapBitmap != null)
            {
                //  CubeMapTexture = Texture.FromBitmap(device, CubeMapBitmap, Usage.AutoGenerateMipMap, Pool.Managed);
            }
            if (MainBitmap != null)
            {
                MainTexture = CreateTexture(ref device, MainBitmap);
                // try
                // {
                //    
                // }
                // catch
                // {
      //          MainTexture = Texture.FromBitmap(device, MainBitmap, Usage.AutoGenerateMipMap, Pool.Managed);
                // }
            }
        }
        public void KillBitmaps()
        {
            BumpMapBitmap = null;
            CubeMapBitmap = null;
            MainBitmap = null;

        }
        public static Texture CreateTexture(ref Device device, Bitmap bitmap)
        {
            if (bitmap == null) { return null; }






            Texture texture = new Texture(device, bitmap.Width, bitmap.Height, 1,
 Usage.AutoGenerateMipMap, Format.A8R8G8B8, Pool.Managed);

            System.Drawing.Imaging.BitmapData bitmapData = bitmap.LockBits(new Rectangle(0, 0, bitmap.Width, bitmap.Height),
            System.Drawing.Imaging.ImageLockMode.ReadOnly, System.Drawing.Imaging.PixelFormat.Format32bppArgb);
            int pitch;
            GraphicsStream textureData = texture.LockRectangle(0, LockFlags.None, out pitch);

            //Debug.Assert(bitmap.PixelFormat == System.Drawing.Imaging.PixelFormat.Format32bppArgb);
            // Debug.Assert(sizeof(int) == 4 && (bitmapData.Stride & 3) == 0 && (pitch & 3) == 0);

            unsafe
            {
                int* texturePointer = (int*)textureData.InternalDataPointer;
                for (int y = 0; y < bitmap.Height; y++)
                {
                    int* bitmapLinePointer = (int*)bitmapData.Scan0 + y * (bitmapData.Stride / sizeof(int));
                    int* textureLinePointer = texturePointer + y * (pitch / sizeof(int));
                    int length = bitmap.Width;
                    while (--length >= 0)
                        *textureLinePointer++ = *bitmapLinePointer++;
                }
            }

            bitmap.UnlockBits(bitmapData);
            texture.UnlockRectangle(0);
            texture.GenerateMipSubLevels();
            texture.AutoGenerateFilterType = TextureFilter.Linear;
            return texture;


        }
    }


}
namespace entity
{

    public class DXShader
    {
        private string myTitle;
        private string myFile;
        private Effect myEffect;

        public string MyTitle { get { return myTitle; } }
        public Effect MyEffect { get { return myEffect; } }

        public DXShader(string title, string filename, ref  Device myDevice)
        {
            myTitle = title;
            myFile = filename;
            string error = "";
            myEffect = Effect.FromFile(myDevice, filename, null, null, ShaderFlags.PartialPrecision, null, out error);
        }
    }


}