
// ----------------
// PluginManager.cs

using System;
using System.Collections.Generic;
using System.Reflection;
using System.IO;
using System.Windows.Forms;


namespace entity
{
    public  class EntityPlugin:UserControl 
    {
        public string PluginName;
        public string Author;
        public int MapNumber;
        public string tagtype = "*.*";

        public EntityPlugin()
        {
            this.Dock = DockStyle.Fill;
            this.PluginName = "Default Plugin";
            InitializeComponent();
        }
        public virtual void Run(int mapnum,ref ToolStripProgressBar progressbar)
        {

        }

        public string GetName()
        {
            return this.PluginName;
        }

        private void InitializeComponent()
        {
            this.SuspendLayout();
            // 
            // EntityPlugin
            // 
            this.Name = "EntityPlugin";
            this.ResumeLayout(false);

        }
    }

    public class PluginManager
    {
        
        public PluginManagerList Plugin = new PluginManagerList();
        
        public class PluginManagerList : List<EntityPlugin>
        {


            public void Add(string pluginsPath)
            {
                foreach (FileInfo file in new DirectoryInfo(pluginsPath).GetFiles())
                {
                    Assembly asm;
                    try
                    {
                        asm = Assembly.LoadFile(file.FullName);
                    }
                    catch
                    {
                        continue;
                    }
                    foreach (Type type in asm.GetTypes())
                       // foreach (Type interf in type.GetType())
                            if (type.BaseType == typeof(EntityPlugin))
                                this.Add((EntityPlugin)Activator.CreateInstance(type));

                  
                }
            }
        }
    }
}


