using System;
using System.Collections;
using System.Collections.Generic;
using System.Text;

namespace entity.IFP
{
    public sealed class MakeIFPS
    {
        #region Fields
        public static Hashtable Results;
        #endregion
        public static void ToDir(int map,string path)
        {
            if (path[path.Length-1]!='\\')path+="\\";
            MakeIFPS.Results = new Hashtable();
            MetaScanner ms = new MetaScanner();
            List<Meta> metas = new List<Meta>();
            for (int x=0;x<Maps.map[map].IndexHeader.metaCount;x++)
            {
                Meta m = new Meta();
                m.ReadMetaFromMap(x, map, true);
                ms.ScanManually(ref m, map);
               
                metas.Add(m);
            }

            for (int x = 0; x < metas.Count; x++)
            {
                Meta m=metas[x];
                DissectMeta(ref m);
                metas[x] = m;
        
            }
        }

        public static void DissectMeta(ref Meta m)
        {
            object tempobject = MakeIFPS.Results[m.type];
            if (tempobject == null)
            {
                MetaResult mr = new MetaResult();
                IFPIO io = IFP.IFPHashMap.GetIfp(m.type, m.mapnumber);
                mr.IFP = io;
                MakeIFPS.Results.Add(m.type, mr);
                tempobject = MakeIFPS.Results[m.type];
             }
            MetaResult CurrentResult=tempobject as MetaResult;
            // figure out headersize for current meta 
            int headersize=m.size;
            for (int x = 0; x < m.items.Count; x++)
            {
               if (m.items[x].type== Meta.ItemType.Reflexive) 
               {
                      Meta.Reflexive tempr=m.items[x] as Meta.Reflexive;
                      if (tempr.translation < headersize && tempr.intag == m.tagnumber) headersize = tempr.translation;
                }
            }

            if (CurrentResult.HeaderSizes.IndexOf(headersize) == -1) CurrentResult.HeaderSizes.Add(headersize);
            ///
           MakeIFPS.AnalyzeReferences(ref m);
        }

        public static void AnalyzeReferences(ref Meta m)
        {

        }

        public class MetaResult
        {
            public string TagType;
            public List<int> HeaderSizes = new List<int>();
            public IFPIO IFP;
        }
    }
}
