using System;
using System.IO;
using System.Collections;
using System.Collections.Generic;
using System.Windows.Forms;
namespace entity
{

	public class Builder
	{
		#region Fields
		#endregion
		#region Constructor
		public Builder()
		{
		
		}
		#endregion
		#region Methods
		public void BuildMapFromInfoFile(string inputFile,ref MapLayout layout,int mapnumber,bool addsounds)
		{
			ArrayList metas=new ArrayList(0);
            string[] split = inputFile.Split('.');
            if (split[split.Length - 1] == "info")
            {
                FileStream FS = new FileStream(inputFile, FileMode.Open);
                StreamReader SR = new StreamReader(FS);
                string temps = "";
                do
                {
                    temps = SR.ReadLine();

                    if (temps == null) { break; }
                    Meta m = new Meta();
                    m.LoadMetaFromFile(temps, mapnumber);
                    if (addsounds == false)
                    {
                        if (m.type == "snd!") { continue; }
                    }
                    bool exists = false;
                    for (int x = 0; x < Maps.map[mapnumber].IndexHeader.metaCount; x++)
                    {
                        if (Maps.map[mapnumber].FileNames.Name[x] == m.name && Maps.map[mapnumber].MetaInfo.TagType[x] == m.type)
                        {
                            exists = true;
                            break;
                        }
                    }
                    if (exists == false)
                    {
                        for (int x = 0; x < metas.Count; x++)
                        {
                            if (((Meta)metas[x]).name == m.name && ((Meta)metas[x]).type == m.type)
                            {
                                exists = true;
                                break;
                            }

                        }
                    }
                    if (exists == false)
                    {
                        metas.Add(m);
                    }
                }
                while (temps != null);

                SR.Close();
                FS.Close();
            }
            else
            {
                Meta m = new Meta();
                m.LoadMetaFromFile(inputFile, mapnumber);
                bool exists = false;
                for (int x = 0; x < Maps.map[mapnumber].IndexHeader.metaCount; x++)
                {
                    if (Maps.map[mapnumber].FileNames.Name[x] == m.name && Maps.map[mapnumber].MetaInfo.TagType[x] == m.type)
                    {
                        exists = true;
                        break;
                    }
                }
          
                if (exists == false)
                {
                    metas.Add(m);
                }


            }
			MapBuilder(metas,ref layout,mapnumber,addsounds);
		}
		public void MapBuilder(ArrayList metas,ref MapLayout layout,int mapnumber,bool addsounds)
		{
            string[] filestofix=new string[0];
            if (Maps.map[mapnumber].MapHeader.mapType != MapTypes.Internal)
            {
                if (MessageBox.Show("This map is an external resource and in order to add to it you have to update all the other maps. Continue?", "", MessageBoxButtons.OKCancel) == DialogResult.Cancel) { return; }
                OpenFileDialog openfiles = new OpenFileDialog();
                openfiles.Multiselect = true;
                openfiles.Filter = "Halo 2 Map (*.map)| *.map";
                openfiles.ShowDialog();
               
                filestofix = openfiles.FileNames;
            }

            if (addsounds == false)
            {

                for (int x = 0; x < metas.Count; x++)
                {
                    if (((Meta)metas[x]).type == "snd!")
                    {
                        metas.RemoveAt(x);
                        x--;
                    }
                }

            }
		
			int totalshift=0;
			///find new strings
			///
			///
			ArrayList strings=new ArrayList();
			for (int x=0;x<metas.Count;x++)
			{
				Meta m=((Meta)metas[x]);
				for (int y=0;y<m.items.Count;y++)
				{
					entity.Meta.Item ii=(entity.Meta.Item)m.items[y];
					if (ii.type==entity.Meta.ItemType.String)
					{
						entity.Meta.String iii=(entity.Meta.String)ii;
						if (Array.IndexOf(Maps.map[mapnumber].Strings.Name,iii.name)==-1)
						{
							if (strings.IndexOf(iii.name)==-1)
							{
								strings.Add(iii.name);	
							}
						}
					}
				}
			}
            
			///read ugh to meta
			///
			///

            Maps.map[mapnumber].OpenMap(MapTypes.Internal);
			Meta ughmeta=new Meta();
			ughmeta.ReadMetaFromMap(Maps.map[mapnumber].IndexHeader.metaCount-1,mapnumber,true);
            IFPIO ifp = IFP.IFPHashMap.GetIfp("ugh!", mapnumber);
            ughmeta.rawType = RawDataContainerType.Empty;
			ughmeta.headersize=ifp.headerSize;
			MetaScanner ms=new MetaScanner();
			ms.ScanWithIFP(ref ifp,ref ughmeta,mapnumber);
            string temps="";		

	
		    ///get model info
            int tempint=layout.FindByType(RawDataContainerType.Model);
            LayOutChunk loc = (LayOutChunk)layout.chunks[tempint];
            /////////
            ///sound raw data
            //////////////
            int sndshift = 0;
            int sndpermcount = 0;
            int sndchoicecount = 0;
            int sndchunk1count = 0;
            int addedsoundnames = 0;


            MetaSplitter metasplit = new MetaSplitter();
            metasplit.SplitWithIFP(ref ifp,ref ughmeta,mapnumber);
            Maps.map[mapnumber].OpenMap(MapTypes.Internal);
            int soundnameindex = 0;
            int soundpermutationindex = 0;
            int soundchoiceindex = 0;
            int soundchunk1index = 0;
            for (int x = 0; x < metasplit.Header.Chunks[0].ChunkResources.Count; x++)
            {
                if (metasplit.Header.Chunks[0].ChunkResources[x].type == Meta.ItemType.Reflexive)
                {
                    Meta.Reflexive r = (Meta.Reflexive)metasplit.Header.Chunks[0].ChunkResources[x];
                    if (r.offset == 16) soundnameindex = x;
                    if (r.offset == 32) soundpermutationindex = x;
                    if (r.offset == 40) soundchoiceindex = x;
                    if (r.offset == 64) soundchunk1index = x;
                }
            }
            MetaSplitter.SplitReflexive soundnamereflexive = metasplit.Header.Chunks[0].ChunkResources[soundnameindex] as MetaSplitter.SplitReflexive;
            MetaSplitter.SplitReflexive soundpermutationreflexive = metasplit.Header.Chunks[0].ChunkResources[soundpermutationindex] as MetaSplitter.SplitReflexive;
            MetaSplitter.SplitReflexive soundchoicereflexive = metasplit.Header.Chunks[0].ChunkResources[soundchoiceindex] as MetaSplitter.SplitReflexive;
            MetaSplitter.SplitReflexive soundchunk1reflexive = metasplit.Header.Chunks[0].ChunkResources[soundchunk1index] as MetaSplitter.SplitReflexive;
            for (int x = 0; x < metas.Count; x++)
            {
                Meta m = ((Meta)metas[x]);
                if (m.rawType == RawDataContainerType.Sound)
                {
                    Sound tempsound=(Sound)m.raw;
                    BinaryWriter BW = new BinaryWriter(m.MS);
                    int y=0;
                        
                        
                        //writes new index to meta
                        BW.BaseStream.Position = 8;
                        ushort temppermindex=(ushort)(Maps.map[mapnumber].ugh.Permutations.Count+sndpermcount);
                        BW.Write(temppermindex);



                    
                         for (int e=0;e<tempsound.Permutations.Length;e++)
                        {
           
                          for (int ee=0;ee<tempsound.Permutations[e].choicecount;ee++)
                           {
                                int nindex=Maps.map[mapnumber].ugh.SoundNames.IndexOf(tempsound.Permutations[e].Choices[ee].Name);
                                if (nindex==-1)
                                {
                                    int nindex2 = strings.IndexOf(tempsound.Permutations[e].Choices[ee].Name);
                                    if (nindex2 == -1)
                                    {
                                   
                                        strings.Add(tempsound.Permutations[e].Choices[ee].Name);
                                        nindex2 = strings.Count - 1;
                                    }
                                    nindex2 += Maps.map[mapnumber].Strings.Name.Length;
                                    Maps.map[mapnumber].ugh.SoundNames.Add(tempsound.Permutations[e].Choices[ee].Name);
                                    tempsound.Permutations[e].Choices[ee].NameIndex =(ushort) (Maps.map[mapnumber].ugh.SoundNames.Count - 1);

                                    MetaSplitter.SplitReflexive tempss = new MetaSplitter.SplitReflexive();
                                    tempss.chunksize = soundnamereflexive.Chunks[0].chunksize;
                                    tempss.MS=new MemoryStream(tempss.chunksize);
                                    BinaryWriter soundnameBW = new BinaryWriter(tempss.MS);
                                    soundnameBW.BaseStream.Position = 0;
                                    byte z = 0;
                                    soundnameBW.Write((ushort)nindex2);
                                    soundnameBW.Write(z);
                                    soundnameBW.Write((byte)tempsound.Permutations[e].Choices[ee].Name.Length);
                                    soundnamereflexive.Chunks.Add(tempss);
                                    addedsoundnames++;
                                }
                                else
                                {
                                    tempsound.Permutations[e].Choices[ee].NameIndex = (ushort)nindex;
                                }
                           }
                         }

                      

                        ///cycle through permutations and write them
                        for (int e=0;e<tempsound.Permutations.Length;e++)
                        {
                               
                          
                           MetaSplitter.SplitReflexive tempss = new MetaSplitter.SplitReflexive();
                           tempss.chunksize = soundpermutationreflexive.Chunks[0].chunksize;
                           tempss.MS = new MemoryStream(tempss.chunksize);
                           BinaryWriter permBW = new BinaryWriter(tempss.MS);
                           permBW.BaseStream.Position = 0;
                          
                           permBW.Write(tempsound.Permutations[e].unknown1);
                           permBW.Write(tempsound.Permutations[e].unknown2);
                           tempsound.Permutations[e].choiceindex=(ushort)(Maps.map[mapnumber].ugh.Choices.Count+sndchoicecount);
                           permBW.Write(tempsound.Permutations[e].choiceindex);
                           permBW.Write(tempsound.Permutations[e].choicecount);
                           soundpermutationreflexive.Chunks.Add(tempss);
                           for (int ee=0;ee<tempsound.Permutations[e].choicecount;ee++)
                           {

                              
                               MetaSplitter.SplitReflexive tempsss = new MetaSplitter.SplitReflexive();
                               tempsss.chunksize = soundchoicereflexive.Chunks[0].chunksize;
                               tempsss.MS = new MemoryStream(tempsss.chunksize);
                               BinaryWriter choiceBW = new BinaryWriter(tempsss.MS);
                               choiceBW.BaseStream.Position = 0;
                             
                               choiceBW.Write(tempsound.Permutations[e].Choices[ee].NameIndex);
                               choiceBW.Write(tempsound.Permutations[e].Choices[ee].unknown1);
                               choiceBW.Write(tempsound.Permutations[e].Choices[ee].unknown2);

                               choiceBW.Write(tempsound.Permutations[e].Choices[ee].unknown3);
                               tempsound.Permutations[e].Choices[ee].soundindex=(ushort)(Maps.map[mapnumber].ugh.SoundChunks1.Count+sndchunk1count);
                               choiceBW.Write(tempsound.Permutations[e].Choices[ee].soundindex);
                               choiceBW.Write(tempsound.Permutations[e].Choices[ee].soundcount);
                               soundchoicereflexive.Chunks.Add(tempsss);

                               for (int eee=0;eee<tempsound.Permutations[e].Choices[ee].soundcount;eee++)
                               {
                                   RawDataChunk r = (RawDataChunk)m.raw.rawChunks[y];
                                   ///write raw to map
                                  int tempintx = loc.startoffset + sndshift;
                                 Maps.map[mapnumber].BW.BaseStream.Position = tempintx;
                                 Maps.map[mapnumber].BW.BaseStream.Write(r.MS.ToArray(), 0, r.size);
                                //write padding
                               int tempinty = Maps.map[mapnumber].Functions.Padding(r.size, 512);
                                 byte[] tempbytes = new byte[tempinty];
                                Maps.map[mapnumber].BW.Write(tempbytes);
                                    sndshift += r.size + tempinty;
                                   y++;

                                  
                                   MetaSplitter.SplitReflexive tempssss = new MetaSplitter.SplitReflexive();
                                   tempssss.chunksize = soundchoicereflexive.Chunks[0].chunksize;
                                   tempssss.MS = new MemoryStream(tempssss.chunksize);
                                   BinaryWriter sndchnk1BW = new BinaryWriter(tempssss.MS);
                                   sndchnk1BW.BaseStream.Position = 0;
                                   sndchnk1BW.Write(tempintx);
                                   sndchnk1BW.Write(tempsound.Permutations[e].Choices[ee].SoundChunks1[eee].size);
                                   sndchnk1BW.Write(tempsound.Permutations[e].Choices[ee].SoundChunks1[eee].unknown1);
                                   sndchnk1BW.Write(tempsound.Permutations[e].Choices[ee].SoundChunks1[eee].unknown2);
                                   soundchunk1reflexive.Chunks.Add(tempssss);
                                   sndchunk1count++;
                               }
                               sndchoicecount++;
                           }
                           sndpermcount++;
                        }

                
                    metas[x] = m;
                }
            }

            totalshift += sndshift;
            if (sndshift>0)
            {

                metasplit.Header.Chunks[0].ChunkResources[soundnameindex] = soundnamereflexive;
                metasplit.Header.Chunks[0].ChunkResources[soundpermutationindex] = soundpermutationreflexive;
                metasplit.Header.Chunks[0].ChunkResources[soundchoiceindex] = soundchoicereflexive;
                metasplit.Header.Chunks[0].ChunkResources[soundchunk1index] = soundchunk1reflexive;

                ughmeta=MetaBuilder.BuildMeta(metasplit,mapnumber);
              


                
            }
            metas.Add(ughmeta);


			//////////////////////////////////////
			///model raw data
			///
			int modeshift=0;
			
			loc.startoffset+=totalshift;
			loc.endoffset=loc.startoffset+loc.size;
            Maps.map[mapnumber].BW.BaseStream.Position=loc.startoffset;
            Maps.map[mapnumber].BW.BaseStream.Write(loc.MS.ToArray(), 0, loc.size);
			for (int x=0;x<metas.Count;x++)
			{
				Meta m=((Meta)metas[x]);
				if (m.rawType==RawDataContainerType.Model)
				{
					BinaryWriter BW=new BinaryWriter(m.MS);
					for (int y=0;y<m.raw.rawChunks.Count;y++)
					{
						RawDataChunk r=(RawDataChunk) m.raw.rawChunks[y];
						int tempintx=loc.endoffset+modeshift;
						//writes new pointer to loaded meta
						BW.BaseStream.Position=r.pointerMetaOffset;
						BW.Write(tempintx);
						BW.Write(r.size);
						//writes raw to map file
						Maps.map[mapnumber].BW.BaseStream.Position=tempintx;
						Maps.map[mapnumber].BW.BaseStream.Write(r.MS.ToArray(),0,r.size);
						//write padding
						int tempinty=Maps.map[mapnumber].Functions.Padding(r.size,512);
						byte[] tempbytes=new byte[tempinty];
						Maps.map[mapnumber].BW.Write(tempbytes);
						modeshift+=r.size+tempinty;
					}	
					metas[x]=m;
				}
			}
			
			loc.size+=modeshift;
			loc.endoffset=loc.startoffset+loc.size;
		
			layout.chunks[tempint]=loc;
			totalshift+=modeshift;
			
			/////////////////////////////////////
			/// bsp raw
			///
			tempint=layout.FindByType(RawDataContainerType.BSP);
			loc=(LayOutChunk) layout.chunks[tempint];
			loc.startoffset+=totalshift;
			int tempint2=layout.FindByType(RawDataContainerType.BSPMeta);
			LayOutChunk loc2=(LayOutChunk) layout.chunks[tempint2];
            uint bsprawsize = (uint)loc.size;
            uint oldbspsize = (uint)loc.size;
			int bspshift=0;
			int bspmagic=Maps.map[mapnumber].BSP.sbsp[0].magic;
			int newmagicreflexive=bspmagic+loc2.startoffset;
            bool found = false;
            Meta tempbspmeta = new Meta(); ;
            bool foundbsptoimport = false;
			for (int x=0;x<metas.Count;x++)
			{
				Meta m=((Meta)metas[x]);
				if (m.type=="sbsp")
				{
                    foundbsptoimport = true;
					bsprawsize=0;
					BinaryWriter BW=new BinaryWriter(m.MS);
                    int[] tempoff = new int[m.raw.rawChunks.Count];
                    
					for (int y=0;y<m.raw.rawChunks.Count;y++)
					{
                        found = false;
						RawDataChunk r=(RawDataChunk) m.raw.rawChunks[y];
                        for (int yy = 0; yy < y; yy++)
                        {
                            RawDataChunk rr = (RawDataChunk)m.raw.rawChunks[yy];
                            if (rr.offset == r.offset&&rr.rawLocation==r.rawLocation )
                            {
                                tempoff[y] = tempoff[yy];
                                //writes new pointer to loaded meta
                                BW.BaseStream.Position = r.pointerMetaOffset;
                                BW.Write(tempoff[y]);
                                BW.Write(r.size);
                                found = true;
                                break;
                            }
                        }
                        if (found == true) { continue; }

                        tempoff[y] = loc.startoffset + (int)bsprawsize;
                      //  MessageBox.Show("Test");
						//writes new pointer to loaded meta
						BW.BaseStream.Position=r.pointerMetaOffset;
                        BW.Write(tempoff[y]);
						BW.Write(r.size);
						//writes raw to map file
                        Maps.map[mapnumber].BW.BaseStream.Position = loc.startoffset + bsprawsize;
						Maps.map[mapnumber].BW.BaseStream.Write(r.MS.ToArray(),0,r.size);
						//write padding
						int tempinty=Maps.map[mapnumber].Functions.Padding(r.size,512);
						byte[] tempbytes=new byte[tempinty];
						Maps.map[mapnumber].BW.Write(tempbytes);
                        bsprawsize += (uint)(r.size + tempinty);
					}












                    
					
					totalshift+=(int)(bsprawsize-oldbspsize);
                    bspshift += (int)(bsprawsize - oldbspsize);
                   
                    loc.size = (int)bsprawsize;
                    loc.endoffset = (int)(loc.startoffset + bsprawsize);
					layout.chunks[tempint]=loc;
					loc2.MS=m.MS;
					loc2.size=m.size;
					loc2.endoffset=loc2.startoffset+m.size;
					layout.chunks[tempint2]=loc2;
					bspmagic=m.magic;
					newmagicreflexive=bspmagic+m.offset;
                    tempbspmeta = m;
					metas.RemoveAt(x);
					break;
				}
                
				if (x==metas.Count-1)
				{
					Maps.map[mapnumber].BW.BaseStream.Position=loc.startoffset;
					Maps.map[mapnumber].BW.BaseStream.Write(loc.MS.ToArray(),0,loc.size);
                    loc.endoffset = loc.startoffset + loc.size;
					layout.chunks[tempint]=loc;
					
				}
			}


			//////////////////////////////////////
			///weather raw data
			///
			int weathershift=0;
			tempint=layout.FindByType(RawDataContainerType.Weather);
			if (tempint!=-1)
			{
				loc=(LayOutChunk) layout.chunks[tempint];
				loc.startoffset+=totalshift;
				Maps.map[mapnumber].BW.BaseStream.Position=loc.startoffset;
				Maps.map[mapnumber].BW.BaseStream.Write(loc.MS.ToArray(),0,loc.size);
			}
			else
			{
				loc=new LayOutChunk(0);
				loc.rawType=RawDataContainerType.Weather;
				int tx=layout.FindByType(RawDataContainerType.BSP);
				loc.startoffset=((LayOutChunk)layout.chunks[tx]).endoffset;
				loc.size=0;
			}
			for (int x=0;x<metas.Count;x++)
			{
				Meta m=((Meta)metas[x]);
				if (m.rawType==RawDataContainerType.Weather)
				{
					BinaryWriter BW=new BinaryWriter(m.MS);
					for (int y=0;y<m.raw.rawChunks.Count;y++)
					{
						RawDataChunk r=(RawDataChunk) m.raw.rawChunks[y];
						int tempintx=loc.startoffset+loc.size+weathershift;
						//writes new pointer to loaded meta
						BW.BaseStream.Position=r.pointerMetaOffset;
						BW.Write(tempintx);
						BW.Write(r.size);
						//writes raw to map file
						Maps.map[mapnumber].BW.BaseStream.Position=tempintx;
						Maps.map[mapnumber].BW.BaseStream.Write(r.MS.ToArray(),0,r.size);
						//write padding
						int tempinty=Maps.map[mapnumber].Functions.Padding(r.size,512);
						byte[] tempbytes=new byte[tempinty];
						Maps.map[mapnumber].BW.Write(tempbytes);
						weathershift+=r.size+tempinty;
					}	
					metas[x]=m;
				}
			}
			loc.size+=weathershift;
			loc.endoffset=loc.startoffset+loc.size;
			if (tempint==-1)
			{
				if (weathershift>0){layout.chunks.Add(loc);};
			}
			else
			{	
				layout.chunks[tempint]=loc;
			}

			totalshift+=weathershift;
							
			

			//////////////////////////////////////
			///decr raw data
			///
			int decrshift=0;
			tempint=layout.FindByType(RawDataContainerType.DECR);
			if (tempint!=-1)
			{
				loc=(LayOutChunk) layout.chunks[tempint];
				loc.startoffset+=totalshift;
				Maps.map[mapnumber].BW.BaseStream.Position=loc.startoffset;
				Maps.map[mapnumber].BW.BaseStream.Write(loc.MS.ToArray(),0,loc.size);
			}
			else
			{
				loc=new LayOutChunk(0);
				loc.rawType=RawDataContainerType.DECR;
				int tx=layout.FindByType(RawDataContainerType.Weather);
				if (tx==-1)
				{
					tx=layout.FindByType(RawDataContainerType.BSP);
				}
				loc.startoffset=((LayOutChunk)layout.chunks[tx]).endoffset;
				loc.size=0;
			}
			for (int x=0;x<metas.Count;x++)
			{
				Meta m=((Meta)metas[x]);
				if (m.rawType==RawDataContainerType.DECR)
				{
					BinaryWriter BW=new BinaryWriter(m.MS);
					for (int y=0;y<m.raw.rawChunks.Count;y++)
					{
						RawDataChunk r=(RawDataChunk) m.raw.rawChunks[y];
						int tempintx=loc.startoffset+loc.size+decrshift;
						//writes new pointer to loaded meta
						BW.BaseStream.Position=r.pointerMetaOffset;
						BW.Write(tempintx);
						BW.Write(r.size);
						//writes raw to map file
						Maps.map[mapnumber].BW.BaseStream.Position=tempintx;
						Maps.map[mapnumber].BW.BaseStream.Write(r.MS.ToArray(),0,r.size);
						//write padding
						int tempinty=Maps.map[mapnumber].Functions.Padding(r.size,512);
						byte[] tempbytes=new byte[tempinty];
						Maps.map[mapnumber].BW.Write(tempbytes);
						decrshift+=r.size+tempinty;
					}	
					metas[x]=m;
				}
			}
			loc.size+=decrshift;
			loc.endoffset=loc.startoffset+loc.size;
			if (tempint==-1)
			{
				if (decrshift>0){layout.chunks.Add(loc);};
			}
			else
			{	
				layout.chunks[tempint]=loc;
			}

			totalshift+=decrshift;
		

			//////////////////////////////////////
			///prtm raw data
			///
			int prtmshift=0;
			tempint=layout.FindByType(RawDataContainerType.PRTM);
			if (tempint!=-1)
			{
				loc=(LayOutChunk) layout.chunks[tempint];
				loc.startoffset+=totalshift;
				Maps.map[mapnumber].BW.BaseStream.Position=loc.startoffset;
				Maps.map[mapnumber].BW.BaseStream.Write(loc.MS.ToArray(),0,loc.size);
			}
			else
			{
				loc=new LayOutChunk(0);
				loc.rawType=RawDataContainerType.PRTM;
				int tx=layout.FindByType(RawDataContainerType.DECR);
				if (tx==-1)
				{
					tx=layout.FindByType(RawDataContainerType.Weather);
					if (tx==-1)
					{
						tx=layout.FindByType(RawDataContainerType.BSP);
					}
				}
				loc.startoffset=((LayOutChunk)layout.chunks[tx]).endoffset;
				loc.size=0;
			}
			for (int x=0;x<metas.Count;x++)
			{
				Meta m=((Meta)metas[x]);
				if (m.rawType==RawDataContainerType.PRTM)
				{
					BinaryWriter BW=new BinaryWriter(m.MS);
					for (int y=0;y<m.raw.rawChunks.Count;y++)
					{
						RawDataChunk r=(RawDataChunk) m.raw.rawChunks[y];
						int tempintx=loc.startoffset+loc.size+prtmshift;
						//writes new pointer to loaded meta
						BW.BaseStream.Position=r.pointerMetaOffset;
						BW.Write(tempintx);
						BW.Write(r.size);
						//writes raw to map file
						Maps.map[mapnumber].BW.BaseStream.Position=tempintx;
						Maps.map[mapnumber].BW.BaseStream.Write(r.MS.ToArray(),0,r.size);
						//write padding
						int tempinty=Maps.map[mapnumber].Functions.Padding(r.size,512);
						byte[] tempbytes=new byte[tempinty];
						Maps.map[mapnumber].BW.Write(tempbytes);
						prtmshift+=r.size+tempinty;
					}	
					metas[x]=m;
				}
			}
			loc.size+=prtmshift;
			loc.endoffset=loc.startoffset+loc.size;
			if (tempint==-1)
			{
				if (prtmshift>0){layout.chunks.Add(loc);};
			}
			else
			{	
				layout.chunks[tempint]=loc;
			}

			totalshift+=prtmshift;


			//////////////////////////////////////
			///jmad raw data
			///
			int jmadshift=0;
			tempint=layout.FindByType(RawDataContainerType.Animation);
			if (tempint!=-1)
			{
				loc=(LayOutChunk) layout.chunks[tempint];
				loc.startoffset+=totalshift;
				Maps.map[mapnumber].BW.BaseStream.Position=loc.startoffset;
				Maps.map[mapnumber].BW.BaseStream.Write(loc.MS.ToArray(),0,loc.size);
			}
			else
			{
				loc=new LayOutChunk(0);
				loc.rawType=RawDataContainerType.Animation;
				int tx=layout.FindByType(RawDataContainerType.PRTM);
				if (tx==-1)
				{
					tx=layout.FindByType(RawDataContainerType.DECR);
					if (tx==-1)
					{
						tx=layout.FindByType(RawDataContainerType.Weather);
						if (tx==-1)
						{
							tx=layout.FindByType(RawDataContainerType.BSP);
						}
					}
				}
				
				loc.startoffset=((LayOutChunk)layout.chunks[tx]).endoffset;
				loc.size=0;
			}
			for (int x=0;x<metas.Count;x++)
			{
				Meta m=((Meta)metas[x]);
				if (m.rawType==RawDataContainerType.Animation)
				{
					BinaryWriter BW=new BinaryWriter(m.MS);
					for (int y=0;y<m.raw.rawChunks.Count;y++)
					{
						RawDataChunk r=(RawDataChunk) m.raw.rawChunks[y];
						int tempintx=loc.startoffset+loc.size+jmadshift;
						//writes new pointer to loaded meta
						BW.BaseStream.Position=r.pointerMetaOffset-4;
						BW.Write(r.size);
						BW.Write(tempintx);
						
						//writes raw to map file
						Maps.map[mapnumber].BW.BaseStream.Position=tempintx;
						Maps.map[mapnumber].BW.BaseStream.Write(r.MS.ToArray(),0,r.size);
						//write padding
						int tempinty=Maps.map[mapnumber].Functions.Padding(r.size,512);
						byte[] tempbytes=new byte[tempinty];
						Maps.map[mapnumber].BW.Write(tempbytes);
						jmadshift+=r.size+tempinty;
					}	
					metas[x]=m;
				}
			}
			loc.size+=jmadshift;
			loc.endoffset=loc.startoffset+loc.size;
			if (tempint==-1)
			{
				if (jmadshift>0){layout.chunks.Add(loc);};
			}
			else
			{	
				layout.chunks[tempint]=loc;
			}

			totalshift+=jmadshift;
			
		

			//////////////////////////////////////
			///bsp meta data
			///
			uint bspmetasize=0;
			int bspmetashift=0;
			uint oldbspmetasize=(uint)Maps.map[mapnumber].BSP.sbsp[0].size;
			tempint=layout.FindByType(RawDataContainerType.BSPMeta);
			loc=(LayOutChunk) layout.chunks[tempint];
			loc.startoffset+=totalshift;
			loc.endoffset+=totalshift;
            bspmetasize = (uint)loc.size;
			int tempinteger=layout.FindByType(RawDataContainerType.MetaData );
			loc2=(LayOutChunk) layout.chunks[tempinteger];
			int tempintxx=loc.startoffset;

            if (foundbsptoimport ==false)
			{
				int tempint3=layout.FindByType(RawDataContainerType.BSP);
				LayOutChunk loc3=(LayOutChunk) layout.chunks[tempint3];
				BinaryWriter BWZ=new BinaryWriter(loc.MS);
				for (int w=0;w<loc3.rawPieces.Count;w++)
				{
					RawInfoChunk r=(RawInfoChunk) loc3.rawPieces[w];
					BWZ.BaseStream.Position=r.offsetOfPointer-Maps.map[mapnumber].BSP.sbsp[0].offset;
                    r.offset += (uint)(modeshift + sndshift);
					BWZ.Write(r.offset);
				}
				layout.chunks[tempint3]=loc3;
            }
      

			//writes new pointer and magic and size to scenario meta
			BinaryWriter BWX=new BinaryWriter(loc2.MS);
            int tempoffx = Maps.map[mapnumber].MetaInfo.Offset[3]  -Maps.map[mapnumber].MapHeader.metaStart - Maps.map[mapnumber].MapHeader.indexOffset + Maps.map[mapnumber].BSP.sbsp[0].pointerOffset;
			BWX.BaseStream.Position=tempoffx;
			
			BWX.Write(tempintxx);
			BWX.Write(loc.size);
			BWX.Write(newmagicreflexive);
			//writes raw to map file
            int bspoffset = tempintxx;
		Maps.map[mapnumber].BW.BaseStream.Position=tempintxx;
			Maps.map[mapnumber].BW.BaseStream.Write(loc.MS.ToArray(),0,loc.size);
			//write padding
			
	
			layout.chunks[tempint]=loc;
            totalshift += (int)(bspmetasize - oldbspmetasize);
            bspmetashift = (int)(bspmetasize - oldbspmetasize);
            if (bspmetashift < 0) { bspmetashift = 0; }
            else
            {

                byte[] tempbytesxxxx = new byte[bspmetashift];
                Maps.map[mapnumber].BW.Write(tempbytesxxxx);
                totalshift += bspmetashift;
            }
			////stringnames1
			///
			tempint=layout.FindByType(RawDataContainerType.Strings1);
			loc=(LayOutChunk) layout.chunks[tempint];
			loc.startoffset+=totalshift;
			int tempoldsize=Maps.map[mapnumber].MapHeader.scriptReferenceCount*128;
			int oldpadding=Maps.map[mapnumber].Functions.Padding(tempoldsize,512);
			int tempnewsrsize=strings.Count*128;
			Maps.map[mapnumber].BW.BaseStream.Position=loc.startoffset;
			Maps.map[mapnumber].BW.BaseStream.Write(loc.MS.ToArray(),0,tempoldsize);
			byte[] tempb=new byte[tempnewsrsize];
			Maps.map[mapnumber].BW.BaseStream.Write(tempb,0,tempnewsrsize);
			int padding=Maps.map[mapnumber].Functions.Padding(tempoldsize+tempnewsrsize,512);
			tempb=new byte[padding];
			Maps.map[mapnumber].BW.BaseStream.Write(tempb,0,padding);
			for (int x=0;x<strings.Count;x++)
			{
				Maps.map[mapnumber].BW.BaseStream.Position=loc.startoffset+tempoldsize+(x*128);
				char[] tempc=((String)strings[x]).ToCharArray();
				Maps.map[mapnumber].BW.Write(tempc);
			}
			loc.size+=-oldpadding+tempnewsrsize+padding;
			loc.endoffset=loc.startoffset+loc.size;
			totalshift+=-oldpadding+tempnewsrsize+padding;
			Maps.map[mapnumber].BW.BaseStream.Position=352;
			Maps.map[mapnumber].BW.Write(loc.startoffset);
			int newcount=Maps.map[mapnumber].MapHeader.scriptReferenceCount+strings.Count;
			Maps.map[mapnumber].BW.Write(newcount);
			layout.chunks[tempint]=loc;

	//MessageBox.Show("Test");

			////stringsindex
			///
			tempint=layout.FindByType(RawDataContainerType.StringsIndex);
			loc=(LayOutChunk) layout.chunks[tempint];
			loc.startoffset+=totalshift;
			tempoldsize=Maps.map[mapnumber].MapHeader.scriptReferenceCount*4;
			oldpadding=Maps.map[mapnumber].Functions.Padding(tempoldsize,512);
			tempnewsrsize=strings.Count*4;
			Maps.map[mapnumber].BW.BaseStream.Position=loc.startoffset;
			Maps.map[mapnumber].BW.BaseStream.Write(loc.MS.ToArray(),0,tempoldsize);
			tempb=new byte[tempnewsrsize];
			Maps.map[mapnumber].BW.BaseStream.Write(tempb,0,tempnewsrsize);
			padding=Maps.map[mapnumber].Functions.Padding(tempoldsize+tempnewsrsize,512);
			tempb=new byte[padding];
			Maps.map[mapnumber].BW.BaseStream.Write(tempb,0,padding);
			int temporary=Maps.map[mapnumber].MapHeader.sizeOfScriptReference;
			for (int x=0;x<strings.Count;x++)
			{
				Maps.map[mapnumber].BW.BaseStream.Position=loc.startoffset+tempoldsize+(x*4);
				Maps.map[mapnumber].BW.Write(temporary);
				temporary+=((String)strings[x]).Length+1;
			}
			loc.size+=-oldpadding+tempnewsrsize+padding;
			loc.endoffset=loc.startoffset+loc.size;
			totalshift+=-oldpadding+tempnewsrsize+padding;
		
			Maps.map[mapnumber].BW.BaseStream.Position=364;
			Maps.map[mapnumber].BW.Write(loc.startoffset);
			
			layout.chunks[tempint]=loc;

			////strings2
			///
			tempint=layout.FindByType(RawDataContainerType.Strings2 );
			loc=(LayOutChunk) layout.chunks[tempint];
			loc.startoffset+=totalshift;
			tempoldsize=Maps.map[mapnumber].MapHeader.sizeOfScriptReference;
			oldpadding=Maps.map[mapnumber].Functions.Padding(tempoldsize,512);
			tempnewsrsize=temporary-Maps.map[mapnumber].MapHeader.sizeOfScriptReference;
			Maps.map[mapnumber].BW.BaseStream.Position=loc.startoffset;
			Maps.map[mapnumber].BW.BaseStream.Write(loc.MS.ToArray(),0,tempoldsize);
			tempb=new byte[tempnewsrsize];
			Maps.map[mapnumber].BW.BaseStream.Write(tempb,0,tempnewsrsize);
			padding=Maps.map[mapnumber].Functions.Padding(tempoldsize+tempnewsrsize,512);
			tempb=new byte[padding];
			Maps.map[mapnumber].BW.BaseStream.Write(tempb,0,padding);
			temporary=loc.startoffset+Maps.map[mapnumber].MapHeader.sizeOfScriptReference;
			byte zero=0;
			for (int x=0;x<strings.Count;x++)
			{
				Maps.map[mapnumber].BW.BaseStream.Position=temporary;
				char[] h=((String)strings[x]).ToCharArray();
				Maps.map[mapnumber].BW.Write(h);
				Maps.map[mapnumber].BW.Write(zero);
				temporary+=((String)strings[x]).Length+1;
			}
			loc.size+=-oldpadding+tempnewsrsize+padding;
			loc.endoffset=loc.startoffset+loc.size;
			totalshift+=-oldpadding+tempnewsrsize+padding;
			int bleh=loc.size-padding;
			Maps.map[mapnumber].BW.BaseStream.Position=360;
			Maps.map[mapnumber].BW.Write(bleh);
			Maps.map[mapnumber].BW.BaseStream.Position=368;
			Maps.map[mapnumber].BW.Write(loc.startoffset);
			layout.chunks[tempint]=loc;

			////file names
			///
			tempint=layout.FindByType(RawDataContainerType.FileNames );
			loc=(LayOutChunk) layout.chunks[tempint];
			loc.startoffset+=totalshift;
			tempoldsize=Maps.map[mapnumber].MapHeader.fileNamesSize;
			oldpadding=Maps.map[mapnumber].Functions.Padding(tempoldsize,512);
		

			Maps.map[mapnumber].BW.BaseStream.Position=loc.startoffset;
			Maps.map[mapnumber].BW.BaseStream.Write(loc.MS.ToArray(),0,tempoldsize-Maps.map[mapnumber].FileNames.Length[Maps.map[mapnumber].IndexHeader.metaCount-1]-1);
			

			temporary=loc.startoffset+tempoldsize-Maps.map[mapnumber].FileNames.Length[Maps.map[mapnumber].IndexHeader.metaCount-1]-1;
			zero=0;
			for (int x=0;x<metas.Count;x++)
			{
				Maps.map[mapnumber].BW.BaseStream.Position=temporary;
				char[] h=((Meta)metas[x]).name.ToCharArray();
				Maps.map[mapnumber].BW.Write(h);
				Maps.map[mapnumber].BW.Write(zero);
				temporary+=((Meta)metas[x]).name.Length+1;
			}
			tempnewsrsize=temporary-loc.startoffset-tempoldsize;
			padding=Maps.map[mapnumber].Functions.Padding(tempoldsize+tempnewsrsize,512);
			tempb=new byte[padding];
			Maps.map[mapnumber].BW.BaseStream.Write(tempb,0,padding);


			loc.size+=-oldpadding+tempnewsrsize+padding;
			loc.endoffset=loc.startoffset+loc.size;
			totalshift+=-oldpadding+tempnewsrsize+padding;
			Maps.map[mapnumber].BW.BaseStream.Position=704;
			newcount=Maps.map[mapnumber].MapHeader.fileCount+metas.Count-1;
			Maps.map[mapnumber].BW.Write(newcount);
			Maps.map[mapnumber].BW.Write(loc.startoffset);
			int hhh=temporary-loc.startoffset;
			Maps.map[mapnumber].BW.Write(hhh);
			layout.chunks[tempint]=loc;


			////files index
			///
			tempint=layout.FindByType(RawDataContainerType.FileNamesIndex );
			loc=(LayOutChunk) layout.chunks[tempint];
			loc.startoffset+=totalshift;
			tempoldsize=Maps.map[mapnumber].MapHeader.fileCount*4;
			oldpadding=Maps.map[mapnumber].Functions.Padding(tempoldsize,512);
			tempnewsrsize=(metas.Count*4)-4;
			Maps.map[mapnumber].BW.BaseStream.Position=loc.startoffset;
			Maps.map[mapnumber].BW.BaseStream.Write(loc.MS.ToArray(),0,tempoldsize);
			tempb=new byte[tempnewsrsize];
			Maps.map[mapnumber].BW.BaseStream.Write(tempb,0,tempnewsrsize);
			padding=Maps.map[mapnumber].Functions.Padding(tempoldsize+tempnewsrsize,512);
			tempb=new byte[padding];
			Maps.map[mapnumber].BW.BaseStream.Write(tempb,0,padding);
			temporary=Maps.map[mapnumber].MapHeader.fileNamesSize-Maps.map[mapnumber].FileNames.Length[Maps.map[mapnumber].IndexHeader.metaCount-1]-1;
			for (int x=0;x<metas.Count;x++)
			{
				Maps.map[mapnumber].BW.BaseStream.Position=loc.startoffset+tempoldsize+(x*4)-4;
				Maps.map[mapnumber].BW.Write(temporary);
				temporary+=((Meta)metas[x]).name.Length+1;
			}
			loc.size+=-oldpadding+tempnewsrsize+padding;
			loc.endoffset=loc.startoffset+loc.size;
           
			totalshift+=-oldpadding+tempnewsrsize+padding;
			Maps.map[mapnumber].BW.BaseStream.Position=716;
			Maps.map[mapnumber].BW.Write(loc.startoffset);
			layout.chunks[tempint]=loc;


			tempint=layout.FindByType(RawDataContainerType.UnicodeNamesIndex );
			for (int x=0;x<8;x++)
			{
				loc=(LayOutChunk) layout.chunks[tempint+(x*2)];
				loc.startoffset+=totalshift;
				loc.endoffset+=totalshift;
				Maps.map[mapnumber].BW.BaseStream.Position=loc.startoffset;
				Maps.map[mapnumber].BW.BaseStream.Write(loc.MS.ToArray(),0,loc.size);
				layout.chunks[tempint+(x*2)]=loc;
				loc2=(LayOutChunk) layout.chunks[tempint+(x*2)+1];
				loc2.startoffset+=totalshift;
				loc2.endoffset+=totalshift;
				Maps.map[mapnumber].BW.BaseStream.Position=loc2.startoffset;
				Maps.map[mapnumber].BW.BaseStream.Write(loc2.MS.ToArray(),0,loc2.size);
				layout.chunks[tempint+(x*2)+1]=loc2;
			}
			tempint=layout.FindByType(RawDataContainerType.MetaData);
			for (int x=0;x<9;x++)
			{
				loc=(LayOutChunk) layout.chunks[tempint];
				BinaryWriter BW=new BinaryWriter(loc.MS);
				BW.BaseStream.Position=Maps.map[mapnumber].MetaInfo.Offset[0]-Maps.map[mapnumber].MapHeader.metaStart-Maps.map[mapnumber].MapHeader.indexOffset+Maps.map[mapnumber].Unicode.ut[x].indexPointerOffset;
                Maps.map[mapnumber].Unicode.ut[x].indexOffset += totalshift;
                Maps.map[mapnumber].Unicode.ut[x].tableOffset += totalshift;
                BW.Write(Maps.map[mapnumber].Unicode.ut[x].indexOffset);
                BW.Write(Maps.map[mapnumber].Unicode.ut[x].tableOffset);
				layout.chunks[tempint]=loc;
			}


			tempint=layout.FindByType(RawDataContainerType.Crazy);
			loc=(LayOutChunk) layout.chunks[tempint];
			loc.startoffset+=totalshift;
			loc.endoffset+=totalshift;
			Maps.map[mapnumber].BW.BaseStream.Position=loc.startoffset;
			Maps.map[mapnumber].BW.BaseStream.Write(loc.MS.ToArray(),0,loc.size);
			Maps.map[mapnumber].BW.BaseStream.Position=344;
			Maps.map[mapnumber].BW.Write(loc.startoffset);
			layout.chunks[tempint]=loc;




			//////////////////////////////////////
			///bitmap raw data
			///
			int bitmshift=0;
			tempint=layout.FindByType(RawDataContainerType.Bitmap);
			loc=(LayOutChunk) layout.chunks[tempint];
			loc.startoffset+=totalshift;
			Maps.map[mapnumber].BW.BaseStream.Position=loc.startoffset;
			Maps.map[mapnumber].BW.BaseStream.Write(loc.MS.ToArray(),0,loc.size);
			int bitmappad=0;
			for (int x=0;x<metas.Count;x++)
			{
				Meta m=((Meta)metas[x]);
				if (m.rawType==RawDataContainerType.Bitmap)
				{
					BinaryWriter BW=new BinaryWriter(m.MS);
					for (int y=0;y<m.raw.rawChunks.Count;y++)
					{
						RawDataChunk r=(RawDataChunk) m.raw.rawChunks[y];
						int tempintx=loc.startoffset+loc.size+bitmshift;;
						//writes new pointer to loaded meta
						BW.BaseStream.Position=r.pointerMetaOffset;
						BW.Write(tempintx);
						//BW.Write(r.size);
						//writes raw to map file
						Maps.map[mapnumber].BW.BaseStream.Position=tempintx;
						Maps.map[mapnumber].BW.BaseStream.Write(r.MS.ToArray(),0,r.size);
						//write padding
						int tempinty=Maps.map[mapnumber].Functions.Padding(r.size,512);
						byte[] tempbytes=new byte[tempinty];
						Maps.map[mapnumber].BW.Write(tempbytes);
						bitmshift+=r.size+tempinty;
						
						bitmappad=tempinty;
					}	
					metas[x]=m;
				}
			}
            
            totalshift += bitmshift;
			loc.size+=bitmshift;
			loc.endoffset=loc.startoffset+loc.size;
			layout.chunks[tempint]=loc;
			


			tempint=layout.FindByType(RawDataContainerType.MetaIndex);

			loc=(LayOutChunk) layout.chunks[tempint];
			loc.startoffset+=totalshift;
			loc.endoffset+=totalshift;


            tempint = layout.FindByType(RawDataContainerType.MetaData);
          
            loc2 = (LayOutChunk)layout.chunks[tempint];
            loc2.startoffset += totalshift;
            loc2.endoffset += totalshift;


			Maps.map[mapnumber].BW.BaseStream.Position=loc.startoffset;
			Maps.map[mapnumber].BW.BaseStream.Write(loc.MS.ToArray(),0,loc.size);
            Maps.map[mapnumber].BW.BaseStream.Position = loc2.startoffset;
            Maps.map[mapnumber].BW.BaseStream.Write(loc2.MS.ToArray(), 0, loc2.size);
			Maps.map[mapnumber].BW.BaseStream.Position=16;
			Maps.map[mapnumber].BW.Write(loc.startoffset);
			newcount=metas.Count+Maps.map[mapnumber].IndexHeader.metaCount-1;
			Maps.map[mapnumber].BW.BaseStream.Position=loc.startoffset+24;
			Maps.map[mapnumber].BW.Write(newcount);

			Maps.map[mapnumber].BR.BaseStream.Position=Maps.map[mapnumber].IndexHeader.tagsOffset+totalshift+8;
			Maps.map[mapnumber].SecondaryMagic=Maps.map[mapnumber].BR.ReadInt32()-(loc.startoffset+Maps.map[mapnumber].MapHeader.metaStart);

			int where=Maps.map[mapnumber].MetaInfo.Offset[Maps.map[mapnumber].IndexHeader.metaCount-1]+totalshift;
            
			int howfar=0;
			for (int x=0;x<metas.Count;x++)
			{
				Meta m=(Meta)metas[x];
				int fuck=Maps.map[mapnumber].IndexHeader.tagsOffset+totalshift+((Maps.map[mapnumber].IndexHeader.metaCount-1)*16)+(x*16);
			

				char[] metatype=m.type.ToCharArray();
				Array.Reverse(metatype);
				int ident=Maps.map[mapnumber].MetaInfo.Ident[Maps.map[mapnumber].IndexHeader.metaCount-1]+(x*65537);
				int offset=where+howfar;
				
				if (x==metas.Count-1)
				{
					int wherex=Maps.map[mapnumber].MetaInfo.Offset[0]+totalshift+756;
					Maps.map[mapnumber].BW.BaseStream.Position=wherex;
					Maps.map[mapnumber].BW.Write(ident);
				}

                if (m.type == "phmo" | m.type == "coll" | m.type == "spas" )
				{
					int tempoffset=offset;
					do
					{
						string tempss=tempoffset.ToString("X");
						char[] tempc=tempss.ToCharArray();
						int	xxx=tempc.Length;
						if (m.padding==tempc[xxx-1])
						{
							int diff=tempoffset-offset;
							tempb=new byte[diff];
							Maps.map[mapnumber].BW.BaseStream.Position=offset;
							Maps.map[mapnumber].BW.Write(tempb);
							if (x==0)
							{
								int tempsize=Maps.map[mapnumber].MetaInfo.Size[Maps.map[mapnumber].IndexHeader.metaCount-2];
								tempsize+=diff;
								int temploc=Maps.map[mapnumber].IndexHeader.tagsOffset+totalshift+((Maps.map[mapnumber].IndexHeader.metaCount-2)*16)+12;
								Maps.map[mapnumber].BW.BaseStream.Position=temploc;
								Maps.map[mapnumber].BW.Write(tempsize);
							}
							else
							{
								int tempsize=((Meta)metas[x-1]).size;
								tempsize+=diff;
								int temploc=Maps.map[mapnumber].IndexHeader.tagsOffset+totalshift+((Maps.map[mapnumber].IndexHeader.metaCount-1)*16)+((x-1)*16)+12;
								Maps.map[mapnumber].BW.BaseStream.Position=temploc;
								Maps.map[mapnumber].BW.Write(tempsize);
									
							}
							offset=tempoffset;
						howfar+=diff;
							break;
						}
						tempoffset++;
					}
					while (temps!=null);
				}

				int offsetwithmagic=offset+Maps.map[mapnumber].SecondaryMagic;
				int size=m.size;
				
				Maps.map[mapnumber].BW.BaseStream.Position=fuck;
				Maps.map[mapnumber].BW.Write(metatype);
				Maps.map[mapnumber].BW.Write(ident);
				Maps.map[mapnumber].BW.Write(offsetwithmagic);
				Maps.map[mapnumber].BW.Write(size);
				howfar+=m.size;

				Maps.map[mapnumber].BW.BaseStream.Position=offset;
				Maps.map[mapnumber].BW.BaseStream.Write(m.MS.ToArray(),0,m.size);

				for (int xx=0;xx<m.items.Count;xx++)
				{
						
					Meta.Item i=(Meta.Item)m.items[xx];
					switch (i.type)
					{
						case Meta.ItemType.Ident:
							Meta.Ident id=(Meta.Ident)i;
							if (id.pointstotagnumber==-1|x==metas.Count-1)
							{
								
									for (int e=0;e<metas.Count;e++)
									{
										Meta tempm=(Meta)metas[e];
										if (tempm.name==id.pointstotagname&&tempm.type==id.pointstotagtype)
										{
											id.ident=Maps.map[mapnumber].MetaInfo.Ident[Maps.map[mapnumber].IndexHeader.metaCount-1]+(e*65537);;
											break;
										}
										if (e==metas.Count-1)
										{
											if (id.pointstotagname!="Null")
											{
												int sss=Array.IndexOf(Maps.map[mapnumber].MetaInfo.TagType,id.pointstotagtype);
												id.ident=sss!=-1?Maps.map[mapnumber].MetaInfo.Ident[sss]:-1;
												//id.ident=-1;
											}
											else
											{
												id.ident=-1;
											}
										}
									}
							
							}
							else
							{
								id.ident=Maps.map[mapnumber].MetaInfo.Ident[id.pointstotagnumber];
							}
							Maps.map[mapnumber].BW.BaseStream.Position=offset+id.offset;
							Maps.map[mapnumber].BW.Write(id.ident);
							break;
						case Meta.ItemType.Reflexive :
							Meta.Reflexive reflex=(Meta.Reflexive)i;
							int newreflex=reflex.translation+offset+Maps.map[mapnumber].SecondaryMagic;
							Maps.map[mapnumber].BW.BaseStream.Position=offset+reflex.offset;
                            Maps.map[mapnumber].BW.Write(reflex.chunkcount);
							Maps.map[mapnumber].BW.Write(newreflex);
							break;	
						case Meta.ItemType.String :
							Meta.String s=(Meta.String)i;
							short stringnum=0;
							byte stringlength=0;
							for (int e=0;e<Maps.map[mapnumber].MapHeader.scriptReferenceCount;e++)
							{
								if (s.name==Maps.map[mapnumber].Strings.Name[e])
								{
									stringnum=(short)e;
									stringlength=(byte)Maps.map[mapnumber].Strings.Length[e];
								}
							}
							for (int e=0;e<strings.Count;e++)
							{
								if (((string)strings[e])==s.name)
								{

									stringnum=(short)(Maps.map[mapnumber].MapHeader.scriptReferenceCount+e);
									stringlength=(byte)s.name.Length;
								}
							}

							Maps.map[mapnumber].BW.BaseStream.Position=offset+s.offset;
							Maps.map[mapnumber].BW.Write(stringnum);
							Maps.map[mapnumber].BW.Write(zero);
							Maps.map[mapnumber].BW.Write(stringlength);
							break;
					}

				}
				
			}
			//totalshift+=howfar;
			
			int tempfilesize=Maps.map[mapnumber].MapHeader.fileSize+totalshift+howfar-Maps.map[mapnumber].MetaInfo.Size[Maps.map[mapnumber].IndexHeader.metaCount-1];//(int)Maps.map[mapnumber].BW.BaseStream.Length;
			//Maps.map[mapnumber].MapHeader.fileSize+totalshift+howfar-Maps.map[mapnumber].MetaInfo.Size [Maps.map[mapnumber].IndexHeader.metaCount-1];
			padding=Maps.map[mapnumber].Functions.Padding(tempfilesize,512);
			tempb=new byte[padding];
			Maps.map[mapnumber].BW.BaseStream.Position=tempfilesize;
			Maps.map[mapnumber].BW.Write(tempb);
			tempfilesize+=padding;

            int olddifference = (Maps.map[mapnumber].MapHeader.fileSize - (Maps.map[mapnumber].MapHeader.indexOffset));
			int difference=(tempfilesize-(Maps.map[mapnumber].MapHeader.indexOffset+totalshift));
            int metasize = Maps.map[mapnumber].MapHeader.metaSize+howfar- Maps.map[mapnumber].MetaInfo.Size[Maps.map[mapnumber].IndexHeader.metaCount - 1] +padding;
           // int combined = Maps.map[mapnumber].MapHeader.combinedSize + difference;
           int combined = Maps.map[mapnumber].MapHeader.combinedSize - olddifference + difference;
                //(int)bspmetasize + difference;
            //MessageBox.Show("test");
             //   combined
            //metasize -= bspmetashift;
                //Maps.map[mapnumber].MapHeader.combinedSize + howfar - Maps.map[mapnumber].MetaInfo.Size[Maps.map[mapnumber].IndexHeader.metaCount - 1] + padding;
            //(int)bspmetasize + difference - bspmetashift;
           
			Maps.map[mapnumber].BW.BaseStream.Position=8;
			Maps.map[mapnumber].BW.Write(tempfilesize);
			Maps.map[mapnumber].BW.BaseStream.Position=24;
			Maps.map[mapnumber].BW.Write(metasize);
			Maps.map[mapnumber].BW.Write(combined);

            Maps.map[mapnumber].BW.BaseStream.SetLength(tempfilesize);



            if (bspmagic == Maps.map[mapnumber].BSP.sbsp[0].magic)
            {
                
            }
            else
            {



                int tempbspmagic = Maps.map[mapnumber].BSP.sbsp[0].magic + Maps.map[mapnumber].BSP.sbsp[0].offset-bspoffset;


                for (int xx = 0; xx < tempbspmeta.items.Count; xx++)
                {
                    Meta.Item i = (Meta.Item)tempbspmeta.items[xx];
                    switch (i.type)
                    {
                        case Meta.ItemType.Ident:
                            Meta.Ident id = (Meta.Ident)i;
                            if (id.pointstotagnumber == -1)
                            {
                                for (int e = 0; e < metas.Count; e++)
                                {
                                    Meta tempm = (Meta)metas[e];
                                    if (tempbspmeta.name == id.pointstotagname && tempbspmeta.type == id.pointstotagtype)
                                    {
                                        id.ident = Maps.map[mapnumber].BSP.sbsp[0].ident;
                                        break;
                                    }
                                    else if (tempm.name == id.pointstotagname && tempm.type == id.pointstotagtype)
                                    {
                                        id.ident = Maps.map[mapnumber].MetaInfo.Ident[Maps.map[mapnumber].IndexHeader.metaCount - 1] + (e * 65537); ;
                                        break;
                                    }
                                    if (e == metas.Count - 1)
                                    {
                                        int sss = Array.IndexOf(Maps.map[mapnumber].MetaInfo.TagType, id.intagtype);
                                        id.ident = sss != -1 ? Maps.map[mapnumber].MetaInfo.Ident[sss] : -1;

                                    }
                                }
                            }
                            else
                            {
                                id.ident = Maps.map[mapnumber].MetaInfo.Ident[id.pointstotagnumber];
                            }
                            Maps.map[mapnumber].BW.BaseStream.Position = bspoffset + id.offset;
                            Maps.map[mapnumber].BW.Write(id.ident);
                            break;
                        case Meta.ItemType.String:
                            Meta.String s = (Meta.String)i;
                            short stringnum = 0;
                            byte stringlength = 0;
                            for (int e = 0; e < Maps.map[mapnumber].MapHeader.scriptReferenceCount; e++)
                            {
                                if (s.name == Maps.map[mapnumber].Strings.Name[e])
                                {
                                    stringnum = (short)e;
                                    stringlength = (byte)Maps.map[mapnumber].Strings.Length[e];
                                }
                            }
                            for (int e = 0; e < strings.Count; e++)
                            {
                                if (((string)strings[e]) == s.name)
                                {

                                    stringnum = (short)(Maps.map[mapnumber].MapHeader.scriptReferenceCount + e);
                                    stringlength = (byte)s.name.Length;
                                }
                            }

                            Maps.map[mapnumber].BW.BaseStream.Position = bspoffset + s.offset;
                            Maps.map[mapnumber].BW.Write(stringnum);
                            Maps.map[mapnumber].BW.Write(new byte());
                            Maps.map[mapnumber].BW.Write(stringlength);
                            break;

                        case Meta.ItemType.Reflexive:
                            Meta.Reflexive rr = (Meta.Reflexive)i;
                            int newreflex = bspoffset + rr.translation + tempbspmagic;
                            Maps.map[mapnumber].BW.BaseStream.Position = bspoffset + rr.offset + 4;
                           // Maps.map[mapnumber].BW.Write(newreflex);

                            break;
                    }

                }


            }





			for (int x=0;x<layout.chunks.Count;x++)
			{
				loc=(LayOutChunk) layout.chunks[x];
				for (int xx=0;xx<loc.rawPieces.Count;xx++)
				{
					RawInfoChunk r=(RawInfoChunk)loc.rawPieces[xx];
					r.offsetOfPointer+=totalshift;
					Maps.map[mapnumber].BW.BaseStream.Position=r.offsetOfPointer;
					switch (r.rawType)
					{
						case RawDataType.bitm:
							r.offset+=(uint)(totalshift-bitmshift);
							Maps.map[mapnumber].BW.Write(r.offset);
							break;
						case RawDataType.DECR:
                            r.offset += (uint)(sndshift + modeshift + bspshift + weathershift);
							Maps.map[mapnumber].BW.Write(r.offset);
							break;
                //       case RawDataType.snd2:
						case RawDataType.jmad:
                            r.offset += (uint)(sndshift + modeshift + bspshift + weathershift + decrshift + prtmshift);
							Maps.map[mapnumber].BW.Write(r.offset);
							break;
						case RawDataType.mode1:
                            r.offset += (uint)(sndshift);
                            Maps.map[mapnumber].BW.Write(r.offset);
							break;
						case RawDataType.mode2:
                            r.offset += (uint)(sndshift);
                            Maps.map[mapnumber].BW.Write(r.offset);
							break;
						case RawDataType.PRTM:
                            r.offset += (uint)(sndshift + modeshift + bspshift + weathershift + decrshift);
							Maps.map[mapnumber].BW.Write(r.offset);
							break;
						case RawDataType.weat:
                            r.offset += (uint)(sndshift + modeshift + bspshift);
							Maps.map[mapnumber].BW.Write(r.offset);
							break;
					}
					
				}
			}
			
			layout.chunks[tempint]=loc;
		//	layout.SortChunksByOffset();
	
			Maps.map[mapnumber].CloseMap();


            for (int y = 0; y < filestofix.Length; y++)
            {
            
                int mapid = Maps.Add(filestofix[y]);
                MapAnalyzer analyze = new MapAnalyzer();
                MapLayout lo=analyze.ScanMapForLayOut(mapid,true);
             
                Maps.map[mapid].OpenMap(MapTypes.Internal);

                for (int x = 0; x < lo.chunks.Count; x++)
                {
                    loc = (LayOutChunk)lo.chunks[x];
                    for (int xx = 0; xx < loc.rawPieces.Count; xx++)
                    {
                        RawInfoChunk r = (RawInfoChunk)loc.rawPieces[xx];
                        if (r.location != Maps.map[mapnumber].MapHeader.mapType) { continue; }
                        
                        Maps.map[mapid].BW.BaseStream.Position = r.offsetOfPointer;
                        switch (r.rawType)
                        {
                            case RawDataType.bitm:
                                r.offset += (uint)(totalshift - bitmshift);
                                r.offset |= 0X40000000;
                                Maps.map[mapid].BW.Write(r.offset);
                                break;
                            case RawDataType.DECR:
                                r.offset += (uint)(sndshift + modeshift + bspshift + weathershift);
                                r.offset |= 0X40000000;
                                Maps.map[mapid].BW.Write(r.offset);
                                break;
                            case RawDataType.snd2:
                            case RawDataType.jmad:
                                r.offset += (uint)(sndshift + modeshift + bspshift + weathershift + decrshift + prtmshift);
                                r.offset |= 0X40000000;
                                Maps.map[mapid].BW.Write(r.offset);
                                break;
                            case RawDataType.mode1:
                                r.offset += (uint)(sndshift);
                                r.offset |= 0X40000000;
                                Maps.map[mapid].BW.Write(r.offset);
                                break;
                            case RawDataType.mode2:
                                r.offset += (uint)(sndshift);
                                r.offset |= 0X40000000;
                                Maps.map[mapid].BW.Write(r.offset);
                                break;
                            case RawDataType.PRTM:
                                r.offset += (uint)(sndshift + modeshift + bspshift + weathershift + decrshift);
                                r.offset |= 0X40000000;
                                Maps.map[mapid].BW.Write(r.offset);
                                break;
                            case RawDataType.weat:
                                r.offset += (uint)(sndshift + modeshift + bspshift);
                                r.offset |= 0X40000000;
                                Maps.map[mapid].BW.Write(r.offset);
                                break;
                        }

                    }
                }
                
                Maps.map[mapid].CloseMap();
                Maps.map[mapid].Sign();
                Maps.map.RemoveAt(mapid);
            }
			
			
		}
        #endregion

    }
}
