using System;
using System.Collections;
using System.Windows.Forms;

namespace entity
{

    


    public class MetaEditor
    {
        #region Fields
        ReflexiveContainer Controls;
        public static Map map;
        #endregion
        #region Constructor
        public MetaEditor(IFPIO ifp,SplitContainer split,Map mapx)
        {
            map = mapx;
         
            ReflexiveContainer tempr = new ReflexiveContainer("Header");
            MakeControls(0,ifp.items, ref tempr);
            Controls = tempr;
            DrawControls(ref split);
        }
        #endregion
        #region Methods
        public static void GenerateIdentTypeCombobox(ComboBox c)
        {
          //  c = new ComboBox();
           // 
            IEnumerator i=map.MetaInfo.TagTypes.Keys.GetEnumerator();

            while (i.MoveNext())
            {
                c.Items.Add((string)i.Current);
            }
            c.Sorted = true;
           // return c;
        }
        public void MakeControls(int y,object[] ifpobjects,ref  ReflexiveContainer reflex)
        {
        
            foreach (object o in ifpobjects)
            {
                IFPIO.BaseObject tempbase = (IFPIO.BaseObject)o;
                   
                    switch (tempbase.ObjectType)
                    {
                        case IFPIO.ObjectEnum.Reflexive:
                            IFPIO.Reflexive r=(IFPIO.Reflexive) tempbase;
                          //  if (r.visible == false) { break; }
                            ReflexiveContainer tempr = new ReflexiveContainer(r);
                            MakeControls(0,r.items, ref tempr);
                            reflex.Controls.Add(tempr);
                           
                         
                           
                            break;
                       case IFPIO.ObjectEnum.Ident :
                            IFPIO.Ident id = (IFPIO.Ident)tempbase;
                          //  if (id.visible == false) { break; }
                            IdentContainer tempid = new IdentContainer(id);
                            reflex.Controls.Add(tempid);
                            break;
                        case IFPIO.ObjectEnum.Int:
                            IFPIO.IFPInt int32 = (IFPIO.IFPInt)tempbase;
                          //  if (int32.visible == false) { break; }
                            Int32Container tempint = new Int32Container(int32);
                            reflex.Controls.Add(tempint);
                            break;
                       
                    }
            }
        }
        public void DrawControls(ref SplitContainer s)
        {
            s.Panel2Collapsed = true;
            s.Panel2.Controls.Clear();
            DrawControlsRecursive(ref s, ref Controls);
            s.Panel2Collapsed = false;
        }

        private void DrawControlsRecursive(ref SplitContainer s ,ref ReflexiveContainer reflex)
        {
            foreach (object o in reflex.Controls)
            {
                PluginControl tempbase = (PluginControl)o;
                bool nospacer =  true;
                switch (tempbase.type )
                {
                    case ContainerType.Reflexive:
                        ReflexiveContainer r = (ReflexiveContainer)tempbase;

                        DrawControlsRecursive(ref r.Container, ref r);
                        reflex.height += 25;
                       
                        s.Panel2.Controls.Add(r.Container);
                        s.Panel2.Controls[s.Panel2.Controls.Count - 1].BringToFront();
                        s.Panel2.Controls[s.Panel2.Controls.Count - 1].Update();
                        break;
                    case ContainerType.Ident:
                        IdentContainer id = (IdentContainer)tempbase;
                        s.Panel2.Controls.Add(id.panel);
                        reflex.height += id.panel.Height ;
                        s.Panel2.Controls[s.Panel2.Controls.Count - 1].BringToFront();
                        s.Panel2.Controls[s.Panel2.Controls.Count - 1].Update();
                        break;
                    case ContainerType.Int32:
                        Int32Container int32 = (Int32Container)tempbase;
                        s.Panel2.Controls.Add(int32.panel);
                        reflex.height += int32.panel.Height;
                        s.Panel2.Controls[s.Panel2.Controls.Count - 1].BringToFront();
                        s.Panel2.Controls[s.Panel2.Controls.Count - 1].Update();
                        break;
                    default:
                        nospacer = true;
                        break;
                }
                if (nospacer == true) { continue; }
                Panel  Spacerx = new Panel();
                Spacerx.Height = 10;
                Spacerx.BackColor = System.Drawing.Color.Transparent;
                Spacerx.Dock = DockStyle.Top;
                s.Panel2.Controls.Add(Spacerx);
                s.Panel2.Controls[s.Panel2.Controls.Count - 1].BringToFront();
                s.Panel2.Controls[s.Panel2.Controls.Count - 1].Update();
                reflex.height += 10;
            }
        }
   

        #endregion
        #region enums
        public enum ContainerType
        {
            Reflexive,
            Ident,
            StringID,
            Int32,
            Int16,
        }
        #endregion
        #region Classes
        public class PluginControl
        {
            public int height;
            public int width;
            public ContainerType type;
            public int offset;
        }
        public class ReflexiveContainer : PluginControl
        {
            public SplitContainer Container;
            public ArrayList Controls=new ArrayList(0);
            public ComboBox SelectedChunkComboBox;
            protected  System.Drawing.Size minSize = new System.Drawing.Size();
            protected System.Drawing.Size maxSize = new System.Drawing.Size();

            public void SetMaxSize(int width,int height)
            {
                maxSize = new System.Drawing.Size(width, height);
            }

            public void SetMinSize(int width, int height)
            {
                minSize = new System.Drawing.Size(width, height);
            }

            public System.Drawing.Size MaxSize
            {
                get { return maxSize; }
                set { maxSize = value; }
            }

            public System.Drawing.Size MinSize
            {
                get { return minSize; }
                set { minSize = value; }
            }

            public ReflexiveContainer(string name)
            {
                base.height = 25;
                type = ContainerType.Reflexive;
                Label templabel = new Label();
                templabel.BorderStyle = BorderStyle.FixedSingle;
                templabel.BackColor = System.Drawing.Color.WhiteSmoke;
                templabel.Text = name;
                templabel.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
                templabel.Dock = DockStyle.Left;
                
                templabel.MouseDown += new MouseEventHandler(ReflexiveHeader_MouseDown);

                SelectedChunkComboBox = new ComboBox();
                SelectedChunkComboBox.Dock = DockStyle.Right;
                SelectedChunkComboBox.Width = 50;
                SelectedChunkComboBox.FlatStyle = FlatStyle.Popup;
                //container
                SplitContainer tempsplit = new SplitContainer();
                tempsplit.Orientation = Orientation.Horizontal;
                tempsplit.Panel1MinSize = 0;
                tempsplit.SplitterDistance = 25;
                tempsplit.IsSplitterFixed = true;
                tempsplit.SplitterWidth = 1;
                tempsplit.Dock = DockStyle.Fill;
                //panel 1
                tempsplit.Panel1.Controls.Add(SelectedChunkComboBox);
                tempsplit.Panel1.Controls.Add(templabel);
                
                //panel 2
                tempsplit.Panel2.AutoScroll = true;
                tempsplit.Panel2.BackColor = System.Drawing.Color.Honeydew;
                //    Padding prop = new Padding();
                //    prop.All = 10;
                //  tempsplit.Panel2.Margin = prop;
                tempsplit.Panel2Collapsed = true;


                Container = tempsplit;



            }
            
            public ReflexiveContainer(IFPIO.Reflexive reflexive)
            {
                type = ContainerType.Reflexive;
              //  Controls.
                Label templabel = new Label();
                templabel.BorderStyle = BorderStyle.FixedSingle;
                templabel.BackColor = System.Drawing.Color.Silver;
                templabel.Text = "Reflexive (" + reflexive.name + ")  Offset: " + reflexive.offset.ToString("X") ;
                templabel.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
                templabel.Dock = DockStyle.Fill;
                templabel.MouseDown += new MouseEventHandler(ReflexiveHeader_MouseDown);

                SelectedChunkComboBox = new ComboBox();
                SelectedChunkComboBox.Dock = DockStyle.Right;
                SelectedChunkComboBox.Width = 50;
                SelectedChunkComboBox.Height = 25;
                 SelectedChunkComboBox.FlatStyle = FlatStyle.Popup;
                //container
                SplitContainer tempsplit = new SplitContainer();
                 tempsplit.Orientation = Orientation.Horizontal;
                tempsplit.Panel1MinSize = 0;
                tempsplit.SplitterDistance = 25;
                tempsplit.IsSplitterFixed = true;
                tempsplit.SplitterWidth = 1;
                tempsplit.Dock = DockStyle.Top;
                SetMaxSize(0, 25);
                tempsplit.MaximumSize = this.MaxSize;
                //panel 1
                tempsplit.Panel1.Controls.Add(templabel);
                tempsplit.Panel1.Controls.Add(SelectedChunkComboBox);
                //panel 2
                tempsplit.Panel2.AutoScroll = true;
                tempsplit.Panel2.BackColor = System.Drawing.Color.Honeydew;
                Padding prop = new Padding();
                prop.All = 10;
                //prop.Right = 0;
                tempsplit.Panel2.Padding = prop;
                tempsplit.Panel2Collapsed = true;
                tempsplit.BorderStyle = BorderStyle.None;
               //tempsplit.Visible = true;

                this.Container = tempsplit;
              
              

            }
            private void ReflexiveHeader_MouseDown(object sender, MouseEventArgs e)
            {
                Label x = (Label)sender;
                SplitterPanel s = (SplitterPanel)x.Parent;
                SplitContainer sc = (SplitContainer)s.Parent;
                if (sc.Panel2Collapsed == false)
                {
                    SetMaxSize(0, 25);
                    SetMinSize(0, 25);
                    sc.MaximumSize = this.MaxSize;
                    sc.MinimumSize  = this.MinSize;
                    sc.Height = 25;
                    sc.BorderStyle = BorderStyle.None;
                    
                    sc.Panel2Collapsed = true;
                    sc.SplitterDistance = 25;
                    sc.Update();
                    
                    x.BackColor = System.Drawing.Color.Silver;
                }
                else
                {
                    
                    SetMaxSize(0, height+50);
                    SetMinSize(0, 25);
         
                    sc.MaximumSize = this.MaxSize;
                    sc.MinimumSize = this.MinSize;
                    sc.Height = height+50;
                    sc.BorderStyle = BorderStyle.FixedSingle;
                      sc.Panel2Collapsed = false;
                    sc.SplitterDistance = 25;
                    sc.Update();
                    x.BackColor = System.Drawing.Color.CornflowerBlue;
                }
            }
        }


        public class IdentContainer : PluginControl
        {
            public Panel panel;
            public Label DescriptionLabel;
            public ComboBox TagTypeCombo;
            public ComboBox NameCombo;


            public IdentContainer(IFPIO.Ident ident)
            {
                type = ContainerType.Ident;
                Label templabel = new Label();
                templabel.BorderStyle = BorderStyle.FixedSingle;
                templabel.BackColor = System.Drawing.Color.Silver;
                templabel.Text = "Ident (" + ident.name + ")  Offset: " + ident.offset.ToString("X"); 
                templabel.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
                templabel.Dock = DockStyle.Top;
                templabel.Height = 20;
                templabel.Width = 125;
                templabel.Top = 0;

                DescriptionLabel = templabel;
                TagTypeCombo = new ComboBox() ;
                TagTypeCombo.Width = 75;
               TagTypeCombo.Dock = DockStyle.Right;
                TagTypeCombo.Top = 20;
                TagTypeCombo.Left = 0;
             //   TagTypeCombo=
                    MetaEditor.GenerateIdentTypeCombobox(TagTypeCombo);
                
                NameCombo = new ComboBox();
                NameCombo.Width = 250;
               NameCombo.Dock = DockStyle.Bottom;
                NameCombo.Top = 20;
                NameCombo.Left = 200;
               // NameCombo.Dock = DockStyle.Top;
                panel = new Panel();
                panel.Dock = DockStyle.Top;
                panel.Height = 40;
              //  panel.BorderStyle = BorderStyle.FixedSingle;
                panel.Controls.Add(DescriptionLabel);
                panel.Controls.Add(TagTypeCombo);
                panel.Controls.Add(NameCombo);
            }
        }


        public class Int32Container : PluginControl
        {
            public Panel panel;
            public Label DescriptionLabel;
            public TextBox IntTextBox;
         
            public Int32Container(IFPIO.IFPInt intx)
            {
                type = ContainerType.Int32;
                Label templabel = new Label();
                templabel.BorderStyle = BorderStyle.FixedSingle;
                templabel.BackColor = System.Drawing.Color.Silver;
                templabel.Text = "Int32 (" + intx.name + ")  Offset: " + intx.offset.ToString("X");
                templabel.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
                templabel.Dock = DockStyle.Left;
                templabel.Height = 20;
                templabel.AutoSize = true;
                DescriptionLabel = templabel;

                IntTextBox = new TextBox();
                IntTextBox.Dock = DockStyle.Fill;
                IntTextBox.Height = 20;
                //IntTextBox.Text=

                
                // NameCombo.Dock = DockStyle.Top;
                panel = new Panel();
                panel.Dock = DockStyle.Top;
                panel.Height = 40;
                //  panel.BorderStyle = BorderStyle.FixedSingle;
                panel.Controls.Add(DescriptionLabel);
                panel.Controls.Add(IntTextBox);
                
            }
        }
        #endregion
    }
}
