using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
using System.Windows.Forms;

namespace entity
{
    class MetaItemComparer
    {
        #region fields
        private Meta ifpMeta;
        private Meta manualMeta;
        private MetaScanner metaScanner;
        private string startUpPath;
        #endregion
        #region constructor
        public MetaItemComparer(int mapnumber, string istartUpPath)
        {
            startUpPath = istartUpPath;
            int counter = 0;
            string tagTypeString = "";
           // try
           // {
                for (counter = 0; counter < Maps.map[mapnumber].MapHeader.fileCount; counter++)
                {
                    metaScanner = new MetaScanner();
                    ifpMeta = new Meta();
                    manualMeta = new Meta();
                    manualMeta.ReadMetaFromMap(counter, mapnumber, false);
                    ifpMeta.ReadMetaFromMap(counter, mapnumber, false);
                    //parse ifp and scan meta with it
                    IFPIO io = IFP.IFPHashMap.GetIfp(ifpMeta.type, mapnumber);

                    ifpMeta.headersize = io.headerSize;
                    manualMeta.headersize = io.headerSize;
                    try
                    {
                        metaScanner.ScanWithIFP(ref io, ref ifpMeta, mapnumber);
                    }
                    catch
                    {
                        MessageBox.Show("Broken IFP - " + ifpMeta.type);
                    }
                    metaScanner.ScanManually(ref manualMeta, mapnumber);
                    check(mapnumber);
                }
          //  }
          //  catch (System.IO.FileNotFoundException)
          //  {
                MessageBox.Show("Tag Type " + tagTypeString + " Doesn't Have A Plugin");
         //   }
        }
        #endregion
        #region Methods
        private void check(int mapnumber)
        {
            List<Meta.Item> iList = new List<Meta.Item>(0);
            bool allOK = true;
            for (int counter = 0; counter < manualMeta.items.Count; counter++)
            {
                bool Ok = false;
                for (int counter2 = 0; counter2 < ifpMeta.items.Count; counter2++)
                {
                    if (manualMeta.items[counter].mapOffset == ifpMeta.items[counter2].mapOffset)
                        Ok = true;
                }
                if (Ok == false)
                {
                    iList.Add(manualMeta.items[counter]);
                    allOK = false;
                }
            }
            if (allOK == false)
                WritePluginError(iList,mapnumber);
        }
        private void WritePluginError(List<Meta.Item> iList, int mapnumber)
        {
            string difolder = startUpPath + "\\PluginTestResults\\" + FixTagTypeFileName(ifpMeta.type.Trim()) + "\\";
            DirectoryInfo di = new DirectoryInfo(difolder);
            if (di.Exists == false)
            { di.Create(); }
            string fileName = difolder + Maps.map[mapnumber].FileNames.Name[manualMeta.tagnumber].Replace('\\', '-') + ".check";
            FileStream fs = new FileStream(fileName, FileMode.Create, FileAccess.Write, FileShare.None);
            StreamWriter swFromFileStream = new StreamWriter(fs);
            for (int counter = 0; counter < iList.Count; counter++)
            {
                switch (iList[counter].type)
                {
                    case Meta.ItemType.Reflexive:
                        {
                            swFromFileStream.WriteLine(
                                "Reflexive | "
                                + " Map Offset : "
                                + ((Meta.Reflexive)iList[counter]).mapOffset.ToString().PadLeft(10, '0')
                                + " | Offset in Tag : "
                                + ((Meta.Reflexive)iList[counter]).offset.ToString().PadLeft(10, '0')
                                );
                            break;
                        }
                    case Meta.ItemType.Ident:
                        {
                            swFromFileStream.WriteLine(
                                "Ident | "
                                + " Map Offset : "
                                + ((Meta.Ident)iList[counter]).mapOffset.ToString().PadLeft(10, '0')
                                + " | Offset in Tag : "
                                + ((Meta.Ident)iList[counter]).offset.ToString().PadLeft(10, '0')
                                + " | Ident Type"
                                + ((Meta.Ident)iList[counter]).pointstotagtype
                                + " | Ident Name "
                                +((Meta.Ident)iList[counter]).pointstotagname
                                
                                );
                            break;
                        }
                    case Meta.ItemType.String:
                        {
                            swFromFileStream.WriteLine(
                                "Sid |"
                                + " Map Offset : "
                                + ((Meta.String)iList[counter]).mapOffset.ToString().PadLeft(10, '0')
                                + " Offset In Tag : "
                                + ((Meta.String)iList[counter]).offset.ToString().PadLeft(10, '0')
                                + " | SID Name : "
                                + ((Meta.String)iList[counter]).name
                                );
                            break;
                        }
                }

            }
            swFromFileStream.Close();
            fs.Close();

        }
        private string FixTagTypeFileName(string temp)
        {
            temp = temp.Replace("<", "_").Replace(">", "_");
            return temp;
        }
        #endregion
    }
}
