using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace entity.Forms.Meta_Editor
{
    public partial class ColorShifting : Form
    {
        private bool changeText = false;
        public ColorShifting()
        {
            InitializeComponent();
            hScrlBRed.Value = ShiftColors.StartingRed;
            hScrlBGreen.Value = ShiftColors.StartingGreen;
            hScrlBBlue.Value = ShiftColors.StartingBlue;
            txtBBlue.Text =  ShiftColors.StartingBlue.ToString();
            txtBGreen.Text = ShiftColors.StartingGreen.ToString();
            txtBRed.Text = ShiftColors.StartingRed.ToString();
            hScrlBBlueToShift.Value = ShiftColors.BlueToShift;
            hScrlBGreenToShift.Value = ShiftColors.GreenToShift;
            hScrlBRedToShift.Value = ShiftColors.RedToShift;
            txtbBlueToShift.Text = ShiftColors.BlueToShift.ToString();
            txtbGreenToShift.Text = ShiftColors.GreenToShift.ToString();
            txtbRedToShift.Text = ShiftColors.RedToShift.ToString();
            SetStartingColorPreview();
            this.UpdateLayersPreview();
            this.changeText = true;
        }

        private void hScrlBRed_Scroll(object sender, ScrollEventArgs e)
        {
            this.changeText = false;
            txtBRed.Text = hScrlBRed.Value.ToString();
            SetStartingColorPreview();
            this.UpdateLayersPreview();
            this.changeText = true;
        }

        private void hScrlBGreen_Scroll(object sender, ScrollEventArgs e)
        {
            this.changeText = false;
            txtBGreen.Text = hScrlBGreen.Value.ToString();
            SetStartingColorPreview();
            this.UpdateLayersPreview();
            this.changeText = true;
        }

        private void hScrlBBlue_Scroll(object sender, ScrollEventArgs e)
        {
            this.changeText = false;
            txtBBlue.Text = hScrlBBlue.Value.ToString();
            SetStartingColorPreview();
            this.UpdateLayersPreview();
            this.changeText = true;
        }
        private void SetStartingColorPreview()
        {
            this.labStartingColorPreview.BackColor = System.Drawing.Color.FromArgb(255,hScrlBRed.Value,hScrlBGreen.Value,hScrlBBlue.Value);
        }

        private void hScrlBRedToShift_Scroll(object sender, ScrollEventArgs e)
        {
            this.changeText = false;
            txtbRedToShift.Text = hScrlBRedToShift.Value.ToString();
            this.UpdateLayersPreview();
            this.changeText = true;
        }

        private void hScrlBGreenToShift_Scroll(object sender, ScrollEventArgs e)
        {
            this.changeText = false;
            txtbGreenToShift.Text = hScrlBGreenToShift.Value.ToString();
            this.UpdateLayersPreview();
            this.changeText = true;
        }

        private void hScrlBBlueToShift_Scroll(object sender, ScrollEventArgs e)
        {
            this.changeText = false;
            txtbBlueToShift.Text = hScrlBBlueToShift.Value.ToString();
            this.UpdateLayersPreview();
            this.changeText = true;
        }
        private void UpdateLayersPreview()
        {
            int incrementer = 0;
            for (int counter = 18; counter > -1; counter--)
            {
                ((Label)this.Controls[counter]).BackColor = System.Drawing.Color.FromArgb(255, ShiftColors.Shifter(incrementer, hScrlBRedToShift.Value, hScrlBRed.Value), ShiftColors.Shifter(incrementer, hScrlBGreenToShift.Value, hScrlBGreen.Value), ShiftColors.Shifter(incrementer, hScrlBBlueToShift.Value, hScrlBBlue.Value));
                incrementer++;
            }
        }

        private void txtBRed_TextChanged(object sender, EventArgs e)
        {
            if (this.changeText == false)
                return;
            try
            {
                this.hScrlBRed.Value = Convert.ToInt32(txtBRed.Text);
                this.hScrlBGreen.Value = Convert.ToInt32(txtBGreen.Text);
                this.hScrlBBlue.Value = Convert.ToInt32(txtBBlue.Text);
                this.hScrlBRedToShift.Value = Convert.ToInt32(txtbRedToShift.Text);
                this.hScrlBGreenToShift.Value = Convert.ToInt32(txtbGreenToShift.Text);
                this.hScrlBBlueToShift.Value = Convert.ToInt32(txtbBlueToShift.Text);
                SetStartingColorPreview();
                this.UpdateLayersPreview();
            }
            catch
            {
            }
        }

        private void buttCancel_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void buttSave_Click(object sender, EventArgs e)
        {
            ShiftColors.StartingRed = this.hScrlBRed.Value;
            ShiftColors.StartingGreen = this.hScrlBGreen.Value;
            ShiftColors.StartingBlue = this.hScrlBBlue.Value;
            ShiftColors.RedToShift = this.hScrlBRedToShift.Value;
            ShiftColors.GreenToShift = this.hScrlBGreenToShift.Value;
            ShiftColors.BlueToShift = this.hScrlBBlueToShift.Value;
            ShiftColors.WritePlugin();
            this.Close();
        }
    }
}