using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;

namespace entity.Forms.Meta_Editor
{
    public partial class Float : UserControl
    {
        private int mapIndex;
        public int chunkOffset;
        public int offsetInMap;
        public float value;
        public string EntName = "Error in getting plugin element name";
        private bool isNulledOutReflexive = true;
        public Float(string iEntName, int map, int iOffsetInChunk)
        {
            this.chunkOffset = iOffsetInChunk;
            mapIndex = map;
            this.EntName = iEntName;
            InitializeComponent();
            this.Size = this.PreferredSize;
            this.Dock = DockStyle.Top;
            this.Controls[0].Text = EntName;
            this.AutoSize = false;
        }
        public void Populate(int iOffset)
        {
            this.isNulledOutReflexive = false;
            bool openedMap = false;
            if (Maps.map[mapIndex].isOpen == false)
            {
                Maps.map[mapIndex].OpenMap(MapTypes.Internal);
                openedMap = true;
            }
            Maps.map[mapIndex].BR.BaseStream.Position = iOffset + this.chunkOffset;
            this.value = Maps.map[mapIndex].BR.ReadSingle();
            this.Controls[2].Text = value.ToString();
            this.offsetInMap = iOffset + this.chunkOffset;
            if (openedMap == true)
                Maps.map[mapIndex].CloseMap();
        }
        public void Save()
        {
            if (this.isNulledOutReflexive == true)
                return;
            bool openedMap = false;
            if (Maps.map[mapIndex].isOpen == false)
            {
                Maps.map[mapIndex].OpenMap(MapTypes.Internal);
                openedMap = true;
            }
            Maps.map[mapIndex].BW.BaseStream.Position = this.offsetInMap;
            Maps.map[mapIndex].BW.Write(this.value);
            if (openedMap == true)
                Maps.map[mapIndex].CloseMap();
        }
        void textBox1_TextChanged(object sender, System.EventArgs e)
        {
            ((TextBox)sender).TextChanged -= textBox1_TextChanged;
            try
            {
                this.value = Convert.ToSingle(((TextBox)sender).Text);
            }
            catch
            {
                MessageBox.Show(((TextBox)sender).Text + " Is not a float");
                ((TextBox)sender).Text = this.value.ToString();
            }
            ((TextBox)sender).TextChanged += new System.EventHandler(textBox1_TextChanged);
        }
    }
}
