using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;
using entity.Forms.Meta_Editor;

namespace entity.Forms.Meta_Editor
{
    public partial class Ident : UserControl
    {
        public int LineNumber;
        private int mapIndex;
        public int chunkOffset;
        public int identInt32;
        public int offsetInMap;
        public string tagType;
        public int tagIndex;
        public string tagName;
        private bool doesHaveTagType;
        private bool AddEvents = true;
        private int tagComboBoxIndexer = 0;
        public string EntName = "Error in getting plugin element name";
        private bool isNulledOutReflexive = true;
        public Ident(string iEntName, int map, int iOffsetInChunk,bool idoesHaveTagType,int iLineNumber)
        {
            this.LineNumber = iLineNumber; 
            this.doesHaveTagType = idoesHaveTagType;
            mapIndex = map;
            this.EntName = iEntName;
            this.chunkOffset = iOffsetInChunk;
            InitializeComponent();
            this.Controls[0].Text = EntName;
            this.Dock = DockStyle.Top;
            this.Size = this.PreferredSize;
            this.AutoSize = false;
        }

     
        private void FillTagBoxWithNames(bool changeTagType)
        {
            this.tagType = ((ComboBox)this.Controls[2]).Text;
            ((ComboBox)this.Controls[1]).Items.Clear();
            ((ComboBox)this.Controls[1]).Sorted = true;
            if (((System.Windows.Forms.ComboBox)this.Controls[2]).Text != "null")
            {
                for (int counter = 0; counter < Maps.map[mapIndex].FileNames.Name.Length; counter++)
                {
                    if (this.tagType == Maps.map[mapIndex].MetaInfo.TagType[counter])
                    {
                        ((ComboBox)this.Controls[1]).Items.Add(Maps.map[mapIndex].FileNames.Name[counter]);
                    }
                }
            }
            ((ComboBox)this.Controls[1]).Sorted = false;
            ((ComboBox)this.Controls[1]).Items.Add("null");
            if (changeTagType == true)
            {
                ((ComboBox)this.Controls[1]).SelectedIndex = 0;
                this.tagComboBoxIndexer = 0;
                this.tagName = (string)((ComboBox)this.Controls[1]).Items[0];
            }
            else
            {
                this.tagComboBoxIndexer = ((ComboBox)this.Controls[1]).Items.IndexOf(tagName);
            }
        }
        public void Populate(int iOffset)
        {
            this.isNulledOutReflexive = false;
            bool openedMap = false;
            if (Maps.map[mapIndex].isOpen == false)
            {
                Maps.map[mapIndex].OpenMap(MapTypes.Internal);
                openedMap = true;
            }
            Maps.map[mapIndex].BR.BaseStream.Position =  iOffset + this.chunkOffset;
            this.offsetInMap = iOffset + this.chunkOffset;
            int tempint = Maps.map[mapIndex].BR.ReadInt32();
            this.tagIndex = Maps.map[mapIndex].Functions.Meta.FindMetaByID(tempint, mapIndex);
            if (this.tagIndex != -1)
            {
                this.tagName = Maps.map[mapIndex].FileNames.Name[this.tagIndex];
                this.tagType = Maps.map[mapIndex].MetaInfo.TagType[this.tagIndex];
            }
            else
            {
                this.tagName = "null";
                this.tagType = "null";
            }
            this.identInt32 = tempint;
            if (this.offsetInMap == 0)
            {

            }
            if (openedMap == true)
                Maps.map[mapIndex].CloseMap();
            ((ComboBox)this.Controls[1]).Size = ((ComboBox)this.Controls[1]).PreferredSize;
            if (AddEvents == true)
            {
                AddEvents = false;
                ((ComboBox)this.Controls[1]).MouseClick += new System.Windows.Forms.MouseEventHandler(this.comboBox1_MouseClick);
                ((ComboBox)this.Controls[1]).DropDownClosed += new System.EventHandler(this.TagName_DropDownClose);
                ((ComboBox)this.Controls[2]).SelectedIndexChanged += new System.EventHandler(this.TagType_SelectedIndexChanged);
                ((ComboBox)this.Controls[2]).DropDown += new System.EventHandler(this.TagType_DropDown);
                ((ComboBox)this.Controls[1]).TextChanged += new System.EventHandler(this.comboBox1_TextChanged);
            }
            this.UpdateIdentBoxes();
        }
        private void UpdateIdentBoxes()
        {
            ((ComboBox)this.Controls[1]).Text = this.tagName;
            ((ComboBox)this.Controls[2]).Text = this.tagType;
        }
        public void Save()
        {
            if (this.isNulledOutReflexive == true)
                return;
            bool openedMap = false;
            if (Maps.map[mapIndex].isOpen == false)
            {
                Maps.map[mapIndex].OpenMap(MapTypes.Internal);
                openedMap = true;
            }
            this.FindByNameAndTagType();
            if (this.doesHaveTagType == true)
            {
                Maps.map[mapIndex].BW.BaseStream.Position = this.offsetInMap - 4;
                if (this.tagType != "null")
                {
                    List<char> tempList = new List<char>(0);
                    tempList.AddRange(this.tagType.ToCharArray(0, 4));
                    tempList.TrimExcess();
                    tempList.Reverse();
                    char[] tempchar = tempList.ToArray();
                    Maps.map[mapIndex].BW.Write(tempchar);
                }
            }
            Maps.map[mapIndex].BW.BaseStream.Position = this.offsetInMap;
            Maps.map[mapIndex].BW.Write(this.identInt32);
            if (openedMap == true)
                Maps.map[mapIndex].CloseMap();
        }
        public void Poke()
        {
            uint Address = (uint)(this.offsetInMap + Maps.map[mapIndex].SelectedMeta.magic);
            this.FindByNameAndTagType();
            Feline_rawr.RTH_Imports.Poke(Address, (uint)this.identInt32, 32);
        }
        private void FindByNameAndTagType()
        {
            this.tagName = ((ComboBox)this.Controls[1]).Text;
            this.tagType =((ComboBox)this.Controls[2]).Text;
            for (int x = 0; x < Maps.map[mapIndex].IndexHeader.metaCount; x++)
            {
                if (this.tagType == Maps.map[mapIndex].MetaInfo.TagType[x] && this.tagName == Maps.map[mapIndex].FileNames.Name[x])
                {
                    this.identInt32 = Maps.map[mapIndex].MetaInfo.Ident[x];
                    return;
                }
            }
            this.identInt32 = -1;
        }
        #region ComboBox Events


        private void comboBox1_MouseClick(object sender, MouseEventArgs e)
        {
            this.FillTagBoxWithNames(false);
            ((ComboBox)sender).MouseClick -= this.comboBox1_MouseClick;
        }



        private void TagType_SelectedIndexChanged(object sender, EventArgs e)
        {
            ((ComboBox)this.Controls[1]).MouseClick -= this.comboBox1_MouseClick;
            this.FillTagBoxWithNames(true);
        }

        private void TagType_DropDown(object sender, EventArgs e)
        {
            ((ComboBox)sender).Items.Clear();
            IEnumerator i = Maps.map[mapIndex].MetaInfo.TagTypes.Keys.GetEnumerator();
            while (i.MoveNext())
            {

                ((ComboBox)sender).Items.Add((string)i.Current);
            }
            ((ComboBox)sender).Sorted = true;
            ((ComboBox)sender).Sorted = false;
            ((ComboBox)sender).Items.Add((object)"null");
        }


        private void comboBox1_TextChanged(object sender, EventArgs e)
        {
            ((ComboBox)sender).Width = (((ComboBox)sender).Text.Length * 5) + 50;
        }
        private void TagName_DropDownClose(object sender, EventArgs e)
        {
            if (((ComboBox)sender).Items[((ComboBox)sender).SelectedIndex].ToString() == "null")
            {
                ((ComboBox)this.Controls[2]).Text = "null";
            }
        }
        public void SetFocus(int LineToCheck)
        {
            if (this.LineNumber == LineToCheck)
                this.Focus();
        }
        #endregion


    }

}
