using System;
using System.Drawing;
using System.Windows.Forms;
using Microsoft.DirectX;
using Microsoft.DirectX.DirectInput;
using Microsoft.DirectX.Direct3D;
using Direct3D = Microsoft.DirectX.Direct3D;
using entity.Raw;
using System.Collections.Generic;
using System.Collections;
using System.IO;
namespace entity
{

    public class BSPViewer : Form
    {
        #region Fields
        BSP.BSPModel bsp;
        int mapnumber;
        DXShader shaderx;
        private Label label3;
        private ToolStrip statusStrip;
        private ToolStripLabel tslabel;
        private ToolStripLabel toolStripLabel2;
        private TD.SandDock.SandDockManager sandDockManager1;
        private TD.SandDock.DockContainer leftSandDock;
        private TD.SandDock.DockControl dockControl1;
        private System.Windows.Forms.Button SaveChanges;
        private TD.SandDock.DockControl dockControl2;
        private System.Windows.Forms.Button findspawn;
        private System.Windows.Forms.Button mi4;
        private System.Windows.Forms.Button SelectAllSpawns;
        private TD.SandDock.DockControl dockControl3;
        private TreeView treeView1;
        private TD.SandDock.DockControl dockControl4;
        private GroupBox fcordgb;
        private Label fcordlz;
        private Label fcordly;
        private Label fcordlx;
        private TextBox fcordx;
        private System.Windows.Forms.Button fcordbutton;
        private TextBox fcordy;
        private TextBox fcordz;
        private TD.SandDock.DockControl dockControl5;
        private GroupBox groupBox2;
        private System.Windows.Forms.Button button2;
        private System.Windows.Forms.Button button1;
        private CheckBox checkBox2;
        private RadioButton radioButton2;
        private RadioButton radioButton1;
        private TrackBar trackBar3;
        private TrackBar trackBar2;
        private TrackBar trackBar1;
        private Panel panel1;
        private GroupBox groupBox1;
        private Label label2;
        private Label label1;
        private ComboBox comboBox1;
        private CheckBox checkBox1;
        private TD.SandDock.DockContainer rightSandDock;
        private TD.SandDock.DockContainer bottomSandDock;
        private TD.SandDock.DockContainer topSandDock;
        private CheckedListBox checkedListBox1;
        private CheckBox checkBox3;
        private System.Windows.Forms.Button button3;
        private CheckBox checkBox4;
        private Vector3 lightVector = new Vector3(0.0f, 0.0f, 1.0f);


        private int VectorToRgba(Vector3 v, float height)
        {
            int r = (int)(127.0f * v.X + 128.0f);
            int g = (int)(127.0f * v.Y + 128.0f);
            int b = (int)(127.0f * v.Z + 128.0f);
            int a = (int)(255.0f * height);

            return ((a << 24) + (r << 16) + (g << 8) + (b << 0));
        }

        #region DirectX
        entity.Renderer.Renderer render = new entity.Renderer.Renderer();
        Matrix WorldTransform = Matrix.Identity;
        public entity.Renderer.Camera2 cam;
        #endregion

        #region SpawnInfo
        List<ParsedModel> SpawnModel = new List<ParsedModel>();
        int[] spawnmodelindex;
        Mesh[] BoundingBoxModel;
        Matrix[] TranslationMatrix;
        public int visibleSpawnsBitMask;
        #region SelectedSpawns
        List<int> SelectedSpawn = new List<int>();
        Renderer.BSP_Renderer.SpawnInfo.SpawnType selectedSpawnType;

        bool itemrotate = false;
        #endregion
        #endregion

        #region Materials
        Material BoundingBoxSelected;
        Material BlueMaterial;
        Material BlackMaterial;
        Material GreenMaterial;
        Material DefaultMaterial;
        #endregion

        #region MultiSelect
        float selectionHeight;
        float selectionWidth;
        float selectionDepth;
        Vector3 selectionStart;
        bool selectionMulti = false;
        Mesh selectionMesh = null;
        #endregion

         #region misc
        int oldx = 0;
        int oldy = 0;
        #endregion

        #endregion

        #region Constructor
        public BSPViewer(BSP.BSPModel tempbsp, int mapnumberx)
        {
            //InitializeComponent
            InitializeComponent();

            dockControl1.LayoutSystem.Collapsed = true;
            dockControl2.LayoutSystem.Collapsed = true;
            dockControl3.LayoutSystem.Collapsed = true;
            dockControl4.LayoutSystem.Collapsed = true;
            dockControl5.LayoutSystem.Collapsed = true;

            Application.DoEvents();
 
            //Center horizontal
            int tempnum1 = 155 / 2;
            int tempnum2 = Screen.PrimaryScreen.WorkingArea.Width / 2;
            int tempnum3 = tempnum2 - tempnum1;
            label3.Left = tempnum3;

            //Center vertical
            int tempnum4 = 28 / 2;
            int tempnum5 = Screen.PrimaryScreen.WorkingArea.Height / 2;
            int tempnum6 = tempnum5 - tempnum4 - 30 - 25;
            label3.Top = tempnum6;

            this.BackColor = Color.Blue;

            //Clear the labels
            toolStripLabel2.Text = "Camera Position: X: 0  Y: 0  Z: 0";
            tslabel.Text = "";

            // Set the initial size of our form
            //this.ClientSize = new System.Drawing.Size(800, 600);
            // And its caption
            this.Text = "BSP Viewer";

            Application.DoEvents();

            bsp = tempbsp;
            mapnumber = mapnumberx;

            #region MouseEvents
            this.MouseDown += new MouseEventHandler(BSPViewer_MouseDown);
            this.MouseMove += new System.Windows.Forms.MouseEventHandler(this.ModelViewer_MouseDown);
            this.MouseUp += new System.Windows.Forms.MouseEventHandler(this.ModelViewer_MouseUp);
            #endregion

            #region VisibleSpawns
            string[] strings = Enum.GetNames(typeof(Renderer.BSP_Renderer.SpawnInfo.SpawnType));
     
            treeView1.Sorted = true;

            int CameraCount = 0;
            int DeathZoneCount = 0;
            int LightCount = 0;
            int ObjectiveCount = 0;
            int PlayerCount = 0;

            foreach (string s in strings)
            {

                //Add the type the the CheckListBox
                checkedListBox1.Items.Add(s);

                //Add the type to the treeview
                TreeNode tn = new TreeNode();
                for (int i = 0; i < bsp.Spawns.Spawn.Count; i++)
                {
                    if (s.ToString() == bsp.Spawns.Spawn[i].Type.ToString())
                    {
                        TreeNode tn2 = new TreeNode();
                        if (bsp.Spawns.Spawn[i].Type.ToString() == "Collection")
                        {
                            switch (Maps.map[mapnumber].HaloVersion)
                            {
                                case Map.HaloVersionEnum.Halo2:
                            entity.Renderer.BSP_Renderer.SpawnInfo.Collection tempspawn = (entity.Renderer.BSP_Renderer.SpawnInfo.Collection)bsp.Spawns.Spawn[i];
                            tn2.Text = tempspawn.TagPath.ToString();
                            break;
                                case Map.HaloVersionEnum.Halo1:
                                case Map.HaloVersionEnum.HaloCE:
                                    entity.Renderer.BSP_Renderer.SpawnInfo.H1Collection tempspawnx = (entity.Renderer.BSP_Renderer.SpawnInfo.H1Collection)bsp.Spawns.Spawn[i];
                                    tn2.Text = tempspawnx.TagPath.ToString();
                                    break;
                            }
                        }
                        else if (bsp.Spawns.Spawn[i].Type.ToString() == "Obstacle")
                        {
                            entity.Renderer.BSP_Renderer.SpawnInfo.ObstacleSpawn tempspawn = (entity.Renderer.BSP_Renderer.SpawnInfo.ObstacleSpawn)bsp.Spawns.Spawn[i];
                            tn2.Text = tempspawn.TagPath.ToString();
                        }
                        else if (bsp.Spawns.Spawn[i].Type.ToString() == "Weapon")
                        {
                            entity.Renderer.BSP_Renderer.SpawnInfo.WeaponSpawn tempspawn = (entity.Renderer.BSP_Renderer.SpawnInfo.WeaponSpawn)bsp.Spawns.Spawn[i];
                            tn2.Text = tempspawn.TagPath.ToString();
                        }
                        else if (bsp.Spawns.Spawn[i].Type.ToString() == "Scenery")
                        {
                            entity.Renderer.BSP_Renderer.SpawnInfo.ScenerySpawn tempspawn = (entity.Renderer.BSP_Renderer.SpawnInfo.ScenerySpawn)bsp.Spawns.Spawn[i];
                            tn2.Text = tempspawn.TagPath.ToString();
                        }
                        else if (bsp.Spawns.Spawn[i].Type.ToString() == "Machine")
                        {
                            entity.Renderer.BSP_Renderer.SpawnInfo.MachineSpawn tempspawn = (entity.Renderer.BSP_Renderer.SpawnInfo.MachineSpawn)bsp.Spawns.Spawn[i];
                            tn2.Text = tempspawn.TagPath.ToString();
                        }
                        else if (bsp.Spawns.Spawn[i].Type.ToString() == "Control")
                        {
                            entity.Renderer.BSP_Renderer.SpawnInfo.ControlSpawn tempspawn = (entity.Renderer.BSP_Renderer.SpawnInfo.ControlSpawn)bsp.Spawns.Spawn[i];
                            tn2.Text = tempspawn.TagPath.ToString();
                        }
                        else if (bsp.Spawns.Spawn[i].Type.ToString() == "Biped")
                        {
                            entity.Renderer.BSP_Renderer.SpawnInfo.BipedSpawn tempspawn = (entity.Renderer.BSP_Renderer.SpawnInfo.BipedSpawn)bsp.Spawns.Spawn[i];
                            tn2.Text = tempspawn.TagPath.ToString();
                        }
                        else if (bsp.Spawns.Spawn[i].Type.ToString() == "Equipment")
                        {
                            entity.Renderer.BSP_Renderer.SpawnInfo.EquipmentSpawn tempspawn = (entity.Renderer.BSP_Renderer.SpawnInfo.EquipmentSpawn)bsp.Spawns.Spawn[i];
                            tn2.Text = tempspawn.TagPath.ToString();
                        }
                        else if (bsp.Spawns.Spawn[i].Type.ToString() == "Vehicle")
                        {
                            entity.Renderer.BSP_Renderer.SpawnInfo.VehicleSpawn tempspawn = (entity.Renderer.BSP_Renderer.SpawnInfo.VehicleSpawn)bsp.Spawns.Spawn[i];
                            tn2.Text = tempspawn.TagPath.ToString();
                        }
                        else if (bsp.Spawns.Spawn[i].Type.ToString() == "Light")
                        {
                            entity.Renderer.BSP_Renderer.SpawnInfo.LightSpawn tempspawn = (entity.Renderer.BSP_Renderer.SpawnInfo.LightSpawn)bsp.Spawns.Spawn[i];
                            tn2.Text = tempspawn.TagPath.ToString();
                        }
                        else if (bsp.Spawns.Spawn[i].Type.ToString() == "Camera")
                        {
                            tn2.Text = bsp.Spawns.Spawn[i].Type.ToString() + " {" + CameraCount.ToString() + "}";
                            CameraCount += 1;
                        }
                        else if (bsp.Spawns.Spawn[i].Type.ToString() == "DeathZone")
                        {
                            tn2.Text = bsp.Spawns.Spawn[i].Type.ToString() + " {" + DeathZoneCount.ToString() + "}";
                            DeathZoneCount += 1;
                        }
                        else if (bsp.Spawns.Spawn[i].Type.ToString() == "Objective")
                        {
                            tn2.Text = bsp.Spawns.Spawn[i].Type.ToString() + " {" + ObjectiveCount.ToString() + "}";
                            ObjectiveCount += 1;
                        }
                        else if (bsp.Spawns.Spawn[i].Type.ToString() == "Player")
                        {
                            tn2.Text = bsp.Spawns.Spawn[i].Type.ToString() + " {" + PlayerCount.ToString() + "}";
                            PlayerCount += 1;
                        }
                        else
                        {
                            tn2.Text = bsp.Spawns.Spawn[i].Type.ToString();
                        }
                        tn2.Tag = i;
                        tn.Nodes.Add(tn2);
                    }
                }
                tn.Text = s.ToString();
                tn.Tag = -1;
                treeView1.Nodes.Add(tn);
            }

            #endregion

            #region Lightmaps

            Load_Lightmaps_Into_An_Array();
            int temppicboxX = 0;
            int temppicboxY = 0;
            int tempintforme = 0;
            for (int i = 0; i < Maps.map[mapnumber].BSP.sbsp[tempbsp.BspNumber].LightMap_Palettes.Count; i++)
            {

                PictureBox temppicbox = new PictureBox();
                temppicbox.Image = RenderLightmap(i);
                temppicbox.SizeMode = PictureBoxSizeMode.StretchImage;
                temppicbox.Width = 64;
                temppicbox.Height = 64;
                temppicbox.Location = new Point(temppicboxX, temppicboxY);
                temppicbox.Tag = i;
                temppicbox.Click += new EventHandler(this.PictureBox_Click);
                panel1.Controls.Add(temppicbox);
                comboBox1.Items.Add(i);
                if (tempintforme <= 1)
                {
                    tempintforme += 1;
                    temppicboxX += 68;
                }
                else
                {
                    tempintforme = 0;
                    temppicboxX = 0;
                    temppicboxY += 68;
                }

            }

            #endregion

            Main();
        }
        #endregion

        #region Methods
        #region CleanUp
        public new void Dispose()
        {

            bsp.Dispose();

            //Reset the lightmaps
            Array.ConstrainedCopy(LightMap_Array_Backup, 0, LightMap_Array, 0, LightMap_Array.Length);
            ReloadFromArray();

            bsp = null;
            cam.Dispose();
            cam = null;
            this.Dispose(true);
            GC.SuppressFinalize(this);

        }
        #endregion

        #region EditFunctions
        #region FindFirstSelectedSpawn
        void findspawn_Click(object sender, EventArgs e)
        {
            if (SelectedSpawn.Count == 0) { return; }

            cam.Position.X = bsp.Spawns.Spawn[SelectedSpawn[0]].X;
            cam.Position.Y = bsp.Spawns.Spawn[SelectedSpawn[0]].Y;
            cam.Position.Z = bsp.Spawns.Spawn[SelectedSpawn[0]].Z;

            cam.radianv = 0;
            cam.radianh = 0;

            cam.x = bsp.Spawns.Spawn[SelectedSpawn[0]].X;
            cam.y = bsp.Spawns.Spawn[SelectedSpawn[0]].Y;
            cam.z = bsp.Spawns.Spawn[SelectedSpawn[0]].Z;
        }
        #endregion
        #region MoveAllSpawnsToOneSpot
        void mi4_Click(object sender, EventArgs e)
        {
            if (SelectedSpawn.Count != 1)
            {
                MessageBox.Show("Select One Object Or Spawn");
            }
            else
            {

                for (int i = 0; i < bsp.Spawns.Spawn.Count; i++)
                {
                    if (((int)bsp.Spawns.Spawn[i].Type & visibleSpawnsBitMask) == 0) { continue; }
                    bsp.Spawns.Spawn[i].X = bsp.Spawns.Spawn[SelectedSpawn[0]].X;
                    bsp.Spawns.Spawn[i].Y = bsp.Spawns.Spawn[SelectedSpawn[0]].Y;
                    bsp.Spawns.Spawn[i].Z = bsp.Spawns.Spawn[SelectedSpawn[0]].Z;
                    TranslationMatrix[i] = MakeMatrixForSpawn(i);
                }
            }
        }
        #endregion
        #region SelectAllVisibleSpawns
        void SelectAllSpawns_Click(object sender, EventArgs e)
        {
            SelectedSpawn.Clear();
            for (int i = 0; i < bsp.Spawns.Spawn.Count; i++)
            {
                if (((int)bsp.Spawns.Spawn[i].Type & visibleSpawnsBitMask) == 0) { continue; }
                SelectedSpawn.Add(i);
            }
        }
        #endregion
        #endregion
        #region FileFunctions
        //SaveChanges
        private void SaveChanges_Click(object sender, EventArgs e)
        {
            SelectedSpawn.Clear();
            Maps.map[mapnumber].OpenMap(MapTypes.Internal);
            for (int i = 0; i < bsp.Spawns.Spawn.Count; i++)
            {
                if (bsp.Spawns.Spawn[i].Type == entity.Renderer.BSP_Renderer.SpawnInfo.SpawnType.DeathZone) { continue; }
                Maps.map[mapnumber].BW.BaseStream.Position = bsp.Spawns.Spawn[i].offset;
                Maps.map[mapnumber].BW.Write(bsp.Spawns.Spawn[i].X);
                Maps.map[mapnumber].BW.Write(bsp.Spawns.Spawn[i].Y);
                Maps.map[mapnumber].BW.Write(bsp.Spawns.Spawn[i].Z);
                #region Rotation
                #region RotationOneDirection
                if (bsp.Spawns.Spawn[i] is entity.Renderer.BSP_Renderer.SpawnInfo.RotateDirectionBaseSpawn)
                {
                    entity.Renderer.BSP_Renderer.SpawnInfo.RotateDirectionBaseSpawn tempspawn = bsp.Spawns.Spawn[i] as entity.Renderer.BSP_Renderer.SpawnInfo.RotateDirectionBaseSpawn;

                    Maps.map[mapnumber].BW.Write(tempspawn.RotationDirection);
                }
                #endregion
                #region RotationYawPitchRoll
                else if (bsp.Spawns.Spawn[i] is entity.Renderer.BSP_Renderer.SpawnInfo.RotateYawPitchRollBaseSpawn)
                {
                    entity.Renderer.BSP_Renderer.SpawnInfo.RotateYawPitchRollBaseSpawn tempspawn = bsp.Spawns.Spawn[i] as entity.Renderer.BSP_Renderer.SpawnInfo.RotateYawPitchRollBaseSpawn;
                    if (Maps.map[mapnumber].HaloVersion == Map.HaloVersionEnum.Halo2)
                    {
                        Maps.map[mapnumber].BW.Write(tempspawn.Roll);
                        //Maps.map[mapnumber].BW.Write(tempspawn.Yaw);
                        if (tempspawn.isWeird == true) { tempspawn.Pitch = -tempspawn.Pitch; }
                        Maps.map[mapnumber].BW.Write(tempspawn.Pitch);
                        Maps.map[mapnumber].BW.Write(tempspawn.Yaw);
                        //Maps.map[mapnumber].BW.Write(tempspawn.Roll);
                    }
                    else
                    {
                        Maps.map[mapnumber].BW.Write(Renderer.Renderer.RadianToDegree(tempspawn.Yaw));
                        //Maps.map[mapnumber].BW.Write(tempspawn.Yaw);
                     
                        Maps.map[mapnumber].BW.Write(Renderer.Renderer.RadianToDegree(tempspawn.Pitch));
                        Maps.map[mapnumber].BW.Write(Renderer.Renderer.RadianToDegree(tempspawn.Roll));
                    }
                }
                #endregion
                #endregion
                #region ObjectiveSpawn
                if (bsp.Spawns.Spawn[i] is entity.Renderer.BSP_Renderer.SpawnInfo.ObjectiveSpawn)
                {
                    entity.Renderer.BSP_Renderer.SpawnInfo.ObjectiveSpawn os;
                    os = bsp.Spawns.Spawn[i] as entity.Renderer.BSP_Renderer.SpawnInfo.ObjectiveSpawn;
                    Maps.map[mapnumber].BW.BaseStream.Position = bsp.Spawns.Spawn[i].offset + 16;
                    Maps.map[mapnumber].BW.Write((short)os.ObjectiveType);
                    Maps.map[mapnumber].BW.Write((short)os.Team);
                    Maps.map[mapnumber].BW.Write((short)os.number);
                }
                #endregion
                #region Collection
                else if (bsp.Spawns.Spawn[i] is entity.Renderer.BSP_Renderer.SpawnInfo.Collection)
                {
                    entity.Renderer.BSP_Renderer.SpawnInfo.Collection os;
                    os = bsp.Spawns.Spawn[i] as entity.Renderer.BSP_Renderer.SpawnInfo.Collection;
                    Maps.map[mapnumber].BW.BaseStream.Position = bsp.Spawns.Spawn[i].offset - 60;
                    Maps.map[mapnumber].BW.Write((int)os.SpawnsInMode);

                }
                #endregion
            }
            Maps.map[mapnumber].CloseMap();
      
            MessageBox.Show("Done");
        }
        #endregion

        #region Input
        #region MouseFunctions
        #region OnMouseDown
        void BSPViewer_MouseDown(object sender, MouseEventArgs e)
        {
            #region StartMultiSelect
            if (e.Button == MouseButtons.Middle)
            {
                selectionHeight = 0;
                selectionWidth = 0;
                selectionDepth = 0;
                selectionMulti = true;
                selectionStart = render.Mark3DCursorPosition(e.X, e.Y, Matrix.Identity);
            }
            #endregion
            #region StartCameraRotation
            else if (e.Button == MouseButtons.Right)
            {
                cam.oldx = e.X;
                cam.oldy = e.Y;
            }
            #endregion
            #region SpawnSelection
            else if (e.Button == MouseButtons.Left)
            {
                #region DecideUponObjectRotation
                if (SelectedSpawn.Count > 0)
                {
                    if (rotationBitMask == 0)
                    {
                        // return;
                    }
                    else
                    {

                        selectionStart = render.Mark3DCursorPosition(e.X, e.Y, Matrix.Identity);
                        oldx = e.X;
                        oldy = e.Y;
                        itemrotate = true;
                        return;
                    }
                }
                #endregion
                #region CycleThroughSpawns
                for (int x = 0; x < bsp.Spawns.Spawn.Count ; x++)
                {
                    //check bitmask for visibility
                    if (((int)bsp.Spawns.Spawn[x].Type & visibleSpawnsBitMask) == 0) { continue; }
                    int tempcount=SpawnModel[spawnmodelindex[x]].Display.Chunk.Count;
                    bool useboundingbox=false;
                    switch (bsp.Spawns.Spawn[x].Type)
                    {
                        case entity.Renderer.BSP_Renderer.SpawnInfo.SpawnType.Camera:
                            tempcount = 1; useboundingbox = true;
                            break;
                        case entity.Renderer.BSP_Renderer.SpawnInfo.SpawnType.Light:
                            tempcount = 1; useboundingbox = true;
                            break;
                    }
                    for (int yy = 0; yy < tempcount; yy++)
                    {
                        //check for mesh intersection
                        Mesh tempm;
                        if (!useboundingbox)
                        {
                            tempm = SpawnModel[spawnmodelindex[x]].Display.meshes[yy];
                        }
                        else
                        {
                            tempm = BoundingBoxModel[x];
                        }
                        if (render.MeshPick(e.X, e.Y, tempm, TranslationMatrix[x]) == true)
                        {

                            #region ClearStatus
                            statusStrip.Items.Clear();
                            // SelectedSpawn.Clear();
                            #endregion

                            #region DisplayCameraPosition
                            //Set camera postion
                            string tempstring = toolStripLabel2.Text;
                            string tempstring2 = "Camera Position: X: " + cam.x.ToString() + "  Y: " + cam.y.ToString() + "  Z: " + cam.z.ToString();
                            if (tempstring != tempstring2)
                            {

                                if (statusStrip.Items.IndexOf(toolStripLabel2) != -1)
                                {
                                    statusStrip.Items.RemoveAt(statusStrip.Items.IndexOf(toolStripLabel2));
                                }

                                toolStripLabel2 = new ToolStripLabel();
                                toolStripLabel2.Text = tempstring2;
                                toolStripLabel2.Alignment = ToolStripItemAlignment.Right;
                                statusStrip.Items.Add(toolStripLabel2);
                            }
                            #endregion

                            #region TurnSpawnOnOrOff
                            int tempi = SelectedSpawn.IndexOf(x);

                            if (tempi != -1)
                            {
                                SelectedSpawn.RemoveAt(tempi); return;
                            }

                            SelectedSpawn.Add(x);
                            selectedSpawnType = bsp.Spawns.Spawn[x].Type;
                            #endregion
                            tslabel.Text = "Type: " + bsp.Spawns.Spawn[x].Type.ToString()
                                         + "  X: " + bsp.Spawns.Spawn[x].X.ToString()
                                         + "  Y: " + bsp.Spawns.Spawn[x].Y.ToString()
                                         + "  Z: " + bsp.Spawns.Spawn[x].Z.ToString();


                            #region YawPitchRollInfo
                            if (bsp.Spawns.Spawn[x] is Renderer.BSP_Renderer.SpawnInfo.RotateYawPitchRollBaseSpawn)
                            {
                                Renderer.BSP_Renderer.SpawnInfo.RotateYawPitchRollBaseSpawn temprot;
                                temprot = bsp.Spawns.Spawn[x] as Renderer.BSP_Renderer.SpawnInfo.RotateYawPitchRollBaseSpawn;
                                tslabel.Text += "  Yaw:" + temprot.Yaw;
                                tslabel.Text += "  Pitch:" + temprot.Pitch;
                                tslabel.Text += "  Roll:" + temprot.Roll;
                            }
                            #endregion

                            #region NameInfo
                            if (bsp.Spawns.Spawn[x] is Renderer.BSP_Renderer.SpawnInfo.RotateYawPitchRollBaseSpawn)
                            {
                                Renderer.BSP_Renderer.SpawnInfo.RotateYawPitchRollBaseSpawn temprot;
                                temprot = bsp.Spawns.Spawn[x] as Renderer.BSP_Renderer.SpawnInfo.RotateYawPitchRollBaseSpawn;
                                //tslabel.Text += "  Name: " + temprot.ModelName;
                            }
                            else if (bsp.Spawns.Spawn[x] is Renderer.BSP_Renderer.SpawnInfo.RotateDirectionBaseSpawn)
                            {
                                Renderer.BSP_Renderer.SpawnInfo.RotateDirectionBaseSpawn temprot;
                                temprot = bsp.Spawns.Spawn[x] as Renderer.BSP_Renderer.SpawnInfo.RotateDirectionBaseSpawn;
                                //tslabel.Text += "  Name: " + temprot.ModelName;
                            }

                            #endregion
                            statusStrip.Items.Add(tslabel);

                            #region ObjectiveSpawn
                            if (bsp.Spawns.Spawn[x] is entity.Renderer.BSP_Renderer.SpawnInfo.ObjectiveSpawn)
                            {
                                entity.Renderer.BSP_Renderer.SpawnInfo.ObjectiveSpawn os;
                                os = bsp.Spawns.Spawn[x] as entity.Renderer.BSP_Renderer.SpawnInfo.ObjectiveSpawn;

                                #region StatusStripSetup
                                #region ObjectiveTypeEnumComboBox
                                TSComboBox combo = new TSComboBox();
                                Array testx = Enum.GetNames(typeof(entity.Renderer.BSP_Renderer.SpawnInfo.ObjectiveSpawn.ObjectiveTypeEnum));

                                for (int y = 0; y < testx.Length; y++)
                                {
                                    combo.Items.Add(testx.GetValue(y).ToString());

                                }
                                int tempindex = combo.Items.IndexOf(os.ObjectiveType.ToString());
                                if (tempindex != -1) { combo.SelectedIndex = tempindex; }

                                combo.SelectedIndexChanged += new EventHandler(combo_SelectedIndexChanged2);

                                combo.BackColor = Color.Gray;
                                combo.FlatStyle = FlatStyle.Flat;
                                combo.DropDownStyle = ComboBoxStyle.DropDownList;
                                statusStrip.Items.Add(combo);
                                #endregion

                                #region TeamTypeEnumComboBox
                                combo = new TSComboBox();
                                testx = Enum.GetNames(typeof(entity.Renderer.BSP_Renderer.SpawnInfo.ObjectiveSpawn.TeamType));

                                for (int y = 0; y < testx.Length; y++)
                                {
                                    combo.Items.Add(testx.GetValue(y).ToString());

                                }
                                tempindex = combo.Items.IndexOf(os.Team.ToString());
                                if (tempindex != -1) { combo.SelectedIndex = tempindex; }
                                combo.SelectedIndexChanged += new EventHandler(combo_SelectedIndexChanged);
                                combo.BackColor = Color.Gray;
                                combo.FlatStyle = FlatStyle.Flat;
                                combo.DropDownStyle = ComboBoxStyle.DropDownList;
                                statusStrip.Items.Add(combo);
                                #endregion

                                #region ObjectiveIndexTextBox
                                ToolStripTextBox tb = new ToolStripTextBox();
                                tb.AutoSize = false;
                                tb.BackColor = Color.White;
                                tb.BorderStyle = BorderStyle.FixedSingle;
                                tb.Height = 20;
                                tb.Width = 30;
                                tb.Text = os.number.ToString();
                                tb.TextChanged += new EventHandler(tb_TextChanged);
                                statusStrip.Items.Add(tb);
                                #endregion
                                #endregion
                            }
                            #endregion

                            #region CollectionSpawn
                            else if (bsp.Spawns.Spawn[x] is entity.Renderer.BSP_Renderer.SpawnInfo.Collection)
                            {
                                entity.Renderer.BSP_Renderer.SpawnInfo.Collection os;
                                os = bsp.Spawns.Spawn[x] as entity.Renderer.BSP_Renderer.SpawnInfo.Collection;

                                #region StatusStripSetup
                                #region SpawnsInEnumComboBox
                                TSComboBox combo = new TSComboBox();
                                Array testx = Enum.GetNames(typeof(entity.Renderer.BSP_Renderer.SpawnInfo.Collection.SpawnsInEnum));

                                for (int y = 0; y < testx.Length; y++)
                                {
                                    combo.Items.Add(testx.GetValue(y).ToString());

                                }
                                int tempindex = combo.Items.IndexOf(os.SpawnsInMode.ToString());
                                if (tempindex != -1) { combo.SelectedIndex = tempindex; }
                                combo.SelectedIndexChanged += new EventHandler(combo_SelectedIndexChanged3);
                                combo.BackColor = Color.Gray;
                                combo.FlatStyle = FlatStyle.Flat;
                                combo.DropDownStyle = ComboBoxStyle.DropDownList;
                                statusStrip.Items.Add(combo);
                                #endregion
                                #endregion
                            }
                            #endregion;

                            break;
                        }
                    }
                }
                #endregion
            }
            #endregion
        }
        #endregion
        #region OnMouseMove
        private void ModelViewer_MouseDown(object sender, MouseEventArgs e)
        {
            #region MultiSelect
            if (selectionMulti == true)
            {
                Vector3 tempvec = render.Mark3DCursorPosition(e.X, e.Y, Matrix.Identity);
                selectionWidth = tempvec.X - selectionStart.X;
                selectionHeight = tempvec.Y - selectionStart.Y;
                selectionDepth = tempvec.Z - selectionStart.Z;
                selectionWidth *= 2;
                selectionHeight *= 7;
                selectionDepth *= 2;
                float tempselectionWidth = selectionWidth;
                float tempselectionHeight = selectionHeight;
                float tempselectionDepth = selectionDepth;
                if (tempselectionWidth < 0) { tempselectionWidth = -tempselectionWidth; }
                if (tempselectionHeight < 0) { tempselectionHeight = -tempselectionHeight; }
                if (tempselectionDepth < 0) { tempselectionDepth = -tempselectionDepth; }
                tslabel.Text = selectionStart.X.ToString() + "  " + selectionStart.Y.ToString() + selectionStart.Z.ToString() + "  " + selectionWidth.ToString() + "  " + selectionHeight.ToString() + "  " + selectionDepth.ToString();
                selectionMesh = Mesh.Box(render.device, tempselectionWidth, tempselectionHeight, tempselectionDepth);


            }
            #endregion
            #region SelectedSpawnRotation
            else if (rotationBitMask != 0 && itemrotate == true)
            {
                Vector3 tempvec = render.Mark3DCursorPosition(e.X, e.Y, Matrix.Identity);
                selectionWidth = tempvec.X - selectionStart.X;
                selectionHeight = tempvec.Y - selectionStart.Y;
                selectionDepth = tempvec.Z - selectionStart.Z;
                selectionStart = tempvec;

                foreach (int spawnid in SelectedSpawn)
                {

                    if (bsp.Spawns.Spawn[spawnid] is Renderer.BSP_Renderer.SpawnInfo.BoundingBoxSpawn) { continue; }
                    #region ControlAndRotate
                    if ((rotationBitMask & (int)SelectedItemRotationType.Control) != 0)
                    {

                        if (bsp.Spawns.Spawn[spawnid] is Renderer.BSP_Renderer.SpawnInfo.RotateYawPitchRollBaseSpawn)
                        {

                            Renderer.BSP_Renderer.SpawnInfo.RotateYawPitchRollBaseSpawn temp;
                            temp = (Renderer.BSP_Renderer.SpawnInfo.RotateYawPitchRollBaseSpawn)bsp.Spawns.Spawn[spawnid];
                            temp.Yaw += selectionHeight * cam.speed;
                            if (temp.Yaw > (float)Math.PI) { temp.Yaw = -(float)Math.PI; }
                            else if (temp.Yaw < (float)-Math.PI) { temp.Yaw = (float)Math.PI;}
                        }
                        else
                        {
                            Renderer.BSP_Renderer.SpawnInfo.RotateDirectionBaseSpawn temp;
                            temp = (Renderer.BSP_Renderer.SpawnInfo.RotateDirectionBaseSpawn)bsp.Spawns.Spawn[spawnid];
                            temp.RotationDirection += selectionHeight * cam.speed;
                            //  if (temp.RotationDirection > (float)Math.PI) { temp.RotationDirection = temp.RotationDirection - ((float)Math.PI * 2); }
                            //  else if (temp.RotationDirection < (float)-Math.PI) { temp.RotationDirection = temp.RotationDirection + ((float)Math.PI * 2); }
                        }

                    }
                    #endregion
                    #region ShiftAndRotate
                    if ((rotationBitMask & (int)SelectedItemRotationType.Shift) != 0)
                    {

                        if (bsp.Spawns.Spawn[spawnid] is Renderer.BSP_Renderer.SpawnInfo.RotateYawPitchRollBaseSpawn)
                        {
                            Renderer.BSP_Renderer.SpawnInfo.RotateYawPitchRollBaseSpawn temp;
                            temp = (Renderer.BSP_Renderer.SpawnInfo.RotateYawPitchRollBaseSpawn)bsp.Spawns.Spawn[spawnid];
                            temp.Pitch += selectionWidth * cam.speed; ;
                            if (temp.Pitch > (float)Math.PI) { temp.Pitch = -(float)Math.PI; }
                            else if (temp.Pitch < (float)-Math.PI) { temp.Pitch = (float)Math.PI; }
                        }
                    }
                    #endregion
                    #region AltAndRotate
                    if ((rotationBitMask & (int)SelectedItemRotationType.Alt) != 0)
                    {
                        if (bsp.Spawns.Spawn[spawnid] is Renderer.BSP_Renderer.SpawnInfo.RotateYawPitchRollBaseSpawn)
                        {
                            Renderer.BSP_Renderer.SpawnInfo.RotateYawPitchRollBaseSpawn temp;
                            temp = (Renderer.BSP_Renderer.SpawnInfo.RotateYawPitchRollBaseSpawn)bsp.Spawns.Spawn[spawnid];
                            temp.Roll += selectionDepth * cam.speed;
                            if (temp.Roll > (float)Math.PI) { temp.Roll = -(float)Math.PI; }
                            else if (temp.Roll < (float)-Math.PI) { temp.Roll = (float)Math.PI; }
                        }
                    }
                    #endregion
                    TranslationMatrix[spawnid] = MakeMatrixForSpawn(spawnid);
                }
            }
            #endregion
            #region CameraRotation
            if (e.Button == MouseButtons.Right)
            {
                cam.change(e.X, e.Y);
            }
            #endregion

        }
        #endregion
        #region OnMouseUp
        private void ModelViewer_MouseUp(object sender, MouseEventArgs e)
        {
            #region EndRotation
            if (itemrotate == true)
            {
                itemrotate = false;
                rotationBitMask = 0;
            }
            #endregion
            #region EndMultiSelect
            if (selectionMulti == true)
            {
                selectionMulti = false;
                selectionMesh = null;
                float halfwidth = selectionWidth / 2;
                float halfheight = selectionHeight / 2;
                float halfdepth = selectionDepth / 2;
                float poshalfwidth = halfwidth;
                float poshalfheight = halfheight;
                float poshalfdepth = halfdepth;


                float tempselectionWidth = selectionWidth;
                float tempselectionHeight = selectionHeight;
                float tempselectionDepth = selectionDepth;

                if (poshalfwidth < 0) { poshalfwidth = -poshalfwidth; }
                if (poshalfheight < 0) { poshalfheight = -poshalfheight; }
                if (poshalfdepth < 0) { poshalfdepth = -poshalfdepth; }
                // float minx = selectionStart.X + halfwidth - poshalfwidth;
                // float maxx = selectionStart.X + poshalfwidth + halfwidth;
                // float miny = selectionStart.Y + halfheight - poshalfheight;
                //  float maxy = selectionStart.Y + poshalfheight + halfheight;
                //  float minz = selectionStart.Z + halfdepth - poshalfdepth;
                //   float maxz = selectionStart.Z + poshalfdepth + halfdepth;
                float minx = selectionStart.X - poshalfwidth;
                float maxx = selectionStart.X + poshalfwidth;
                float miny = selectionStart.Y - poshalfheight;
                float maxy = selectionStart.Y + poshalfheight;
                float minz = selectionStart.Z - poshalfdepth;
                float maxz = selectionStart.Z + poshalfdepth;
                SelectedSpawn.Clear();
                for (int i = 0; i < bsp.Spawns.Spawn.Count; i++)
                {
                    if (bsp.Spawns.Spawn[i].X > minx && bsp.Spawns.Spawn[i].X < maxx &&
                        bsp.Spawns.Spawn[i].Y > miny && bsp.Spawns.Spawn[i].Y < maxy &&
                        bsp.Spawns.Spawn[i].Z > minz && bsp.Spawns.Spawn[i].Z < maxz)
                    {
                        SelectedSpawn.Add(i);
                    }

                }
            }
            #endregion
        }
        #endregion
        #endregion
        #region KeyBoardFunctions
        public void MoveSpawnsWithKeyboard()
        {
            rotationBitMask = 0;
            try
            {
                cam.device.Acquire();
            }
            catch
            {
                return;
            }
            for (int x = 0; x < SelectedSpawn.Count; x++)
            {


                foreach (Key kk in cam.device.GetPressedKeys())
                {
                    // tslabel.Text = kk.ToString();
                    switch (kk.ToString())
                    {
                        case "Up":
                            bsp.Spawns.Spawn[SelectedSpawn[x]].X += cam.speed;
                            break;
                        case "DownArrow":
                            bsp.Spawns.Spawn[SelectedSpawn[x]].X -= cam.speed;
                            break;
                        case "LeftArrow":
                            bsp.Spawns.Spawn[SelectedSpawn[x]].Y += cam.speed;
                            break;
                        case "Right":
                            bsp.Spawns.Spawn[SelectedSpawn[x]].Y -= cam.speed;
                            break;
                        case "PageDown":
                            bsp.Spawns.Spawn[SelectedSpawn[x]].Z -= cam.speed;
                            break;
                        case "PageUp":
                            bsp.Spawns.Spawn[SelectedSpawn[x]].Z += cam.speed;
                            break;
                        case "LeftControl":
                            rotationBitMask |= (int)SelectedItemRotationType.Control;
                            break;
                        case "RightControl":
                            rotationBitMask |= (int)SelectedItemRotationType.Control;
                            break;
                        case "LeftShift":
                            rotationBitMask |= (int)SelectedItemRotationType.Shift;
                            break;
                        case "RightShift":
                            rotationBitMask |= (int)SelectedItemRotationType.Shift;
                            break;
                        case "RightMenu":
                            rotationBitMask |= (int)SelectedItemRotationType.Alt;
                            break;
                        case "LeftMenu":
                            rotationBitMask |= (int)SelectedItemRotationType.Alt;
                            break;

                    }
                }
                TranslationMatrix[SelectedSpawn[x]] = MakeMatrixForSpawn(SelectedSpawn[x]);

            }
        }
        #endregion
        #endregion

        #region SpawnRotation
        int rotationBitMask;
        [FlagsAttribute]
        public enum SelectedItemRotationType : int
        {
            None = 0x00,
            Control = 0x01,
            Shift = 0x02,
            Alt = 0x04
        }
        #endregion
        #region SpawnSelection
        void ContextMenu_Click(object sender, System.Windows.Forms.ItemCheckEventArgs e)
        {
              string checkeditemsname = checkedListBox1.Items[e.Index].ToString();
              Type typ = typeof(Renderer.BSP_Renderer.SpawnInfo.SpawnType);
              Renderer.BSP_Renderer.SpawnInfo.SpawnType bm = (Renderer.BSP_Renderer.SpawnInfo.SpawnType)Enum.Parse(typ, checkeditemsname, true);
              if (e.CurrentValue == CheckState.Checked)
              {
                  visibleSpawnsBitMask ^= (int)bm;
              }
              else
              {
                  visibleSpawnsBitMask ^= (int)bm;
              }

        }
        #endregion
        #region SpawnEvents
        #region ObjectiveSpawnEvents
        #region IndexChanged
        void tb_TextChanged(object sender, EventArgs e)
        {
            ToolStripTextBox tb = sender as ToolStripTextBox;

            try
            {
                if (short.Parse(tb.Text) < 0) { tb.Text = "0"; }
            }
            catch
            {
                return;
            }

            foreach (int i in SelectedSpawn)
            {
                if (bsp.Spawns.Spawn[i].Type == entity.Renderer.BSP_Renderer.SpawnInfo.SpawnType.Objective)
                {
                    entity.Renderer.BSP_Renderer.SpawnInfo.ObjectiveSpawn os = bsp.Spawns.Spawn[i] as entity.Renderer.BSP_Renderer.SpawnInfo.ObjectiveSpawn;
                    os.number = short.Parse(tb.Text);
                    bsp.Spawns.Spawn[i] = os;
                }
            }
            base.Focus();
        }
        #endregion
        #region TeamTypeChanged
        void combo_SelectedIndexChanged(object sender, EventArgs e)
        {
            ToolStripComboBox cb = sender as ToolStripComboBox;

            foreach (int i in SelectedSpawn)
            {
                if (bsp.Spawns.Spawn[i].Type == entity.Renderer.BSP_Renderer.SpawnInfo.SpawnType.Objective)
                {
                    entity.Renderer.BSP_Renderer.SpawnInfo.ObjectiveSpawn os = bsp.Spawns.Spawn[i] as entity.Renderer.BSP_Renderer.SpawnInfo.ObjectiveSpawn;
                    object test = Enum.Parse(typeof(entity.Renderer.BSP_Renderer.SpawnInfo.ObjectiveSpawn.TeamType), cb.Items[cb.SelectedIndex].ToString(), true);
                    os.Team = (entity.Renderer.BSP_Renderer.SpawnInfo.ObjectiveSpawn.TeamType)test;
                    bsp.Spawns.Spawn[i] = os;
                }
            }
        }
        #endregion
        #region ObjectiveTypeChanged
        void combo_SelectedIndexChanged2(object sender, EventArgs e)
        {
            ToolStripComboBox cb = sender as ToolStripComboBox;

            foreach (int i in SelectedSpawn)
            {
                if (bsp.Spawns.Spawn[i].Type == entity.Renderer.BSP_Renderer.SpawnInfo.SpawnType.Objective)
                {

                    entity.Renderer.BSP_Renderer.SpawnInfo.ObjectiveSpawn os = bsp.Spawns.Spawn[i] as entity.Renderer.BSP_Renderer.SpawnInfo.ObjectiveSpawn;

                    object test = Enum.Parse(typeof(entity.Renderer.BSP_Renderer.SpawnInfo.ObjectiveSpawn.ObjectiveTypeEnum), cb.Items[cb.SelectedIndex].ToString(), true);
                    os.ObjectiveType = (entity.Renderer.BSP_Renderer.SpawnInfo.ObjectiveSpawn.ObjectiveTypeEnum)test;
                    bsp.Spawns.Spawn[i] = os;
                }
            }
        }
        #endregion
        #endregion
        #region CollectionSpawnEvents
        #region SpawnsInEnumChanged
        void combo_SelectedIndexChanged3(object sender, EventArgs e)
        {
            ToolStripComboBox cb = sender as ToolStripComboBox;

            foreach (int i in SelectedSpawn)
            {
                if (bsp.Spawns.Spawn[i].Type == entity.Renderer.BSP_Renderer.SpawnInfo.SpawnType.Collection)
                {
                    entity.Renderer.BSP_Renderer.SpawnInfo.Collection os = bsp.Spawns.Spawn[i] as entity.Renderer.BSP_Renderer.SpawnInfo.Collection;
                    object test = Enum.Parse(typeof(entity.Renderer.BSP_Renderer.SpawnInfo.Collection.SpawnsInEnum), cb.Items[cb.SelectedIndex].ToString(), true);
                    os.SpawnsInMode = (entity.Renderer.BSP_Renderer.SpawnInfo.Collection.SpawnsInEnum)test;
                    bsp.Spawns.Spawn[i] = os;
                }
            }
        }
        #endregion
        #endregion
        #endregion
        #region SpawnMatrixes
        public void MakeMatrixes()
        {
            TranslationMatrix = new Matrix[bsp.Spawns.Spawn.Count];
            for (int x = 0; x < bsp.Spawns.Spawn.Count; x++)
            {
                TranslationMatrix[x] = MakeMatrixForSpawn(x);
            }
        }
        public Matrix MakeMatrixForSpawn(int x)
        {
            Matrix m = Matrix.Identity;

            #region SpawnWithOneRotationDirection
            if (bsp.Spawns.Spawn[x] is entity.Renderer.BSP_Renderer.SpawnInfo.RotateDirectionBaseSpawn)
            {
                entity.Renderer.BSP_Renderer.SpawnInfo.RotateDirectionBaseSpawn tempspawn;
                tempspawn = bsp.Spawns.Spawn[x] as entity.Renderer.BSP_Renderer.SpawnInfo.RotateDirectionBaseSpawn;
                Matrix rotate = Matrix.Identity;
                rotate.RotateYawPitchRoll(0, 0, tempspawn.RotationDirection);
                // rotate.RotateYawPitchRoll(tempspawn.Yaw, tempspawn.Pitch, tempspawn.Roll);
                m.Multiply(rotate);
            }
            #endregion
            #region SpawnWithYawPitchRoll
            else if (bsp.Spawns.Spawn[x] is entity.Renderer.BSP_Renderer.SpawnInfo.RotateYawPitchRollBaseSpawn)
            {

                entity.Renderer.BSP_Renderer.SpawnInfo.RotateYawPitchRollBaseSpawn tempspawn;
                tempspawn = bsp.Spawns.Spawn[x] as entity.Renderer.BSP_Renderer.SpawnInfo.RotateYawPitchRollBaseSpawn;
                Matrix rotate = Matrix.Identity;


                if (Maps.map[mapnumber].HaloVersion == Map.HaloVersionEnum.Halo2)
                {
                    //if (tempspawn.Pitch > 0) { tempspawn.Pitch -= (float)Math.PI; }


                    float tempf3 = tempspawn.Roll;

                    Matrix m1 = Matrix.Identity;
                    m1.RotateX(tempspawn.Yaw);//tempspawn.Yaw);
                    Matrix m2 = Matrix.Identity;
                    m2.RotateY(tempspawn.Pitch);//tempspawn.Pitch);
                    Matrix m3 = Matrix.Identity;
                    m3.RotateZ(tempspawn.Roll);//);


                    rotate = m1 * m2 * m3;
                    // rotate.RotateYawPitchRoll(tempspawn.Yaw, tempspawn.Pitch, tempspawn.Roll);
                }
                else
                {
                    rotate.RotateYawPitchRoll(tempspawn.Yaw, tempspawn.Pitch, tempspawn.Roll);
                }
                m = rotate; ;
            }
            #endregion
            m.Multiply(Matrix.Translation(bsp.Spawns.Spawn[x].X, bsp.Spawns.Spawn[x].Y, bsp.Spawns.Spawn[x].Z));
            return m;

        }
        #endregion



        #region Halo2Resources
        int HaloLightCount = 1;
        public void LoadSpawns()
        {
            SpawnModel = new List<ParsedModel>();
            spawnmodelindex = new int[bsp.Spawns.Spawn.Count];
            BoundingBoxModel = new Mesh[bsp.Spawns.Spawn.Count];

            for (int x = 0; x < bsp.Spawns.Spawn.Count; x++)
            {
                Maps.map[mapnumber].OpenMap(MapTypes.Internal);
                #region BoundingBoxOnlySpawn
                if (bsp.Spawns.Spawn[x] is Renderer.BSP_Renderer.SpawnInfo.BoundingBoxSpawn)
                {
                    Renderer.BSP_Renderer.SpawnInfo.BoundingBoxSpawn tempbox;
                    tempbox = bsp.Spawns.Spawn[x] as Renderer.BSP_Renderer.SpawnInfo.BoundingBoxSpawn;
                    BoundingBoxModel[x] = Mesh.Box(render.device, tempbox.width, tempbox.height, tempbox.length);
                    continue;
                }
                #endregion
                #region CameraSpawn
                if (bsp.Spawns.Spawn[x] is Renderer.BSP_Renderer.SpawnInfo.CameraSpawn)
                {
                    Renderer.BSP_Renderer.SpawnInfo.CameraSpawn tempbox;
                    tempbox = bsp.Spawns.Spawn[x] as Renderer.BSP_Renderer.SpawnInfo.CameraSpawn;
                    BoundingBoxModel[x] = Mesh.Cylinder(render.device, 0.1f, 2.0f, 10f, 10, 10);
                    continue;
                }
                #endregion

                #region LightSpawn
                if (bsp.Spawns.Spawn[x] is Renderer.BSP_Renderer.SpawnInfo.LightSpawn)
                {
                    Renderer.BSP_Renderer.SpawnInfo.LightSpawn tempbox;
                    tempbox = bsp.Spawns.Spawn[x] as Renderer.BSP_Renderer.SpawnInfo.LightSpawn;
                    tempbox.LightInfo = new entity.MetaContainers.HaloLight(tempbox.ModelTagNumber, mapnumber);
                    bsp.Spawns.Spawn[x] = tempbox;
                    BoundingBoxModel[x] = Mesh.Cylinder(render.device, 0.5f, 0.0f, 1f, 10, 10);
                    if (render.lighting == true)
                    {
                        render.device.Lights[HaloLightCount].Type = LightType.Point;
                        render.device.Lights[HaloLightCount].Position = new Vector3(tempbox.X, tempbox.Y, tempbox.Z);
                        render.device.Lights[HaloLightCount].Direction = new Vector3(-tempbox.Yaw, -tempbox.Pitch, -tempbox.Roll);
                        render.device.Lights[HaloLightCount].Range = 10f;
                        //  render.device.Lights[HaloLightCount].=0.5f;
                        //  render.device.Lights[HaloLightCount].p = 1.0f;
                        render.device.Lights[HaloLightCount].Falloff = 1.0f;
                        render.device.Lights[HaloLightCount].Attenuation0 = 1.0f;
                        render.device.Lights[HaloLightCount].Diffuse = Color.FromArgb(tempbox.LightInfo.r, tempbox.LightInfo.g, tempbox.LightInfo.b);
                        render.device.Lights[HaloLightCount].Update();
                        render.device.Lights[HaloLightCount].Enabled = true;
                    }

                    HaloLightCount++;

                    continue;
                }
                #endregion


                Renderer.BSP_Renderer.SpawnInfo.RotationSpawn tempspawn = bsp.Spawns.Spawn[x] as Renderer.BSP_Renderer.SpawnInfo.RotationSpawn;


                #region ScanForExistingModels
                bool found = false;
                for (int xx = 0; xx < x; xx++)
                {
                    Renderer.BSP_Renderer.SpawnInfo.RotationSpawn tempspawn2 = bsp.Spawns.Spawn[xx] as Renderer.BSP_Renderer.SpawnInfo.RotationSpawn;
                    if (bsp.Spawns.Spawn[xx] is Renderer.BSP_Renderer.SpawnInfo.BoundingBoxSpawn)
                    {
                        continue;
                    }
                    if (tempspawn.ModelTagNumber == tempspawn2.ModelTagNumber)
                    {


                        BoundingBoxModel[x] = BoundingBoxModel[xx];
                        spawnmodelindex[x] = spawnmodelindex[xx];
                        found = true;
                        break;
                    }
                }

                if (found) { continue; }
                #endregion
                #region ReadSpawnMeta
                Meta m = new Meta();
                if (tempspawn.ModelTagNumber == -1) { MessageBox.Show("Test"); }
                m.ReadMetaFromMap(tempspawn.ModelTagNumber, mapnumber, false);
                #endregion
                #region DirectXModel
                ParsedModel pm = new ParsedModel(ref m, mapnumber);
                //pm.PermutationString=pm.hlmt.Permutations[pm.hlmt.FindPermutationByBaseClass,
                Raw.ParsedModel.DisplayedInfo.LoadDirectXTexturesAndBuffers(ref render.device, ref pm);
                SpawnModel.Add(pm);
                spawnmodelindex[x] = SpawnModel.Count - 1; m = null;
                #endregion
                #region BoundingBox
                float boxwidth = pm.BoundingBox.MaxX - pm.BoundingBox.MinX;
                float boxheight = pm.BoundingBox.MaxY - pm.BoundingBox.MinY;
                float boxdepth = pm.BoundingBox.MaxZ - pm.BoundingBox.MinZ;
                BoundingBoxModel[x] = Mesh.Box(render.device, boxwidth, boxheight, boxdepth);
                #endregion

                #region Fog
                if (render.device.DeviceCaps.RasterCaps.SupportsFogTable && bsp.sky.fogenabled && bsp.sky.fog.FogThickness != 0)
                {
                    int a = (int)(bsp.sky.fog.A * 255);
                    int r = (int)(bsp.sky.fog.R * 255);
                    int g = (int)(bsp.sky.fog.G * 255);
                    int b = (int)(bsp.sky.fog.B * 255);
                    render.device.RenderState.FogColor = Color.FromArgb(a, r, g, b);
                    render.device.RenderState.FogStart = bsp.sky.fog.Start;
                    render.device.RenderState.FogEnd = bsp.sky.fog.End;
                    render.device.RenderState.FogDensity = bsp.sky.fog.FogThickness;// bsp.sky.fog.FogThickness;

                    render.device.RenderState.FogTableMode = FogMode.Linear;
                    render.device.RenderState.FogEnable = true;
                }
                //   render.device.RenderState.FogVertexMode = FogMode.Linear;
                #endregion
                Maps.map[mapnumber].CloseMap();
            }

        }
        #endregion

        public bool InitializeGraphics()
        {

            //try
            //{
            this.Show();
            this.Focus();
            Application.DoEvents();

            #region CreateDevice
            render.CreateDevice(this);

            #endregion
            #region CreateHaloDirectXResources
            BSP.BSPModel.BSPDisplayedInfo.LoadDirectXTexturesAndBuffers(ref render.device, ref bsp);
            Raw.ParsedModel.DisplayedInfo.LoadDirectXTexturesAndBuffers(ref render.device, ref bsp.SkyBox);
            LoadSpawns();
            MakeMatrixes();

            #endregion

            #region InitializeMaterials
            BoundingBoxSelected = new Material();
            BoundingBoxSelected.Diffuse = Color.Red;
            BoundingBoxSelected.Ambient = Color.Red;
            DefaultMaterial = new Material();
            DefaultMaterial.Diffuse = Color.White;
            DefaultMaterial.Ambient = Color.White;
            BlackMaterial = new Material();
            BlackMaterial.Diffuse = Color.Black;
            BlackMaterial.Ambient = Color.Black;
            BlackMaterial.Specular = Color.Black;
            BlueMaterial = new Material();
            BlueMaterial.Diffuse = Color.Blue;
            BlueMaterial.Ambient = Color.Blue;
            GreenMaterial = new Material();
            GreenMaterial.Diffuse = Color.GreenYellow;
            GreenMaterial.Ambient = Color.GreenYellow;
            #endregion









            return true;

            //}
            //catch (DirectXException)
            //{
            // Catch any errors and return a failure
            //	return false;
            //	}
        }


        private void SetupMatrices()
        {
            render.device.Transform.World = Matrix.Identity;// Matrix.RotationAxis(new Vector3((float)Math.Cos(Environment.TickCount / 250.0f), 1, (float)Math.Sin(Environment.TickCount / 250.0f)), Environment.TickCount / 1000.0f);
            render.device.Transform.View = Matrix.LookAtRH(cam.Position, cam.LookAt, cam.UpVector);
            render.device.Transform.Projection = Matrix.PerspectiveFovRH(0.7f, 1.0f, 1.0f, 1000.0f);
            // cam.BuildViewFrustum(ref render.device);
        }
        private void Render()
        {
            if (render.pause)
                return;



            render.BeginScene(Color.Blue);
            SetupMatrices();

            #region Input
            cam.move();
            MoveSpawnsWithKeyboard();
            #endregion
            #region RenderBSP
            render.device.Transform.World = Matrix.Identity;
            render.device.SamplerState[0].AddressU = TextureAddress.Wrap;
            render.device.SamplerState[0].AddressV = TextureAddress.Wrap;
            render.device.RenderState.Lighting = true;
            render.device.RenderState.ZBufferEnable = false;
            render.device.RenderState.ZBufferWriteEnable = false;
         //   Raw.ParsedModel.DisplayedInfo.Draw(ref render.device, bsp.SkyBox);
            render.device.RenderState.ZBufferEnable = true;
            render.device.RenderState.ZBufferWriteEnable = true;
            render.device.SamplerState[0].AddressU = TextureAddress.Wrap;
            render.device.SamplerState[0].AddressV = TextureAddress.Wrap;
            //    render.device.RenderState.Lighting = false;

            render.device.Transform.World = Matrix.Identity;
            BSP.BSPModel.BSPDisplayedInfo.Draw(ref render.device, ref bsp, true, ref cam, shaderx);

            //Set camera postion
            string tempstring = toolStripLabel2.Text;
            string tempstring2 = "Camera Position: X: " + cam.x.ToString() + "  Y: " + cam.y.ToString() + "  Z: " + cam.z.ToString();
            if (tempstring != tempstring2)
            {

                if (statusStrip.Items.IndexOf(toolStripLabel2) != -1)
                {
                    statusStrip.Items.RemoveAt(statusStrip.Items.IndexOf(toolStripLabel2));
                }
                
                toolStripLabel2 = new ToolStripLabel();
                toolStripLabel2.Text = tempstring2;
                toolStripLabel2.Alignment = ToolStripItemAlignment.Right;
                statusStrip.Items.Add(toolStripLabel2);
            }

            #endregion
            #region RenderSpawns
            for (int x = 0; x < bsp.Spawns.Spawn.Count; x++)
            {
                if (((int)bsp.Spawns.Spawn[x].Type & visibleSpawnsBitMask) == 0) { continue; }

                render.device.Transform.World = TranslationMatrix[x];
                Vector3 tempv = new Vector3();
                tempv.X = bsp.Spawns.Spawn[x].X;
                tempv.Y = bsp.Spawns.Spawn[x].Y;
                tempv.Z = bsp.Spawns.Spawn[x].Z;
                //  if (!cam.SphereInFrustum(tempv,10f)){continue;}
                
          
         
      
       

                #region DrawLights
                bool selected = false;
                for (int i = 0; i < SelectedSpawn.Count; i++)
                {
                    if (SelectedSpawn[i] == x)
                    {
                        render.device.Material = BoundingBoxSelected;
                        render.device.SetTexture(0, null);
                        render.device.RenderState.AlphaBlendEnable = false;
                        render.device.RenderState.AlphaTestEnable = false;
                        render.device.RenderState.FillMode = FillMode.WireFrame;
                        BoundingBoxModel[x].DrawSubset(0);
                        selected = true;
                        continue;
                    }
     
                }
               if (bsp.Spawns.Spawn[x] is Renderer.BSP_Renderer.SpawnInfo.LightSpawn)
                {
                    if (!selected)
                    {
                        render.device.Material = BlueMaterial;
                        render.device.SetTexture(0, null);
                        render.device.RenderState.AlphaBlendEnable = false;
                        render.device.RenderState.AlphaTestEnable = false;
                        render.device.RenderState.FillMode = FillMode.WireFrame;
                        BoundingBoxModel[x].DrawSubset(0);
                    }
                    continue;
                }
                #endregion
  


     

              

                #region Camera
       
              selected=false;

                for (int i = 0; i < SelectedSpawn.Count; i++)
                {
                    if (SelectedSpawn[i] == x)
                    {
                        render.device.Material = BoundingBoxSelected;
                        render.device.SetTexture(0, null);
                        render.device.RenderState.AlphaBlendEnable = false;
                        render.device.RenderState.AlphaTestEnable = false;
                        render.device.RenderState.FillMode = FillMode.WireFrame;
                        BoundingBoxModel[x].DrawSubset(0);
                        selected = true;
                        continue;
                    }
              
                }
        
          


                if (bsp.Spawns.Spawn[x] is Renderer.BSP_Renderer.SpawnInfo.CameraSpawn)
                {
                    if (!selected)
                    {
                        render.device.Material = BlueMaterial;
                        render.device.SetTexture(0, null);
                        render.device.RenderState.AlphaBlendEnable = false;
                        render.device.RenderState.AlphaTestEnable = false;
                        render.device.RenderState.FillMode = FillMode.WireFrame;
                        BoundingBoxModel[x].DrawSubset(0);
                    }
                    continue;
                }
                #endregion

                #region BoundingBox

                for (int i = 0; i < SelectedSpawn.Count; i++)
                {
                    if (SelectedSpawn[i] == x)
                    {
                        render.device.Material = BoundingBoxSelected;
                        render.device.SetTexture(0, null);
                        render.device.RenderState.AlphaBlendEnable = false;
                        render.device.RenderState.AlphaTestEnable = false;
                        render.device.RenderState.FillMode = FillMode.WireFrame;
                        BoundingBoxModel[x].DrawSubset(0);
                        break;
                    }

                }
                if (bsp.Spawns.Spawn[x] is Renderer.BSP_Renderer.SpawnInfo.BoundingBoxSpawn)
                {

                    continue;
                }
                #endregion


                #region ObjectiveSpawnColoring
                render.device.Material = DefaultMaterial;
                render.device.RenderState.FillMode = FillMode.Solid;
                if (bsp.Spawns.Spawn[x] is entity.Renderer.BSP_Renderer.SpawnInfo.ObjectiveSpawn)
                {
                    entity.Renderer.BSP_Renderer.SpawnInfo.ObjectiveSpawn os = bsp.Spawns.Spawn[x] as entity.Renderer.BSP_Renderer.SpawnInfo.ObjectiveSpawn;
                    switch (os.Team)
                    {
                        case entity.Renderer.BSP_Renderer.SpawnInfo.ObjectiveSpawn.TeamType.Defense:
                            render.device.Material = BoundingBoxSelected;
                            break;
                        case entity.Renderer.BSP_Renderer.SpawnInfo.ObjectiveSpawn.TeamType.Offense:
                            render.device.Material = BlueMaterial;
                            break;
                        case entity.Renderer.BSP_Renderer.SpawnInfo.ObjectiveSpawn.TeamType.Neutral:
                            render.device.Material = GreenMaterial;
                            break;
                        default:
                            render.device.Material = DefaultMaterial;
                            break;
                    }

                }
                else
                {
                    render.device.Material = DefaultMaterial;
                }
                #endregion

                Raw.ParsedModel.DisplayedInfo.Draw(ref render.device, SpawnModel[spawnmodelindex[x]]);


            }
            #endregion
            #region MultiSelectMesh
            if (selectionMesh != null)
            {
                Matrix m = Matrix.Identity;
                float halfwidth = selectionWidth / 2;
                float halfheight = selectionHeight / 2;
                float halfdepth = selectionDepth / 2;
                //m.Multiply(Matrix.Translation(selectionStart.X + halfwidth, selectionStart.Y + halfheight, selectionStart.Z + halfdepth));
                m.Multiply(Matrix.Translation(selectionStart.X, selectionStart.Y, selectionStart.Z));
                render.device.Transform.World = m;
                render.device.SetTexture(0, null);
                render.device.RenderState.AlphaBlendEnable = false;
                render.device.RenderState.AlphaTestEnable = false;
                render.device.RenderState.FillMode = FillMode.WireFrame;
                render.device.Material = BoundingBoxSelected;

                selectionMesh.DrawSubset(0);
            }
            #endregion

            if (label3.Visible == true)
            {
                label3.Visible = false;
            }

            if (this.BackColor == Color.Blue)
            {
                this.BackColor = Color.FromArgb(235, 233, 237);
            }

            render.EndScene();
        }

        protected override void OnPaint(System.Windows.Forms.PaintEventArgs e)
        {
            this.Render(); // Render on painting
        }
        protected override void OnKeyPress(System.Windows.Forms.KeyPressEventArgs e)
        {
            if ((int)(byte)e.KeyChar == (int)System.Windows.Forms.Keys.Escape)
                this.Dispose(); // Esc was pressed
        }
        protected override void OnResize(System.EventArgs e)
        {
            //     this.Render();//
            render.pause = ((this.WindowState == FormWindowState.Minimized) || !this.Visible);

        }



        /// <summary>
        /// The main entry point for the application.
        /// </summary>
        /// 

        public void Main()
        {

            using (BSPViewer frm = (BSPViewer)this)
            {
                if (!frm.InitializeGraphics()) // Initialize Direct3D
                {
                    MessageBox.Show("Could not initialize Direct3D.  This tutorial will exit.");
                    return;
                }
                frm.Show();
                frm.Focus();
                cam = new entity.Renderer.Camera2(this);// Camera(device);

                // While the form is still valid, render and process messages
                while (frm.Created)
                {
                    frm.Render();
                    Application.DoEvents();
                    GC.Collect(0);
                    GC.WaitForPendingFinalizers();
                    GC.Collect(0);
                    //  System.Threading.Thread.Sleep(100);
                }
            }
        }

        private void InitializeComponent()
        {
            this.label3 = new System.Windows.Forms.Label();
            this.statusStrip = new System.Windows.Forms.ToolStrip();
            this.tslabel = new System.Windows.Forms.ToolStripLabel();
            this.toolStripLabel2 = new System.Windows.Forms.ToolStripLabel();
            this.sandDockManager1 = new TD.SandDock.SandDockManager();
            this.leftSandDock = new TD.SandDock.DockContainer();
            this.dockControl1 = new TD.SandDock.DockControl();
            this.SaveChanges = new System.Windows.Forms.Button();
            this.dockControl2 = new TD.SandDock.DockControl();
            this.checkBox3 = new System.Windows.Forms.CheckBox();
            this.checkedListBox1 = new System.Windows.Forms.CheckedListBox();
            this.findspawn = new System.Windows.Forms.Button();
            this.mi4 = new System.Windows.Forms.Button();
            this.SelectAllSpawns = new System.Windows.Forms.Button();
            this.dockControl3 = new TD.SandDock.DockControl();
            this.treeView1 = new System.Windows.Forms.TreeView();
            this.dockControl4 = new TD.SandDock.DockControl();
            this.fcordgb = new System.Windows.Forms.GroupBox();
            this.fcordlz = new System.Windows.Forms.Label();
            this.fcordly = new System.Windows.Forms.Label();
            this.fcordlx = new System.Windows.Forms.Label();
            this.fcordx = new System.Windows.Forms.TextBox();
            this.fcordbutton = new System.Windows.Forms.Button();
            this.fcordy = new System.Windows.Forms.TextBox();
            this.fcordz = new System.Windows.Forms.TextBox();
            this.dockControl5 = new TD.SandDock.DockControl();
            this.button3 = new System.Windows.Forms.Button();
            this.groupBox2 = new System.Windows.Forms.GroupBox();
            this.button2 = new System.Windows.Forms.Button();
            this.button1 = new System.Windows.Forms.Button();
            this.checkBox2 = new System.Windows.Forms.CheckBox();
            this.radioButton2 = new System.Windows.Forms.RadioButton();
            this.radioButton1 = new System.Windows.Forms.RadioButton();
            this.trackBar3 = new System.Windows.Forms.TrackBar();
            this.trackBar2 = new System.Windows.Forms.TrackBar();
            this.trackBar1 = new System.Windows.Forms.TrackBar();
            this.panel1 = new System.Windows.Forms.Panel();
            this.groupBox1 = new System.Windows.Forms.GroupBox();
            this.label2 = new System.Windows.Forms.Label();
            this.label1 = new System.Windows.Forms.Label();
            this.comboBox1 = new System.Windows.Forms.ComboBox();
            this.checkBox1 = new System.Windows.Forms.CheckBox();
            this.rightSandDock = new TD.SandDock.DockContainer();
            this.bottomSandDock = new TD.SandDock.DockContainer();
            this.topSandDock = new TD.SandDock.DockContainer();
            this.checkBox4 = new System.Windows.Forms.CheckBox();
            this.statusStrip.SuspendLayout();
            this.leftSandDock.SuspendLayout();
            this.dockControl1.SuspendLayout();
            this.dockControl2.SuspendLayout();
            this.dockControl3.SuspendLayout();
            this.dockControl4.SuspendLayout();
            this.fcordgb.SuspendLayout();
            this.dockControl5.SuspendLayout();
            this.groupBox2.SuspendLayout();
            ((System.ComponentModel.ISupportInitialize)(this.trackBar3)).BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.trackBar2)).BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.trackBar1)).BeginInit();
            this.groupBox1.SuspendLayout();
            this.SuspendLayout();
            // 
            // label3
            // 
            this.label3.AutoSize = true;
            this.label3.BackColor = System.Drawing.Color.Transparent;
            this.label3.Font = new System.Drawing.Font("Arial Black", 15F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label3.Location = new System.Drawing.Point(592, 0);
            this.label3.Name = "label3";
            this.label3.Size = new System.Drawing.Size(155, 28);
            this.label3.TabIndex = 8;
            this.label3.Text = ".:LOADING:.";
            // 
            // statusStrip
            // 
            this.statusStrip.Dock = System.Windows.Forms.DockStyle.Bottom;
            this.statusStrip.GripStyle = System.Windows.Forms.ToolStripGripStyle.Hidden;
            this.statusStrip.Items.AddRange(new System.Windows.Forms.ToolStripItem[] {
            this.tslabel,
            this.toolStripLabel2});
            this.statusStrip.Location = new System.Drawing.Point(0, 625);
            this.statusStrip.Name = "statusStrip";
            this.statusStrip.Size = new System.Drawing.Size(795, 25);
            this.statusStrip.TabIndex = 9;
            this.statusStrip.Text = "toolStrip1";
            // 
            // tslabel
            // 
            this.tslabel.Name = "tslabel";
            this.tslabel.Size = new System.Drawing.Size(38, 22);
            this.tslabel.Text = "tslabel";
            // 
            // toolStripLabel2
            // 
            this.toolStripLabel2.Alignment = System.Windows.Forms.ToolStripItemAlignment.Right;
            this.toolStripLabel2.Name = "toolStripLabel2";
            this.toolStripLabel2.Size = new System.Drawing.Size(78, 22);
            this.toolStripLabel2.Text = "toolStripLabel2";
            // 
            // sandDockManager1
            // 
            this.sandDockManager1.OwnerForm = this;
            // 
            // leftSandDock
            // 
            this.leftSandDock.Controls.Add(this.dockControl1);
            this.leftSandDock.Controls.Add(this.dockControl2);
            this.leftSandDock.Controls.Add(this.dockControl3);
            this.leftSandDock.Controls.Add(this.dockControl4);
            this.leftSandDock.Controls.Add(this.dockControl5);
            this.leftSandDock.Dock = System.Windows.Forms.DockStyle.Left;
            this.leftSandDock.Guid = new System.Guid("7b82af44-7394-4006-9310-e7e7e6293930");
            this.leftSandDock.LayoutSystem = new TD.SandDock.SplitLayoutSystem(250, 400, System.Windows.Forms.Orientation.Horizontal, new TD.SandDock.LayoutSystemBase[] {
            ((TD.SandDock.LayoutSystemBase)(new TD.SandDock.ControlLayoutSystem(250, 625, new TD.SandDock.DockControl[] {
                        this.dockControl1,
                        this.dockControl2,
                        this.dockControl3,
                        this.dockControl4,
                        this.dockControl5}, this.dockControl2)))});
            this.leftSandDock.Location = new System.Drawing.Point(0, 0);
            this.leftSandDock.Manager = this.sandDockManager1;
            this.leftSandDock.Name = "leftSandDock";
            this.leftSandDock.Size = new System.Drawing.Size(254, 625);
            this.leftSandDock.TabIndex = 13;
            // 
            // dockControl1
            // 
            this.dockControl1.Closable = false;
            this.dockControl1.Controls.Add(this.SaveChanges);
            this.dockControl1.Guid = new System.Guid("baf66d5e-5ae2-42bd-a116-5b600f86e7af");
            this.dockControl1.Location = new System.Drawing.Point(0, 18);
            this.dockControl1.Name = "dockControl1";
            this.dockControl1.Size = new System.Drawing.Size(250, 584);
            this.dockControl1.TabIndex = 0;
            this.dockControl1.Text = "Main";
            // 
            // SaveChanges
            // 
            this.SaveChanges.Location = new System.Drawing.Point(12, 17);
            this.SaveChanges.Name = "SaveChanges";
            this.SaveChanges.Size = new System.Drawing.Size(215, 23);
            this.SaveChanges.TabIndex = 1;
            this.SaveChanges.Text = "Save Changes";
            this.SaveChanges.UseVisualStyleBackColor = true;
            this.SaveChanges.Click += new System.EventHandler(this.SaveChanges_Click);
            // 
            // dockControl2
            // 
            this.dockControl2.Closable = false;
            this.dockControl2.Controls.Add(this.checkBox4);
            this.dockControl2.Controls.Add(this.checkBox3);
            this.dockControl2.Controls.Add(this.checkedListBox1);
            this.dockControl2.Controls.Add(this.findspawn);
            this.dockControl2.Controls.Add(this.mi4);
            this.dockControl2.Controls.Add(this.SelectAllSpawns);
            this.dockControl2.Guid = new System.Guid("3838baa4-58e1-4863-b0d8-82180bab7409");
            this.dockControl2.Location = new System.Drawing.Point(0, 18);
            this.dockControl2.Name = "dockControl2";
            this.dockControl2.Size = new System.Drawing.Size(250, 584);
            this.dockControl2.TabIndex = 1;
            this.dockControl2.Text = "Edit";
            // 
            // checkBox3
            // 
            this.checkBox3.AutoSize = true;
            this.checkBox3.Location = new System.Drawing.Point(15, 107);
            this.checkBox3.Name = "checkBox3";
            this.checkBox3.Size = new System.Drawing.Size(104, 17);
            this.checkBox3.TabIndex = 7;
            this.checkBox3.Text = "View All Spawns";
            this.checkBox3.UseVisualStyleBackColor = true;
            this.checkBox3.CheckedChanged += new System.EventHandler(this.checkBox3_CheckedChanged);
            // 
            // checkedListBox1
            // 
            this.checkedListBox1.FormattingEnabled = true;
            this.checkedListBox1.Location = new System.Drawing.Point(12, 130);
            this.checkedListBox1.Name = "checkedListBox1";
            this.checkedListBox1.Size = new System.Drawing.Size(225, 214);
            this.checkedListBox1.Sorted = true;
            this.checkedListBox1.TabIndex = 0;
            this.checkedListBox1.ItemCheck += new System.Windows.Forms.ItemCheckEventHandler(this.ContextMenu_Click);
            // 
            // findspawn
            // 
            this.findspawn.Location = new System.Drawing.Point(23, 72);
            this.findspawn.Name = "findspawn";
            this.findspawn.Size = new System.Drawing.Size(175, 23);
            this.findspawn.TabIndex = 6;
            this.findspawn.Text = "Find First Selected Spawn";
            this.findspawn.UseVisualStyleBackColor = true;
            this.findspawn.Click += new System.EventHandler(this.findspawn_Click);
            // 
            // mi4
            // 
            this.mi4.Location = new System.Drawing.Point(23, 43);
            this.mi4.Name = "mi4";
            this.mi4.Size = new System.Drawing.Size(175, 23);
            this.mi4.TabIndex = 5;
            this.mi4.Text = "Move All Spawns Here";
            this.mi4.UseVisualStyleBackColor = true;
            this.mi4.Click += new System.EventHandler(this.mi4_Click);
            // 
            // SelectAllSpawns
            // 
            this.SelectAllSpawns.Location = new System.Drawing.Point(23, 14);
            this.SelectAllSpawns.Name = "SelectAllSpawns";
            this.SelectAllSpawns.Size = new System.Drawing.Size(175, 23);
            this.SelectAllSpawns.TabIndex = 4;
            this.SelectAllSpawns.Text = "Select All Spawns";
            this.SelectAllSpawns.UseVisualStyleBackColor = true;
            this.SelectAllSpawns.Click += new System.EventHandler(this.SelectAllSpawns_Click);
            // 
            // dockControl3
            // 
            this.dockControl3.Closable = false;
            this.dockControl3.Controls.Add(this.treeView1);
            this.dockControl3.Guid = new System.Guid("99e2161d-408c-498f-acde-40db65d6db24");
            this.dockControl3.Location = new System.Drawing.Point(0, 18);
            this.dockControl3.Name = "dockControl3";
            this.dockControl3.Size = new System.Drawing.Size(250, 584);
            this.dockControl3.TabIndex = 2;
            this.dockControl3.Text = "Spawns";
            // 
            // treeView1
            // 
            this.treeView1.Dock = System.Windows.Forms.DockStyle.Fill;
            this.treeView1.Location = new System.Drawing.Point(0, 0);
            this.treeView1.Name = "treeView1";
            this.treeView1.Size = new System.Drawing.Size(250, 584);
            this.treeView1.TabIndex = 1;
            this.treeView1.DoubleClick += new System.EventHandler(this.treeView1_DoubleClick);
            // 
            // dockControl4
            // 
            this.dockControl4.Closable = false;
            this.dockControl4.Controls.Add(this.fcordgb);
            this.dockControl4.Guid = new System.Guid("a94fefcb-cae4-4234-86b6-d85bc85e0023");
            this.dockControl4.Location = new System.Drawing.Point(0, 18);
            this.dockControl4.Name = "dockControl4";
            this.dockControl4.Size = new System.Drawing.Size(250, 584);
            this.dockControl4.TabIndex = 3;
            this.dockControl4.Text = "Tools";
            // 
            // fcordgb
            // 
            this.fcordgb.Controls.Add(this.fcordlz);
            this.fcordgb.Controls.Add(this.fcordly);
            this.fcordgb.Controls.Add(this.fcordlx);
            this.fcordgb.Controls.Add(this.fcordx);
            this.fcordgb.Controls.Add(this.fcordbutton);
            this.fcordgb.Controls.Add(this.fcordy);
            this.fcordgb.Controls.Add(this.fcordz);
            this.fcordgb.Location = new System.Drawing.Point(3, 3);
            this.fcordgb.Name = "fcordgb";
            this.fcordgb.Size = new System.Drawing.Size(244, 129);
            this.fcordgb.TabIndex = 5;
            this.fcordgb.TabStop = false;
            this.fcordgb.Text = "Coordinate Finder";
            // 
            // fcordlz
            // 
            this.fcordlz.AutoSize = true;
            this.fcordlz.Location = new System.Drawing.Point(25, 74);
            this.fcordlz.Name = "fcordlz";
            this.fcordlz.Size = new System.Drawing.Size(17, 13);
            this.fcordlz.TabIndex = 6;
            this.fcordlz.Text = "Z:";
            // 
            // fcordly
            // 
            this.fcordly.AutoSize = true;
            this.fcordly.Location = new System.Drawing.Point(25, 48);
            this.fcordly.Name = "fcordly";
            this.fcordly.Size = new System.Drawing.Size(17, 13);
            this.fcordly.TabIndex = 5;
            this.fcordly.Text = "Y:";
            // 
            // fcordlx
            // 
            this.fcordlx.AutoSize = true;
            this.fcordlx.Location = new System.Drawing.Point(25, 22);
            this.fcordlx.Name = "fcordlx";
            this.fcordlx.Size = new System.Drawing.Size(17, 13);
            this.fcordlx.TabIndex = 4;
            this.fcordlx.Text = "X:";
            // 
            // fcordx
            // 
            this.fcordx.Location = new System.Drawing.Point(48, 19);
            this.fcordx.Name = "fcordx";
            this.fcordx.Size = new System.Drawing.Size(152, 20);
            this.fcordx.TabIndex = 0;
            this.fcordx.Text = "0";
            // 
            // fcordbutton
            // 
            this.fcordbutton.Location = new System.Drawing.Point(74, 97);
            this.fcordbutton.Name = "fcordbutton";
            this.fcordbutton.Size = new System.Drawing.Size(75, 23);
            this.fcordbutton.TabIndex = 3;
            this.fcordbutton.Text = "Find!";
            this.fcordbutton.UseVisualStyleBackColor = true;
            this.fcordbutton.Click += new System.EventHandler(this.fcordbutton_Click);
            // 
            // fcordy
            // 
            this.fcordy.Location = new System.Drawing.Point(48, 45);
            this.fcordy.Name = "fcordy";
            this.fcordy.Size = new System.Drawing.Size(152, 20);
            this.fcordy.TabIndex = 1;
            this.fcordy.Text = "0";
            // 
            // fcordz
            // 
            this.fcordz.Location = new System.Drawing.Point(48, 71);
            this.fcordz.Name = "fcordz";
            this.fcordz.Size = new System.Drawing.Size(152, 20);
            this.fcordz.TabIndex = 2;
            this.fcordz.Text = "0";
            // 
            // dockControl5
            // 
            this.dockControl5.Controls.Add(this.button3);
            this.dockControl5.Controls.Add(this.groupBox2);
            this.dockControl5.Controls.Add(this.panel1);
            this.dockControl5.Controls.Add(this.groupBox1);
            this.dockControl5.Guid = new System.Guid("f641181f-8274-43e0-8421-3f46471b23a2");
            this.dockControl5.Location = new System.Drawing.Point(0, 18);
            this.dockControl5.Name = "dockControl5";
            this.dockControl5.Size = new System.Drawing.Size(250, 584);
            this.dockControl5.TabIndex = 4;
            this.dockControl5.Text = "Lightmap Palettes";
            // 
            // button3
            // 
            this.button3.Location = new System.Drawing.Point(29, 13);
            this.button3.Name = "button3";
            this.button3.Size = new System.Drawing.Size(193, 23);
            this.button3.TabIndex = 10;
            this.button3.Text = "Apply";
            this.button3.UseVisualStyleBackColor = true;
            this.button3.Click += new System.EventHandler(this.button3_Click);
            // 
            // groupBox2
            // 
            this.groupBox2.Controls.Add(this.button2);
            this.groupBox2.Controls.Add(this.button1);
            this.groupBox2.Controls.Add(this.checkBox2);
            this.groupBox2.Controls.Add(this.radioButton2);
            this.groupBox2.Controls.Add(this.radioButton1);
            this.groupBox2.Controls.Add(this.trackBar3);
            this.groupBox2.Controls.Add(this.trackBar2);
            this.groupBox2.Controls.Add(this.trackBar1);
            this.groupBox2.Location = new System.Drawing.Point(10, 45);
            this.groupBox2.Name = "groupBox2";
            this.groupBox2.Size = new System.Drawing.Size(231, 178);
            this.groupBox2.TabIndex = 9;
            this.groupBox2.TabStop = false;
            this.groupBox2.Text = "Color Adjustment";
            // 
            // button2
            // 
            this.button2.Location = new System.Drawing.Point(110, 149);
            this.button2.Name = "button2";
            this.button2.Size = new System.Drawing.Size(75, 23);
            this.button2.TabIndex = 7;
            this.button2.Text = "Preview";
            this.button2.UseVisualStyleBackColor = true;
            this.button2.Click += new System.EventHandler(this.button2_Click);
            // 
            // button1
            // 
            this.button1.Location = new System.Drawing.Point(29, 149);
            this.button1.Name = "button1";
            this.button1.Size = new System.Drawing.Size(75, 23);
            this.button1.TabIndex = 0;
            this.button1.Text = "Reset";
            this.button1.UseVisualStyleBackColor = true;
            this.button1.Click += new System.EventHandler(this.button1_Click);
            // 
            // checkBox2
            // 
            this.checkBox2.AutoSize = true;
            this.checkBox2.Location = new System.Drawing.Point(73, 129);
            this.checkBox2.Name = "checkBox2";
            this.checkBox2.Size = new System.Drawing.Size(63, 17);
            this.checkBox2.TabIndex = 6;
            this.checkBox2.Text = "Colorize";
            this.checkBox2.UseVisualStyleBackColor = true;
            this.checkBox2.CheckedChanged += new System.EventHandler(this.checkBox2_CheckedChanged);
            // 
            // radioButton2
            // 
            this.radioButton2.AutoSize = true;
            this.radioButton2.Location = new System.Drawing.Point(119, 106);
            this.radioButton2.Name = "radioButton2";
            this.radioButton2.Size = new System.Drawing.Size(91, 17);
            this.radioButton2.TabIndex = 5;
            this.radioButton2.Text = "Color Balance";
            this.radioButton2.UseVisualStyleBackColor = true;
            this.radioButton2.CheckedChanged += new System.EventHandler(this.radioButton2_CheckedChanged);
            // 
            // radioButton1
            // 
            this.radioButton1.AutoSize = true;
            this.radioButton1.Checked = true;
            this.radioButton1.Location = new System.Drawing.Point(20, 106);
            this.radioButton1.Name = "radioButton1";
            this.radioButton1.Size = new System.Drawing.Size(98, 17);
            this.radioButton1.TabIndex = 4;
            this.radioButton1.TabStop = true;
            this.radioButton1.Text = "Hue\\Saturation";
            this.radioButton1.UseVisualStyleBackColor = true;
            this.radioButton1.CheckedChanged += new System.EventHandler(this.radioButton1_CheckedChanged);
            // 
            // trackBar3
            // 
            this.trackBar3.Location = new System.Drawing.Point(6, 78);
            this.trackBar3.Maximum = 100;
            this.trackBar3.Minimum = -100;
            this.trackBar3.Name = "trackBar3";
            this.trackBar3.Size = new System.Drawing.Size(219, 45);
            this.trackBar3.TabIndex = 3;
            this.trackBar3.TickStyle = System.Windows.Forms.TickStyle.None;
            this.trackBar3.Scroll += new System.EventHandler(this.trackBar3_Scroll);
            // 
            // trackBar2
            // 
            this.trackBar2.Location = new System.Drawing.Point(6, 49);
            this.trackBar2.Maximum = 100;
            this.trackBar2.Minimum = -100;
            this.trackBar2.Name = "trackBar2";
            this.trackBar2.Size = new System.Drawing.Size(219, 45);
            this.trackBar2.TabIndex = 2;
            this.trackBar2.TickStyle = System.Windows.Forms.TickStyle.None;
            this.trackBar2.Scroll += new System.EventHandler(this.trackBar2_Scroll);
            // 
            // trackBar1
            // 
            this.trackBar1.Location = new System.Drawing.Point(6, 19);
            this.trackBar1.Maximum = 100;
            this.trackBar1.Minimum = -100;
            this.trackBar1.Name = "trackBar1";
            this.trackBar1.Size = new System.Drawing.Size(219, 45);
            this.trackBar1.TabIndex = 1;
            this.trackBar1.TickStyle = System.Windows.Forms.TickStyle.None;
            this.trackBar1.Scroll += new System.EventHandler(this.trackBar1_Scroll);
            // 
            // panel1
            // 
            this.panel1.AutoScroll = true;
            this.panel1.Location = new System.Drawing.Point(10, 229);
            this.panel1.Name = "panel1";
            this.panel1.Size = new System.Drawing.Size(231, 224);
            this.panel1.TabIndex = 7;
            // 
            // groupBox1
            // 
            this.groupBox1.Controls.Add(this.label2);
            this.groupBox1.Controls.Add(this.label1);
            this.groupBox1.Controls.Add(this.comboBox1);
            this.groupBox1.Controls.Add(this.checkBox1);
            this.groupBox1.Location = new System.Drawing.Point(10, 459);
            this.groupBox1.Name = "groupBox1";
            this.groupBox1.Size = new System.Drawing.Size(231, 100);
            this.groupBox1.TabIndex = 8;
            this.groupBox1.TabStop = false;
            this.groupBox1.Text = "Lightmap Chunk Selection";
            // 
            // label2
            // 
            this.label2.Location = new System.Drawing.Point(16, 16);
            this.label2.Name = "label2";
            this.label2.Size = new System.Drawing.Size(201, 33);
            this.label2.TabIndex = 7;
            this.label2.Text = "Choose what chunk you would like to edit for the lightmap";
            // 
            // label1
            // 
            this.label1.AutoSize = true;
            this.label1.Location = new System.Drawing.Point(16, 78);
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size(41, 13);
            this.label1.TabIndex = 6;
            this.label1.Text = "Chunk:";
            // 
            // comboBox1
            // 
            this.comboBox1.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.comboBox1.Enabled = false;
            this.comboBox1.FormattingEnabled = true;
            this.comboBox1.Location = new System.Drawing.Point(63, 75);
            this.comboBox1.Name = "comboBox1";
            this.comboBox1.Size = new System.Drawing.Size(150, 21);
            this.comboBox1.TabIndex = 5;
            // 
            // checkBox1
            // 
            this.checkBox1.AutoSize = true;
            this.checkBox1.Checked = true;
            this.checkBox1.CheckState = System.Windows.Forms.CheckState.Checked;
            this.checkBox1.Location = new System.Drawing.Point(19, 52);
            this.checkBox1.Name = "checkBox1";
            this.checkBox1.Size = new System.Drawing.Size(58, 17);
            this.checkBox1.TabIndex = 4;
            this.checkBox1.Text = "Edit All";
            this.checkBox1.UseVisualStyleBackColor = true;
            this.checkBox1.CheckedChanged += new System.EventHandler(this.checkBox1_CheckedChanged);
            // 
            // rightSandDock
            // 
            this.rightSandDock.Dock = System.Windows.Forms.DockStyle.Right;
            this.rightSandDock.Guid = new System.Guid("63cd0407-8e90-4f94-bab3-8ea89fde67af");
            this.rightSandDock.LayoutSystem = new TD.SandDock.SplitLayoutSystem(250, 400);
            this.rightSandDock.Location = new System.Drawing.Point(795, 0);
            this.rightSandDock.Manager = this.sandDockManager1;
            this.rightSandDock.Name = "rightSandDock";
            this.rightSandDock.Size = new System.Drawing.Size(0, 625);
            this.rightSandDock.TabIndex = 14;
            // 
            // bottomSandDock
            // 
            this.bottomSandDock.Dock = System.Windows.Forms.DockStyle.Bottom;
            this.bottomSandDock.Guid = new System.Guid("8f427dca-24ab-40d5-9b32-732d9d46a574");
            this.bottomSandDock.LayoutSystem = new TD.SandDock.SplitLayoutSystem(250, 400);
            this.bottomSandDock.Location = new System.Drawing.Point(0, 625);
            this.bottomSandDock.Manager = this.sandDockManager1;
            this.bottomSandDock.Name = "bottomSandDock";
            this.bottomSandDock.Size = new System.Drawing.Size(795, 0);
            this.bottomSandDock.TabIndex = 15;
            // 
            // topSandDock
            // 
            this.topSandDock.Dock = System.Windows.Forms.DockStyle.Top;
            this.topSandDock.Guid = new System.Guid("53192ca4-cccc-4c39-bb57-5e16efa82d64");
            this.topSandDock.LayoutSystem = new TD.SandDock.SplitLayoutSystem(250, 400);
            this.topSandDock.Location = new System.Drawing.Point(0, 0);
            this.topSandDock.Manager = this.sandDockManager1;
            this.topSandDock.Name = "topSandDock";
            this.topSandDock.Size = new System.Drawing.Size(795, 0);
            this.topSandDock.TabIndex = 16;
            // 
            // checkBox4
            // 
            this.checkBox4.AutoSize = true;
            this.checkBox4.Location = new System.Drawing.Point(23, 350);
            this.checkBox4.Name = "checkBox4";
            this.checkBox4.Size = new System.Drawing.Size(184, 17);
            this.checkBox4.TabIndex = 8;
            this.checkBox4.Text = "Auto select item on treeview click";
            this.checkBox4.UseVisualStyleBackColor = true;
            // 
            // BSPViewer
            // 
            this.ClientSize = new System.Drawing.Size(795, 650);
            this.Controls.Add(this.leftSandDock);
            this.Controls.Add(this.rightSandDock);
            this.Controls.Add(this.bottomSandDock);
            this.Controls.Add(this.topSandDock);
            this.Controls.Add(this.statusStrip);
            this.Controls.Add(this.label3);
            this.Name = "BSPViewer";
            this.WindowState = System.Windows.Forms.FormWindowState.Maximized;
            this.statusStrip.ResumeLayout(false);
            this.statusStrip.PerformLayout();
            this.leftSandDock.ResumeLayout(false);
            this.dockControl1.ResumeLayout(false);
            this.dockControl2.ResumeLayout(false);
            this.dockControl2.PerformLayout();
            this.dockControl3.ResumeLayout(false);
            this.dockControl4.ResumeLayout(false);
            this.fcordgb.ResumeLayout(false);
            this.fcordgb.PerformLayout();
            this.dockControl5.ResumeLayout(false);
            this.groupBox2.ResumeLayout(false);
            this.groupBox2.PerformLayout();
            ((System.ComponentModel.ISupportInitialize)(this.trackBar3)).EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.trackBar2)).EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.trackBar1)).EndInit();
            this.groupBox1.ResumeLayout(false);
            this.groupBox1.PerformLayout();
            this.ResumeLayout(false);
            this.PerformLayout();

        }

        #endregion

        #region MiscControls

        public class TSComboBox : ToolStripComboBox
        {
            protected override void OnKeyPress(KeyPressEventArgs e)
            {
                e.Handled = true;
            }
            protected override void OnKeyDown(KeyEventArgs e)
            {
                e.Handled = true;
            }
        }

        private void fcordbutton_Click(object sender, EventArgs e)
        {
            try
            {
                cam.Position.X = Convert.ToSingle(fcordx.Text);
                cam.Position.Y = Convert.ToSingle(fcordx.Text);
                cam.Position.Z = Convert.ToSingle(fcordx.Text);

                cam.radianv = 0;
                cam.radianh = 0;

                cam.x = Convert.ToSingle(fcordx.Text);
                cam.y = Convert.ToSingle(fcordx.Text);
                cam.z = Convert.ToSingle(fcordx.Text);
            }
            catch
            {
                MessageBox.Show("There was a problem finding your Coordinate.");
            }

        }

        private void treeView1_DoubleClick(object sender, EventArgs e)
        {
            int tempint = (int)((TreeView)sender).SelectedNode.Tag;
            if (tempint >= 0)
            {
                cam.Position.X = bsp.Spawns.Spawn[tempint].X;
                cam.Position.Y = bsp.Spawns.Spawn[tempint].Y;
                cam.Position.Z = bsp.Spawns.Spawn[tempint].Z;

                cam.radianv = 0;
                cam.radianh = 0;

                cam.x = bsp.Spawns.Spawn[tempint].X;
                cam.y = bsp.Spawns.Spawn[tempint].Y;
                cam.z = bsp.Spawns.Spawn[tempint].Z;

                #region ComboSelection
                string checkeditemsname = bsp.Spawns.Spawn[tempint].Type.ToString();
                int checkitemsindex = checkedListBox1.Items.IndexOf(checkeditemsname);
              //  MessageBox.Show(checkitemsindex.ToString());
                Type typ = typeof(Renderer.BSP_Renderer.SpawnInfo.SpawnType);
                Renderer.BSP_Renderer.SpawnInfo.SpawnType bm = (Renderer.BSP_Renderer.SpawnInfo.SpawnType)Enum.Parse(typ, checkeditemsname, true);
                if (checkedListBox1.GetItemCheckState(checkitemsindex) == CheckState.Unchecked)
                {
                    checkedListBox1.SetItemCheckState(checkitemsindex, CheckState.Checked);
                }
                #endregion

                #region AutoSelect
                if (checkBox4.Checked == true)
                {

                    #region ClearStatus
                    statusStrip.Items.Clear();
                    // SelectedSpawn.Clear();
                    #endregion

                    #region DisplayCameraPosition
                    //Set camera postion
                    string tempstring = toolStripLabel2.Text;
                    string tempstring2 = "Camera Position: X: " + cam.x.ToString() + "  Y: " + cam.y.ToString() + "  Z: " + cam.z.ToString();
                    if (tempstring != tempstring2)
                    {

                        if (statusStrip.Items.IndexOf(toolStripLabel2) != -1)
                        {
                            statusStrip.Items.RemoveAt(statusStrip.Items.IndexOf(toolStripLabel2));
                        }

                        toolStripLabel2 = new ToolStripLabel();
                        toolStripLabel2.Text = tempstring2;
                        toolStripLabel2.Alignment = ToolStripItemAlignment.Right;
                        statusStrip.Items.Add(toolStripLabel2);
                    }
                    #endregion

                    #region TurnSpawnOnOrOff
                    int tempi = SelectedSpawn.IndexOf(tempint);

                    if (tempi != -1)
                    {
                        SelectedSpawn.RemoveAt(tempi);
                    }
                     
                    SelectedSpawn.Add(tempint);
                                       
                    selectedSpawnType = bsp.Spawns.Spawn[tempint].Type;
                    #endregion
                    tslabel.Text = "Type: " + bsp.Spawns.Spawn[tempint].Type.ToString()
                                 + "  X: " + bsp.Spawns.Spawn[tempint].X.ToString()
                                 + "  Y: " + bsp.Spawns.Spawn[tempint].Y.ToString()
                                 + "  Z: " + bsp.Spawns.Spawn[tempint].Z.ToString();


                    #region YawPitchRollInfo
                    if (bsp.Spawns.Spawn[tempint] is Renderer.BSP_Renderer.SpawnInfo.RotateYawPitchRollBaseSpawn)
                    {
                        Renderer.BSP_Renderer.SpawnInfo.RotateYawPitchRollBaseSpawn temprot;
                        temprot = bsp.Spawns.Spawn[tempint] as Renderer.BSP_Renderer.SpawnInfo.RotateYawPitchRollBaseSpawn;
                        tslabel.Text += "  Yaw:" + temprot.Yaw;
                        tslabel.Text += "  Pitch:" + temprot.Pitch;
                        tslabel.Text += "  Roll:" + temprot.Roll;
                    }
                    #endregion

                    #region NameInfo
                    if (bsp.Spawns.Spawn[tempint] is Renderer.BSP_Renderer.SpawnInfo.RotateYawPitchRollBaseSpawn)
                    {
                        Renderer.BSP_Renderer.SpawnInfo.RotateYawPitchRollBaseSpawn temprot;
                        temprot = bsp.Spawns.Spawn[tempint] as Renderer.BSP_Renderer.SpawnInfo.RotateYawPitchRollBaseSpawn;
                        //tslabel.Text += "  Name: " + temprot.ModelName;
                    }
                    else if (bsp.Spawns.Spawn[tempint] is Renderer.BSP_Renderer.SpawnInfo.RotateDirectionBaseSpawn)
                    {
                        Renderer.BSP_Renderer.SpawnInfo.RotateDirectionBaseSpawn temprot;
                        temprot = bsp.Spawns.Spawn[tempint] as Renderer.BSP_Renderer.SpawnInfo.RotateDirectionBaseSpawn;
                        //tslabel.Text += "  Name: " + temprot.ModelName;
                    }

                    #endregion
                    statusStrip.Items.Add(tslabel);

                    #region ObjectiveSpawn
                    if (bsp.Spawns.Spawn[tempint] is entity.Renderer.BSP_Renderer.SpawnInfo.ObjectiveSpawn)
                    {
                        entity.Renderer.BSP_Renderer.SpawnInfo.ObjectiveSpawn os;
                        os = bsp.Spawns.Spawn[tempint] as entity.Renderer.BSP_Renderer.SpawnInfo.ObjectiveSpawn;

                        #region StatusStripSetup
                        #region ObjectiveTypeEnumComboBox
                        TSComboBox combo = new TSComboBox();
                        Array testx = Enum.GetNames(typeof(entity.Renderer.BSP_Renderer.SpawnInfo.ObjectiveSpawn.ObjectiveTypeEnum));

                        for (int y = 0; y < testx.Length; y++)
                        {
                            combo.Items.Add(testx.GetValue(y).ToString());

                        }
                        int tempindex = combo.Items.IndexOf(os.ObjectiveType.ToString());
                        if (tempindex != -1) { combo.SelectedIndex = tempindex; }

                        combo.SelectedIndexChanged += new EventHandler(combo_SelectedIndexChanged2);

                        combo.BackColor = Color.Gray;
                        combo.FlatStyle = FlatStyle.Flat;
                        combo.DropDownStyle = ComboBoxStyle.DropDownList;
                        statusStrip.Items.Add(combo);
                        #endregion

                        #region TeamTypeEnumComboBox
                        combo = new TSComboBox();
                        testx = Enum.GetNames(typeof(entity.Renderer.BSP_Renderer.SpawnInfo.ObjectiveSpawn.TeamType));

                        for (int y = 0; y < testx.Length; y++)
                        {
                            combo.Items.Add(testx.GetValue(y).ToString());

                        }
                        tempindex = combo.Items.IndexOf(os.Team.ToString());
                        if (tempindex != -1) { combo.SelectedIndex = tempindex; }
                        combo.SelectedIndexChanged += new EventHandler(combo_SelectedIndexChanged);
                        combo.BackColor = Color.Gray;
                        combo.FlatStyle = FlatStyle.Flat;
                        combo.DropDownStyle = ComboBoxStyle.DropDownList;
                        statusStrip.Items.Add(combo);
                        #endregion

                        #region ObjectiveIndexTextBox
                        ToolStripTextBox tb = new ToolStripTextBox();
                        tb.AutoSize = false;
                        tb.BackColor = Color.White;
                        tb.BorderStyle = BorderStyle.FixedSingle;
                        tb.Height = 20;
                        tb.Width = 30;
                        tb.Text = os.number.ToString();
                        tb.TextChanged += new EventHandler(tb_TextChanged);
                        statusStrip.Items.Add(tb);
                        #endregion
                        #endregion
                    }
                    #endregion

                    #region CollectionSpawn
                    else if (bsp.Spawns.Spawn[tempint] is entity.Renderer.BSP_Renderer.SpawnInfo.Collection)
                    {
                        entity.Renderer.BSP_Renderer.SpawnInfo.Collection os;
                        os = bsp.Spawns.Spawn[tempint] as entity.Renderer.BSP_Renderer.SpawnInfo.Collection;

                        #region StatusStripSetup
                        #region SpawnsInEnumComboBox
                        TSComboBox combo = new TSComboBox();
                        Array testx = Enum.GetNames(typeof(entity.Renderer.BSP_Renderer.SpawnInfo.Collection.SpawnsInEnum));

                        for (int y = 0; y < testx.Length; y++)
                        {
                            combo.Items.Add(testx.GetValue(y).ToString());

                        }
                        int tempindex = combo.Items.IndexOf(os.SpawnsInMode.ToString());
                        if (tempindex != -1) { combo.SelectedIndex = tempindex; }
                        combo.SelectedIndexChanged += new EventHandler(combo_SelectedIndexChanged3);
                        combo.BackColor = Color.Gray;
                        combo.FlatStyle = FlatStyle.Flat;
                        combo.DropDownStyle = ComboBoxStyle.DropDownList;
                        statusStrip.Items.Add(combo);
                        #endregion
                        #endregion
                    }
                    #endregion;     

                   
                }
                #endregion

                Application.DoEvents();
                this.Focus();
                Application.DoEvents();
            }
        }

        #region Lightmaps

        private void checkBox1_CheckedChanged(object sender, EventArgs e)
        {
            if (checkBox1.Checked == true)
            {
                comboBox1.Enabled = false;
            }
            else
            {
                comboBox1.Enabled = true;
            }
        }


        public Image RenderLightmap(int LightmapIndex)
        {


            MemoryStream Image_MemoryStream = new MemoryStream();
            BinaryWriter Image_BW = new BinaryWriter(Image_MemoryStream);

            //Creat the header and write it
            byte[] MyHeader = { 66, 77, 56, 3, 0, 0, 0, 0, 0, 0, 54, 0, 0, 0, 40, 0, 0, 0, 16, 0, 0, 0, 16, 0, 0, 0, 1, 0, 24, 0, 0, 0, 0, 0, 2, 3, 0, 0, 18, 11, 0, 0, 18, 11, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };
            Image_BW.Write(MyHeader);

            //Write the RGB
            for (int i = 0; i < 1024; i += 4)
            {

                Image_BW.Write(LightMap_Array[(LightmapIndex * 1024) + i + 0]);
                Image_BW.Write(LightMap_Array[(LightmapIndex * 1024) + i + 1]);
                Image_BW.Write(LightMap_Array[(LightmapIndex * 1024) + i + 2]);
            }

            Image_BW.Write(0);
            Image_BW.Flush();

            Image tempimage;
            tempimage = Image.FromStream(Image_MemoryStream);
            tempimage.RotateFlip(RotateFlipType.Rotate180FlipX);

            return tempimage;

        }

        private void trackBar1_Scroll(object sender, EventArgs e)
        {
            trackint1 = trackBar1.Value;
            EditLightmaps();
        }

        private void trackBar2_Scroll(object sender, EventArgs e)
        {
            trackint2 = trackBar2.Value;
            EditLightmaps();
        }

        private void trackBar3_Scroll(object sender, EventArgs e)
        {
            trackint3 = trackBar3.Value;
            EditLightmaps();
        }

        int trackint1 = 0;
        int trackint2 = 0;
        int trackint3 = 0;

        byte[] LightMap_Array;
        byte[] LightMap_Array_Backup;

        private void Load_Lightmaps_Into_An_Array()
        {

            LightMap_Array = new byte[Maps.map[mapnumber].BSP.sbsp[bsp.BspNumber].LightMap_Palettes.Count * 1024];

            LightMap_Array_Backup = new byte[LightMap_Array.Length];

            for (int i = 0; i < Maps.map[mapnumber].BSP.sbsp[bsp.BspNumber].LightMap_Palettes.Count; i++)
            {

                for (int j = 0; j < 256; j++)
                {


                    BSPContainer.Palette_Color temp = Maps.map[mapnumber].BSP.sbsp[bsp.BspNumber].LightMap_Palettes[i][j];

                    LightMap_Array[(i * 1024) + (j * 4) + 0] = Convert.ToByte(temp.r);
                    LightMap_Array[(i * 1024) + (j * 4) + 1] = Convert.ToByte(temp.g);
                    LightMap_Array[(i * 1024) + (j * 4) + 2] = Convert.ToByte(temp.b);
                    LightMap_Array[(i * 1024) + (j * 4) + 3] = Convert.ToByte(temp.a);


                }

            }

            Array.Copy(LightMap_Array, LightMap_Array_Backup, LightMap_Array.Length);

        }

        private void EditLightmaps()
        {


            if (radioButton1.Checked == true)
            {

                if (checkBox1.Checked == true)
                {

                    byte[][] temparray = new byte[1][];
                    for (int i = 0; i < Maps.map[mapnumber].BSP.sbsp[bsp.BspNumber].LightMap_Palettes.Count; i++)
                    {
                        temparray[0] = new byte[1024];
                        Array.ConstrainedCopy(LightMap_Array_Backup, i * 1024, temparray[0], 0, 1024);
                        Array.ConstrainedCopy(HueSaturation(temparray, trackint1, trackint2, trackint3, checkBox2.Checked)[0], 0, LightMap_Array, i * 1024, 1024);
                    }

                    foreach (PictureBox picbox in panel1.Controls)
                    {
                        ((PictureBox)picbox).Image = RenderLightmap(((int)(((PictureBox)picbox).Tag)));
                    }

                }
                else
                {
                    byte[][] temparray = new byte[1][];
                    temparray[0] = new byte[1024];
                    Array.ConstrainedCopy(LightMap_Array_Backup, Convert.ToInt32(comboBox1.Text) * 1024, temparray[0], 0, 1024);
                    Array.ConstrainedCopy(HueSaturation(temparray, trackint1, trackint2, trackint3, checkBox2.Checked)[0], 0, LightMap_Array, Convert.ToInt32(comboBox1.Text) * 1024, 1024);

                    foreach (PictureBox picbox in panel1.Controls)
                    {
                        if (((int)(((PictureBox)picbox).Tag)) == Convert.ToInt32(comboBox1.Text))
                        {
                            ((PictureBox)picbox).Image = RenderLightmap(((int)(((PictureBox)picbox).Tag)));
                        }
                    }

                }

            }
            else
            {

                if (checkBox1.Checked == true)
                {
                    byte[][] temparray = new byte[1][];
                    for (int i = 0; i < Maps.map[mapnumber].BSP.sbsp[bsp.BspNumber].LightMap_Palettes.Count; i++)
                    {
                        temparray[0] = new byte[1024];
                        Array.ConstrainedCopy(LightMap_Array_Backup, i * 1024, temparray[0], 0, 1024);
                        Array.ConstrainedCopy(ColorBalance(temparray, trackint1, trackint2, trackint3, checkBox2.Checked)[0], 0, LightMap_Array, i * 1024, 1024);
                    }

                    foreach (PictureBox picbox in panel1.Controls)
                    {
                        ((PictureBox)picbox).Image = RenderLightmap(((int)(((PictureBox)picbox).Tag)));
                    }

                }
                else
                {
                    byte[][] temparray = new byte[1][];
                    temparray[0] = new byte[1024];
                    Array.ConstrainedCopy(LightMap_Array_Backup, Convert.ToInt32(comboBox1.Text) * 1024, temparray[0], 0, 1024);
                    Array.ConstrainedCopy(ColorBalance(temparray, trackint1, trackint2, trackint3, checkBox2.Checked)[0], 0, LightMap_Array, Convert.ToInt32(comboBox1.Text) * 1024, 1024);

                    foreach (PictureBox picbox in panel1.Controls)
                    {
                        if (((int)(((PictureBox)picbox).Tag)) == Convert.ToInt32(comboBox1.Text))
                        {
                            ((PictureBox)picbox).Image = RenderLightmap(((int)(((PictureBox)picbox).Tag)));
                        }
                    }

                }

            }



        }

        private byte[][] HueSaturation(byte[][] source, int hueShift, int satShift, int lightShift, bool colorize)
        {
            byte[][] adjusted = new byte[source.Length][];
            double shiftH = (double)hueShift;
            double shiftS = ((double)satShift) / 100;
            double shiftL = ((double)lightShift) / 100;
            for (int i = 0; i < source.Length; i++)
            {
                adjusted[i] = new byte[1024];
                for (int x = 0; x < 1024; x += 4)
                {
                    // RGB -> HSL
                    double B = ((double)source[i][x]) / 255;
                    double G = ((double)source[i][x + 1]) / 255;
                    double R = ((double)source[i][x + 2]) / 255;
                    double max = Math.Max(Math.Max(R, G), B);
                    double min = Math.Min(Math.Min(R, G), B);
                    double L = ((double)0.5) * (max + min);
                    double S = L == 0 || L == 1 ? 0 : // Filter undefined
                        L <= 0.5 ? (max - min) / (max + min) : (max - min) / (2 - (max + min));
                    double H = colorize ? 0 : // colorize
                        S == 0 ? 0 : // saturation == 0
                        R >= G && R >= B ? 60 * (G - B) / (max - min) : // max == red
                        G >= R && G >= B ? 60 * (B - R) / (max - min) + 120 : // max == blue
                        60 * (R - G) / (max - min) + 240; // max == green

                    // Shift HSL
                    H = H + shiftH;
                    S = !colorize && S == 0 ? 0 : // Don't create saturation
                        shiftS <= 0 ? S * (1 + shiftS) : S + shiftS * (1 - S);
                    L = shiftL <= 0 ? L * (1 + shiftL) : L + shiftL * (1 - L);

                    // HSL -> RGB
                    double d = L <= 0.5 ? S * L : S * (1 - L);
                    if (L == 0 || L == 1 || S == 0 || d == 0)
                        R = G = B = L;
                    else
                    {
                        while (H >= 360)
                            H -= 360;
                        while (H < 0)
                            H += 360;
                        //double d = L <= 0.5 ? S*L : S*(1-L);
                        min = L - d;
                        max = L + d;
                        double F = H < 60 ? H :
                            H < 180 ? H - 120 :
                            H < 300 ? H - 240 :
                            H - 360;
                        double mid = min + Math.Abs(F / 60) * (max - min);
                        switch ((int)Math.Floor(H / 60))
                        {
                            case 0:
                                R = max;
                                G = mid;
                                B = min;
                                break;
                            case 1:
                                R = mid;
                                G = max;
                                B = min;
                                break;
                            case 2:
                                R = min;
                                G = max;
                                B = mid;
                                break;
                            case 3:
                                R = min;
                                G = mid;
                                B = max;
                                break;
                            case 4:
                                R = mid;
                                G = min;
                                B = max;
                                break;
                            case 5:
                                R = max;
                                G = min;
                                B = mid;
                                break;
                        }
                    }

                    adjusted[i][x] = (byte)(B * 255);
                    adjusted[i][x + 1] = (byte)(G * 255);
                    adjusted[i][x + 2] = (byte)(R * 255);
                    adjusted[i][x + 3] = (byte)255;
                }
            }
            return adjusted;
        }

        private byte[][] ColorBalance(byte[][] source, int redShift, int greenShift, int blueShift, bool preserve)
        {
            byte[][] adjusted = new byte[source.Length][];
            double shiftR = ((double)redShift) / 100d;
            double shiftG = ((double)greenShift) / 100d;
            double shiftB = ((double)blueShift) / 100d;
            if (preserve)
            {
                // Avoid Complete Desaturation
                shiftR *= 0.99d;
                shiftG *= 0.99d;
                shiftB *= 0.99d;
            }
            for (int i = 0; i < source.Length; i++)
            {
                adjusted[i] = new byte[1024];
                for (int x = 0; x < 1024; x += 4)
                {
                    double B = ((double)source[i][x]) / 255d;
                    double G = ((double)source[i][x + 1]) / 255d;
                    double R = ((double)source[i][x + 2]) / 255d;
                    if (preserve)
                    {
                        // RGB -> L
                        double max = Math.Max(Math.Max(R, G), B);
                        double min = Math.Min(Math.Min(R, G), B);
                        double L = ((double)0.5) * (max + min);
                        //double S = L == 0 || L == 1 ? 0 : // Filter undefined
                        //	L <= 0.5 ? (max-min)/(max+min) : (max-min)/(2-(max+min));

                        // RGB + Shift -> HS
                        B = shiftB <= 0 ? B * (1 + shiftB) : B + shiftB * (1 - B);
                        G = shiftG <= 0 ? G * (1 + shiftG) : G + shiftG * (1 - G);
                        R = shiftR <= 0 ? R * (1 + shiftR) : R + shiftR * (1 - R);
                        max = Math.Max(Math.Max(R, G), B);
                        min = Math.Min(Math.Min(R, G), B);
                        double tempL = 0.5d * (max + min);
                        double S = tempL == 0 || tempL == 1 ? 0 : // Filter undefined
                            tempL <= 0.5 ? (max - min) / (max + min) : (max - min) / (2 - (max + min));
                        double H = S == 0 ? 0 : // saturation == 0
                            R >= G && R >= B ? 60 * (G - B) / (max - min) : // max == red
                            G >= R && G >= B ? 60 * (B - R) / (max - min) + 120 : // max == green
                            60 * (R - G) / (max - min) + 240; // max == blue		

                        // HSL -> RGB
                        double d = L <= 0.5 ? S * L : S * (1 - L);
                        if (L == 0 || L == 1 || S == 0 || d == 0)
                            R = G = B = L;
                        else
                        {
                            while (H >= 360)
                                H -= 360;
                            while (H < 0)
                                H += 360;
                            //double d = L <= 0.5 ? S*L : S*(1-L);
                            min = L - d;
                            max = L + d;
                            double F = H < 60 ? H :
                                H < 180 ? H - 120 :
                                H < 300 ? H - 240 :
                                H - 360;
                            double mid = min + Math.Abs(F / 60) * (max - min);
                            switch ((int)Math.Floor(H / 60))
                            {
                                case 0:
                                    R = max;
                                    G = mid;
                                    B = min;
                                    break;
                                case 1:
                                    R = mid;
                                    G = max;
                                    B = min;
                                    break;
                                case 2:
                                    R = min;
                                    G = max;
                                    B = mid;
                                    break;
                                case 3:
                                    R = min;
                                    G = mid;
                                    B = max;
                                    break;
                                case 4:
                                    R = mid;
                                    G = min;
                                    B = max;
                                    break;
                                case 5:
                                    R = max;
                                    G = min;
                                    B = mid;
                                    break;
                            }
                        }
                    }
                    else
                    {
                        B = shiftB <= 0 ? B * (1 + shiftB) : B + shiftB * (1 - B);
                        G = shiftG <= 0 ? G * (1 + shiftG) : G + shiftG * (1 - G);
                        R = shiftR <= 0 ? R * (1 + shiftR) : R + shiftR * (1 - R);
                    }

                    adjusted[i][x] = (byte)(B * 255);
                    adjusted[i][x + 1] = (byte)(G * 255);
                    adjusted[i][x + 2] = (byte)(R * 255);
                    adjusted[i][x + 3] = (byte)255;
                }
            }
            return adjusted;
        }

        private void button1_Click(object sender, EventArgs e)
        {

            trackBar1.Value = 0;
            trackBar2.Value = 0;
            trackBar3.Value = 0;

            Array.ConstrainedCopy(LightMap_Array_Backup, 0, LightMap_Array, 0, LightMap_Array.Length);

            foreach (PictureBox picbox in panel1.Controls)
            {
                ((PictureBox)picbox).Image = RenderLightmap(((int)(((PictureBox)picbox).Tag)));
            }

        }

        private void button2_Click(object sender, EventArgs e)
        {

            ReloadFromArray();

            bsp.LoadLightmaps(mapnumber);

            BSP.BSPModel.BSPDisplayedInfo.LoadLightmapTextures(ref render.device, ref bsp);

        }

        private void ReloadFromArray()
        {



            for (int i = 0; i < Maps.map[mapnumber].BSP.sbsp[bsp.BspNumber].LightMap_Palettes.Count; i++)
            {

                for (int j = 0; j < 256; j++)
                {

                    BSPContainer.Palette_Color temp = new BSPContainer.Palette_Color();

                    temp.r = LightMap_Array[(i * 1024) + (j * 4) + 0];
                    temp.g = LightMap_Array[(i * 1024) + (j * 4) + 1];
                    temp.b = LightMap_Array[(i * 1024) + (j * 4) + 2];
                    temp.a = LightMap_Array[(i * 1024) + (j * 4) + 3];

                    Maps.map[mapnumber].BSP.sbsp[bsp.BspNumber].LightMap_Palettes[i][j] = temp;

                }

            }


        }

        private void PictureBox_Click(object sender, EventArgs e)
        {

            checkBox1.Checked = false;
            comboBox1.SelectedIndex = (int)((PictureBox)sender).Tag;

        }

        private void button3_Click(object sender, EventArgs e)
        {

            //Save the lightmap
            Maps.map[mapnumber].BSP.sbsp[bsp.BspNumber].WritePalettes(mapnumber);

            //Apply the new palettes
            Array.ConstrainedCopy(LightMap_Array, 0, LightMap_Array_Backup, 0, LightMap_Array.Length);

            trackBar1.Value = 0;
            trackBar2.Value = 0;
            trackBar3.Value = 0;

            MessageBox.Show("Done");

        }

        private void radioButton1_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton1.Checked == true)
            {
                checkBox2.Text = "Colorize";
                checkBox2.Checked = false;
                trackBar1.Value = 0;
                trackBar2.Value = 0;
                trackBar3.Value = 0;
                Array.ConstrainedCopy(LightMap_Array_Backup, 0, LightMap_Array, 0, LightMap_Array.Length);

                foreach (PictureBox picbox in panel1.Controls)
                {
                    ((PictureBox)picbox).Image = RenderLightmap(((int)(((PictureBox)picbox).Tag)));
                }
            }
            else
            {
                checkBox2.Text = "Preserve Lightness";
                checkBox2.Checked = true;
                trackBar1.Value = 0;
                trackBar2.Value = 0;
                trackBar3.Value = 0;
                Array.ConstrainedCopy(LightMap_Array_Backup, 0, LightMap_Array, 0, LightMap_Array.Length);

                foreach (PictureBox picbox in panel1.Controls)
                {
                    ((PictureBox)picbox).Image = RenderLightmap(((int)(((PictureBox)picbox).Tag)));
                }
            }
        }

        private void radioButton2_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton1.Checked == true)
            {
                checkBox2.Text = "Colorize";
                checkBox2.Checked = false;
                trackBar1.Value = 0;
                trackBar2.Value = 0;
                trackBar3.Value = 0;
                Array.ConstrainedCopy(LightMap_Array_Backup, 0, LightMap_Array, 0, LightMap_Array.Length);

                foreach (PictureBox picbox in panel1.Controls)
                {
                    ((PictureBox)picbox).Image = RenderLightmap(((int)(((PictureBox)picbox).Tag)));
                }
                EditLightmaps();
            }
            else
            {
                checkBox2.Text = "Preserve Lightness";
                checkBox2.Checked = true;
                trackBar1.Value = 0;
                trackBar2.Value = 0;
                trackBar3.Value = 0;
                Array.ConstrainedCopy(LightMap_Array_Backup, 0, LightMap_Array, 0, LightMap_Array.Length);

                foreach (PictureBox picbox in panel1.Controls)
                {
                    ((PictureBox)picbox).Image = RenderLightmap(((int)(((PictureBox)picbox).Tag)));
                }
                EditLightmaps();
            }
        }

        private void checkBox2_CheckedChanged(object sender, EventArgs e)
        {

            EditLightmaps();

        }

        #endregion

        private void checkBox3_CheckedChanged(object sender, EventArgs e)
        {
            if (checkBox3.Checked == true)
            {
                for (int i = 0; i < checkedListBox1.Items.Count; i++)
                {
                    checkedListBox1.SetItemCheckState(i, CheckState.Checked);
                }
            }
            else
            {
                for (int i = 0; i < checkedListBox1.Items.Count; i++)
                {
                    checkedListBox1.SetItemCheckState(i, CheckState.Unchecked);
                }
            }
        }
                     

    }
        #endregion
    }