using System;
using System.Collections.Generic;
using System.Collections;
using System.Windows.Forms;
namespace entity.Renderer.BSP_Renderer
{
    public class SpawnInfo
    {
        public List<BaseSpawn> Spawn = new List<BaseSpawn>();
        #region Constructor

        public SpawnInfo(int mapnumber)
        {
            switch (Maps.map[mapnumber].HaloVersion)
            {
                case Map.HaloVersionEnum.HaloCE:
                case Map.HaloVersionEnum.Halo1:
                    H1SpawnInfo(mapnumber);
                    break;
                case Map.HaloVersionEnum.Halo2:
                    H2SpawnInfo(mapnumber);
                    break;
            }
        }
        public void H1SpawnInfo(int mapnumber)
        {
            Maps.map[mapnumber].OpenMap(MapTypes.Internal);
            //collections
            Maps.map[mapnumber].BR.BaseStream.Position = Maps.map[mapnumber].MetaInfo.Offset[0] + 900;
            int tempc = Maps.map[mapnumber].BR.ReadInt32();
            int tempr = Maps.map[mapnumber].BR.ReadInt32() - Maps.map[mapnumber].PrimaryMagic;

            for (int x = 0; x < tempc; x++)
            {
                Maps.map[mapnumber].OpenMap(MapTypes.Internal);
                H1Collection vs = new H1Collection();
                Maps.map[mapnumber].BR.BaseStream.Position = tempr + (144 * x) + 4;
                vs.SpawnsInMode = (H1Collection.H1CollectionTypeEnum)Maps.map[mapnumber].BR.ReadInt32();
                Maps.map[mapnumber].BR.BaseStream.Position = tempr + (144 * x) + 64;
                vs.offset = tempr + (144 * x) + 64;
                vs.X = Maps.map[mapnumber].BR.ReadSingle();
                vs.Y = Maps.map[mapnumber].BR.ReadSingle();
                vs.Z = Maps.map[mapnumber].BR.ReadSingle();
                vs.RotationDirection = Renderer.DegreeToRadian(Maps.map[mapnumber].BR.ReadSingle());

                Maps.map[mapnumber].BR.BaseStream.Position = tempr + (144 * x) + 92;
                int tempbase = Maps.map[mapnumber].Functions.Meta.FindMetaByID(Maps.map[mapnumber].BR.ReadInt32(), mapnumber);
                if (tempbase == -1) { continue; }
                Maps.map[mapnumber].CloseMap();
                vs.TagPath = Maps.map[mapnumber].FileNames.Name[tempbase];
                vs.ModelTagNumber = Maps.map[mapnumber].Functions.FindModelByBaseClass(tempbase, mapnumber);
                if (vs.ModelTagNumber == -1) { continue; }
                vs.ModelName = Maps.map[mapnumber].FileNames.Name[vs.ModelTagNumber];
                Spawn.Add(vs);
            }


            //vehicle
            Maps.map[mapnumber].OpenMap(MapTypes.Internal);
            Maps.map[mapnumber].BR.BaseStream.Position = Maps.map[mapnumber].MetaInfo.Offset[0] + 588;
           int[] temppalette = new int[Maps.map[mapnumber].BR.ReadInt32()];
           int[] temppalette2 = new int[temppalette.Length];
           tempr = Maps.map[mapnumber].BR.ReadInt32() - Maps.map[mapnumber].PrimaryMagic;
            for (int x = 0; x < temppalette.Length; x++)
            {
                Maps.map[mapnumber].OpenMap(MapTypes.Internal);
                Maps.map[mapnumber].BR.BaseStream.Position = tempr + (x * 48) + 12;
                int tempbase = Maps.map[mapnumber].Functions.Meta.FindMetaByID(Maps.map[mapnumber].BR.ReadInt32(), mapnumber);
                Maps.map[mapnumber].CloseMap();
                temppalette2[x] = tempbase;
                temppalette[x] = Maps.map[mapnumber].Functions.FindModelByBaseClass(tempbase, mapnumber);
            }


            Maps.map[mapnumber].OpenMap(MapTypes.Internal);
            Maps.map[mapnumber].BR.BaseStream.Position = Maps.map[mapnumber].MetaInfo.Offset[0] + 576;
            tempc = Maps.map[mapnumber].BR.ReadInt32();
            tempr = Maps.map[mapnumber].BR.ReadInt32() - Maps.map[mapnumber].PrimaryMagic;

            for (int x = 0; x < tempc; x++)
            {
                Maps.map[mapnumber].BR.BaseStream.Position = tempr + (120 * x);
                short tempshort = Maps.map[mapnumber].BR.ReadInt16();

                if (tempshort == -1) { continue; }
                Maps.map[mapnumber].BR.BaseStream.Position = tempr + (120 * x) + 8;
                VehicleSpawn vs = new VehicleSpawn();
                vs.offset = tempr + (120 * x) + 8;
                vs.X = Maps.map[mapnumber].BR.ReadSingle();
                vs.Y = Maps.map[mapnumber].BR.ReadSingle();
                vs.Z = Maps.map[mapnumber].BR.ReadSingle();
                
           
                vs.Yaw =Renderer.DegreeToRadian( Maps.map[mapnumber].BR.ReadSingle());
                vs.Pitch = Renderer.DegreeToRadian(Maps.map[mapnumber].BR.ReadSingle());
                vs.Roll = Renderer.DegreeToRadian(Maps.map[mapnumber].BR.ReadSingle());
                vs.ModelTagNumber = temppalette[tempshort];
                if (vs.ModelTagNumber == -1) { continue; }
                vs.TagPath = Maps.map[mapnumber].FileNames.Name[temppalette2[tempshort]];
                vs.ModelName = Maps.map[mapnumber].FileNames.Name[vs.ModelTagNumber];
                Spawn.Add(vs);

            
            
            }






            Maps.map[mapnumber].OpenMap(MapTypes.Internal);
            Maps.map[mapnumber].BR.BaseStream.Position = Maps.map[mapnumber].MetaInfo.Offset[0] + 540;
           temppalette = new int[Maps.map[mapnumber].BR.ReadInt32()];
             temppalette2 = new int[temppalette.Length];
            tempr = Maps.map[mapnumber].BR.ReadInt32() - Maps.map[mapnumber].PrimaryMagic;
            for (int x = 0; x < temppalette.Length; x++)
            {
                Maps.map[mapnumber].OpenMap(MapTypes.Internal);
                Maps.map[mapnumber].BR.BaseStream.Position = tempr + (x * 48) + 12;
                int tempbase = Maps.map[mapnumber].Functions.Meta.FindMetaByID(Maps.map[mapnumber].BR.ReadInt32(), mapnumber);
                Maps.map[mapnumber].CloseMap();
                temppalette2[x] = tempbase;
                temppalette[x] = Maps.map[mapnumber].Functions.FindModelByBaseClass(tempbase, mapnumber);
            }


            Maps.map[mapnumber].OpenMap(MapTypes.Internal);
            Maps.map[mapnumber].BR.BaseStream.Position = Maps.map[mapnumber].MetaInfo.Offset[0] + 528;
            tempc = Maps.map[mapnumber].BR.ReadInt32();
            tempr = Maps.map[mapnumber].BR.ReadInt32() - Maps.map[mapnumber].PrimaryMagic;

            for (int x = 0; x < tempc; x++)
            {
                Maps.map[mapnumber].BR.BaseStream.Position = tempr + (72 * x);
                short tempshort = Maps.map[mapnumber].BR.ReadInt16();

                if (tempshort == -1) { continue; }
                Maps.map[mapnumber].BR.BaseStream.Position = tempr + (72 * x) + 8;
                ScenerySpawn vs = new ScenerySpawn();
                vs.offset = tempr + (72 * x) + 8;
                vs.X = Maps.map[mapnumber].BR.ReadSingle();
                vs.Y = Maps.map[mapnumber].BR.ReadSingle();
                vs.Z = Maps.map[mapnumber].BR.ReadSingle();
                vs.Yaw = Renderer.DegreeToRadian(Maps.map[mapnumber].BR.ReadSingle());
                vs.Pitch = Renderer.DegreeToRadian(Maps.map[mapnumber].BR.ReadSingle());
                vs.Roll = Renderer.DegreeToRadian(Maps.map[mapnumber].BR.ReadSingle());
                vs.ModelTagNumber = temppalette[tempshort];
                if (vs.ModelTagNumber == -1) { continue; }
                vs.TagPath = Maps.map[mapnumber].FileNames.Name[temppalette2[tempshort]];
                vs.ModelName = Maps.map[mapnumber].FileNames.Name[vs.ModelTagNumber];
                Spawn.Add(vs);

            }
        }
        public void H2SpawnInfo(int mapnumber)
        {
            Maps.map[mapnumber].OpenMap(MapTypes.Internal);

            //find default mc model
            Maps.map[mapnumber].BR.BaseStream.Position = Maps.map[mapnumber].MetaInfo.Offset[0] + 308;
            int tempr = Maps.map[mapnumber].BR.ReadInt32() - Maps.map[mapnumber].SecondaryMagic;
            Maps.map[mapnumber].BR.BaseStream.Position = tempr + 4;
            int tempbipdtag = Maps.map[mapnumber].Functions.Meta.FindMetaByID(Maps.map[mapnumber].BR.ReadInt32(), mapnumber);
            Maps.map[mapnumber].CloseMap();
            int bipdmodeltag = Maps.map[mapnumber].Functions.FindModelByBaseClass(tempbipdtag, mapnumber);

            //Find objective models

            Maps.map[mapnumber].OpenMap(MapTypes.Internal);
            Maps.map[mapnumber].BR.BaseStream.Position = Maps.map[mapnumber].MetaInfo.Offset[Maps.map[mapnumber].Functions.Meta.FindByNameAndTagType("mulg", "multiplayer\\multiplayer_globals", mapnumber)] + 12;
            tempr = Maps.map[mapnumber].BR.ReadInt32();
            int ctfmodeltag = -1;
            int ballmodeltag = -1;
            int juggernautdmodeltag = -1;
            int assultmodeltag = -1;
            if (tempr != 0)
            {
                tempr -= Maps.map[mapnumber].SecondaryMagic;
                Maps.map[mapnumber].BR.BaseStream.Position = tempr + 4;
                int tempCtftag = Maps.map[mapnumber].Functions.Meta.FindMetaByID(Maps.map[mapnumber].BR.ReadInt32(), mapnumber);
                Maps.map[mapnumber].BR.BaseStream.Position = tempr + 12;
                int tempBalltag = Maps.map[mapnumber].Functions.Meta.FindMetaByID(Maps.map[mapnumber].BR.ReadInt32(), mapnumber);
                Maps.map[mapnumber].BR.BaseStream.Position = tempr + 52;
                int tempJuggernauttag = Maps.map[mapnumber].Functions.Meta.FindMetaByID(Maps.map[mapnumber].BR.ReadInt32(), mapnumber);
                Maps.map[mapnumber].BR.BaseStream.Position = tempr + 60;
                int tempAssaulttag = Maps.map[mapnumber].Functions.Meta.FindMetaByID(Maps.map[mapnumber].BR.ReadInt32(), mapnumber);
                Maps.map[mapnumber].CloseMap();

                ctfmodeltag = Maps.map[mapnumber].Functions.FindModelByBaseClass(tempCtftag, mapnumber);
                ballmodeltag = Maps.map[mapnumber].Functions.FindModelByBaseClass(tempBalltag, mapnumber);
                juggernautdmodeltag = Maps.map[mapnumber].Functions.FindModelByBaseClass(tempJuggernauttag, mapnumber);
                assultmodeltag = Maps.map[mapnumber].Functions.FindModelByBaseClass(tempAssaulttag, mapnumber);

            }
            ////Player Spawns
            Maps.map[mapnumber].OpenMap(MapTypes.Internal);
            Maps.map[mapnumber].BR.BaseStream.Position = Maps.map[mapnumber].MetaInfo.Offset[3] + 256;
            int tempc = Maps.map[mapnumber].BR.ReadInt32();
            tempr = Maps.map[mapnumber].BR.ReadInt32() - Maps.map[mapnumber].SecondaryMagic;
            for (int x = 0; x < tempc; x++)
            {
                Maps.map[mapnumber].BR.BaseStream.Position = tempr + (52 * x);

                PlayerSpawn ps = new PlayerSpawn();
                ps.offset = tempr + (52 * x);
                ps.X = Maps.map[mapnumber].BR.ReadSingle();
                ps.Y = Maps.map[mapnumber].BR.ReadSingle();
                ps.Z = Maps.map[mapnumber].BR.ReadSingle();
                ps.RotationDirection = Maps.map[mapnumber].BR.ReadSingle();
                ps.ModelTagNumber = bipdmodeltag;
                ps.ModelName = Maps.map[mapnumber].FileNames.Name[ps.ModelTagNumber];
                Spawn.Add(ps);

            }


            ////death zones
            Maps.map[mapnumber].BR.BaseStream.Position = Maps.map[mapnumber].MetaInfo.Offset[3] + 264;
            tempc = Maps.map[mapnumber].BR.ReadInt32();
            tempr = Maps.map[mapnumber].BR.ReadInt32() - Maps.map[mapnumber].SecondaryMagic;
            for (int x = 0; x < tempc; x++)
            {
                Maps.map[mapnumber].BR.BaseStream.Position = tempr + (68 * x) + 36;

                DeathZone ps = new DeathZone();
                ps.offset = tempr + (68 * x) + 36;
                ps.X = Maps.map[mapnumber].BR.ReadSingle();
                ps.Y = Maps.map[mapnumber].BR.ReadSingle();
                ps.Z = Maps.map[mapnumber].BR.ReadSingle();
                //   Maps.map[mapnumber].BR.ReadSingle();
                ps.width = Maps.map[mapnumber].BR.ReadSingle();
                ps.height = Maps.map[mapnumber].BR.ReadSingle();
                ps.length = Maps.map[mapnumber].BR.ReadSingle();

                float widthhalf = ps.length / 2;
                // ps.X = ps.X - widthhalf;
                widthhalf = ps.width / 2;

                ps.Y = ps.Y + widthhalf;

                widthhalf = ps.height / 2;
                ps.Z += ps.length / 2;
                //    MessageBox.Show("DeathZone");

                Spawn.Add(ps);

            }



            ////lights

            //palette
            Maps.map[mapnumber].BR.BaseStream.Position = Maps.map[mapnumber].MetaInfo.Offset[3] + 240;
            int[] temppalette = new int[Maps.map[mapnumber].BR.ReadInt32()];
            int[] temppalette2 = new int[temppalette.Length];
            tempr = Maps.map[mapnumber].BR.ReadInt32() - Maps.map[mapnumber].SecondaryMagic;
            for (int x = 0; x < temppalette.Length; x++)
            {
                Maps.map[mapnumber].BR.BaseStream.Position = tempr + (x * 40) + 4;
                int tempbase = Maps.map[mapnumber].Functions.Meta.FindMetaByID(Maps.map[mapnumber].BR.ReadInt32(), mapnumber);
                temppalette2[x] = tempbase;
                temppalette[x] = tempbase;
            }


            //placement
            Maps.map[mapnumber].BR.BaseStream.Position = Maps.map[mapnumber].MetaInfo.Offset[3] + 232;
            tempc = Maps.map[mapnumber].BR.ReadInt32();
            tempr = Maps.map[mapnumber].BR.ReadInt32() - Maps.map[mapnumber].SecondaryMagic;
            for (int x = 0; x < tempc; x++)
            {

                Maps.map[mapnumber].BR.BaseStream.Position = tempr + (108 * x);
                short tempshort = Maps.map[mapnumber].BR.ReadInt16();

                if (tempshort == -1) { continue; }
                Maps.map[mapnumber].BR.BaseStream.Position = tempr + (108 * x) + 8;
                LightSpawn vs = new LightSpawn();
                vs.offset = tempr + (108 * x) + 8;
                vs.X = Maps.map[mapnumber].BR.ReadSingle();
                vs.Y = Maps.map[mapnumber].BR.ReadSingle();
                vs.Z = Maps.map[mapnumber].BR.ReadSingle();
                vs.Roll = Maps.map[mapnumber].BR.ReadSingle();
                vs.Pitch = Maps.map[mapnumber].BR.ReadSingle();
                vs.Yaw = Maps.map[mapnumber].BR.ReadSingle();

                vs.ModelTagNumber = temppalette[tempshort];
                if (vs.ModelTagNumber == -1) { continue; }
                vs.TagPath = Maps.map[mapnumber].FileNames.Name[temppalette2[tempshort]];
                vs.ModelName = Maps.map[mapnumber].FileNames.Name[vs.ModelTagNumber];
                Spawn.Add(vs);

            }



            ////objectives
            Maps.map[mapnumber].BR.BaseStream.Position = Maps.map[mapnumber].MetaInfo.Offset[3] + 280;
            tempc = Maps.map[mapnumber].BR.ReadInt32();
            tempr = Maps.map[mapnumber].BR.ReadInt32() - Maps.map[mapnumber].SecondaryMagic;
            for (int x = 0; x < tempc; x++)
            {
                Maps.map[mapnumber].BR.BaseStream.Position = tempr + (32 * x);

                ObjectiveSpawn ps = new ObjectiveSpawn();
                ps.offset = tempr + (32 * x);
                ps.X = Maps.map[mapnumber].BR.ReadSingle();
                ps.Y = Maps.map[mapnumber].BR.ReadSingle();
                ps.Z = Maps.map[mapnumber].BR.ReadSingle();
                ps.RotationDirection = Maps.map[mapnumber].BR.ReadSingle();
                ps.ObjectiveType = (ObjectiveSpawn.ObjectiveTypeEnum)Maps.map[mapnumber].BR.ReadInt16();
                ps.Team = (ObjectiveSpawn.TeamType)Maps.map[mapnumber].BR.ReadInt16();
                ps.number = Maps.map[mapnumber].BR.ReadInt16();

                if (ps.ObjectiveType == ObjectiveSpawn.ObjectiveTypeEnum.OddballSpawn && ballmodeltag != -1)
                {
                    ps.ModelTagNumber = ballmodeltag;
                }
                else if (ps.ObjectiveType == ObjectiveSpawn.ObjectiveTypeEnum.CTFRespawn && ctfmodeltag != -1)
                {
                    ps.ModelTagNumber = ctfmodeltag;
                }
                else if (ps.ObjectiveType == ObjectiveSpawn.ObjectiveTypeEnum.AssaultRespawn && assultmodeltag != -1)
                {
                    ps.ModelTagNumber = assultmodeltag;
                }
                else
                {
                    ps.ModelTagNumber = bipdmodeltag;
                }

                ps.ModelName = Maps.map[mapnumber].FileNames.Name[ps.ModelTagNumber];
                Spawn.Add(ps);

            }

            ///vehicles 
            Maps.map[mapnumber].BR.BaseStream.Position = Maps.map[mapnumber].MetaInfo.Offset[3] + 120;
            temppalette = new int[Maps.map[mapnumber].BR.ReadInt32()];
            temppalette2 = new int[temppalette.Length];
            tempr = Maps.map[mapnumber].BR.ReadInt32() - Maps.map[mapnumber].SecondaryMagic;
            for (int x = 0; x < temppalette.Length; x++)
            {
                Maps.map[mapnumber].OpenMap(MapTypes.Internal);
                Maps.map[mapnumber].BR.BaseStream.Position = tempr + (x * 40) + 4;
                int tempbase = Maps.map[mapnumber].Functions.Meta.FindMetaByID(Maps.map[mapnumber].BR.ReadInt32(), mapnumber);
                Maps.map[mapnumber].CloseMap();
                temppalette2[x] = tempbase;
                temppalette[x] = Maps.map[mapnumber].Functions.FindModelByBaseClass(tempbase, mapnumber);
            }

            Maps.map[mapnumber].OpenMap(MapTypes.Internal);
            Maps.map[mapnumber].BR.BaseStream.Position = Maps.map[mapnumber].MetaInfo.Offset[3] + 112;
            tempc = Maps.map[mapnumber].BR.ReadInt32();
            tempr = Maps.map[mapnumber].BR.ReadInt32() - Maps.map[mapnumber].SecondaryMagic;

            for (int x = 0; x < tempc; x++)
            {
                Maps.map[mapnumber].BR.BaseStream.Position = tempr + (84 * x);
                short tempshort = Maps.map[mapnumber].BR.ReadInt16();

                if (tempshort == -1) { continue; }
                Maps.map[mapnumber].BR.BaseStream.Position = tempr + (84 * x) + 8;
                VehicleSpawn vs = new VehicleSpawn();
                vs.offset = tempr + (84 * x) + 8;
                vs.X = Maps.map[mapnumber].BR.ReadSingle();
                vs.Y = Maps.map[mapnumber].BR.ReadSingle();
                vs.Z = Maps.map[mapnumber].BR.ReadSingle();
                vs.Roll = Maps.map[mapnumber].BR.ReadSingle();
                vs.Pitch = Maps.map[mapnumber].BR.ReadSingle();
                vs.Yaw = Maps.map[mapnumber].BR.ReadSingle();
                vs.ModelTagNumber = temppalette[tempshort];
                if (vs.ModelTagNumber == -1) { continue; }
                vs.TagPath = Maps.map[mapnumber].FileNames.Name[temppalette2[tempshort]];
                vs.ModelName = Maps.map[mapnumber].FileNames.Name[vs.ModelTagNumber];
                Spawn.Add(vs);

            }


            ////equipment


            Maps.map[mapnumber].BR.BaseStream.Position = Maps.map[mapnumber].MetaInfo.Offset[3] + 136;
            temppalette = new int[Maps.map[mapnumber].BR.ReadInt32()];
            temppalette2 = new int[temppalette.Length];
            tempr = Maps.map[mapnumber].BR.ReadInt32() - Maps.map[mapnumber].SecondaryMagic;
            for (int x = 0; x < temppalette.Length; x++)
            {
                Maps.map[mapnumber].OpenMap(MapTypes.Internal);
                Maps.map[mapnumber].BR.BaseStream.Position = tempr + (x * 40) + 4;
                int tempbase = Maps.map[mapnumber].Functions.Meta.FindMetaByID(Maps.map[mapnumber].BR.ReadInt32(), mapnumber);
                Maps.map[mapnumber].CloseMap();
                temppalette2[x] = tempbase;
                temppalette[x] = Maps.map[mapnumber].Functions.FindModelByBaseClass(tempbase, mapnumber);
            }


            Maps.map[mapnumber].OpenMap(MapTypes.Internal);
            Maps.map[mapnumber].BR.BaseStream.Position = Maps.map[mapnumber].MetaInfo.Offset[3] + 128;
            tempc = Maps.map[mapnumber].BR.ReadInt32();
            tempr = Maps.map[mapnumber].BR.ReadInt32() - Maps.map[mapnumber].SecondaryMagic;

            for (int x = 0; x < tempc; x++)
            {
                Maps.map[mapnumber].BR.BaseStream.Position = tempr + (56 * x);
                short tempshort = Maps.map[mapnumber].BR.ReadInt16();

                if (tempshort == -1) { continue; }
                Maps.map[mapnumber].BR.BaseStream.Position = tempr + (56 * x) + 8;
                EquipmentSpawn vs = new EquipmentSpawn();
                vs.offset = tempr + (56 * x) + 8;
                vs.X = Maps.map[mapnumber].BR.ReadSingle();
                vs.Y = Maps.map[mapnumber].BR.ReadSingle();
                vs.Z = Maps.map[mapnumber].BR.ReadSingle();
                vs.RotationDirection = Maps.map[mapnumber].BR.ReadSingle();
                vs.ModelTagNumber = temppalette[tempshort];
                if (vs.ModelTagNumber == -1) { continue; }
                vs.TagPath = Maps.map[mapnumber].FileNames.Name[temppalette2[tempshort]];
                vs.ModelName = Maps.map[mapnumber].FileNames.Name[vs.ModelTagNumber];
                Spawn.Add(vs);

            }


            //bipeds

            Maps.map[mapnumber].BR.BaseStream.Position = Maps.map[mapnumber].MetaInfo.Offset[3] + 104;
            temppalette = new int[Maps.map[mapnumber].BR.ReadInt32()];
            temppalette2 = new int[temppalette.Length];
            tempr = Maps.map[mapnumber].BR.ReadInt32() - Maps.map[mapnumber].SecondaryMagic;
            for (int x = 0; x < temppalette.Length; x++)
            {
                Maps.map[mapnumber].OpenMap(MapTypes.Internal);
                Maps.map[mapnumber].BR.BaseStream.Position = tempr + (x * 40) + 4;
                int tempbase = Maps.map[mapnumber].Functions.Meta.FindMetaByID(Maps.map[mapnumber].BR.ReadInt32(), mapnumber);
                Maps.map[mapnumber].CloseMap();
                temppalette2[x] = tempbase;
                temppalette[x] = Maps.map[mapnumber].Functions.FindModelByBaseClass(tempbase, mapnumber);
            }


            Maps.map[mapnumber].OpenMap(MapTypes.Internal);
            Maps.map[mapnumber].BR.BaseStream.Position = Maps.map[mapnumber].MetaInfo.Offset[3] + 96;
            tempc = Maps.map[mapnumber].BR.ReadInt32();
            tempr = Maps.map[mapnumber].BR.ReadInt32() - Maps.map[mapnumber].SecondaryMagic;

            for (int x = 0; x < tempc; x++)
            {
                Maps.map[mapnumber].BR.BaseStream.Position = tempr + (84 * x);
                short tempshort = Maps.map[mapnumber].BR.ReadInt16();

                if (tempshort == -1) { continue; }
                Maps.map[mapnumber].BR.BaseStream.Position = tempr + (84 * x) + 8;
                BipedSpawn vs = new BipedSpawn();
                vs.offset = tempr + (84 * x) + 8;
                vs.X = Maps.map[mapnumber].BR.ReadSingle();
                vs.Y = Maps.map[mapnumber].BR.ReadSingle();
                vs.Z = Maps.map[mapnumber].BR.ReadSingle();
                vs.RotationDirection = Maps.map[mapnumber].BR.ReadSingle();
                vs.ModelTagNumber = temppalette[tempshort];
                if (vs.ModelTagNumber == -1) { continue; }
                vs.TagPath = Maps.map[mapnumber].FileNames.Name[temppalette2[tempshort]];
                vs.ModelName = Maps.map[mapnumber].FileNames.Name[vs.ModelTagNumber];
                Spawn.Add(vs);

            }


            //control

            Maps.map[mapnumber].BR.BaseStream.Position = Maps.map[mapnumber].MetaInfo.Offset[3] + 192;
            temppalette = new int[Maps.map[mapnumber].BR.ReadInt32()];
            temppalette2 = new int[temppalette.Length];
            tempr = Maps.map[mapnumber].BR.ReadInt32() - Maps.map[mapnumber].SecondaryMagic;
            for (int x = 0; x < temppalette.Length; x++)
            {
                Maps.map[mapnumber].OpenMap(MapTypes.Internal);
                Maps.map[mapnumber].BR.BaseStream.Position = tempr + (x * 40) + 4;
                int tempbase = Maps.map[mapnumber].Functions.Meta.FindMetaByID(Maps.map[mapnumber].BR.ReadInt32(), mapnumber);
                Maps.map[mapnumber].CloseMap();
                temppalette2[x] = tempbase;
                temppalette[x] = Maps.map[mapnumber].Functions.FindModelByBaseClass(tempbase, mapnumber);
            }


            Maps.map[mapnumber].OpenMap(MapTypes.Internal);
            Maps.map[mapnumber].BR.BaseStream.Position = Maps.map[mapnumber].MetaInfo.Offset[3] + 184;
            tempc = Maps.map[mapnumber].BR.ReadInt32();
            tempr = Maps.map[mapnumber].BR.ReadInt32() - Maps.map[mapnumber].SecondaryMagic;

            for (int x = 0; x < tempc; x++)
            {
                Maps.map[mapnumber].BR.BaseStream.Position = tempr + (68 * x);
                short tempshort = Maps.map[mapnumber].BR.ReadInt16();

                if (tempshort == -1) { continue; }
                Maps.map[mapnumber].BR.BaseStream.Position = tempr + (68 * x) + 8;
                ControlSpawn vs = new ControlSpawn();
                vs.offset = tempr + (68 * x) + 8;
                vs.X = Maps.map[mapnumber].BR.ReadSingle();
                vs.Y = Maps.map[mapnumber].BR.ReadSingle();
                vs.Z = Maps.map[mapnumber].BR.ReadSingle();
                vs.RotationDirection = Maps.map[mapnumber].BR.ReadSingle();
                vs.ModelTagNumber = temppalette[tempshort];
                if (vs.ModelTagNumber == -1) { continue; }
                vs.TagPath = Maps.map[mapnumber].FileNames.Name[temppalette2[tempshort]];
                vs.ModelName = Maps.map[mapnumber].FileNames.Name[vs.ModelTagNumber];
                Spawn.Add(vs);

            }


            ////machines


            Maps.map[mapnumber].BR.BaseStream.Position = Maps.map[mapnumber].MetaInfo.Offset[3] + 176;
            temppalette = new int[Maps.map[mapnumber].BR.ReadInt32()];
            temppalette2 = new int[temppalette.Length];
            tempr = Maps.map[mapnumber].BR.ReadInt32() - Maps.map[mapnumber].SecondaryMagic;
            for (int x = 0; x < temppalette.Length; x++)
            {
                Maps.map[mapnumber].OpenMap(MapTypes.Internal);
                Maps.map[mapnumber].BR.BaseStream.Position = tempr + (x * 40) + 4;
                int tempbase = Maps.map[mapnumber].Functions.Meta.FindMetaByID(Maps.map[mapnumber].BR.ReadInt32(), mapnumber);
                Maps.map[mapnumber].CloseMap();
                temppalette2[x] = tempbase;
                temppalette[x] = Maps.map[mapnumber].Functions.FindModelByBaseClass(tempbase, mapnumber);
            }


            Maps.map[mapnumber].OpenMap(MapTypes.Internal);
            Maps.map[mapnumber].BR.BaseStream.Position = Maps.map[mapnumber].MetaInfo.Offset[3] + 168;
            tempc = Maps.map[mapnumber].BR.ReadInt32();
            tempr = Maps.map[mapnumber].BR.ReadInt32() - Maps.map[mapnumber].SecondaryMagic;

            for (int x = 0; x < tempc; x++)
            {
                Maps.map[mapnumber].BR.BaseStream.Position = tempr + (72 * x);
                short tempshort = Maps.map[mapnumber].BR.ReadInt16();

                if (tempshort == -1) { continue; }
                Maps.map[mapnumber].BR.BaseStream.Position = tempr + (72 * x) + 8;
                MachineSpawn vs = new MachineSpawn();
                vs.offset = tempr + (72 * x) + 8;
                vs.X = Maps.map[mapnumber].BR.ReadSingle();
                vs.Y = Maps.map[mapnumber].BR.ReadSingle();
                vs.Z = Maps.map[mapnumber].BR.ReadSingle();
                vs.Roll = Maps.map[mapnumber].BR.ReadSingle();
                vs.Pitch = Maps.map[mapnumber].BR.ReadSingle();
                vs.Yaw = Maps.map[mapnumber].BR.ReadSingle();
                vs.ModelTagNumber = temppalette[tempshort];
                if (vs.ModelTagNumber == -1) { continue; }
                vs.TagPath = Maps.map[mapnumber].FileNames.Name[temppalette2[tempshort]];
                vs.ModelName = Maps.map[mapnumber].FileNames.Name[vs.ModelTagNumber];
                Spawn.Add(vs);

            }



            ////scenery


            Maps.map[mapnumber].BR.BaseStream.Position = Maps.map[mapnumber].MetaInfo.Offset[3] + 88;
            temppalette = new int[Maps.map[mapnumber].BR.ReadInt32()];
            temppalette2 = new int[temppalette.Length];
            tempr = Maps.map[mapnumber].BR.ReadInt32() - Maps.map[mapnumber].SecondaryMagic;
            for (int x = 0; x < temppalette.Length; x++)
            {
                Maps.map[mapnumber].OpenMap(MapTypes.Internal);
                Maps.map[mapnumber].BR.BaseStream.Position = tempr + (x * 40) + 4;
                int tempbase = Maps.map[mapnumber].Functions.Meta.FindMetaByID(Maps.map[mapnumber].BR.ReadInt32(), mapnumber);
                Maps.map[mapnumber].CloseMap();
                temppalette2[x] = tempbase;
                temppalette[x] = Maps.map[mapnumber].Functions.FindModelByBaseClass(tempbase, mapnumber);
            }


            Maps.map[mapnumber].OpenMap(MapTypes.Internal);
            Maps.map[mapnumber].BR.BaseStream.Position = Maps.map[mapnumber].MetaInfo.Offset[3] + 80;
            tempc = Maps.map[mapnumber].BR.ReadInt32();
            tempr = Maps.map[mapnumber].BR.ReadInt32() - Maps.map[mapnumber].SecondaryMagic;

            for (int x = 0; x < tempc; x++)
            {
                Maps.map[mapnumber].BR.BaseStream.Position = tempr + (92 * x);
                short tempshort = Maps.map[mapnumber].BR.ReadInt16();

                if (tempshort == -1) { continue; }
                Maps.map[mapnumber].BR.BaseStream.Position = tempr + (92 * x) + 8;
                ScenerySpawn vs = new ScenerySpawn();
                vs.offset = tempr + (92 * x) + 8;
                vs.X = Maps.map[mapnumber].BR.ReadSingle();
                vs.Y = Maps.map[mapnumber].BR.ReadSingle();
                vs.Z = Maps.map[mapnumber].BR.ReadSingle();
                vs.Roll = Maps.map[mapnumber].BR.ReadSingle();
                vs.Pitch = Maps.map[mapnumber].BR.ReadSingle();
                vs.Yaw = Maps.map[mapnumber].BR.ReadSingle();
                vs.ModelTagNumber = temppalette[tempshort];
                if (vs.ModelTagNumber == -1) { continue; }
                vs.TagPath = Maps.map[mapnumber].FileNames.Name[temppalette2[tempshort]];
                vs.ModelName = Maps.map[mapnumber].FileNames.Name[vs.ModelTagNumber];
                Spawn.Add(vs);

            }



            ////weapons


            Maps.map[mapnumber].BR.BaseStream.Position = Maps.map[mapnumber].MetaInfo.Offset[3] + 152;
            temppalette = new int[Maps.map[mapnumber].BR.ReadInt32()];
            temppalette2 = new int[temppalette.Length];
            tempr = Maps.map[mapnumber].BR.ReadInt32() - Maps.map[mapnumber].SecondaryMagic;
            for (int x = 0; x < temppalette.Length; x++)
            {
                Maps.map[mapnumber].OpenMap(MapTypes.Internal);
                Maps.map[mapnumber].BR.BaseStream.Position = tempr + (x * 40) + 4;
                int tempbase = Maps.map[mapnumber].Functions.Meta.FindMetaByID(Maps.map[mapnumber].BR.ReadInt32(), mapnumber);
                Maps.map[mapnumber].CloseMap();
                temppalette2[x] = tempbase;
                temppalette[x] = Maps.map[mapnumber].Functions.FindModelByBaseClass(tempbase, mapnumber);
            }


            Maps.map[mapnumber].OpenMap(MapTypes.Internal);
            Maps.map[mapnumber].BR.BaseStream.Position = Maps.map[mapnumber].MetaInfo.Offset[3] + 144;
            tempc = Maps.map[mapnumber].BR.ReadInt32();
            tempr = Maps.map[mapnumber].BR.ReadInt32() - Maps.map[mapnumber].SecondaryMagic;

            for (int x = 0; x < tempc; x++)
            {
                Maps.map[mapnumber].BR.BaseStream.Position = tempr + (84 * x);
                short tempshort = Maps.map[mapnumber].BR.ReadInt16();

                if (tempshort == -1) { continue; }
                Maps.map[mapnumber].BR.BaseStream.Position = tempr + (84 * x) + 8;
                WeaponSpawn vs = new WeaponSpawn();
                vs.offset = tempr + (84 * x) + 8;
                vs.X = Maps.map[mapnumber].BR.ReadSingle();
                vs.Y = Maps.map[mapnumber].BR.ReadSingle();
                vs.Z = Maps.map[mapnumber].BR.ReadSingle();
                vs.Roll = Maps.map[mapnumber].BR.ReadSingle();
                vs.Pitch = Maps.map[mapnumber].BR.ReadSingle();
                vs.Yaw = Maps.map[mapnumber].BR.ReadSingle();
                vs.ModelTagNumber = temppalette[tempshort];
                if (vs.ModelTagNumber == -1) { continue; }
                vs.TagPath = Maps.map[mapnumber].FileNames.Name[temppalette2[tempshort]];
                vs.ModelName = Maps.map[mapnumber].FileNames.Name[vs.ModelTagNumber];
                Spawn.Add(vs);

            }




            ////obstacles


            Maps.map[mapnumber].BR.BaseStream.Position = Maps.map[mapnumber].MetaInfo.Offset[3] + 816;
            temppalette = new int[Maps.map[mapnumber].BR.ReadInt32()];
            temppalette2 = new int[temppalette.Length];
            tempr = Maps.map[mapnumber].BR.ReadInt32() - Maps.map[mapnumber].SecondaryMagic;
            for (int x = 0; x < temppalette.Length; x++)
            {
                Maps.map[mapnumber].OpenMap(MapTypes.Internal);
                Maps.map[mapnumber].BR.BaseStream.Position = tempr + (x * 40) + 4;
                int tempbase = Maps.map[mapnumber].Functions.Meta.FindMetaByID(Maps.map[mapnumber].BR.ReadInt32(), mapnumber);
                Maps.map[mapnumber].CloseMap();
                temppalette2[x] = tempbase;
                temppalette[x] = Maps.map[mapnumber].Functions.FindModelByBaseClass(tempbase, mapnumber);
            }


            Maps.map[mapnumber].OpenMap(MapTypes.Internal);
            Maps.map[mapnumber].BR.BaseStream.Position = Maps.map[mapnumber].MetaInfo.Offset[3] + 808;
            tempc = Maps.map[mapnumber].BR.ReadInt32();
            tempr = Maps.map[mapnumber].BR.ReadInt32() - Maps.map[mapnumber].SecondaryMagic;

            for (int x = 0; x < tempc; x++)
            {
                Maps.map[mapnumber].BR.BaseStream.Position = tempr + (76 * x);
                short tempshort = Maps.map[mapnumber].BR.ReadInt16();

                if (tempshort == -1) { continue; }
                Maps.map[mapnumber].BR.BaseStream.Position = tempr + (76 * x) + 8;
                ObstacleSpawn vs = new ObstacleSpawn();
                vs.offset = tempr + (76 * x) + 8;
                vs.X = Maps.map[mapnumber].BR.ReadSingle();
                vs.Y = Maps.map[mapnumber].BR.ReadSingle();
                vs.Z = Maps.map[mapnumber].BR.ReadSingle();
                vs.Roll = Maps.map[mapnumber].BR.ReadSingle();
                vs.Pitch = Maps.map[mapnumber].BR.ReadSingle();
                vs.Yaw = Maps.map[mapnumber].BR.ReadSingle();
                vs.ModelTagNumber = temppalette[tempshort];
                if (vs.ModelTagNumber == -1) { continue; }
                vs.TagPath = Maps.map[mapnumber].FileNames.Name[temppalette2[tempshort]];
                vs.ModelName = Maps.map[mapnumber].FileNames.Name[vs.ModelTagNumber];
                Spawn.Add(vs);

            }


            //collections
            Maps.map[mapnumber].BR.BaseStream.Position = Maps.map[mapnumber].MetaInfo.Offset[3] + 288;
            tempc = Maps.map[mapnumber].BR.ReadInt32();
            tempr = Maps.map[mapnumber].BR.ReadInt32() - Maps.map[mapnumber].SecondaryMagic;

            for (int x = 0; x < tempc; x++)
            {
                Maps.map[mapnumber].OpenMap(MapTypes.Internal);
                Collection vs = new Collection();
                Maps.map[mapnumber].BR.BaseStream.Position = tempr + (144 * x) + 4;
                vs.SpawnsInMode = (Collection.SpawnsInEnum)Maps.map[mapnumber].BR.ReadInt32();
                Maps.map[mapnumber].BR.BaseStream.Position = tempr + (144 * x) + 64;
                vs.offset = tempr + (144 * x) + 64;
                vs.X = Maps.map[mapnumber].BR.ReadSingle();
                vs.Y = Maps.map[mapnumber].BR.ReadSingle();
                vs.Z = Maps.map[mapnumber].BR.ReadSingle();
                vs.Roll = Maps.map[mapnumber].BR.ReadSingle();
                vs.Pitch = Maps.map[mapnumber].BR.ReadSingle();
                vs.Yaw = Maps.map[mapnumber].BR.ReadSingle();

                //test
              //  if (vs.Pitch > 0) { vs.Pitch = -vs.Pitch; vs.isWeird = true; } else { vs.isWeird = false; }

                Maps.map[mapnumber].BR.BaseStream.Position = tempr + (144 * x) + 92;
                int tempbase = Maps.map[mapnumber].Functions.Meta.FindMetaByID(Maps.map[mapnumber].BR.ReadInt32(), mapnumber);
                if (tempbase == -1) { continue; }
                Maps.map[mapnumber].CloseMap();
                vs.TagPath = Maps.map[mapnumber].FileNames.Name[tempbase];
                vs.ModelTagNumber = Maps.map[mapnumber].Functions.FindModelByBaseClass(tempbase, mapnumber);
                if (vs.ModelTagNumber == -1) { continue; }
                vs.ModelName = Maps.map[mapnumber].FileNames.Name[vs.ModelTagNumber];
                Spawn.Add(vs);
            }

            //cameras
            Maps.map[mapnumber].OpenMap(MapTypes.Internal);
            Maps.map[mapnumber].BR.BaseStream.Position = Maps.map[mapnumber].MetaInfo.Offset[3] + 488;
            tempc = Maps.map[mapnumber].BR.ReadInt32();
            tempr = Maps.map[mapnumber].BR.ReadInt32() - Maps.map[mapnumber].SecondaryMagic;

            for (int x = 0; x < tempc; x++)
            {
                Maps.map[mapnumber].OpenMap(MapTypes.Internal);
                CameraSpawn vs = new CameraSpawn();
                Maps.map[mapnumber].BR.BaseStream.Position = tempr + (64 * x) + 36;
                vs.offset = tempr + (64 * x) + 36;
                vs.X = Maps.map[mapnumber].BR.ReadSingle();
                vs.Y = Maps.map[mapnumber].BR.ReadSingle();
                vs.Z = Maps.map[mapnumber].BR.ReadSingle();
                vs.Roll = Maps.map[mapnumber].BR.ReadSingle();
                vs.Pitch = Maps.map[mapnumber].BR.ReadSingle();
                vs.Yaw = Maps.map[mapnumber].BR.ReadSingle();
                vs.fov = Maps.map[mapnumber].BR.ReadSingle();
                vs.ModelTagNumber = -1;


                Spawn.Add(vs);


            }

            Maps.map[mapnumber].CloseMap();

        }
        #endregion
        #region enums
        [FlagsAttribute]
        public enum SpawnType : int
        {
            Player = 1,
            Weapon = 2,
            Collection = 4,
            Vehicle = 8,
            Obstacle = 16,
            Machine = 32,
            Scenery = 64,
            Objective = 128,
            Equipment = 256,
            ItemCollection = 512,
            Biped = 1024,
            Control = 2048,
            Special = 4096,
            DeathZone = 8192,
            Camera = 16384,
            Light = 32768
        }
        public enum SpawnRotationType
        {
            Direction,
            YawPitchRoll

        }
        #endregion
        #region Classes
        public class BoundingBoxSpawn : BaseSpawn
        {

            public float width;
            public float height;
            public float length;

        }
        public class BaseSpawn
        {
            public SpawnType Type;
            public string TagPath;
            public float X;
            public float Y;
            public float Z;

            public int offset;
        }
        public class RotationSpawn : BaseSpawn
        {
            public int ModelTagNumber;
            public string ModelName;
            public SpawnRotationType RotationType;
        }
        public class RotateDirectionBaseSpawn : RotationSpawn
        {
            public float RotationDirection;

        }
        public class RotateYawPitchRollBaseSpawn : RotationSpawn
        {
            public Boolean isWeird;
            public float Yaw;
            public float Pitch;
            public float Roll;

        }
        public class PlayerSpawn : RotateDirectionBaseSpawn
        {

            public PlayerSpawn()
            {
                this.Type = SpawnType.Player;
                this.RotationType = SpawnRotationType.Direction;
            }
        }
        public class BipedSpawn : RotateDirectionBaseSpawn
        {
            
            public BipedSpawn()
            {
                this.Type = SpawnType.Biped;
                this.RotationType = SpawnRotationType.Direction;
            }
        }
        public class VehicleSpawn : RotateYawPitchRollBaseSpawn
        {
            
            public VehicleSpawn()
            {
                this.Type = SpawnType.Vehicle;
                this.RotationType = SpawnRotationType.YawPitchRoll;
            }
        }
        public class CameraSpawn : RotateYawPitchRollBaseSpawn
        {
            public float fov;
            
            public CameraSpawn()
            {
                this.Type = SpawnType.Camera;
                this.RotationType = SpawnRotationType.YawPitchRoll;
            }
        }
        public class LightSpawn : RotateYawPitchRollBaseSpawn
        {
            public MetaContainers.HaloLight LightInfo;
            
            public LightSpawn()
            {
                this.Type = SpawnType.Light;
                this.RotationType = SpawnRotationType.YawPitchRoll;
            }
        }
        public class ScenerySpawn : RotateYawPitchRollBaseSpawn
        {
            
            public ScenerySpawn()
            {
                this.Type = SpawnType.Scenery;
                this.RotationType = SpawnRotationType.YawPitchRoll;
            }
        }
        public class WeaponSpawn : RotateYawPitchRollBaseSpawn
        {
            
            public WeaponSpawn()
            {
                this.Type = SpawnType.Weapon;
                this.RotationType = SpawnRotationType.YawPitchRoll;
            }
        }
        public class EquipmentSpawn : RotateDirectionBaseSpawn
        {
            
            public EquipmentSpawn()
            {
                this.Type = SpawnType.Equipment;
                this.RotationType = SpawnRotationType.Direction;
            }
        }
        public class ControlSpawn : RotateDirectionBaseSpawn
        {
            
            public ControlSpawn()
            {
                this.Type = SpawnType.Control;
                this.RotationType = SpawnRotationType.Direction;
            }
        }
        public class SpecialSpawn : BoundingBoxSpawn
        {
            public string Name;
            public SpecialSpawnType specialSpawnType;
            public enum SpecialSpawnType
            {
                CTF,
                Initital
            }
            public SpecialSpawn()
            {
                this.Type = SpawnType.Special;

            }
        }
        public class DeathZone : BoundingBoxSpawn
        {
            public string Name;
            public DeathZone()
            {
                this.Type = SpawnType.DeathZone;

            }
        }
        public class MachineSpawn : RotateYawPitchRollBaseSpawn
        {
            
            public MachineSpawn()
            {
                this.Type = SpawnType.Machine;
                this.RotationType = SpawnRotationType.YawPitchRoll;
            }
        }
        public class ObstacleSpawn : RotateYawPitchRollBaseSpawn
        {
            
            public ObstacleSpawn()
            {
                this.Type = SpawnType.Obstacle;
                this.RotationType = SpawnRotationType.YawPitchRoll;
            }
        }
        public class Collection : RotateYawPitchRollBaseSpawn
        {
            public SpawnsInEnum SpawnsInMode;
            
            public Collection()
            {
                this.Type = SpawnType.Collection;
                this.RotationType = SpawnRotationType.YawPitchRoll;

            }
            public enum SpawnsInEnum
            {
                None = 0,
                CTFAndAssault = 1,
                Slayer = 2,
                Oddball = 3,
                KOTHOnly = 4,
                KOTHOnly2 = 5,
                KOTHOnly3 = 6,
                Juggernaut = 7,
                Territories = 8,
                CTFAndAssault2 = 9,
                KOTHOnly4 = 10,
                KOTHOnly5 = 11,
                All = 12,
                AllExceptCTFAndAssault = 13,
                AllExceptCTFAndAssault2 = 14
            }
        }

        public class H1Collection : RotateDirectionBaseSpawn
        {
            public H1CollectionTypeEnum SpawnsInMode;
            
            public H1Collection()
            {
                this.Type = SpawnType.Collection;
                this.RotationType = SpawnRotationType.Direction;

            }
            public enum H1CollectionTypeEnum
            {
                None = 0,
                CTF = 1,
                Slayer = 2,
                Oddball = 3,
                KOTH = 4,
                Race = 5,
                Terminator = 6,
                Stub = 7,
                Ignored1 = 8,
                Ignored2 = 9,
                Ignored3 = 10,
                Ignored4 = 11,
                All = 12,
                AllExceptCTF = 13,
                AllExceptRaceAndCTF = 14
            }
        }
        public class ObjectiveSpawn : RotateDirectionBaseSpawn
        {
            public ObjectiveTypeEnum ObjectiveType;
            public TeamType Team;
            public short number;
            public ObjectiveSpawn()
            {
                this.Type = SpawnType.Objective;
                this.RotationType = SpawnRotationType.Direction;
            }
            public enum ObjectiveTypeEnum
            {
                CTFRespawn = 0,
                CTFScore = 1,
                AssaultRespawn = 2,
                ArmingCircle = 3,
                OddballSpawn = 4,
                TeleporterEntrance = 7,
                TeleporterExit = 8,
                Territory = 10,
                HillVertex1 = 11,
                HillVertex2 = 12,
                HillVertex3 = 13,
                HillVertex4 = 14,
                HillVertex5 = 15,
            }
            public enum TeamType
            {
                Defense = 0,
                Offense = 1,
                Neutral = 8
            }
        }

        #endregion
    }
}