using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.DirectX;
using Microsoft.DirectX.Direct3D;
using Microsoft.DirectX.DirectInput;
using DirectX = Microsoft.DirectX;
using System.Windows.Forms;
namespace entity.Renderer
{
    public class Camera2 : IDisposable
    {
        public DirectX.DirectInput.Device device;
        private Plane[] m_frustum=new Plane[6];
        public float x = 0f;
        public float y = 3f;
        public float z = -5f;
        public float i = 0f;
        public float j = 0f;
        public float k = 0f;
       
        public Vector3 Position;
        public Vector3 LookAt=new Vector3(0,0,0f);
        public Vector3 UpVector = new Vector3(0, 0, 1);
        public float radius = 1.0f;
        public float speed = 0.5f;

        public float radianh;
        public float radianv;
        public bool fixedrotation = false;
        public int oldx = 0;
        public int oldy = 0;
        public Camera2(Form form)
        {
            device = new Microsoft.DirectX.DirectInput.Device( SystemGuid.Keyboard);
            device.SetCooperativeLevel(form,
                CooperativeLevelFlags.Foreground | CooperativeLevelFlags.NonExclusive);
    
            radianh = 0.0f;
            radianv = 0.0f;
            Position = new Vector3(x, y, z);
            ComputePosition();
        }
        public void SetFixed()
        {
            fixedrotation=true;
        }
        public void move()
        {
        
                try
                {
                    device.Acquire();
                }
                catch
                {
                    return;
                }
      

            foreach (Key kk in device.GetPressedKeys())
            {
                
                
                switch (kk.ToString())
                {
                    case "W":
                        x += i * speed;
                        y += j * speed;
                        z += k * speed;
                        Position.X = x;
                        Position.Y = y;
                        Position.Z = z;
                        break;
                    case "S":
                        x -= i * speed;
                        y -= j * speed;
                        z -= k * speed;
                        Position.X = x;
                        Position.Y = y;
                        Position.Z = z;
                
                        break;
                    case "A":
                        ComputeStrafe(false);

                       // y += speed;
                      // Position.Y = y;
                        break;
                    case "D":
                        ComputeStrafe(true);
                       // y -= speed;
                        //Position.Y = y;
                        break;
                    case "Z":
                        z -= speed;
                        Position.Z = z;
                        break;
                    case "X":
                        z += speed;
                        Position.Z = z;
                        break;
                        
                    case "Equals":
                    case "Add":
                        speed += 0.01f;
                    
                        break;
                    case "Minus":
                    case "NumPadMinus":
                        speed -= 0.01f;
                        if (speed < 0) { speed = 0.01f; }
                        break;
                }
                ComputePosition();
            }

        }
        public void change(int x,int y)
        {
            
            int tempx = oldx - x;
            int tempy = oldy - y;
           
            radianh += DegreesToRadian((float)tempx);
            radianv += DegreesToRadian((float)tempy);
      

            ComputePosition();
            oldx = x;
            oldy = y;
        }

        public void AimCamera(Vector3 v)
        {
            i = v.X;
            j = v.Y;
            k = v.Z;
            LookAt.X = i ;
            LookAt.Y = j ;
            LookAt.Z = k ;
        }
        public void ComputeStrafe(bool right)
        {
            // Keep all rotations between 0 and 2PI
            radianh = radianh > (float)Math.PI * 2 ? radianh - (float)Math.PI * 2 : radianh;
            radianh = radianh < 0 ? radianh + (float)Math.PI * 2 : radianh;

            radianv = radianv > (float)Math.PI * 2 ? radianv - (float)Math.PI * 2 : radianv;
            radianv = radianv < 0 ? radianv + (float)Math.PI * 2 : radianv;

            //Switch up-vector based on vertical rotation
            // UpVector = Position.X < 0 ? new Vector3(-1, 0, 1) : new Vector3(1, 0, 1);
            // radianv > Math.PI / 2 && radianv < Math.PI / 2 * 3 ?
            //  new Vector3(0,  1,0) : new Vector3(0,  -1,0);

           float tempi = radius * (float)(Math.Cos(radianh-1.57) * Math.Cos(radianv))*this.speed;
           float tempj = radius * (float)(Math.Sin(radianh - 1.57) * Math.Cos(radianv)) * this.speed;

           if (right == true)
           {
               LookAt.X += tempi;
               LookAt.Y += tempj;

               x += tempi;
               y += tempj;

               Position.X = x;
               Position.Y = y;
           }
           else
           {
               LookAt.X -= tempi;
               LookAt.Y -= tempj;

               x -= tempi;
               y -= tempj;

               Position.X = x;
               Position.Y = y;
           }
      
        }

        public void Dispose()
        {
            device = null;
        }
        public void ComputePosition()
        {
            // Keep all rotations between 0 and 2PI
           //if (fixedcam==true){return;}
            
            radianh = radianh > (float)Math.PI * 2 ? radianh - (float)Math.PI * 2 : radianh;
            radianh = radianh < 0 ? radianh + (float)Math.PI * 2 : radianh;

            radianv = radianv > (float)Math.PI * 2 ? radianv - (float)Math.PI * 2 : radianv;
            radianv = radianv < 0 ? radianv + (float)Math.PI * 2 : radianv;
            
            i =  radius*(float)(Math.Cos(radianh)*Math.Cos(radianv));
            j = radius * (float)(Math.Sin(radianh) * Math.Cos(radianv));
            k = radius * (float)Math.Sin(radianv);;

            if (fixedrotation)
            {
                Position.X = i + x;
                Position.Y = j + y;
                Position.Z = k + z;
            }
            else
            {
                LookAt.X = i + x;
                LookAt.Y = j + y;
                LookAt.Z = k + z;
            }

        }
       

        public float DegreesToRadian(float degree)
        {
            return (float)(degree * (Math.PI / 180));
        }
        /*
        public void BuildViewFrustum(ref DirectX.Direct3D.Device device)
        {
            Matrix viewProjection = device.Transform.View * device.Transform.Projection;

            // Left plane
            m_frustum[0].A = viewProjection.M14 + viewProjection.M11;
            m_frustum[0].B = viewProjection.M24 + viewProjection.M21;
            m_frustum[0].C = viewProjection.M34 + viewProjection.M31;
            m_frustum[0].D = viewProjection.M44 + viewProjection.M41;

            // Right plane
            m_frustum[1].A = viewProjection.M14 - viewProjection.M11;
            m_frustum[1].B = viewProjection.M24 - viewProjection.M21;
            m_frustum[1].C = viewProjection.M34 - viewProjection.M31;
            m_frustum[1].D = viewProjection.M44 - viewProjection.M41;

            // Top plane
            m_frustum[2].A = viewProjection.M14 - viewProjection.M12;
            m_frustum[2].B = viewProjection.M24 - viewProjection.M22;
            m_frustum[2].C = viewProjection.M34 - viewProjection.M32;
            m_frustum[2].D = viewProjection.M44 - viewProjection.M42;

            // Bottom plane
            m_frustum[3].A = viewProjection.M14 + viewProjection.M12;
            m_frustum[3].B = viewProjection.M24 + viewProjection.M22;
            m_frustum[3].C = viewProjection.M34 + viewProjection.M32;
            m_frustum[3].D = viewProjection.M44 + viewProjection.M42;

            // Near plane
            m_frustum[4].A = viewProjection.M13;
            m_frustum[4].B = viewProjection.M23;
            m_frustum[4].C = viewProjection.M33;
            m_frustum[4].D = viewProjection.M43;

            // Far plane
            m_frustum[5].A = viewProjection.M14 - viewProjection.M13;
            m_frustum[5].B = viewProjection.M24 - viewProjection.M23;
            m_frustum[5].C = viewProjection.M34 - viewProjection.M33;
            m_frustum[5].D = viewProjection.M44 - viewProjection.M43;

            // Normalize planes
            for (int i = 0; i < 6; i++)
            {
                m_frustum[i] = Plane.Normalize(m_frustum[i]);
            }
        }

        public bool SphereInFrustum(Vector3 position, float radius)
        {
            Vector4 position4 = new Vector4(position.X, position.Y, position.Z, 1f);
            for (int i = 0; i < 6; i++)
            {
                if (m_frustum[i].Dot(position4) + radius < 0)
                {
                    // Outside the frustum, reject it!
                    return false;
                }
            }
            return true;
        }
        */


       
    }
}
