using System;
using System.Drawing;
using System.Windows.Forms;
using Microsoft.DirectX;
using Microsoft.DirectX.DirectInput;
using Microsoft.DirectX.Direct3D;
using Direct3D = Microsoft.DirectX.Direct3D;

namespace entity
{

    public class ModelViewer : Form
    {
        // Our global variables for this project
        Renderer.Renderer render = new entity.Renderer.Renderer();
        
 
      
     
        Raw.ParsedModel pm;
        entity.Renderer.Camera2 cam;

        Material m1;

        public ModelViewer(Raw.ParsedModel temppm)
        {
            // Set the initial size of our form
            this.ClientSize = new System.Drawing.Size(400, 300);
            // And its caption
            this.Text = "Model Viewer";


            pm = temppm;

            this.MouseDown += new MouseEventHandler(ModelViewer_MouseDown);
            this.MouseMove += new System.Windows.Forms.MouseEventHandler(this.ModelViewer_MouseDownx);
            this.MouseUp += new System.Windows.Forms.MouseEventHandler(this.ModelViewer_MouseUp);

            Main();
        }

        void ModelViewer_MouseDown(object sender, MouseEventArgs e)
        {
            cam.oldx = e.X;
            cam.oldy = e.Y;
        }

        public bool InitializeGraphics()
        {
            //try
            //{

            render.CreateDevice(this);
            
            

            
            Raw.ParsedModel.DisplayedInfo.LoadDirectXTexturesAndBuffers(ref render.device, ref pm);
            cam = new entity.Renderer.Camera2(this);
            cam.speed = 0.005f;

            cam.Position.X = 0.5741551f;
            cam.Position.Y = 0.01331316f;
            cam.Position.Z = 0.4271703f;

            cam.radianv = 6.161014f;
            cam.radianh = 3.14159f;

            cam.x = 0.5741551f;
            cam.y = 0.01331316f;
            cam.z = 0.4271703f;

            cam.ComputePosition();

            m1 = new Material();
            m1.Diffuse = Color.White;
            m1.Ambient = Color.White;
            m1.Specular = Color.White;

      
            return true;
            //}
            //catch (DirectXException)
            //{
            // Catch any errors and return a failure
            //	return false;
            //	}
        }






        private void SetupMatrices()
        {
            render.device.Transform.World = Matrix.Identity;
            render.device.Transform.View = Matrix.LookAtRH(cam.Position, cam.LookAt, cam.UpVector);
            render.device.Transform.Projection = Matrix.PerspectiveFovRH(1.33f, 1.0f, 0.1f, 10000.0f);
        }

        public Boolean firsttimeload = true;

        private void Render()
        {
            if (render.pause)
                return;


            render.BeginScene(Color.Blue);

            cam.move();
            SetupMatrices();

          
            render.device.Material = m1;
            Raw.ParsedModel.DisplayedInfo.DrawMeshes(ref render.device, pm);
           // Raw.ParsedModel.DisplayedInfo.Draw(ref render.device, pm);
            render.EndScene();


        }

        protected override void OnPaint(System.Windows.Forms.PaintEventArgs e)
        {
            this.Render(); // Render on painting
        }
        protected override void OnKeyPress(System.Windows.Forms.KeyPressEventArgs e)
        {
            if ((int)(byte)e.KeyChar == (int)System.Windows.Forms.Keys.Escape)
            {
                this.Dispose(); // Esc was pressed
            }
            else if (e.KeyChar.ToString() == "I" || e.KeyChar.ToString() == "i")
            {

                MessageBox.Show("Camera Cords: X:" + cam.Position.X + " Y:" + cam.Position.Y + " Z:" + cam.Position.Z);
                MessageBox.Show("Looking at: H:" + cam.radianh + " V:" + cam.radianv);
                
            }

            

        //  /  else
           // {
           ///     pause = false;
           // }
        }
        protected override void OnResize(System.EventArgs e)
        {
           //this.WindowState = (FormWindowState.Minimized) || !this.Visible;
            //   Application.DoEvents();
            //   pause = false;
            //this.Render();
        }



        /// <summary>
        /// The main entry point for the application.
        /// </summary>
        public void Main()
        {

            using (ModelViewer frm = (ModelViewer)this)
            {
                if (!frm.InitializeGraphics()) // Initialize Direct3D
                {
                    MessageBox.Show("Could not initialize Direct3D.  This tutorial will exit.");
                    return;
                }
                frm.Show();

                // While the form is still valid, render and process messages
                while (frm.Created)
                {
                    frm.Render();
                    Application.DoEvents();
                }
            }
        }

        private void InitializeComponent()
        {
            this.SuspendLayout();
            // 
            // ModelViewer
            // 
            this.ClientSize = new System.Drawing.Size(292, 266);
            this.Name = "ModelViewer";

            this.ResumeLayout(false);

        }

        private void ModelViewer_MouseDownx(object sender, MouseEventArgs e)
        {
            if (e.Button == MouseButtons.Left)
            {
                cam.change(e.X, e.Y);
            }

        }

        private void ModelViewer_MouseUp(object sender, MouseEventArgs e)
        {

         

        }

    }
}
