using System;
using System.Collections.Generic;
using System.IO;

namespace entity.Scripts
{
    public class Scripts
    {
        Syntax[] syntaxes;
        public Scripts(int mapnumber)
        {
            Maps.map[mapnumber].OpenMap(MapTypes.Internal);
            Maps.map[mapnumber].BR.BaseStream.Position = Maps.map[mapnumber].MetaInfo.Offset[3]+568;
            int tempc = Maps.map[mapnumber].BR.ReadInt32();
            int tempr = Maps.map[mapnumber].BR.ReadInt32()- Maps.map[mapnumber].SecondaryMagic;
            syntaxes = new Syntax[tempc];
            Maps.map[mapnumber].BR.BaseStream.Position = tempr;
            for (int x = 0; x < tempc; x++)
            {
                syntaxes[x] = new Syntax(ref  Maps.map[mapnumber].BR);
            }
            Maps.map[mapnumber].CloseMap();
        }

        public void WriteScriptInfotoText(string path)
        {
            FileStream FS = new FileStream(path, FileMode.Create);
            StreamWriter SW = new StreamWriter(FS);
            for (int x = 0; x < syntaxes.Length; x++)
            {
                if (syntaxes[x].expressionindex==0) continue;
                if (syntaxes[x].type == 9&&syntaxes[x].type2 == 2) continue;
                string temps = "Chunk Number: " + x.ToString() + " Script Table Offset: " + syntaxes[x].scripttableoffset.ToString() + SW.NewLine;
                temps += "Identity: " + syntaxes[x].identity.ToString();
                temps += " Type: " + syntaxes[x].type.ToString();
                temps += " Type2: " + syntaxes[x].type2.ToString() +SW.NewLine ;
                temps += "--------------------------------------------------------------------" + SW.NewLine;
                SW.WriteLine(temps);
            }
            SW.Close();
            FS.Close();
        }


        public class Syntax
        {
            public 	short expressionindex;
            public short identity;
            public short type2;
            public short type;
            public short expressionnumber;
            public short siblingpointer;
            public int scripttableoffset;
            public short value;
            public short childpointer;
            public Syntax(ref BinaryReader BR)
            {
                expressionindex = BR.ReadInt16(); ;
                 identity = BR.ReadInt16(); 
                 type2 = BR.ReadInt16(); 
                 type = BR.ReadInt16(); 
                 expressionnumber = BR.ReadInt16(); 
                 siblingpointer = BR.ReadInt16();
                 scripttableoffset = BR.ReadInt32(); ;
                 value = BR.ReadInt16(); ;
                 childpointer = BR.ReadInt16(); ;
            }
        }
    }
}
